#
#  DS_Gabor_One
#

mod_type  ds_simp_01    # Simple DS, using 1 gabor filter

sscale         0.1      # degr/pix
tscale         0.002    # sec/frame
xn            32        # filter x size
yn            32        # filter y size
tn           128        # filter t size

#
#  Oriented linear filter
#
<filter>
  type           Gabor             # type of filter
  branch         odd               # ["odd"] "odd", "even", "two" for both
  direction      0       (deg)     # preferred direction
  sf             1.25    (cyc/deg) # Spatial frequency
  ssd            0.18    (deg)     # SD of Gaussian in space
  tf            10.0     (cyc/s)   # Temporal frequency
  tsd            0.015   (s)       # SD of Gaussian in time
  exponent       1.0               # [1.0] raise filter output to this exponent
  write_filter   0                 # 0-none, 1-write to file 'zzz....3d'
</filter>


#
#  Spike Generation
#
<spike_gen>
  type          poisson     # Spike generation algorithm, dflt "poisson"; "ifc"
  offset0       0.0         # [0.0] Add to filter output, before scaling
  scale         0.01        # [1.0] Multiply filter output
  offset        0.0         # [0.0] Add to filter output, after scaling
  toffset       0.040   (s) # Time delay (s) added to spike times
  spike_dump    0           # Dump spike gen data to 'zz.dump.spike.pl' if 1
</spike_gen>
