#
#  GaborSimp
#

mod_type filter_xyt                  # Model type

sscale           0.04    (deg/pix)   # Spatial resolution
tscale           0.002   (s/frame)   # Temporal resolution
xn              32       (pix)       # Horizontal size
yn              32       (pix)       # Vertical size
tn            2048       (frame)     # Duration

#
#  Spatial Gabor filter
#
<filter>
  name      spatial             # Name
  form      2d                  # '2d' ['1d']
  type      Gabor               # Gabor is Gaussian times cosine
  theta       0      (deg)      # preferred orientation
  sf          2.00   (cyc/deg)  # Spatial frequency 
  sd_orth     0.150  (deg)      # SD space orthogonal
  sd_par      0.215  (deg)      # SD space parallel
  phase       0      (deg)      # Spatial phase
#  plot_filename zz.gabor.2d     # name of file for writing plot data [NULL]
</filter>

#
#  Biphasic temporal filter
#
<filter>
  name      temporal            # Name
  type      Maxwell             # shape of filter
  origin    center              # ['zero'] or 'center'
  m1          0.020  (s)        # peak time of Maxwell kernel
  m2          0.040  (s)        # optional 2nd kernel, peak time
  amp2       -0.800             # relative amplitude of optional 2nd kernel
  area        1.0               # total area of filter [or specify 'max']
#  plot_filename zz.tfilt.pl     # name of file for writing plot data [NULL]
</filter>

model_write_filter -1   # 1=write, -1=no write

#
#  Spike generation
#
<spike_gen>
  type          poisson     # Spike generation algorithm, dflt "poisson"; "ifc"
  offset0      -0.74        # Add to filter output, BEFORE scaling [0.0]
  scale         0.025       # Multiply filter output [1.0]
  offset        0.0         # Add to filter output, AFTER scaling [0.0]
  toffset       0.030   (s) # Time delay added to spike times
  spike_dump    0           # Dump firing probability to 'zz.dump.pl' if 1
</spike_gen>
