#
#  RD_Exp_T.moo
#
#  Reichardt detector (RD) model for direction selectivity
#
#

mod_type reichardt         # Reichardt model

sscale       0.1           # degr/pix
tscale       0.002         # sec/frame
xn          32             # filter x size
yn          32             # filter y size
tn         128             # filter t size

#--------------------------------------.--------------------------------------#
#                                                                             #
#                                    FILTER                                   #
#                                                                             #
#-----------------------------------------------------------------------------#
<filter>
  name reich

  lp_tau       0.010       # Low-pass time constant (s)
  hp_tau       0.500       # High-pass time constant (s)

  ### Set the number of RD units for spatial integration
  n_unit_x    20           # Number of units along x-dimension
  n_unit_y     1           # Number of units along y-dimension
  dx           1           # x-offset between paired receptors (sampling units)
  opp_flag     1           # 1-oppenent RD is subtracted, 0-non-opponent
  dump         0           # 1-write traces for center RD unit to 'zzz.rd.pl'

</filter>
#--------------------------------------.--------------------------------------#
#                                                                             #
#                                  SPIKE_GEN                                  #
#                                                                             #
#-----------------------------------------------------------------------------#
<spike_gen>
  type          poisson  # Spike generation scheme
  offset0      -0.03     # Add to filter output before scaling [0]
  scale         0.8      # Multiply filter output [1]
  offset        0.0      # Add to filter output after scaling [0]
  toffset       0.030    # Temporal offset (s) added to spike times [0]
  spike_dump    0        # Dump firing probability to 'zz.dump.pl' if 1
</spike_gen>
