/*C  (C) Copyright  Wyeth Bair 1993-2010                                     */
struct input_pair{
  struct pop_mech *msi;    
  int in_index;            
  struct pop_layer *pop0;  
  struct pop_layer *pop1;  
  char *z1;                
  char *distrib;           
  float rf_offset_dir;          
  float rf_offset_dist;         
  float rf_offset_sd_par;       
  float rf_offset_sd_orth;      
  float rf_ph_shift;            
  float rf_ph_dev;              
  int   pair_seed;          
  int   tseed;              
};
struct nmda_param{
  int    nmda_ppmv;  
  int    nmda_v0;    
  float  nmda_v0f;   
  int    nmda_n;     
  float *nmda_gv;    
  float nmda_frac;   
  float nmda_alpha_1;  
  float nmda_amp_1;    
  float nmda_alpha_2;  
  float nmda_amp_2;    
  float nmda_alpha_3;  
  float nmda_amp_3;    
  float nmda1_aetau;   
  float nmda1_tau2inv; 
  float nmda1_totau;   
  float nmda2_aetau;   
  float nmda2_tau2inv; 
  float nmda2_totau;   
  float nmda3_aetau;   
  float nmda3_tau2inv; 
  float nmda3_totau;   
  float lgn_nmda_frac; 
  float lgn_nmda_amp_1;  
  float lgn_nmda_amp_2;  
  float lgn_nmda_amp_3;  
};
struct ifc_param{
  float v_spike;
  float tau_r_ad;      
  float tau_f_ad;      
  float gbar_ad;
  float v_reset_x;
  float v_ex;
  float v_in;
  float v_ad;
  float v_th_x;
  float v_leak_x;
  float g_leak_x;
  float c_x;
  float trefr_x;        
  float trefr_x_s;      
  float trefr_x_sd;     
  float g_tran;         
  float gx_scale;
  float gx_bias;
  float gi_scale;
  float gi_bias;
  char *gx_noise;       
  float gx_noise_mu;    
  float gx_noise_sd;    
  float gx_noise_tsd;   
  char *gi_noise;       
  float gi_noise_mu;    
  float gi_noise_sd;    
  float gi_noise_tsd;   
  int grect;            
  int dump;
  int clip_spike;
};
struct poiss_param{
  char *style;        
  float scale_in;     
  float scale_ad;     
  float offset0;      
  float scale;        
  float offset1;      
};
struct pop_name_list{
  int n;
  char **name;
};
struct pop_circbuf{
  int n;          
  float *d;       
  int i;          
  double t;       
  double dt;      
  int maskn;      
};
struct pop_mech{
  char *name;
  char *type;
  float tau;             
  float amp;             
  float tau_r;           
  float tau_f;           
  float sdf;             
  float sdtau;           
  int wtn;        
  float wdt;      
  int mask1n;     
  float *mask1;   
  int si_comp;    
  float normv;    
  float a,b;      
  struct onode *o;  
};
struct pop_si_sav{
  int n;         
  char **name;   
  int *nmax;     
  int *cnt;      
  float *samp;   
  float **d;     
};
struct pop_si001{
  struct pop_mech *msi;     
  struct pop_circbuf *wt;   
  struct pop_si_sav *sisv;  
};
struct pop_si002{
  struct pop_mech *msi;      
  struct pop_circbuf *wt1;   
  struct pop_circbuf *wt2;   
  struct pop_si_sav *sisv;   
};
union si_union{
  struct pop_si001 *s001;
  struct pop_si002 *s002;
};
struct pop_si{
  int ci;               
  int syn_code;         
  int siui;             
  union si_union *siu;  
};
struct pop_syn{
  struct pop_cell *post;     
  struct pop_cell *pre;      
  int stype;                 
  float w;                   
  float tlast;               
  float alast;               
  float tdelay;              
  struct pop_si *si;         
  short inindx;              
  struct pop_syn *pre_prev;  
  struct pop_syn *pre_next;  
  struct pop_syn *post_prev; 
  struct pop_syn *post_next; 
};
struct pop_lgn_in{
  struct pop_layer *lay;    
  struct pop_mech *mech;    
  int cn0;                  
  int *cx0,*cy0;            
  int cn1;                  
  int *cx1,*cy1;            
  float gw;                 
  int nposs;                
  struct pop_lgn_in *cpair; 
};
struct pop_cell{
  char *name;            
  char *subclass;        
  struct pop_layer *pl;  
  int layx,layy,layz;    
  float cx,cy;           
  float rfx,rfy;         
  float *attrib_f;      
  int nout;                  
  struct pop_syn *out;       
  int nin;                   
  struct pop_syn *in;        
  int syn_proc_code;         
  float input_ex_sdf;        
  float input_ex_sdtau;      
  int lgn_n;                 
  struct pop_lgn_in **lgnin; 
  int lgn_mflag;             
  struct   ifc_param *cifcp;    
  struct poiss_param *cpoissp;  
  struct pop_circbuf *ex1s;       
  struct pop_circbuf *in1s;       
  struct pop_circbuf *ex1g;       
  struct pop_circbuf *ex1g_nmda;  
  struct pop_circbuf *in1g;       
  struct pop_circbuf *ad1g;       
  double gex1t;     
  float gex1;       
  float gdex1;      
  float ex1tau;     
  float ex1amp;     
  float gex1_nmda1,gex1_nmda2,gex1_nmda3;     
  float gdex1_nmda1,gdex1_nmda2,gdex1_nmda3;
  int savg;         
  float *gtex1;     
  float *gtex1_nmda;
  float *gtin1;     
  float *gtex1t;    
  int gtex1n;       
  int gtex1max;     
  int    sava;      
  float *gta0;      
  int    gta_n;     
  int    gta_max;   
  float gin1;       
  float gdin1;      
  float in1tau;     
  float in1amp;     
  int n0;           
  float samp0;      
  float *gtx0;      
  float *gtn0;      
  float *gti0;      
  float *ggain;     
  int nad;            
  float *gta_pulse;   
  float bg_x_rate;    
  float bg_i_rate;    
  float bg_x_amp;     
  float bg_i_amp;     
  float *bg_x_s;      
  float *bg_i_s;      
  int bg_x_n;         
  int bg_i_n;         
  int bg_x_k;         
  int bg_i_k;         
  struct pop_cell *bg_x_corr_c; 
  float            bg_x_corr_f; 
  struct pop_cell *bg_i_corr_c; 
  float            bg_i_corr_f; 
  double x;        
  float y;         
  float yd;        
  float ystart;    
  float yscal;     
  float h;         
  float h1;        
  float hmin;      
  float hmax;      
  int nbad,nok;    
  float eps;       
  float reft;      
  int savv;        
  char *savvname;  
  float dxsav;     
  float xsav;      
  int vnmax;       
  int vn;          
  float *vm;       
  float *vmt;      
  int savd;        
  char *savdname;  
  float xsavd;     
  int vnd;         
  float *vmd;      
  int sdt;     
  int sn;      
  int sxp,sip; 
  float *sx;   
  float *si;   
  int savs;        
  char *savsname;  
  int maxscnt;     
  float *s;        
  int ns;          
  int    *csav_cnt;     
  float **csav_f;       
};
struct pop_icon{
  char *shape;      
  int nside;        
  float r,g,b;      
  float r1,g1,b1;   
  struct onode *o;  
};
struct pop_layer{
  char *name;       
  int runflag;      
  int lgn_in_flag;  
  int lgn_in_n;     
  int lgn_gain;       
  float lgn_gain_tau; 
  float lgn_gain_ca;  
  float lgn_gain_cb;  
  char *laytype;    
  struct pop_icon *icon;  
  struct pop_area *area;  
  int ninlist;            
  struct onode **inlist;  
  char *geomt;     
  int xn,yn,zn;    
  float x0,y0;     
  float xf,yf;     
  float umx,umy;   
  float oddxoff;   
  int irr_n;       
  float *irr_x;    
  float *irr_y;    
  int *irr_id;     
  float irr_dens;  
  struct dll_slist *save_name_list;  
  int  layseed_n;    
  int *layseed;      
  int nmech;               
  struct pop_mech **mech;  
  struct pop_cell ***c;       
  int attrib_fn;         
  char **attrib_fname;   
  struct ifc_param *ifcp;     
  struct poiss_param *poissp; 
  struct nmda_param *nmda_p;  
  int    csav_n;              
  char **csav_datid;          
  char **csav_source;         
  float *csav_samp;           
  int   ***cnt;               
  float ****s;                
  float ***rl;                
  float ***rr;                
  float ***rgl;               
  float ***rgr;               
};
struct pop_map{
  struct onode *o;    
  int xn,yn,zn;       
  float **map2;       
};
struct pop_area{
  char *name;         
  float x0,y0;        
  float xf,yf;        
  int xn,yn;          
  float umx,umy;      
  float sscale;       
};
struct pop_top{
  char *name;               
  char *logf;               
  int xn,yn;                
  int tn;                   
  float tscale;             
  float sscale;             
  float x1,x2;              
  char *out_prefix;         
  int monflag;              
  int retflag;              
  int binoc;                
  int narea;                
  struct pop_area **area;   
  int nlay;                 
  struct pop_layer **lay;   
  int nmap;                 
  struct pop_map **map;     
  char *conn_rw;            
  char *conn_read_dir;      
  char *conn_write_dir;     
};
struct pconn_el{
  int nsyn;  
  int *xi;   
  int *yi;
  int *zi;
  float *w;
};
struct pconn{
  int ftype;                 
  char *name1;               
  char *name2;               
  char *syntype;             
  int xn,yn,zn;              
  struct pconn_el ***c;      
};
