#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>  
#include <math.h>
#include <string.h>
#include "my_util.h"
#include "nr_util.h"
#include "iarray_util.h"
#include "carray_util.h"
#include "farray_util.h"
#include "myrand_util.h"
#include "data_util.h"
#include "min_util.h"
#include "paramfile_util.h"
#include "mod_util.h"
#include "ifc.h"           
#include "mod.h"           
#include "paramfile.h"
static int myid = -1;         
static int numproc = -1;      
static char *mylogf = NULL;   
char ggstr[LONG_SLEN];        
int mod_dcn_action;           
struct dcn_layer_struct{
  char *type;   
  char *name;   
  char *top;    
  char *bot;    
  char *pool;   
  int  nkern;   
  int  kx;      
  int  ky;      
  int  kz;      
  int  stride;  
  int  pad;     
  int  group;   
  int  out_xn;  
  int  out_yn;  
  int  out_zn;  
  float ****kern;  
  float *bias;     
  float ***kern1;  
  float ***r;      
  float ****rt;    
  int loc_size; 
  float alpha;  
  float beta;   
};
int         mod_dcn_xn;      
int         mod_dcn_yn;      
int         mod_dcn_zn;      
int         mod_dcn_tn;      
float       mod_dcn_tscale;  
float       mod_dcn_sscale;  
int mod_dcn_lay_n;  
struct dcn_layer_struct **mod_dcn_lay;    
int mod_dcn_maxli;  
float ***mod_dcn_tstim;  
int mod_dcn_rsize;  
char *mod_dcn_resp_3d_fname;
void mod_dcn_read_rgb_txt(infile)
     char *infile;
{
  FILE *fopen(),*fin;
  int i,j,k;
  int xn,yn,zn;
  float ***s;
  mylog(mylogf,"  MOD_DCN_READ_RGB_TXT\n");
  if ((fin = fopen(infile,"r"))==NULL){
    printf("  File:  %s\n",infile);
    exit_error("MOD_DCN_READ_RGB_TXT","Cannot open file");
  }
  fscanf(fin,"%d %d %d",&zn,&xn,&yn);
  printf("    Images size:  %d %d %d\n",xn,yn,zn);
  if ((xn != mod_dcn_xn) || (yn != mod_dcn_xn))
    exit_error("MOD_DCN_READ_RGB_TXT","Image size mis-match");
  if (zn != mod_dcn_lay[0]->kz)
    exit_error("MOD_DCN_READ_RGB_TXT","Image depth mis-match");
  s = get_3d_farray(zn,xn,yn);
  for(i=0;i<zn;i++){
    for(k=(yn-1);k>=0;k--){   
      for(j=0;j<xn;j++){      
	fscanf(fin,"%f",&(s[i][j][k]));
      }
    }
  }
  fclose(fin);
  if (0){
    float mean,sdev;
    printf("zn,xn,yn = %d  %d %d\n",zn,xn,yn);
    single_mean_sdev_2d_farray(s[0],xn,yn,&mean,&sdev);
    printf("mean 0:  %f  %f\n",mean,sdev);
    single_mean_sdev_2d_farray(s[1],xn,yn,&mean,&sdev);
    printf("mean 1:  %f  %f\n",mean,sdev);
    single_mean_sdev_2d_farray(s[2],xn,yn,&mean,&sdev);
    printf("mean 2:  %f  %f\n",mean,sdev);
    mean_3d_farray(s,zn,xn,yn,&mean);
    printf("mean overal:  %f\n",mean);
  }
  if (0){  
    s[0][20][10] = 256.0;
    s[1][20][10] = 256.0;
    s[2][20][10] = 256.0;
  }
  write_2d_data("zz.stim.0.2d",s[0],0,0,xn,yn,4,2,1,1);
  write_2d_data("zz.stim.1.2d",s[1],0,0,xn,yn,4,2,1,1);
  write_2d_data("zz.stim.2.2d",s[2],0,0,xn,yn,4,2,1,1);
  mod_dcn_tstim = s;
}
int mod_dcn_layi_for_name(name)
     char *name;
{
  int i,k;
  k = -1;
  i = 0;
  while((i < mod_dcn_lay_n) && (k == -1)){
    if (strcmp(mod_dcn_lay[i]->name,name)==0)
      k = i;
    i += 1;
  }
  return k;
}
struct dcn_layer_struct *mod_dcn_lay_for_name(name)
     char *name;
{
  int i;
  struct dcn_layer_struct *t;
  i = mod_dcn_layi_for_name(name);
  if (i < 0)
    t = NULL;
  else
    t = mod_dcn_lay[i];
  return t;
}
void mod_dcn_stat_kern(dl)
     struct dcn_layer_struct *dl;
{
  int i;
  int n,xn,yn,zn;
  float *kmu,mu,sd;
  printf("  MOD_DCN_STAT_KERN\n");
  n  = dl->nkern;
  xn = dl->kx;
  yn = dl->ky;
  zn = dl->kz;
  kmu = get_farray(n);
  for(i=0;i<n;i++)
    single_mean_3d_farray(dl->kern[i],0,zn,0,xn,0,yn,&(kmu[i]));
  mean_sdev_farray(kmu,n,&mu,&sd);
  printf("    %s   Mean, SD of kernel means:  %f %f\n",dl->name,mu,sd);
  mean_sdev_farray(dl->bias,n,&mu,&sd);
  printf("            Bias:  %f %f\n",mu,sd);
  myfree(kmu);
}
void mod_dcn_write_rgb_kernels(outfile)
     char *outfile;
{
  int i,j,k;
  int n,xn,yn,***d,**t;
  float **fr,**fg,**fb,r_min,r_max,g_min,g_max,b_min,b_max,min,max;
  struct dcn_layer_struct *dl;
  dl = mod_dcn_lay[0];
  xn = dl->kx;
  yn = dl->ky;
  n  = dl->nkern;
  d = get_3d_iarray(xn,yn,n);
  for(i=0;i<n;i++){
    fr = dl->kern[i][0];  
    fg = dl->kern[i][1];  
    fb = dl->kern[i][2];  
    get_min_max_2d_farray(fr,xn,yn,&r_min,&r_max);
    get_min_max_2d_farray(fg,xn,yn,&g_min,&g_max);
    get_min_max_2d_farray(fb,xn,yn,&b_min,&b_max);
    min = min_of_three(r_min,g_min,b_min);
    max = max_of_three(r_max,g_max,b_max);
    add_const_2d_farray(fr,0,xn,0,yn,-min);
    add_const_2d_farray(fg,0,xn,0,yn,-min);
    add_const_2d_farray(fb,0,xn,0,yn,-min);
    multiply_2d_farray(fr,xn,yn,1.0/(max-min));
    multiply_2d_farray(fg,xn,yn,1.0/(max-min));
    multiply_2d_farray(fb,xn,yn,1.0/(max-min));
    t = data_util_t11_2d_from_rgb(fr,fg,fb,xn,yn);
    for(j=0;j<xn;j++)
      for(k=0;k<yn;k++)
	d[j][k][i] = t[j][k];
    free_2d_iarray(t,xn);
  }
  write_3d_data_part(outfile,d,0,xn,0,yn,0,n,4,11,1); 
  free_3d_iarray(d,xn,yn,n);
}
void mod_dcn_write_kernel(outfile,lname,ki)
     char *outfile;  
     char *lname;    
     int ki;         
{
  int i,j,k;
  int n,xn,yn,zn,cnt,fpr,mar,nw,nh,w,h,xi,yi;
  float **d,tot;
  struct dcn_layer_struct *dl;
  mylog(mylogf,"  MOD_DCN_WRITE_KERNEL\n");
  fpr = 10;  
  mar = 2;   
  dl = mod_dcn_lay_for_name(lname);
  xn = dl->kx;
  yn = dl->ky;
  zn = dl->kz;
  n  = dl->nkern;
  if ((ki < 0) || (ki > dl->nkern)){
    printf("  Index:  %d is not in 0..%d\n",ki,dl->nkern-1);
    exit_error("MOD_DCN_WRITE__KERNEL","Bad kernel index");
  }
  printf("    Layer %s, kernel %d  (%d,%d,%d)\n",lname,ki,xn,yn,zn);
  nw = mymini(zn,fpr);  
  nh = (int)(zn / nw);  
  if (nw*nh < zn)
    nh += 1;
  w = xn*nw + (nw-1)*mar; 
  h = yn*nh + (nh-1)*mar; 
  d = get_zero_2d_farray(w,h);
  printf("    %d x %d frames\n",nw,nh);
  printf("    %d x %d pix image\n",w,h);
  xi = 0;
  yi = h-yn;
  cnt = 0;
  tot = 0.0;
  for(k=0;k<zn;k++){
    for(i=0;i<xn;i++){  
      for(j=0;j<yn;j++){
	d[xi+i][yi+j] = dl->kern[ki][k][i][j];
	tot += dl->kern[ki][k][i][j];
      }
    }
    xi += xn+mar;
    cnt += 1;
    if (cnt >= fpr){
      yi -= (yn+mar);
      xi = 0;
      cnt = 0;
    }
  }
  printf("    Total:  %f    Avg:  %f\n",tot,tot/(float)(zn*xn*yn));
  write_2d_data(outfile,d,0,0,w,h,4,2,1,1); 
  free_2d_farray(d,w);
}
void mod_dcn_write_3d_resp(outfile,dl)
     char *outfile;
     struct dcn_layer_struct *dl;
{
  int i,j,k;
  int zn,xn,yn;
  float ***d,**t;
  xn = dl->out_xn;
  yn = dl->out_yn;
  zn = dl->out_zn;
  if ((xn > 1) && (yn > 1)){
    d = get_3d_farray(xn,yn,zn);
    for(i=0;i<zn;i++){
      t = dl->r[i];
      for(j=0;j<xn;j++)
	for(k=0;k<yn;k++)
	  d[j][k][i] = t[j][k];
    }
    write_3d_data_part(outfile,d,0,xn,0,yn,0,zn,4,2,1); 
    free_3d_farray(d,xn,yn,zn);
  }
  printf("_______________ %s _________________\n",dl->name);
  if ((xn > 1) && (yn > 1)){
    t = dl->r[0];
    for(j=yn-1;j>(yn-1-5);j--){
      for(i=0;i<5;i++){
	printf(" %11.6f",t[i][j]);
      }
      printf("\n");
    }
  }else{
    t = dl->r[0];
    for(i=0;i<20;i++){
      if (strcmp(dl->type,"Softmax")==0){
	printf(" %5e",t[0][i]);
      }else{
	printf(" %11.6f",t[0][i]);
      }
      if ((i+1)%5 == 0)
	printf("\n");
    }
  }
}
void mod_dcn_read_weights(infile)
     char *infile;  
{
  FILE *fopen(),*fin;
  int i1,i2,i3,i4,n1,n2,n3,n4,sn,ndim,layi;
  float ***kp,**kp1,t,*td;
  char temp[SLEN],*tc,**slist,*lname,*dtype;
  struct dcn_layer_struct *lay;
  mylog(mylogf,"  MOD_DCN_READ_WEIGHTS\n");
  if ((fin = fopen(infile,"r"))==NULL)
    exit_error("MOD_DCN_READ_WEIGHTS","Cannot open file");
  tc = fgets(temp,SLEN,fin); 
  while(tc != NULL){
    printf("    %s",tc);  
    get_items_from_string(tc,&slist,&sn);
    ndim = sn - 3;
    lname = slist[1];  
    dtype = slist[2];  
    layi = mod_dcn_layi_for_name(lname);
    if (layi > mod_dcn_maxli){
      tc = NULL;
    }else{ 
      lay = mod_dcn_lay_for_name(lname);
      if (lay == NULL){
	printf("  Layer name:  %s\n",lname);
	exit_error("MOD_DCN_READ_WEIGHTS","Cannot find layer");
      }
      if (strcmp(dtype,"weights")==0){
	if (strcmp(lay->type,"Convolution")==0){
	  if (ndim != 4)
	    exit_error("MOD_DCN_READ_WEIGHTS","Convolution needs 4 values");
	  n1 = atoi(slist[3]);
	  n2 = atoi(slist[4]);
	  n3 = atoi(slist[5]);
	  n4 = atoi(slist[6]);
	  if (n1 != lay->nkern){
	    printf("  nkern = %d  n1 = %d\n",lay->nkern,n1);
	    exit_error("MOD_DCN_READ_WEIGHTS","nkernel does not match");
	  }
	  if (n2 != lay->kz){
	    printf("  kz = %d  n2 = %d\n",lay->kz,n2);
	    exit_error("MOD_DCN_READ_WEIGHTS","kz does not match");
	  }
	  if (n3 != lay->kx)
	    exit_error("MOD_DCN_READ_WEIGHTS","kx does not match");
	  if (n4 != lay->ky)
	    exit_error("MOD_DCN_READ_WEIGHTS","ky does not match");
	}else if (strcmp(lay->type,"InnerProduct")==0){
	  if (ndim != 2)
	    exit_error("MOD_DCN_READ_WEIGHTS","InnerProduct needs 2 values");
	  n1 = 1;
	  n2 = 1;
	  n3 = atoi(slist[3]);
	  n4 = atoi(slist[4]);
	  if (n3 != lay->kx)
	    exit_error("MOD_DCN_READ_WEIGHTS","InnProd: kx does not match");
	  if (n4 != lay->ky){
	    printf("n4 = %d   lay->ky = %d\n",n4,lay->ky);
	    exit_error("MOD_DCN_READ_WEIGHTS","InnProd: ky does not match");
	  }
	}
	printf("      %d dimensions\n",ndim);
	printf("      %d values to read\n",n1*n2*n3*n4);
	if (strcmp(lay->type,"InnerProduct")==0){
	  for(i3=0;i3<n3;i3++){  
	    td = lay->kern[0][0][i3];
	    for(i4=0;i4<n4;i4++){  
	      fscanf(fin,"%f",&(td[i4]));
	    }
	  }
	}else{
	  for(i1=0;i1<n1;i1++)
	    for(i2=0;i2<n2;i2++)
	      for(i4=(n4-1);i4>=0;i4--){
		for(i3=0;i3<n3;i3++)
		  fscanf(fin,"%f",&(lay->kern[i1][i2][i3][i4]));
	      }
	}
	if ((strcmp(lay->bot,"data")==0)&&(lay->kz == 3)){
	  printf("      ---> Preparing flattened RGB kernels.\n");
	  for(i1=0;i1<n1;i1++){
	    kp = lay->kern[i1];
	    kp1 = lay->kern1[i1];
	    for(i3=0;i3<n3;i3++)
	      for(i4=0;i4<n4;i4++)
		kp1[i3][i4] = kp[0][i3][i4] + kp[1][i3][i4] + kp[2][i3][i4];
	  }
	}
      }else if (strcmp(dtype,"biases")==0){
	n1 = atoi(slist[3]);
	if (strcmp(lay->type,"Convolution")==0){
	  if (n1 != lay->nkern)
	    exit_error("MOD_DCN_READ_WEIGHTS","Conv: bad bias count");
	}else if (strcmp(lay->type,"InnerProduct")==0){
	  if (n1 != lay->kx)
	    exit_error("MOD_DCN_READ_WEIGHTS","InnerProd: bad bias count");
	}
	printf("      %d values to read\n",n1);
	for(i1=0;i1<n1;i1++)
	  fscanf(fin,"%f",&(lay->bias[i1]));
      }else{
	printf("  Data type = %s\n",dtype);
	exit_error("MOD_DCN_READ_WEIGHTS","Unknown data type");
      }
      tc = fgets(temp,SLEN,fin); 
      tc = fgets(temp,SLEN,fin); 
    }
    free_2d_carray(slist,sn);
  }
  fclose(fin);
  mylog(mylogf,"    Done reading weight file.\n");
}
void mod_dcn_lay_set_size(dl,layo)
     struct dcn_layer_struct *dl;
     struct onode *layo;
{
  int zn,xn_in,yn_in;
  struct dcn_layer_struct *layin;
  if (strcmp(dl->bot,"data")==0){
    zn = mod_dcn_zn;
    xn_in = mod_dcn_xn;
    yn_in = mod_dcn_yn;
  }else{
    layin = mod_dcn_lay_for_name(dl->bot);
    if (layin == NULL){
      printf("  Bottom (input) name:  %s\n",dl->bot);
      exit_error("MOD_DCN_LAY_SET_SIZE","Cannot find layer");
    }
    zn = layin->out_zn / dl->group;
    xn_in = layin->out_xn;
    yn_in = layin->out_yn;
  }
  dl->kz = zn;
  if (strcmp(dl->type,"Convolution")==0){
    dl->out_xn = (int)((xn_in + 2*dl->pad - dl->kx) / dl->stride) + 1;
    dl->out_yn = dl->out_xn;
    dl->out_zn = dl->nkern;  
  }else if (strcmp(dl->type,"Pooling")==0){
    dl->out_xn = (int)((xn_in + 2*dl->pad - dl->kx) / dl->stride) + 1;
    dl->out_yn = dl->out_xn;
    dl->out_zn = zn;     
  }else if (strcmp(dl->type,"InnerProduct")==0){
    dl->out_zn = 1;
    dl->out_xn = 1;
    dl->out_yn = dl->nkern;  
    dl->kz = 1;
    dl->kx = dl->nkern;
    dl->ky = layin->out_xn * layin->out_yn * layin->out_zn;
  }else{
    dl->out_xn = xn_in;  
    dl->out_yn = yn_in;
    dl->out_zn = zn;     
  }
}
void mod_dcn_lay_common(dl,layo)
     struct dcn_layer_struct *dl;
     struct onode *layo;
{
  dl->name  = onode_getpar_chr_exit(layo,"name");
  dl->type  = onode_getpar_chr_exit(layo,"type");
  dl->bot   = onode_getpar_chr_exit(layo,"bottom");
  dl->top   = onode_getpar_chr_exit(layo,"top");
  dl->group  = 1;  
  dl->pad    = 0;  
  dl->stride = 1;  
  dl->kx     = 1;  
  dl->ky     = 1;  
}
void mod_dcn_prep_response()
{
  int i;
  int xn,yn,zn;
  struct dcn_layer_struct *dl;
  mylog(mylogf,"  MOD_DCN_PREP_RESPONSE\n");
  for(i=0;i<=mod_dcn_maxli;i++){
    dl = mod_dcn_lay[i];
    if (strcmp(dl->type,"InnerProduct")==0){
      xn = 1;
      yn = dl->kx;
      zn = 1;
    }else{
      xn = dl->out_xn;
      yn = dl->out_yn;
      zn = dl->out_zn;
    }
    dl->r  = get_3d_farray(zn,xn,yn);
    if (mod_dcn_tn > 1)
      dl->rt = get_4d_farray(zn,xn,yn,-1); 
    mod_dcn_rsize += zn * xn * yn;
    printf("    %6s %8d responses\n",dl->name,zn*xn*yn);
  }
  printf("    %6s %8d responses\n","Total",mod_dcn_rsize);
}
struct dcn_layer_struct *mod_dcn_prep_laytype_conv(m,lay)
     struct model_struct *m;   
     struct onode *lay;
{
  struct onode *opar;
  struct dcn_layer_struct *dl;
  mylog(mylogf,"  MOD_DCN_PREP_LAYTYPE_CONV\n");
  dl = (struct dcn_layer_struct *)myalloc(sizeof(struct dcn_layer_struct));
  mod_dcn_lay_common(dl,lay);  
  opar = onode_child_get_unique(lay,"param");
  if (opar == NULL)
    exit_error("MOD_DCN_PREP_LAYTYPE_CONV","Cannot find <param>.");
  dl->nkern  = onode_getpar_int_exit(opar,"num_output");
  dl->kx     = onode_getpar_int_exit(opar,"kernel_size");
  dl->ky     = dl->kx;
  dl->stride = onode_getpar_int_dflt(opar,"stride",1);
  dl->pad    = onode_getpar_int_dflt(opar,"pad",0);
  dl->group  = onode_getpar_int_dflt(opar,"group",1);
  mod_dcn_lay_set_size(dl,lay);  
  printf("    %s (layer %d)\n",dl->name,mod_dcn_lay_n);
  printf("    Kernels:  %d (%d,%d,%d)\n",dl->nkern,dl->kx,dl->ky,dl->kz);
  printf("    Stride:   %d\n",dl->stride);
  printf("    Padding:  %d\n",dl->pad);
  printf("    Output:   %d (%d,%d)\n",dl->out_zn,dl->out_xn,dl->out_yn);
  dl->kern = get_4d_farray(dl->nkern,dl->kz,dl->kx,dl->ky);
  dl->bias = get_farray(dl->nkern);
  if ((strcmp(dl->bot,"data")==0)&&(dl->kz == 3))
    dl->kern1 = get_3d_farray(dl->nkern,dl->kx,dl->ky);
  return dl;
}
struct dcn_layer_struct *mod_dcn_prep_laytype_relu(m,lay)
     struct model_struct *m;    
     struct onode *lay;
{
  struct dcn_layer_struct *dl;
  mylog(mylogf,"  MOD_DCN_PREP_LAYTYPE_RELU\n");
  dl = (struct dcn_layer_struct *)myalloc(sizeof(struct dcn_layer_struct));
  mod_dcn_lay_common(dl,lay);  
  mod_dcn_lay_set_size(dl,lay);  
  printf("    %s (layer %d)\n",dl->name,mod_dcn_lay_n);
  printf("    Output:   %d (%d,%d)\n",dl->out_zn,dl->out_xn,dl->out_yn);
  return dl;
}
struct dcn_layer_struct *mod_dcn_prep_laytype_pool(m,lay)
     struct model_struct *m;    
     struct onode *lay;
{
  struct onode *opar;
  struct dcn_layer_struct *dl;
  mylog(mylogf,"  MOD_DCN_PREP_LAYTYPE_POOL\n");
  dl = (struct dcn_layer_struct *)myalloc(sizeof(struct dcn_layer_struct));
  mod_dcn_lay_common(dl,lay);  
  opar = onode_child_get_unique(lay,"param");
  if (opar == NULL)
    exit_error("MOD_DCN_PREP_LAYTYPE_CONV","Cannot find <param>.");
  dl->kx     = onode_getpar_int_exit(opar,"kernel_size");
  dl->stride = onode_getpar_int_dflt(opar,"stride",1);
  dl->pool   = onode_getpar_chr_exit(opar,"pool");
  mod_dcn_lay_set_size(dl,lay);  
  printf("    %s (layer %d)\n",dl->name,mod_dcn_lay_n);
  printf("    Stride:   %d\n",dl->stride);
  printf("    Padding:  %d\n",dl->pad);
  printf("    Output:   %d (%d,%d)\n",dl->out_zn,dl->out_xn,dl->out_yn);
  return dl;
}
struct dcn_layer_struct *mod_dcn_prep_laytype_iprod(m,lay)
     struct model_struct *m;    
     struct onode *lay;
{
  struct onode *opar;
  struct dcn_layer_struct *dl;
  mylog(mylogf,"  MOD_DCN_PREP_LAYTYPE_IPROD\n");
  dl = (struct dcn_layer_struct *)myalloc(sizeof(struct dcn_layer_struct));
  mod_dcn_lay_common(dl,lay);  
  opar = onode_child_get_unique(lay,"param");
  if (opar == NULL)
    exit_error("MOD_DCN_PREP_LAYTYPE_IPROD","Cannot find <param>.");
  dl->nkern     = onode_getpar_int_exit(opar,"num_output");
  mod_dcn_lay_set_size(dl,lay);  
  printf("    %s (layer %d)\n",dl->name,mod_dcn_lay_n);
  printf("    Kernels:  %d (%d,%d,%d)\n",dl->nkern,dl->kx,dl->ky,dl->kz);
  printf("    Output:   %d (%d,%d)\n",dl->out_zn,dl->out_xn,dl->out_yn);
  dl->kern = get_4d_farray(1,dl->kz,dl->kx,dl->ky); 
  dl->bias = get_farray(dl->kx);
  return dl;
}
struct dcn_layer_struct *mod_dcn_prep_laytype_lrn(m,lay)
     struct model_struct *m;    
     struct onode *lay;
{
  struct onode *opar;
  struct dcn_layer_struct *dl;
  mylog(mylogf,"  MOD_DCN_PREP_LAYTYPE_LRN\n");
  dl = (struct dcn_layer_struct *)myalloc(sizeof(struct dcn_layer_struct));
  mod_dcn_lay_common(dl,lay);  
  opar = onode_child_get_unique(lay,"param");
  if (opar == NULL)
    exit_error("MOD_DCN_PREP_LAYTYPE_LRN","Cannot find <param>.");
  dl->loc_size  = onode_getpar_int_exit(opar,"local_size");
  dl->alpha     = onode_getpar_flt_exit(opar,"alpha");
  dl->beta      = onode_getpar_flt_exit(opar,"beta");
  if ((dl->loc_size % 2) != 1)
    exit_error("MOD_DCN_PREP_LAYTYPE_LRN","Expecting 'loc_size' to be odd");
  mod_dcn_lay_set_size(dl,lay);  
  printf("    %s (layer %d)\n",dl->name,mod_dcn_lay_n);
  printf("    Output:   %d (%d,%d)\n",dl->out_zn,dl->out_xn,dl->out_yn);
  return dl;
}
struct dcn_layer_struct *mod_dcn_prep_laytype_sftmx(m,lay)
     struct model_struct *m;    
     struct onode *lay;
{
  struct dcn_layer_struct *dl;
  mylog(mylogf,"  MOD_DCN_PREP_LAYTYPE_SFTMX\n");
  dl = (struct dcn_layer_struct *)myalloc(sizeof(struct dcn_layer_struct));
  mod_dcn_lay_common(dl,lay);  
  mod_dcn_lay_set_size(dl,lay);  
  printf("    %s (layer %d)\n",dl->name,mod_dcn_lay_n);
  printf("    Output:   %d (%d,%d)\n",dl->out_zn,dl->out_xn,dl->out_yn);
  return dl;
}
void mod_dcn_01_prep(m,s,r)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
{
  int i,k;
  int n,xn,yn,tn,kmax;
  float tscale,sscale;
  char *laytype,*wfname,*stimfile;
  struct onode *fito,*s1o,*c1o,*s2o,*c2o,*t;
  myid = mylog_set_id_log(m->process_id,&mylogf);  
  mylog(mylogf,"  MOD_DCN_01_PREP\n");
  xn     = mod_dcn_xn     = onode_getpar_int_exit(m->o,"xn");
  yn     = mod_dcn_yn     = onode_getpar_int_exit(m->o,"yn");
  tn     = mod_dcn_tn     = onode_getpar_int_exit(m->o,"tn");
  tscale = mod_dcn_tscale = onode_getpar_flt_exit(m->o,"tscale");
  sscale = mod_dcn_sscale = onode_getpar_flt_exit(m->o,"sscale");
  mod_dcn_zn              = onode_getpar_int_exit(m->o,"stim_depth");
  n = onode_count_otype(m->o,"layer");
  printf("    %d layers\n",n);
  mod_dcn_lay = (struct dcn_layer_struct **)
    myalloc(n*sizeof(struct dcn_layer_struct *));
  mod_dcn_rsize = 0;  
  mod_dcn_lay_n = 0;  
  k = 0;
  t = onode_get_next_type(m->o->o,"layer");
  while(t != NULL){
    laytype = onode_getpar_chr_exit(t,"type");
    if (strcmp(laytype,"Convolution")==0){
      mod_dcn_lay[k] = mod_dcn_prep_laytype_conv(m,t);
    }else if (strcmp(laytype,"ReLU")==0){
      mod_dcn_lay[k] = mod_dcn_prep_laytype_relu(m,t);
    }else if (strcmp(laytype,"Pooling")==0){
      mod_dcn_lay[k] = mod_dcn_prep_laytype_pool(m,t);
    }else if (strcmp(laytype,"InnerProduct")==0){
      mod_dcn_lay[k] = mod_dcn_prep_laytype_iprod(m,t);
    }else if (strcmp(laytype,"LRN")==0){
      mod_dcn_lay[k] = mod_dcn_prep_laytype_lrn(m,t);
    }else if (strcmp(laytype,"Softmax")==0){
      mod_dcn_lay[k] = mod_dcn_prep_laytype_sftmx(m,t);
    }else{
      printf("  laytype = %s\n",laytype);
      exit_error("MOD_DCN_01_PREP","Unknown layer type.");
    }
    k += 1;
    mod_dcn_lay_n = k;  
    t = onode_get_next_type(t->next,"layer");
  }
  kmax = -1;
  for(i=0;i<r->n;i++){ 
    if ((r->rformat[i] == 1) || 
	(r->rformat[i] == 2)){  
      k = mod_dcn_layi_for_name(r->plname[i]);
      if (k < 0){
	printf("  Layer name:  %s\n",r->plname[i]);
	exit_error("MOD_DCN_01_PREP","Layer name not found");
      }
      if (k > kmax)
	kmax = k;
    }
  }
  mod_dcn_maxli = kmax;
  printf("  Deepest level required for response request:  %d\n",kmax);
  mod_dcn_prep_response();
  wfname = onode_getpar_chr_exit(m->o,"weight_filename");
  mod_dcn_read_weights(wfname);
  for(i=0;i<mod_dcn_maxli;i++){
    if (strcmp(mod_dcn_lay[i]->type,"Convolution")==0){
      mod_dcn_stat_kern(mod_dcn_lay[i]);
    }
  }
  {
    int xflag;
    char *outfile;
    char *lname;
    char *tstr;
    xflag = 0;  
    outfile  = onode_getpar_chr_dflt(m->o,"write_kernels_rgb",NULL);
    if (outfile != NULL){
      mod_dcn_write_rgb_kernels(outfile);
      xflag = 1;
    }
    t = onode_get_next_type(m->o->o,"item");
    while(t != NULL){
      if (strcmp(t->name,"write_kernel_conv")==0){
	printf("  Name:  %s\n",t->name);
	lname   = onode_get_nth_val(t,0);
	tstr    = onode_get_nth_val(t,1);
	outfile = onode_get_nth_val(t,2);
	mod_dcn_write_kernel(outfile,lname,atoi(tstr));
	myfree(lname);
	myfree(tstr);
	myfree(outfile);
	xflag = 1;
      }
      t = onode_get_next_type(t->next,"item");
    }
    if (xflag == 1){
      printf("  Exiting after writing output files for checking.\n\n");
      exit(0);
    }
  }
  stimfile = onode_getpar_chr_dflt(m->o,"stim_filename",NULL);
  if (stimfile != NULL)
    mod_dcn_read_rgb_txt(stimfile);
  else
    mod_dcn_tstim = NULL;
  mod_dcn_resp_3d_fname = onode_getpar_chr_dflt(m->o,"write_3d_resp",NULL);
}
void mod_dcn_01_done(m)
     struct model_struct *m;        
{
  mylog(mylogf,"  MOD_DCN_01_DONE\n");
}
void mod_dcn_resp_tsave(r,ti)
     struct response_struct *r;  
     int ti;                     
{
  int i;
  int xi,yi,zi,tn;
  float fval;
  struct dcn_layer_struct *lay;
  tn = mod_dcn_tn;
  for(i=0;i<r->n;i++){ 
    if ((r->rformat[i] == 1) ||  
	(r->rformat[i] == 2)){   
      lay = mod_dcn_lay_for_name(r->plname[i]);
      if (lay == NULL){
	printf("  Layer name:  %s\n",r->plname[i]);
	exit_error("MOD_DCN_RESP_TSAVE","Layer name not found");
      }
      xi = r->xi[i];
      yi = r->yi[i];
      zi = r->zi[i];
      fval = lay->r[zi][xi][yi];
    }else{
      printf("  Response format:  %d\n",r->rformat[i]);
      exit_error("MOD_DCN_RESP_TSAVE","Format not implemented");
    }
    if (lay->rt[zi][xi][yi] == NULL) 
      lay->rt[zi][xi][yi] = get_farray(tn);
    lay->rt[zi][xi][yi][ti] = fval;  
  }
}
void mod_dcn_handover(r)
     struct response_struct *r; 
{
  int i;
  int xi,yi,zi,tn;
  float tscale,fval,*t;
  struct dcn_layer_struct *lay;
  tscale = mod_dcn_tscale;
  tn     = mod_dcn_tn;
  for(i=0;i<r->n;i++){ 
    t = NULL;
    if ((r->rformat[i] == 1) ||  
	(r->rformat[i] == 2)){   
      lay = mod_dcn_lay_for_name(r->plname[i]);
      if (lay == NULL){
	printf("  Layer name:  %s\n",r->plname[i]);
	exit_error("MOD_DCN_HANDOVER","Layer name not found");
      }
      xi = r->xi[i];
      yi = r->yi[i];
      zi = r->zi[i];
      if (tn == 1)
	fval = lay->r[zi][xi][yi];  
      else
	t = lay->rt[zi][xi][yi];     
    }else{
      printf("  Response format:  %d\n",r->rformat[i]);
      exit_error("MOD_DCN_HANDOVER","Format not implemented");
    }
    if (tn == 1){
      t = get_const_farray(tn,fval);
      mod_util_resp_store_f_samp(r,i,t,tn,1.0/tscale,mylogf);
      myfree(t);
    }else{
      mod_util_resp_store_f_samp(r,i,t,tn,1.0/tscale,mylogf);
    }
  }
}
float ***mod_dcn_get_padded_r(layin,pad)
     struct dcn_layer_struct *layin;   
     int pad;
{
  int i,j,k;
  int xn,zn,xnp,xn2p;
  float ***d,**t,**tin;
  zn   = layin->out_zn;
  xn   = layin->out_xn;
  if (layin->out_xn != layin->out_yn)
    exit_error("MOD_DCN_GET_PADDED_R","xn != yn");
  xnp  = xn + pad;
  xn2p = xn + 2*pad;
  d = get_3d_farray(zn,xn2p,xn2p);
  for(i=0;i<zn;i++){
    t = d[i];
    for(j=0;j<pad;j++){
      for(k=0;k<xnp;k++){
	t[k][j]         = 0.0;  
	t[j][k+pad]     = 0.0;  
	t[k+pad][j+xnp] = 0.0;  
	t[j+xnp][k]     = 0.0;  
      }
    }
  }
  for(i=0;i<zn;i++){
    t = d[i];
    tin = layin->r[i];
    for(j=0;j<xn;j++){
      for(k=0;k<xn;k++){
	t[pad+j][pad+k] = tin[j][k];
      }
    }
  }
  return d;
}
void mod_dcn_getresp_conv(dl,stim)
     struct dcn_layer_struct *dl;   
     float ***stim;                 
{
  int i,j;
  int ki,kx,ky,kz,nk,nx,ny,nz,ndp_x,ndp_y,stride,x0,y0,z0,pad,grp_sz,inz,cnt;
  int ngr;
  float ***kern,**kp1,***d,tot,**s,bias;
  struct dcn_layer_struct *layin;
  ndp_x  = dl->out_xn;  
  ndp_y  = dl->out_yn;  
  nx     = dl->kx;      
  ny     = dl->ky;      
  nz     = dl->kz;      
  nk     = dl->nkern;   
  stride = dl->stride;  
  pad    = dl->pad;     
  if ((strcmp(dl->bot,"data")==0) && (mod_dcn_tstim == NULL)){
    if (pad != 0)
      exit_error("MOD_DCN_GETRESP_CONV","Padding not implemented on stimulus");
    s = stim[0];
    for(ki=0;ki<nk;ki++){  
      kp1 = dl->kern1[ki];  
      x0 = 0;  
      y0 = 0;  
      for(i=0;i<ndp_x;i++){
	for(j=0;j<ndp_y;j++){  
	  tot = 0.0;
	  for(kx=0;kx<nx;kx++){
	    for(ky=0;ky<ny;ky++){
	      tot += kp1[kx][ky] * s[x0+kx][y0+ky];
	    }
	  }
	  dl->r[ki][i][j] = tot;  
	  y0 += stride;  
	}
	x0 += stride;  
	y0 = 0;  
      }
    }
  }else{  
    if (strcmp(dl->bot,"data")==0){  
      d = mod_dcn_tstim;
      inz = mod_dcn_zn;
    }else{
      layin = mod_dcn_lay_for_name(dl->bot);
      if (pad == 0){
	d = layin->r;
      }else{
	d = mod_dcn_get_padded_r(layin,pad);
      }
      inz = layin->out_zn;
    }
    ngr = inz/nz;  
    if (ngr != dl->group)
      exit_error("MOD_DCN_GETRESP_CONV","Group size error");
    grp_sz = dl->nkern/ngr;
    cnt = 0;  
    z0 = 0;   
    for(ki=0;ki<nk;ki++){  
      kern = dl->kern[ki];  
      bias = dl->bias[ki];  
      if (cnt >= grp_sz){  
	z0 += nz;  
	cnt = 0;
      }
      x0 = 0;  
      y0 = 0;
      for(i=0;i<ndp_x;i++){    
	for(j=0;j<ndp_y;j++){  
	  tot = 0.0;
	  for(kx=0;kx<nx;kx++){
	    for(ky=0;ky<ny;ky++){
	      for(kz=0;kz<nz;kz++){
		tot += kern[kz][kx][ky] * d[z0+kz][x0+kx][y0+ky];
	      }
	    }
	  }
	  dl->r[ki][i][j] = tot + bias;  
	  y0 += stride;  
	}
	x0 += stride;  
	y0 = 0;        
      }
      cnt += 1;
    }
    if (pad > 0)
      free_3d_farray(d,nz,nx+2*pad,nx+2*pad);
  }
}
void mod_dcn_getresp_relu(dl,stim)
     struct dcn_layer_struct *dl;   
     float ***stim;                 
{
  int i,j,k;
  int xn,yn,zn;
  float ***d,***r;
  struct dcn_layer_struct *layin;
  xn = dl->out_xn;
  yn = dl->out_yn;
  zn = dl->out_zn;
  layin = mod_dcn_lay_for_name(dl->bot);
  if ((layin->out_xn != xn) || (layin->out_yn != yn) || (layin->out_zn != zn))
    exit_error("MOD_DCN_GETRESP_RELU","Input / Output size mismatch");
  d = layin->r;
  r = dl->r;
  for(i=0;i<zn;i++){
    for(j=0;j<xn;j++){
      for(k=0;k<yn;k++){
	if (d[i][j][k] < 0.0)
	  r[i][j][k] = 0.0;
	else
	  r[i][j][k] = d[i][j][k];
      }
    }
  }
}
void mod_dcn_getresp_pool(dl,stim)
     struct dcn_layer_struct *dl;   
     float ***stim;                 
{
  int i,j,k;
  int pi,pj,xn,yn,zn,kx,ky,xi,yi,stride;
  float ***d,***r,**t,max;
  struct dcn_layer_struct *layin;
  kx = dl->kx;
  ky = dl->kx;
  stride = dl->stride;
  if (strcmp(dl->pool,"MAX")!=0)
    exit_error("MOD_DCN_GETRESP_POOL","Pooling type must be 'MAX'");
  xn = dl->out_xn;
  yn = dl->out_yn;
  zn = dl->out_zn;
  layin = mod_dcn_lay_for_name(dl->bot);
  d = layin->r;
  r = dl->r;
  for(i=0;i<zn;i++){
    t = d[i];  
    xi = 0;
    yi = 0;
    for(j=0;j<xn;j++){
      for(k=0;k<yn;k++){
	max = t[xi][yi];  
	for(pi=0;pi<kx;pi++){
	  for(pj=0;pj<ky;pj++){
	    if (t[xi+pi][yi+pj] > max)
	      max = t[xi+pi][yi+pj];
	  }
	}
	r[i][j][k] = max;
	yi += stride;
      }
      xi += stride;
      yi = 0;
    }
  }
}
void mod_dcn_getresp_lrn(dl,stim)
     struct dcn_layer_struct *dl;   
     float ***stim;                 
{
  int i,j,k;
  int zi,z0,z1,xn,yn,zn,lsize,zoff;
  float ***d,***r,alpha,beta,ac,tot;
  struct dcn_layer_struct *layin;
  xn = dl->out_xn;
  yn = dl->out_yn;
  zn = dl->out_zn;
  lsize = dl->loc_size;
  alpha = dl->alpha;
  beta  = dl->beta;
  ac = alpha / (float)lsize;  
  zoff = lsize/2;
  layin = mod_dcn_lay_for_name(dl->bot);
  d = layin->r;
  r = dl->r;
  for(i=0;i<zn;i++){
    z0 = i-zoff;
    if (z0 < 0)
      z0 = 0;
    z1 = i+zoff;
    if (z1 >= zn)
      z1 = (zn-1);
    for(j=0;j<xn;j++){
      for(k=0;k<yn;k++){
	tot = 0.0;
	for(zi=z0;zi<=z1;zi++){
	  tot += d[zi][j][k] * d[zi][j][k];
	}
	r[i][j][k] = d[i][j][k] / (float)pow(1.0 + ac*tot,beta);
	if (0){
	  if ((i==0) && (j == 0) && (k == yn-1)){
	    printf("   Tot:  %f   beta,alpha  %f %f\n",tot,beta,alpha);
	    printf("   Norm:  %f --> %f\n",d[i][j][k],r[i][j][k]);
	  }
	}
      }
    }
  }
}
void mod_dcn_getresp_inprod(dl,stim)
     struct dcn_layer_struct *dl;   
     float ***stim;                 
{
  int i,j,k;
  int ki,inx,iny,inz,kk,nkern,tn;
  float tot,*kdata,*t;
  struct dcn_layer_struct *layin;
  nkern = dl->kx;
  layin = mod_dcn_lay_for_name(dl->bot);
  inx = layin->out_xn;
  iny = layin->out_yn;
  inz = layin->out_zn;
  tn = inx * iny * inz;
  if (dl->ky != tn)
    exit_error("MOD_DCN_GETRESP_INPROD","Kernel size mismatch");
  if ((inz == 1) && (inx == 1) && (iny == dl->ky)){
    t = layin->r[0][0];
  }else{
    t = get_farray(tn);
    kk = 0;
    for(k=0;k<inz;k++){
      for(j=(iny-1);j>=0;j--){
	for(i=0;i<inx;i++){
	  t[kk] = layin->r[k][i][j];
	  kk += 1;
	}
      }
    }
  }
  for(ki=0;ki<nkern;ki++){  
    kdata = dl->kern[0][0][ki];  
    tot = 0.0;
    for(i=0;i<tn;i++)
      tot += t[i] * kdata[i];
    dl->r[0][0][ki] = tot + dl->bias[ki];
  }
  if ((inz == 1) && (inx == 1) && (iny == dl->ky))
    ;
  else
    myfree(t);
}
void mod_dcn_getresp_sftmax(dl,stim)
     struct dcn_layer_struct *dl;   
     float ***stim;                 
{
  int i;
  int n,maxi;
  float *d,*tr,tot,vmax;
  struct dcn_layer_struct *layin;
  layin = mod_dcn_lay_for_name(dl->bot);
  if ((layin->out_zn != 1) || (layin->out_xn != 1))
    exit_error("MOD_DCN_GETRESP_SFTMAX","Expecting 1D input");
  n = layin->out_yn;
  d = layin->r[0][0];
  tr = dl->r[0][0];
  printf("    n = %d\n",n);
  vmax = max_of_farray(d,n);
  printf("    vmax = %f\n",vmax);
  tot = 0.0;
  for(i=0;i<n;i++)
    tot += exp(d[i] - vmax);
  printf("    tot = %f\n",tot);
  for(i=0;i<n;i++)
    tr[i] = exp(d[i] - vmax) / tot;
  maxi = max_index_farray(tr,n);
  printf("    max_index = %d\n",maxi);
  printf("    max_value = %f\n",tr[maxi]);
}
void mod_dcn_01_get_response(m,s,r)
     struct model_struct *m;        
     struct stim_struct *s;         
     struct response_struct *r;     
{
  int i,j;
  int xn,yn,tn,ti;
  float ***stim;
  char outfile[SLEN];
  struct dcn_layer_struct *dl;
  xn = mod_dcn_xn;
  yn = mod_dcn_yn;
  tn = mod_dcn_tn;
  stim = get_3d_farray(1,xn,yn);
  for(ti=0;ti<tn;ti++){  
    for(i=0;i<xn;i++){
      for(j=0;j<yn;j++){
	stim[0][i][j] = s->d[i+1][j+1][ti+1];  
      }
    }
    printf("   "); fflush(stdout);
    for(i=0;i<=mod_dcn_maxli;i++){  
      dl = mod_dcn_lay[i];
      if (strcmp(dl->type,"Convolution")==0){
	mod_dcn_getresp_conv(dl,stim);
      }else if (strcmp(dl->type,"ReLU")==0){
	mod_dcn_getresp_relu(dl,stim);
      }else if (strcmp(dl->type,"Pooling")==0){
	mod_dcn_getresp_pool(dl,stim);
      }else if (strcmp(dl->type,"LRN")==0){
	mod_dcn_getresp_lrn(dl,stim);
      }else if (strcmp(dl->type,"InnerProduct")==0){
	mod_dcn_getresp_inprod(dl,stim);
      }else if (strcmp(dl->type,"Softmax")==0){
	mod_dcn_getresp_sftmax(dl,stim);
      }else{
	printf("  Layer type:  %s\n",dl->type);
	exit_error("MOD_DCN_01_GET_RESPONSE","Unknown layer type.");
      }
      printf(" %s",dl->name); fflush(stdout);
      if (mod_dcn_resp_3d_fname != NULL){
	if (strcmp(mod_dcn_resp_3d_fname,"NULL")!=0){
	  sprintf(outfile,"%s.%s.3d",mod_dcn_resp_3d_fname,dl->name);
	  mod_dcn_write_3d_resp(outfile,dl);
	}
      }
    }
    if (tn > 1){
      mod_dcn_resp_tsave(r,ti);
    }
    printf("\n");
  }
  free_3d_farray(stim,1,xn,yn);
  mod_dcn_handover(r);
}
void mod_dcn_run_01(m,s,r,action)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
     int action;                
{
  myid = mylog_set_id_log(m->process_id,&mylogf);  
  numproc = m->process_n;
  mod_dcn_action = action;
  if ((action == 0) || (action == 2) || (action == 10)){
    mod_dcn_01_prep(m,s,r);
  }else if (action == 1){
    mod_dcn_01_get_response(m,s,r);
  }else if (action == -1){
    mod_dcn_01_done(m);
  }
}
