/*C  (C) Copyright  Wyeth Bair 1993-2010                                     */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <GL/glx.h>
#include <GL/gl.h>  
#include "my_util.h"
#include "nr_util.h"
#include "carray_util.h"
#include "iarray_util.h"
#include "farray_util.h"
#include "func_util.h"
#include "myrand_util.h"
#include "data_util.h"
#include "paramfile_util.h"
#include "glplot_util.h"
#include "retina_util.h"
#include "stim_util.h"
#include "mod_util.h"
#include "ifc_util.h"
#include "mod_gui_util.h"
#include "pop_util.h"
#include "mod.h"
#include "paramfile.h"
#include "ifc.h"
static int myid = -1;       
static char *mylogf = NULL; 
char ggstr[LONG_SLEN];      
int mod_mesh_prep_flag = 0;  
char *mod_mesh_out_prefix;  
int mod_mesh_reset;         
char *mod_mesh_replay_file; 
int mod_mesh_type;          
int mod_mesh_w;             
int mod_mesh_h;             
int mod_mesh_tmax;          
int mod_mesh_tn;            
float mod_mesh_tscale;      
float mod_mesh_sscale;      
float mod_mesh_dt;          
float mod_mesh_h2_dt;       
int   mod_mesh_nstep;       
int   mod_mesh_h2_nstep;       
float mod_mesh_dx;          
float mod_mesh_csig;        
float mod_mesh_csig_normw;  
float mod_mesh_csig_min;    
int   mod_mesh_gcs_code;    
int   mod_mesh_gcs_distr;   
float mod_mesh_gcs_prob;    
int   mod_mesh_gcs_seed;    
int   mod_mesh_gcs_n;       
float mod_mesh_whc;         
float mod_mesh_w_h1_s;      
float mod_mesh_w_h2_s;      
float mod_mesh_w_h1_lm;     
float mod_mesh_w_h2_lm;     
float mod_mesh_off_flag;    
float mod_mesh_m_csig;      
float mod_mesh_m_csig_min;  
char *mod_mesh_sgen;        
int   mm_stim_override;     
int   mm_stim_overdel;      
int   mm_stim_overzci;      
char *mm_stim_overbin;      
int mod_mesh_gain_hpflag;   
float *mod_mesh_lp_mask;    
int mod_mesh_lpmn;          
float mod_mesh_lptau;       
float *mod_mesh_lp2_mask;   
int mod_mesh_lp2mn;         
float mod_mesh_lp2tau;      
float mod_mesh_gsig_slope;  
float mod_mesh_gsig_mean;   
float mod_mesh_gain_g2in;   
float *mod_mesh_gain1;      
float *mod_mesh_gain2;      
int mm_mosaic_flag;         
int mm_mosaic_gui;          
int mm_mosaic_out_id;       
int mm_mosaic_cn;           
int *mm_mosaic_cid;         
float *mm_mosaic_cx;        
float *mm_mosaic_cy;        
int *mm_mosaic_cwi;         
int *mm_mosaic_cwj;         
float **mm_mosaic_cww;      
float **mm_mosaic_cex;      
float **mm_mosaic_gin;      
float mm_fsr,mm_fsg,mm_fsb; 
float mm_fmr,mm_fmg,mm_fmb; 
float mm_flr,mm_flg,mm_flb; 
float mm_mosaic_csizepix;   
float mm_mosaic_tsizepix;   
float mm_mosaic_dens_mm;    
float mm_mosaic_dens_deg;   
float mm_mosaic_degpmm;     
float mm_mosaic_noise;      
char *mm_mosaic_arrgn;      
int   mm_mosaic_hex_w;      
int   mm_mosaic_hex_h;      
int    *mm_mosaic_bps_n;    
int   **mm_mosaic_bps_i;    
float **mm_mosaic_bps_w;    
int   **mm_edge6_cid;       
double **mm_edge6_dist;     
int    *mm_edge6_n;         
int     mm_edge_n;          
int    *mm_edge_0;          
int    *mm_edge_1;          
double *mm_edge_w;          
int mod_mesh_ph_tmask_n;    
float *mod_mesh_ph_tmask;   
float mod_mesh_qno_f;       
int   mod_mesh_h2_flag;     
float mod_mesh_gh; 
float mod_mesh_gp; 
float mod_mesh_h2_gh; 
float mod_mesh_h2_gp; 
float mod_mesh_cc; 
float *mod_mesh_hcw;        
float mod_mesh_h1cw[3];     
float mod_mesh_h2cw[3];     
float ***mod_mesh_stim; 
float **mod_mesh_ts1;
float **mod_mesh_ts2;
float *mod_mesh_a; 
float *mod_mesh_b;
float *mod_mesh_c;
float *mod_mesh_r;
float ***mod_mesh_u;      
float **mod_mesh_uo;
float **mod_mesh_un;
float *mod_mesh_tcol;
float **mod_mesh_hirr;    
float **mod_mesh_h2rr;    
float ***mod_mesh_diff = NULL;   
float  **mod_mesh_diffm = NULL;  
float **mod_mesh_ad1;     
float  *mod_mesh_ad1m;    
float mod_mesh_ad1_tau;   
float mod_mesh_ad1_c;     
float mod_mesh_ad1_a;     
int   mod_mesh_ad1_t0;    
float mod_mesh_ad1_init_l;  
float mod_mesh_ad1_init_m;  
float mod_mesh_ad1_init_s;  
float mod_mesh_m_ad1_tau; 
float mod_mesh_m_ad1_c;   
float mod_mesh_m_ad1_a;   
int   mod_mesh_disp;      
float mod_mesh_zoom;      
int mod_mesh_dispn;       
float mod_mesh_min;       
float mod_mesh_max;       
char *mod_mesh_outtype;   
char *mod_mesh_dump_type; 
char *mod_mesh_dump_file; 
int   mod_mesh_dump_cid;  
float mod_mesh_dump_tsec; 
int   mod_mesh_dumpp;     
int   mod_mesh_dump;      
int   mod_mesh_dump_hex;  
int   mod_mesh_slice_ti;  
int   mod_mesh_slice_xi;  
char *mod_mesh_dumpf;     
char *mod_mesh_dumps;     
void model_mesh_mosaic_get_ijw_for_cid(cid,rti,rtj,rw0,rw1,rw2,rw3)
     int cid;
     int *rti,*rtj;
     float *rw0,*rw1,*rw2,*rw3;
{
  *rti = mm_mosaic_cwi[cid];
  *rtj = mm_mosaic_cwj[cid];
  *rw0 = mm_mosaic_cww[cid][0];
  *rw1 = mm_mosaic_cww[cid][1];
  *rw2 = mm_mosaic_cww[cid][2];
  *rw3 = mm_mosaic_cww[cid][3];
}
float *mod_mesh_resp_get_h(mi,xi,yi,hi)
     int mi;  
     int xi;  
     int yi;  
     int hi;  
{
  int i;
  int ti,tj,tn;
  float w0,w1,w2,w3,*t,***u;
  tn = mod_mesh_tn;
  u  = mod_mesh_u;
  t = get_farray(tn);
  if (mm_mosaic_flag == 1){
    if (mod_mesh_type == 0){
      if (hi != 0) 
	exit_error("MOD_MESH_RESP_GET_H","Not yet implemented for non H1");
      model_mesh_mosaic_get_ijw_for_cid(mi,&ti,&tj,&w0,&w1,&w2,&w3);
      for(i=0;i<tn;i++){
	t[i] = (w0*u[i][ti  ][tj  ] + w1*u[i][ti+1][tj  ] + 
		w2*u[i][ti  ][tj+1] + w3*u[i][ti+1][tj+1]);
      }
    }else{
      if (hi == 1){
	for(i=0;i<tn;i++){
	  t[i] = mod_mesh_h2rr[mi][i];
	}
      }else{
	for(i=0;i<tn;i++){
	  t[i] = mod_mesh_hirr[mi][i];
	}
      }
    }
  }else{
    exit_error("MOD_MESH_RESP_GET_H","Not imp'd yet");
  }
  return t;
}
int mod_mesh_get_mm_mosaic_cn(){
  return mm_mosaic_cn;
}
int *mod_mesh_ptr_mm_mosaic_cid(){
  return mm_mosaic_cid;
}
float *mod_mesh_ptr_mm_mosaic_cx(){
  return mm_mosaic_cx;
}
float *mod_mesh_ptr_mm_mosaic_cy(){
  return mm_mosaic_cy;
}
float mod_mesh_get_mm_mosaic_dens_mm(){
  return mm_mosaic_dens_mm;
}
float mod_mesh_get_mm_mosaic_dens_deg(){
  return mm_mosaic_dens_deg;
}
float mod_mesh_get_mm_mosaic_degpmm(){
  return mm_mosaic_degpmm;
}
float *mod_mesh_get_mm_resp(xi,yi,zi,dtype,rn,rsamp)
     int xi;        
     int yi;        
     int zi;        
     char *dtype;   
     int *rn;       
     float *rsamp;  
{
  int tn;
  float *d;
  tn = mod_mesh_tn;
  if (mm_mosaic_flag == 1){
    if ((xi >= 0) && (xi < mm_mosaic_cn) && (yi == 0)){
      if (strcmp(dtype,"photo")==0){
	d = copy_farray(mm_mosaic_cex[xi],tn);
      }else if (strcmp(dtype,"horiz")==0){
	d = mod_mesh_resp_get_h(xi,-1,-1,0);
      }else if (strcmp(dtype,"h2")==0){
	d = mod_mesh_resp_get_h(xi,-1,-1,1);
      }else if (strcmp(dtype,"diff")==0){
	d = copy_farray(mod_mesh_diffm[xi],tn);
      }else
	exit_error("MOD_MESH_GET_MM_RESP","Unknown data type");
    }else{
      exit_error("MOD_MESH_GET_MM_RESP","Bad mosaic index");
    }
  }else{
    if ((xi >= 0) && (xi < mod_mesh_w) && (yi >= 0) && (yi < mod_mesh_h)){
      if (strcmp(dtype,"photo")==0){
	d = copy_farray(mod_mesh_stim[xi][yi],tn);
      }else if (strcmp(dtype,"horiz")==0){
	d = mod_mesh_resp_get_h(-1,xi,yi,0);
      }else if (strcmp(dtype,"diff")==0){
	d = copy_farray(mod_mesh_diff[xi][yi],tn);
      }else
	exit_error("MOD_MESH_GET_MM_RESP","Unknown data type");
    }else{
      exit_error("MOD_MESH_GET_MM_RESP","Bad grid index");
    }
  }
  *rn = tn;
  *rsamp = 1.0 / mod_mesh_tscale;
  return d;
}
void mod_mesh_get_rgc_conn(k,zi,rn,rci,rw)
     int k;       
     int zi;      
     int *rn;     
     int **rci;   
     float **rw;  
{
  int nsyn;
  if (mm_mosaic_flag != 1)
    exit_error("MOD_MESH_GET_RCG_CONN","Mosaic flag not 1");
  nsyn = mm_mosaic_bps_n[k];
  *rn = nsyn;
  *rci = copy_iarray(mm_mosaic_bps_i[k],nsyn);
  *rw  = copy_farray(mm_mosaic_bps_w[k],nsyn);
}
int bps_overlap_count(g1,g2)
     int g1,g2;  
{
  int i,j,k;
  int cnt,n1,n2,*ilist1,*ilist2;
  n1 = mm_mosaic_bps_n[g1];  
  n2 = mm_mosaic_bps_n[g2];  
  ilist1 = mm_mosaic_bps_i[g1];
  ilist2 = mm_mosaic_bps_i[g2];
  cnt = 0;
  for(i=0;i<n1;i++){
    k = ilist1[i];
    for(j=0;j<n2;j++){
      if (k == ilist2[j])
	cnt += 1;
    }
  }
  return cnt;
}
float mod_mesh_mosaic_get_circ_w(x,y)
     float x,y;  
{
  float a,b,c,r;
  float th1,th2,th3,alpha,beta;
  if ((x <= 0) || (x >= 1.0) || (y <= 0) || (y >= 1.0)){
    printf("  *** x,y = %f %f\n",x,y);
    exit_error("MOD_MESH_MOSAIC_GET_CIRC_W","Bad x,y values");
  }
  th1 = asin(y);
  th2 = atan2(y,x);
  th3 = acos(x);
  printf("th1,2,3  %f %f %f\n",th1,th2,th3);
  printf("th1,2,3  %f %f %f (deg)\n",180.0*th1/M_PI,180.0*th2/M_PI,180.0*th3/
	 M_PI);
  alpha = th3 - th2;
  beta  = th2 - th1;
  printf("alpha, beta   %f %f (deg)\n",180.0*alpha/M_PI,180.0*beta/M_PI);
  r = sqrt(x*x + y*y);
  printf("r  %f\n",r);
  a = r/2.0 * sin(alpha);
  b = r/2.0 * sin(beta);
  printf("a,b  %f %f\n",a,b);
  c = (alpha + beta)/2.0 - (a+b);
  printf("  c = %f\n",c);
  return c;
}
int mod_mesh_override_test(ci)
     int ci;  
{
  int flag,cid;
  char *s;
  s = mm_stim_overbin;
  cid = mm_mosaic_cid[ci];
  flag = 0;
  if (ci == mm_stim_overzci){  
    flag = 0;
  }else if (strcmp(s,"all")==0){
    flag = 1;
  }else if (strcmp(s,"none")==0){
    flag = 0;
  }else if (strcmp(s,"S")==0){
    if (cid == 0)
      flag = 1;
  }else if (strcmp(s,"M")==0){
    if (cid == 1)
      flag = 1;
  }else if (strcmp(s,"L")==0){
    if (cid == 2)
      flag = 1;
  }else if (is_int_string(s)){
    if (ci == atoi(s))
      flag = 1;
  }else{
    mylog_ival(mylogf,"cone index",ci);
    mylog_ival(mylogf,"cone ID",cid);
    mylog_cval(mylogf,"stim_override_binary",s);
    mylogx(mylogf,"MOD_MESH_OVERRIDE_TEST",
	   "Unknown value for 'stim_override_binary'");
  }
  return flag;
}
void mod_mesh_mpt_mar(m)
     struct model_struct *m;    
{
  int i;
  int n;
  float *cx,*cy;
  struct pop_top *mpt;
  struct pop_layer *pl;
  mylog(mylogf,"  MOD_MESH_MPT_MAR\n");
  mpt = popu_make_pop_top(mylogf,mod_mesh_sscale,mod_mesh_tscale,
			  mod_mesh_w,mod_mesh_h,mod_mesh_tn);
  mpt->nlay = 4;  
  mpt->lay = (struct pop_layer **)myalloc(mpt->nlay*
					  sizeof(struct pop_layer *));
  n = mm_mosaic_cn;
  cx = mm_mosaic_cx;
  cy = mm_mosaic_cy;
  mpt->lay[0] = popu_make_layer_irreg("cone",n,1,cx,cy,cx,cy);
  mpt->lay[1] = popu_make_layer_cart("horiz",mod_mesh_w,mod_mesh_h,1);
  mpt->lay[2] = popu_make_layer_irreg("bp",n,1,cx,cy,cx,cy);
  mpt->lay[3] = popu_make_layer_irreg("rgc",n,1,cx,cy,cx,cy);
  popu_mar_write(mpt,m->marfile,1);
}
void model_mesh_mosaic_get_w4(xn,yn,cx,cy,cn,rwi,rwj,rww)
     int xn,yn;
     float *cx,*cy;
     int cn;
     int **rwi,**rwj;
     float ***rww;
{
  int i;
  int *cwi,*cwj,xi,yi;
  float **cww,dx,dy;
  cwi = (int *)myalloc(cn*sizeof(int));
  cwj = (int *)myalloc(cn*sizeof(int));
  cww = get_2d_farray(cn,4);
  for(i=0;i<cn;i++){
    xi = (int)cx[i];
    yi = (int)cy[i];
    if ((xi < 0) || (xi >= xn) || (yi < 0) || (yi >= yn))
      exit_error("MODEL_MESH_MOSAIC_GET_W4","Should not happen");
    cwi[i] = xi; 
    cwj[i] = yi;
    dx = cx[i] - (float)xi;
    dy = cy[i] - (float)yi;
    cww[i][0] = (1.0 - dx) * (1.0 - dy);
    cww[i][1] =        dx  * (1.0 - dy);
    cww[i][2] = (1.0 - dx) *        dy;
    cww[i][3] =        dx  *        dy;
  }
  *rwi = cwi; *rwj = cwj; *rww = cww;
}
void model_mesh_mosaic_get_conex4(s,tr_seed)
     struct stim_struct *s;    
     int tr_seed;              
{
  int i,j,k;
  int tn,cn,ti,tj,tid,*cid,***dc;
  float w0,w1,w2,w3,*cxt,ar,ag,ab,colorw,fws,fwm,fwl,*smooth,ts,tnoise;
  float *s0,*s1,*s2,*s3,**cex,***sm,***d;
  int *si0,*si1,*si2,*si3;
  float wr,wg,wb,tr,tg,tb,oval;
  int qseed;
  float qnof;
  mylog(mylogf,"  MODEL_MESH_MOSAIC_GET_CONEX4\n");
  qseed = 29 + tr_seed + tr_seed/2;
  if (qseed > 0)
    qseed = -qseed;
  qnof = mod_mesh_qno_f;
  tn  = mod_mesh_tn;
  cn  = mm_mosaic_cn;
  cid = mm_mosaic_cid;
  if (mm_stim_override == 1){
    mylog(mylogf,"  WARNING: overriding stimulus values.\n");
    for(i=0;i<cn;i++){  
      if (mod_mesh_override_test(i)){
	oval = 1.0;
      }else
	oval = 0.0;
      cxt = mm_mosaic_cex[i];
      if (mm_stim_overdel == 0){
	for(j=0;j<tn;j++)   
	  cxt[j] = oval;
      }else{
	for(j=0;j<tn;j++){  
	  if (j >= tn/2)
	    cxt[j] = oval;
	  else
	    cxt[j] = 0.0;
	}
      }
    }
  }else if ((s->d != NULL) && (s->dc == NULL)){  
    ar = paramfile_get_float_param_default(s->ppl,"amp_r",1.0);
    ag = paramfile_get_float_param_default(s->ppl,"amp_g",1.0);
    ab = paramfile_get_float_param_default(s->ppl,"amp_b",1.0);
    fws = mm_fsr * ar  +  mm_fsg * ag  +  mm_fsb * ab;
    fwm = mm_fmr * ar  +  mm_fmg * ag  +  mm_fmb * ab;
    fwl = mm_flr * ar  +  mm_flg * ag  +  mm_flb * ab;
    sprintf(ggstr,"    Weights for stimulus (s,m,l)  %f %f %f\n",fws,fwm,fwl);
    mylog(mylogf,ggstr);
    for(i=0;i<cn;i++){  
      tid = cid[i];
      if (tid == 0)
	colorw = fws;        
      else if (tid == 1)
	colorw = fwm;        
      else
	colorw = fwl;        
      w0 = colorw * mm_mosaic_cww[i][0];
      w1 = colorw * mm_mosaic_cww[i][1];
      w2 = colorw * mm_mosaic_cww[i][2];
      w3 = colorw * mm_mosaic_cww[i][3];
      ti = mm_mosaic_cwi[i] + 1;  
      tj = mm_mosaic_cwj[i] + 1;
      s0 = &(s->d[ti  ][tj  ][1]);  
      s1 = &(s->d[ti+1][tj  ][1]);
      s2 = &(s->d[ti  ][tj+1][1]);
      s3 = &(s->d[ti+1][tj+1][1]);
      cxt = mm_mosaic_cex[i];
      for(j=0;j<tn;j++){  
	ts = w0*s0[j] + w1*s1[j] + w2*s2[j] + w3*s3[j]; 
	ts += sqrt(ts) * qnof * nr_util_gasdev(&qseed);
	if (ts < 0.0)
	  ts = 0.0;
	cxt[j] = ts;  
      }
    }
  }else{  
    if (s->dc == NULL)
      exit_error("NOT COLOR","Stimulus not 3c");
    for(i=0;i<cn;i++){  
      tid = cid[i];
      if (tid == 0){         
	wr = mm_fsr;
	wg = mm_fsg;
	wb = mm_fsb;
      }else if (tid == 1){   
	wr = mm_fmr;
	wg = mm_fmg;
	wb = mm_fmb;
      }else{                 
	wr = mm_flr;
	wg = mm_flg;
	wb = mm_flb;
      }
      model_mesh_mosaic_get_ijw_for_cid(i,&ti,&tj,&w0,&w1,&w2,&w3);
      w0 /= 255.0;  
      w1 /= 255.0;
      w2 /= 255.0;
      w3 /= 255.0;
      si0 = s->dc[ti  ][tj  ];  
      si1 = s->dc[ti+1][tj  ];  
      si2 = s->dc[ti  ][tj+1];
      si3 = s->dc[ti+1][tj+1];
      cxt = mm_mosaic_cex[i];
      for(j=0;j<tn;j++){  
	data_util_t11_get_rgb_float(si0[j],&tr,&tg,&tb); 
	ts  = w0 * (wr*tr + wg*tg + wb*tb);
	data_util_t11_get_rgb_float(si1[j],&tr,&tg,&tb); 
	ts += w1 * (wr*tr + wg*tg + wb*tb);
	data_util_t11_get_rgb_float(si2[j],&tr,&tg,&tb); 
	ts += w2 * (wr*tr + wg*tg + wb*tb);
	data_util_t11_get_rgb_float(si3[j],&tr,&tg,&tb); 
	ts += w3 * (wr*tr + wg*tg + wb*tb);
	if (qnof > 0.0){
	  ts += sqrt(ts) * qnof * nr_util_gasdev(&qseed);
	}
	if (ts < 0.0)
	  ts = 0.0;
	cxt[j] = ts;  
      }
    }
  }
  cex = mm_mosaic_cex;
  if (mm_stim_override == 0){
    for(i=0;i<cn;i++){
      smooth = convolve_with_mask_causal_x0(cex[i],tn,mod_mesh_ph_tmask,
					    mod_mesh_ph_tmask_n);
      myfree(cex[i]);
      cex[i] = smooth;
    }
  }
  if (mod_mesh_type == 0){  
    sm = mod_mesh_stim;
    for(i=0;i<tn;i++)
      for(j=0;j<mod_mesh_w;j++)
	for(k=0;k<mod_mesh_h;k++)
	  sm[i][j][k] = 0.0;
    for(i=0;i<cn;i++){  
      model_mesh_mosaic_get_ijw_for_cid(i,&ti,&tj,&w0,&w1,&w2,&w3);
      cxt = cex[i];
      for(j=0;j<tn;j++){  
	sm[j][ti  ][tj  ] += w0 * cxt[j] / mm_mosaic_gin[ti  ][tj  ];
	sm[j][ti+1][tj  ] += w1 * cxt[j] / mm_mosaic_gin[ti+1][tj  ];
	sm[j][ti  ][tj+1] += w2 * cxt[j] / mm_mosaic_gin[ti  ][tj+1];
	sm[j][ti+1][tj+1] += w3 * cxt[j] / mm_mosaic_gin[ti+1][tj+1];
      }
    }
  }else{
    ; 
  }
}
void mod_mesh_mosaic_edge_add(cid1,cid2,w)
     int cid1;     
     int cid2;     
     double w;     
{
  int i,k;
  int n,posi,*cidlist,nmax;
  double *distlist;
  nmax = 6;
  n        = mm_edge6_n[cid1];
  distlist = mm_edge6_dist[cid1];
  cidlist  = mm_edge6_cid[cid1];
  posi = -1;
  k = 0;
  while(posi == -1){
    if (w < distlist[k]){  
      k += 1;
      if (k == n)
	posi = k;  
    }else{
      posi = k;
    }
  }
  if (n == nmax){         
    if (posi == 0)           
      return;                
    for(i=1;i<posi;i++){
      distlist[i-1] = distlist[i];  
      cidlist[i-1]  = cidlist[i];
    }
    posi = posi-1;
  }else{                  
    for(i=n-1;i>=posi;i--){
      distlist[i+1] = distlist[i];
      cidlist[i+1] = cidlist[i];
    }
    n += 1;
  }
  distlist[posi] = w;
  cidlist[posi] = cid2;
  mm_edge6_n[cid1] = n;
}
void mod_mesh_cone_mosaic_edge()
{
  int i,j,k;
  int cn,ntot,cid;
  float *cx,*cy;
  double crit_dist_sq,dx,dy,x,y,dsq;
  mylog(mylogf,"  MOD_MESH_CONE_MOSAIC_EDGE\n");
  cx = mm_mosaic_cx;
  cy = mm_mosaic_cy;
  dx = (cx[0] - cx[1]);
  dy = (cy[0] - cy[1]);
  crit_dist_sq = 1.2*1.2*(dx*dx + dy*dy);
  cn = mm_mosaic_cn;
  mm_edge6_cid = get_2d_iarray(cn,6);   
  mm_edge6_dist = get_2d_darray(cn,6);  
  mm_edge6_n = get_zero_iarray(cn);     
  ntot = 0;  
  for(i=0;i<cn;i++){
    x = cx[i];
    y = cy[i];
    for(j=0;j<cn;j++){
      if (j != i){
	dx = x - cx[j];
	dy = y - cy[j];
	dsq = dx*dx + dy*dy;
	if (dsq < crit_dist_sq){
	  mod_mesh_mosaic_edge_add(i,j,sqrt(dsq));
	}
      }
    }
    ntot += mm_edge6_n[i];
  }
  sprintf(ggstr,"    Found %d edges, including duplicates\n",ntot);
  mylog(mylogf,ggstr);
  mm_edge_0 = get_zero_iarray(ntot/2);  
  mm_edge_1 = get_zero_iarray(ntot/2);  
  mm_edge_w = get_darray(ntot/2);       
  k = 0;
  for(i=0;i<cn;i++){
    for(j=0;j<mm_edge6_n[i];j++){
      cid = mm_edge6_cid[i][j];
      if (i < cid){
	mm_edge_0[k] = i;
	mm_edge_1[k] = cid;
	mm_edge_w[k] = mm_edge6_dist[i][j];
	k += 1;
      }
    }
  }
  mm_edge_n = k;
  sprintf(ggstr,"    Found %d unique neighbor pairs\n",mm_edge_n);
  mylog(mylogf,ggstr);
}
void mod_mesh_cone_mosaic_edge_regjit()
{
  int i;
  int cn,i0,i1,n0,n1,nue;
  double dist,dx,dy;
  mylog(mylogf,"  MOD_MESH_CONE_MOSAIC_EDGE_REGJIT\n");
  cn = mm_mosaic_cn;
  mm_edge6_cid  = get_2d_iarray(cn,6);  
  mm_edge6_dist = get_2d_darray(cn,6);  
  mm_edge6_n    = get_zero_iarray(cn);  
  nue = mm_edge_n;  
  for(i=0;i<nue;i++){
    i0 = mm_edge_0[i];  
    i1 = mm_edge_1[i];
    dx = mm_mosaic_cx[i0] - mm_mosaic_cx[i1];  
    dy = mm_mosaic_cy[i0] - mm_mosaic_cy[i1];
    dist = sqrt(dx*dx + dy*dy);
    n0 = mm_edge6_n[i0];  
    n1 = mm_edge6_n[i1];
    mm_edge6_cid[i0][n0] = i1;
    mm_edge6_dist[i0][n0] = dist;
    mm_edge6_n[i0] += 1;
    mm_edge6_cid[i1][n1] = i0;
    mm_edge6_dist[i1][n1] = dist;
    mm_edge6_n[i1] += 1;
  }
  sprintf(ggstr,"    Found %d unique neighbor pairs\n",mm_edge_n);
  mylog(mylogf,ggstr);
}
void model_mesh_cone_mosaic_prep(ro)
     struct onode *ro;  
{
  int i,j;
  int xn,yn,tn,cn,cnt,ti,tj,ncust,seedc,seedx,*cid,out_id,regs;
  float *cx,*cy,dnoise,mupix,dens,lmr,prs,*tww,ecc;
  float distmm,degpermm,conerad,frob;
  char *mofile,*arrgn;
  struct onode *mo;  
  mylog(mylogf,"  MODEL_MESH_CONE_MOSAIC_PREP\n");
  mo = onode_child_get_unique(ro,"cone_mosaic");
  out_id = onode_getpar_int_exit(mo,"out_id");
  mm_mosaic_out_id = out_id;
  if (myid == -1)
    mm_mosaic_gui = onode_getpar_int_dflt(mo,"gui",1);
  else
    mm_mosaic_gui = 0;
  xn = mod_mesh_w;
  yn = mod_mesh_h;
  tn = mod_mesh_tn;
  degpermm = onode_getpar_flt_exit(mo,"degpermm");
  cnt = onode_getpar_int_exit(mo,"ncone");
  ecc = onode_getpar_flt_exit(mo,"ecc");
  if (ecc == -1.0){
    dens = onode_getpar_flt_exit(mo,"dens");
    sprintf(ggstr,"    Density specified as %.2f cones/mm^2\n",dens);
    mylog(mylogf,ggstr);
  }else{
    distmm = ecc/degpermm;
    dens = retutil_get_cone_density(0.95,distmm);
    sprintf(ggstr,"    Eccentricity %.2f degr implies %.2f mm\n",ecc,distmm);
    mylog(mylogf,ggstr);
    sprintf(ggstr,"    Density is %.2f cones/mm^2\n",dens);
    mylog(mylogf,ggstr);
  }
  mupix = 1000.0 * mod_mesh_sscale / degpermm;  
  sprintf(ggstr,"    Derived microns per spatial unit = %f\n",mupix);
  mylog(mylogf,ggstr);
  mofile = onode_getpar_chr_dflt(mo,"file",(char *)NULL);
  if (mofile != NULL){
    retutil_read_mosaic(mofile,&cx,&cy,&cid,&cn);
    myfree(mofile);
  }else{
    seedx  = onode_getpar_int_exit(mo,"seed_loc");
    dnoise = onode_getpar_flt_exit(mo,"noise");
    lmr    = onode_getpar_flt_exit(mo,"lm_ratio");
    prs    = onode_getpar_flt_exit(mo,"prob_s");
    regs   = onode_getpar_int_dflt(mo,"regular_s",0);
    seedc  = onode_getpar_int_exit(mo,"seed_col");
    arrgn  = onode_getpar_chr_dflt(mo,"arrangement","Spiral");
    if (strcmp(arrgn,"Spiral")==0){
      retutil_get_mosaic_color(xn,yn,cnt,dens,mupix,dnoise,seedx,seedc,prs,lmr,
			       mylogf,&cx,&cy,&cid,&cn);
    }else if (strcmp(arrgn,"RegJit")==0){
      retutil_get_mosaic_regjit(xn,yn,cnt,dens,mupix,dnoise,seedx,seedc,prs,lmr,
				regs,mylogf,&cx,&cy,&cid,&cn,
				&mm_edge_0,&mm_edge_1,&mm_edge_w,&mm_edge_n,
				&mm_mosaic_hex_w,&mm_mosaic_hex_h);
    }
    mm_mosaic_noise = dnoise;
    mm_mosaic_arrgn = arrgn;
  }
  mm_mosaic_dens_mm  = dens;
  mm_mosaic_dens_deg = dens / (degpermm * degpermm);
  mm_mosaic_degpmm   = degpermm;
  mofile = onode_getpar_chr_dflt(mo,"custom_cid_file",(char *)NULL);
  if (mofile != NULL){
    if ((strcmp(mofile,"null")!=0) && (strcmp(mofile,"NULL")!=0)){
      ncust = retutil_custom_mosaic_cid_file(mofile,cid,cn);
      sprintf(ggstr,"    %d cones customized from file %s\n",ncust,mofile);
      mylog(mylogf,ggstr);
    }
    myfree(mofile);
  }
  mm_mosaic_cn  = cn;
  mm_mosaic_cid = cid;
  mm_mosaic_cx  = cx;
  mm_mosaic_cy  = cy;
  mm_mosaic_cex = get_2d_farray(cn,tn);
  mod_mesh_ad1m = get_zero_farray(cn); 
  model_mesh_mosaic_get_w4(xn,yn,cx,cy,cn,&mm_mosaic_cwi,&mm_mosaic_cwj,
			   &mm_mosaic_cww);
  if (mod_mesh_type == 0){
    mm_mosaic_gin = get_zero_2d_farray(xn,yn);
    for(i=0;i<cn;i++){  
      ti  = mm_mosaic_cwi[i];
      tj  = mm_mosaic_cwj[i];
      tww = mm_mosaic_cww[i];
      mm_mosaic_gin[ti  ][tj  ] += tww[0];
      mm_mosaic_gin[ti+1][tj  ] += tww[1];
      mm_mosaic_gin[ti  ][tj+1] += tww[2];
      mm_mosaic_gin[ti+1][tj+1] += tww[3];
    }
  }else{
    mm_mosaic_gin = NULL;
  }
  mm_fsr = onode_getpar_nth_flt_exit(mo,"S_rgb",0);
  mm_fsg = onode_getpar_nth_flt_exit(mo,"S_rgb",1);
  mm_fsb = onode_getpar_nth_flt_exit(mo,"S_rgb",2);
  mm_fmr = onode_getpar_nth_flt_exit(mo,"M_rgb",0);
  mm_fmg = onode_getpar_nth_flt_exit(mo,"M_rgb",1);
  mm_fmb = onode_getpar_nth_flt_exit(mo,"M_rgb",2);
  mm_flr = onode_getpar_nth_flt_exit(mo,"L_rgb",0);
  mm_flg = onode_getpar_nth_flt_exit(mo,"L_rgb",1);
  mm_flb = onode_getpar_nth_flt_exit(mo,"L_rgb",2);
  frob  = mm_fsr*mm_fsr + mm_fsg*mm_fsg + mm_fsb*mm_fsb;
  frob += mm_fmr*mm_fmr + mm_fmg*mm_fmg + mm_fmb*mm_fmb;
  frob += mm_flr*mm_flr + mm_flg*mm_flg + mm_flb*mm_flb;
  frob  = sqrt(frob);
  sprintf(ggstr,"    Original Frobenious norm:  %f\n",frob);
  mylog(mylogf,ggstr);
  sprintf(ggstr,"     %8.4f %8.4f %8.4f\n",mm_flr,mm_flg,mm_flb);
  mylog(mylogf,ggstr);
  sprintf(ggstr,"     %8.4f %8.4f %8.4f\n",mm_fmr,mm_fmg,mm_fmb);
  mylog(mylogf,ggstr);
  sprintf(ggstr,"     %8.4f %8.4f %8.4f\n",mm_fsr,mm_fsg,mm_fsb);
  mylog(mylogf,ggstr);
  mm_fsr /= frob;
  mm_fsg /= frob;
  mm_fsb /= frob;
  mm_fmr /= frob;
  mm_fmg /= frob;
  mm_fmb /= frob;
  mm_flr /= frob;
  mm_flg /= frob;
  mm_flb /= frob;
  frob  = mm_fsr*mm_fsr + mm_fsg*mm_fsg + mm_fsb*mm_fsb; 
  frob += mm_fmr*mm_fmr + mm_fmg*mm_fmg + mm_fmb*mm_fmb;
  frob += mm_flr*mm_flr + mm_flg*mm_flg + mm_flb*mm_flb;
  frob  = sqrt(frob);
  sprintf(ggstr,"    Final Frobenious norm:  %f\n",frob);
  mylog(mylogf,ggstr);
  sprintf(ggstr,"     %8.4f %8.4f %8.4f\n",mm_flr,mm_flg,mm_flb);
  mylog(mylogf,ggstr);
  sprintf(ggstr,"     %8.4f %8.4f %8.4f\n",mm_fmr,mm_fmg,mm_fmb);
  mylog(mylogf,ggstr);
  sprintf(ggstr,"     %8.4f %8.4f %8.4f\n",mm_fsr,mm_fsg,mm_fsb);
  mylog(mylogf,ggstr);
  mm_mosaic_csizepix = 0.4 * sqrt(1.0/(sqrt(3.0)/2.0*dens)) * 1000.0/mupix;
  conerad = 0.5 * retutil_get_cone_diam_um(ecc,"Tyler85-OD");
  sprintf(ggstr,"    Cone diameter at eccentricity %.2f degr is %.2f um\n",ecc,
	 conerad*2.0);
  mylog(mylogf,ggstr);
  mm_mosaic_tsizepix = conerad / mupix; 
  if (mod_mesh_type == 1){
    if (strcmp(arrgn,"Spiral")==0){
      mod_mesh_cone_mosaic_edge();
    }else if (strcmp(arrgn,"RegJit")==0){
      mod_mesh_cone_mosaic_edge_regjit();
    }
    mod_mesh_hirr = NULL;
    mod_mesh_h2rr = NULL;
  }
}
void mod_mesh_bp_sum_pick_prob(cx,cy,pseed,ti,tw,rn,rtotw)
     float cx,cy;   
     int   *pseed;  
     int   *ti;     
     float *tw;     
     int   *rn;     
     float *rtotw;  
{
  int i;
  int cn,n,flag;
  float x,y,w,totw;
  cn = mm_mosaic_cn;  
  n = 0;
  totw = 0.0;
  for(i=0;i<cn;i++){ 
    x = mm_mosaic_cx[i];     
    y = mm_mosaic_cy[i];
    w = mod_util_cone_weight(mylogf,x,y,cx,cy,mod_mesh_csig,mm_mosaic_cid[i],
			     mod_mesh_gcs_code,mod_mesh_gcs_distr);
    flag = 1;
    if (w < mod_mesh_csig_min){
      flag = 0;
    }else if (mod_mesh_gcs_prob < 1.0){
      if (myrand_util_ran2(pseed) >= mod_mesh_gcs_prob)
	flag = 0;
    }
    if (flag == 1){
      ti[n] = i;
      tw[n] = w;
      n += 1;
      totw += w;
    }
  }
  *rn = n;
  *rtotw = totw;
}
void mod_mesh_bp_sum_pick_n(cid,cx,cy,n,seed,ti,tw,rtotw,rncan)
     int    cid;    
     float  cx,cy;  
     int    n;      
     int    seed;   
     int   *ti;     
     float *tw;     
     float *rtotw;  
     int   *rncan;  
{
  int i;
  int cn,tn,*tlist;
  float x,y,w,totw;
  cn = mm_mosaic_cn;  
  tlist = (int *)myalloc(cn*sizeof(int));
  tn = 0;
  totw = 0.0;
  for(i=0;i<cn;i++){ 
    x = mm_mosaic_cx[i];     
    y = mm_mosaic_cy[i];
    w = mod_util_cone_weight(mylogf,x,y,cx,cy,mod_mesh_csig,mm_mosaic_cid[i],
			     mod_mesh_gcs_code,mod_mesh_gcs_distr);
    if (w > 0.0){  
      tlist[tn] = i;
      tn += 1;
    }
  }
  if (tn < n){
    printf("  %d candidates, %d requested (cid = %d)\n",tn,n,cid);
    exit_error("MOD_MESH_BP_SUM_PICK_N","Too few candidates");
  }
  shuffle_iarray(tlist,tn,2,seed);
  for(i=0;i<n;i++){
    ti[i] = tlist[i];
    tw[i] = 1.0;
  }
  *rtotw = (float)n;
  *rncan = tn;
}
void mod_mesh_bp_sum_init(){
  int i;
  int cn,n,*ti,totmembyte,seed,*shuf_seed,ncan,ncan_max;
  float cx,cy,totw,*tw;
  mylog(mylogf,"  MOD_MESH_BP_SUM_INIT\n");
  cn = mm_mosaic_cn;  
  ti = (int *)myalloc(cn*sizeof(int));      
  tw = (float *)myalloc(cn*sizeof(float));  
  if ((mod_mesh_gcs_prob < 1.0) || (mod_mesh_gcs_n > 0)){
    if (mod_mesh_gcs_seed > 0.0)
      seed = -mod_mesh_gcs_seed;  
    else
      seed = mod_mesh_gcs_seed;  
  }
  if (mod_mesh_gcs_n > 0){
    shuf_seed = get_seeds(seed,100000,cn);
    n = mod_mesh_gcs_n;
    ncan_max = 0;
  }else
    shuf_seed = NULL;
  mm_mosaic_bps_n = get_zero_iarray(cn);
  mm_mosaic_bps_i = (int **)myalloc(cn*sizeof(int *));
  mm_mosaic_bps_w = (float **)myalloc(cn*sizeof(float *));
  totmembyte = 0;  
  for(i=0;i<cn;i++){ 
    cx = mm_mosaic_cx[i];  
    cy = mm_mosaic_cy[i];
    if (mod_mesh_gcs_n > 0){
      mod_mesh_bp_sum_pick_n(i,cx,cy,n,shuf_seed[i],ti,tw,&totw,&ncan);
      if (ncan > ncan_max)
	ncan_max = ncan;
    }else
      mod_mesh_bp_sum_pick_prob(cx,cy,&seed,ti,tw,&n,&totw);
    mm_mosaic_bps_n[i] = n;
    mm_mosaic_bps_i[i] = copy_iarray(ti,n);
    mm_mosaic_bps_w[i] = copy_farray(tw,n);
    totmembyte += n*8;
  }
  if (mod_mesh_gcs_n > 0){
    sprintf(ggstr,"    Max candidates:  %d\n",ncan_max);
    mylog(mylogf,ggstr);
  }
  sprintf(ggstr,"    Memory used:  %d bytes\n",totmembyte);
  mylog(mylogf,ggstr);
  myfree(ti);
  myfree(tw);
  if (shuf_seed != NULL)
    myfree(shuf_seed);
}
void mod_mesh_ad1_reset(){
  int i,j;
  int w,h,t0;
  float *photo,*horiz,*h2,whc,aval,ws_h1,ws_h2,wlm_h1,wlm_h2;
  t0 = mod_mesh_ad1_t0;
  if (mm_mosaic_flag == 0){
    w = mod_mesh_w;
    h = mod_mesh_h;
    if ((mod_mesh_ad1_init_l == 0.0) &&
	(mod_mesh_ad1_init_m == 0.0) &&
	(mod_mesh_ad1_init_s == 0.0)){
      for(i=0;i<h;i++){
	for(j=0;j<w;j++){
	  mod_mesh_ad1[i][j] = 0.0;
	}
      }
    }else{
      mylogx(mylogf,"MOD_MESH_AD1_RESET","No CIDs for cartesian retina?");
    }
  }else if (mm_mosaic_flag == 1){
    if (t0 >= 0){
      if (mod_mesh_h2_flag == 0){
	whc = mod_mesh_whc;
      }else{
	ws_h1  = mod_mesh_w_h1_s;     
	ws_h2  = mod_mesh_w_h2_s;
	wlm_h1 = mod_mesh_w_h1_lm;
	wlm_h2 = mod_mesh_w_h2_lm;
      }
      for(i=0;i<mm_mosaic_cn;i++){
	photo = mm_mosaic_cex[i];   
	horiz = mod_mesh_hirr[i];   
	if (mod_mesh_h2_flag == 0){
	  aval = photo[t0] - whc*horiz[t0];
	}else{
	  h2 = mod_mesh_h2rr[i];   
	  if (mm_mosaic_cid[i] == 0){ 
	    aval = photo[t0] -  ws_h1*horiz[t0] -  ws_h2*h2[t0];    
	  }else{
	    aval = photo[t0] - wlm_h1*horiz[t0] - wlm_h2*h2[t0];    
	  }
	}
	mod_mesh_ad1m[i] = aval;
      }
    }else if ((mod_mesh_ad1_init_l == 0.0) &&
	      (mod_mesh_ad1_init_m == 0.0) &&
	      (mod_mesh_ad1_init_s == 0.0)){
      for(i=0;i<mm_mosaic_cn;i++)
	mod_mesh_ad1m[i] = 0.0;
    }else{
      mylog(mylogf,"    Setting cone-specific 'ad1' adaptation values.");
      for(i=0;i<mm_mosaic_cn;i++){
	if (mm_mosaic_cid[i] == 0){
	  mod_mesh_ad1m[i] = mod_mesh_ad1_init_s;
	}else if (mm_mosaic_cid[i] == 1){
	  mod_mesh_ad1m[i] = mod_mesh_ad1_init_m;
	}else if (mm_mosaic_cid[i] == 2){
	  mod_mesh_ad1m[i] = mod_mesh_ad1_init_l;
	}
      }
    }
  }
}
void model_mesh_rgc_01_prep(m,s,r)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
{
  int i;
  int w,h,tmax,n,nm1,auto_cent,upflag,win_w,win_h,xi;
  float *mask0,*mask1,*mask2,m1,m2,m1s,m2s,a2,alpha,cx,cy,ad1_t0;
  char fname[SLEN],xval[SLEN],yval[SLEN],tstr[SLEN],*win_title;
  double avg_dist;
  struct onode *ro,*rgo,*rmgo,*spko,*h1o,*h2o;
  myid = mylog_set_id_log(m->process_id,&mylogf);  
  mylog(mylogf,"  MODEL_MESH_RGC_01_PREP\n");
  mod_mesh_prep_flag = 1;
  if (m->marfile == NULL){
    mod_mesh_disp  = param_geti_dflt(r->ppl,"mesh_display_flag",0);
    mod_mesh_zoom  = param_getf_exit(r->ppl,"mesh_display_zoom");
    mod_mesh_dispn = param_getf_exit(r->ppl,"mesh_display_n");
    mod_mesh_min   = param_getf_exit(r->ppl,"mesh_display_min");
    mod_mesh_max   = param_getf_exit(r->ppl,"mesh_display_max");
    mod_mesh_replay_file = param_getc_dflt(r->ppl,"mesh_replay_file","null");
  }else{
    mod_mesh_disp  = 0;
    mod_mesh_zoom  = 8.0;
    mod_mesh_dispn = -1;
    mod_mesh_min   = 0.0;
    mod_mesh_max   = 1.0;
    mod_mesh_replay_file = strdup("null");
  }
  if (r != NULL){
    win_w   = param_geti_dflt(r->ppl,"mesh_gui_winw",480);
    win_h   = param_geti_dflt(r->ppl,"mesh_gui_winh",480);
  }else
    win_w = win_h = 480;  
  ro   = onode_child_get_unique(m->o,"retina0");
  rgo  = onode_get_node_type_item_val(m->o,"pop","name","rgc");
  rmgo = onode_get_node_type_item_val(m->o,"pop","name","rgc_m");
  mod_mesh_out_prefix = onode_getpar_chr_dflt(ro,"outfile","zz");
  mm_stim_override = onode_getpar_int_dflt(ro,"stim_override",0);
  if (mm_stim_override == 1){
    mm_stim_overbin = onode_getpar_chr_dflt(ro,"stim_override_binary","0");
    mm_stim_overdel = onode_getpar_int_dflt(ro,"stim_override_delay",0);
    mm_stim_overzci = onode_getpar_int_dflt(ro,"stim_override_zero_ci",-1);
  }
  mod_mesh_w      = onode_getpar_int_exit(m->o,"xn");
  mod_mesh_h      = onode_getpar_int_exit(m->o,"yn");
  mod_mesh_tmax   = onode_getpar_int_exit(m->o,"tn");
  mod_mesh_tn     = mod_mesh_tmax;
  mod_mesh_tscale = onode_getpar_flt_exit(m->o,"tscale");
  mod_mesh_sscale = onode_getpar_flt_exit(m->o,"sscale");
  mod_mesh_reset  = onode_getpar_int_dflt(m->o,"mod_trial_reset",1);
  {
    float tsl,hsl;
    tsl = onode_getpar_flt_dflt(ro,"mesh_dump_slice_t",-1.0);
    if (tsl == -1.0){
      mod_mesh_slice_ti = -1;  
      mod_mesh_slice_xi = -1;  
    }else{
      mod_mesh_slice_ti = my_rint(tsl/mod_mesh_tscale);
      mylog_xci(mylogf,"MODEL_MESH_RGC_01_PREP","slice_t coord",
		mod_mesh_slice_ti,0,mod_mesh_tn);  
      hsl = onode_getpar_flt_dflt(ro,"mesh_dump_slice_x",0.0);
      mod_mesh_slice_xi = mod_mesh_w/2 + my_rint(hsl/mod_mesh_sscale);
      mylog_xci(mylogf,"MODEL_MESH_RGC_01_PREP","slice_x coord",
		mod_mesh_slice_xi,0,mod_mesh_w);  
    }
  }
  mod_mesh_dump_type = onode_getpar_chr_dflt(ro,"mesh_dump_type","null");
  mod_mesh_dump_cid  = onode_getpar_int_dflt(ro,"mesh_dump_cid",-1);
  mod_mesh_dump_tsec = onode_getpar_flt_dflt(ro,"mesh_dump_tsec",-1.0);
  mod_mesh_dumpp  = onode_getpar_int_dflt(ro,"mesh_dump_prep",0);
  mod_mesh_dump  = onode_getpar_int_dflt(ro,"mesh_dump_all",0);
  if (myid != -1)
    mod_mesh_dump = 0;  
  if (mod_mesh_dump){  
    sprintf(fname,"%s.dump.pl",mod_mesh_out_prefix);
    mod_mesh_dumpf = strdup(fname);
  }else{
    mod_mesh_dumpf = NULL;
    mod_mesh_dumps = NULL;
  }
  mod_mesh_dump_hex  = onode_getpar_int_dflt(ro,"mesh_dump_hex",0);
  mm_mosaic_flag = onode_getpar_int_dflt(ro,"cone_mosaic_flag",0);
  mod_mesh_dump_file = onode_getpar_chr_dflt(ro,"mesh_dump_file","null");
  mod_mesh_outtype = onode_getpar_chr_dflt(ro,"mesh_display_type","hc");
  mod_mesh_type = onode_getpar_int_dflt(ro,"mesh_type",0);
  h1o  = onode_get_node_type_item_val(ro,"h_mesh","name","h1");
  if (h1o == NULL)
    exit_error("MODEL_MESH_RGC_01_PREP","Cannot find <h_mesh> object");
  mod_mesh_gh = onode_getpar_flt_exit(h1o,"gh");
  mod_mesh_gp = onode_getpar_flt_exit(h1o,"gp");
  mod_mesh_dt = onode_getpar_flt_exit(h1o,"dt");
  h2o  = onode_get_node_type_item_val(ro,"h_mesh","name","h2");
  if (h2o != NULL){
    mod_mesh_h2_flag = 1;
    mod_mesh_h2_gh = onode_getpar_flt_exit(h2o,"gh");
    mod_mesh_h2_gp = onode_getpar_flt_exit(h2o,"gp");
    mod_mesh_h2_dt = onode_getpar_flt_exit(h2o,"dt");
  }else
    mod_mesh_h2_flag = 0;
  if (mod_mesh_type == 0){
    mod_mesh_cc = onode_getpar_flt_exit(h1o,"c");
    mod_mesh_nstep = -1;
    mod_mesh_h2_nstep = -1;
  }else{
    mod_mesh_cc = -1.0; 
    if ((mod_mesh_dt > 1.0) || (mod_mesh_dt <= 0.0)){
      mod_mesh_nstep = 1;
      mod_mesh_h2_nstep = 1;
    }else{
      mod_mesh_nstep = my_rint(1.0/mod_mesh_dt);
      if (mod_mesh_h2_flag == 1)
	mod_mesh_h2_nstep = my_rint(1.0/mod_mesh_h2_dt);
    }
  }
  mod_mesh_h1cw[0] = onode_getpar_flt_dflt(h1o,"w_s",1.0);
  mod_mesh_h1cw[1] = onode_getpar_flt_dflt(h1o,"w_m",1.0);
  mod_mesh_h1cw[2] = onode_getpar_flt_dflt(h1o,"w_l",1.0);
  if (mod_mesh_h2_flag == 1){
    mod_mesh_h2cw[0] = onode_getpar_flt_dflt(h2o,"w_s",0.0);
    mod_mesh_h2cw[1] = onode_getpar_flt_dflt(h2o,"w_m",0.0);
    mod_mesh_h2cw[2] = onode_getpar_flt_dflt(h2o,"w_l",0.0);
  }
  mod_mesh_dx = 1.0;
  if (mod_mesh_h2_flag == 0){
    mod_mesh_whc = onode_getpar_flt_exit(ro,"mesh_whc");
  }else{
    mod_mesh_w_h1_s  = onode_getpar_flt_exit(ro,"bipolar_s_wh1");
    mod_mesh_w_h2_s  = onode_getpar_flt_exit(ro,"bipolar_s_wh2");
    mod_mesh_w_h1_lm = onode_getpar_flt_exit(ro,"bipolar_lm_wh1");
    mod_mesh_w_h2_lm = onode_getpar_flt_exit(ro,"bipolar_lm_wh2");
    mod_mesh_whc = 1.0; 
  }
  mod_mesh_off_flag = onode_getpar_int_dflt(ro,"mesh_off_flag",0);
  tmax = mod_mesh_tmax;
  w = mod_mesh_w;
  h = mod_mesh_h;
  if (w != h) exit_error("MOD_MESH_RGC_01_PREP","width must equal height");
  n = w;
  mod_mesh_a = get_zero_farray(n); 
  mod_mesh_b = get_zero_farray(n);
  mod_mesh_c = get_zero_farray(n);
  mod_mesh_r = get_zero_farray(n);
  if (mod_mesh_type == 0){
    mod_mesh_u = get_3d_farray(tmax,h,w);     
    mod_mesh_uo = get_zero_2d_farray(h,w); 
    mod_mesh_un = get_zero_2d_farray(h,w); 
    mod_mesh_tcol = get_zero_farray(h);    
    mod_mesh_hirr = NULL;
    mod_mesh_h2rr = NULL;
  }else{
    mod_mesh_u = NULL;
    mod_mesh_uo = NULL;
    mod_mesh_un = NULL;
    mod_mesh_tcol = NULL;
  }
  mod_mesh_ad1 = get_zero_2d_farray(h,w); 
  mod_mesh_ad1_tau    = onode_getpar_flt_dflt(ro,"ad1_tau",0.0); 
  mod_mesh_ad1_a      = onode_getpar_flt_dflt(ro,"ad1_amp",0.0); 
  mod_mesh_ad1_init_l = onode_getpar_flt_dflt(ro,"ad1_init_l",0.0);
  mod_mesh_ad1_init_m = onode_getpar_flt_dflt(ro,"ad1_init_m",0.0);
  mod_mesh_ad1_init_s = onode_getpar_flt_dflt(ro,"ad1_init_s",0.0);
  ad1_t0     = onode_getpar_flt_dflt(ro,"ad1_t0",-1.0); 
  if (ad1_t0 < 0.0)
    mod_mesh_ad1_t0 = -1;
  else{
    mod_mesh_ad1_t0 = my_rint(ad1_t0 / mod_mesh_tscale);
  }
  mod_mesh_ad1_c = exp(-1.0/(mod_mesh_ad1_tau / mod_mesh_tscale));
  sprintf(ggstr,"    Adaptation constant (ad1_c) = %f\n",mod_mesh_ad1_c);
  mylog(mylogf,ggstr);
  mod_mesh_stim = get_3d_farray(tmax,h,w);
  mod_mesh_ts1 = get_2d_farray(h,w); 
  mod_mesh_ts2 = get_2d_farray(h,w); 
  if (onode_test_int(ro,"photo_delta",1)){
    nm1 = 4;  
    mask0 = get_zero_farray(nm1);
    mask0[0] = 1.0;
  }else{
    m1s = onode_getpar_flt_exit(ro,"mod_mesh_photo_m1"); 
    m2s = onode_getpar_flt_exit(ro,"mod_mesh_photo_m2"); 
    m1 = m1s / mod_mesh_tscale;
    m2 = m2s / mod_mesh_tscale;
    a2 = onode_getpar_flt_exit(ro,"mod_mesh_photo_a2");
    if (m2 > m1)
      nm1 = 5*(int)(0.5+m2); 
    else
      nm1 = 5*(int)(0.5+m1); 
    mask1 = maxwell_farray(0.0,m1,1.0,nm1);
    mask2 = maxwell_farray(0.0,m2,1.0,nm1);
    multiply_farray(mask2,nm1,a2);
    mask0 = subtract_farrays(mask1,mask2,nm1);
    norm_area_farray(mask0,nm1,1.0);
    if (mod_mesh_dumpp){
      sprintf(fname,"%s.prep.dump.pl",mod_mesh_out_prefix);
      append_farray_plot(fname,"maxwell_1",mask1,nm1,1);
      append_farray_plot(fname,"maxwell_2",mask2,nm1,1);
      append_farray_plot(fname,"Filter_M1-M2_v_tunits",mask0,nm1,1);
    }
    myfree(mask1); myfree(mask2);
  }
  mod_mesh_ph_tmask_n = nm1;
  mod_mesh_ph_tmask   = mask0;
  if (onode_test_ostr(ro,"mesh_qno_f") == 1)
    mod_mesh_qno_f = onode_getpar_flt_dflt(ro,"mesh_qno_f",1.0);
  else
    mod_mesh_qno_f = onode_getpar_flt_dflt(ro,"noise_factor",1.0);
  mod_mesh_gcs_distr= onode_getpar_int_dflt(rgo,"sum_bp_distrib",0);
  if (onode_item(rgo,"sum_bp_dist_deg") == 1){
    mod_mesh_csig  = onode_getpar_flt_exit(rgo,"sum_bp_dist_deg");
    mod_mesh_csig /= mod_mesh_sscale;
  }else{
    mod_mesh_csig     = onode_getpar_flt_exit(rgo,"sum_bp_dist");
  }
  mod_mesh_csig_normw = onode_getpar_flt_exit(rgo,"sum_bp_normw");
  mod_mesh_csig_min   = onode_getpar_flt_dflt(rgo,"sum_bp_minw",0.02);
  mod_mesh_gcs_code   = onode_getpar_int_dflt(rgo,"sum_bp_ccode",111);
  mod_mesh_gcs_prob   = onode_getpar_flt_dflt(rgo,"sum_bp_prob",1.0);
  mod_mesh_gcs_seed   = onode_getpar_int_dflt(rgo,"sum_bp_seed",17473);
  mod_mesh_gcs_n      = onode_getpar_int_dflt(rgo,"sum_bp_n",-1);
  spko = onode_child_get_unique(rgo,"spike_gen");
  mod_mesh_sgen = onode_getpar_chr_exit(spko,"type");
  if (rmgo != NULL){
    if (onode_item(rmgo,"sum_bp_dist_deg") == 1){
      mod_mesh_m_csig  = onode_getpar_flt_exit(rmgo,"sum_bp_dist_deg");
      mod_mesh_m_csig /= mod_mesh_sscale;
    }else{
      mod_mesh_m_csig     = onode_getpar_flt_exit(rmgo,"sum_bp_dist");
    }
    mod_mesh_m_csig_min = onode_getpar_flt_dflt(rmgo,"sum_bp_minw",0.02);
    mod_mesh_m_ad1_tau = onode_getpar_flt_dflt(ro,"m_ad1_tau",0.0); 
    mod_mesh_m_ad1_a   = onode_getpar_flt_dflt(ro,"m_ad1_amp",0.0); 
    mod_mesh_m_ad1_c = exp(-1.0/(mod_mesh_m_ad1_tau / mod_mesh_tscale));
  }
  if (onode_test_ostr(rgo,"spike_dump_xi") == 1){
    xi = onode_getpar_int_exit(rgo,"spike_dump_xi");
    if (xi >= 0){
      ifc_util_rm_dump_file();
    }
  }
  mod_mesh_gain1 = get_zero_farray(mod_mesh_tmax);
  mod_mesh_gain2 = get_zero_farray(mod_mesh_tmax);
  mod_mesh_gain_hpflag = onode_getpar_int_dflt(ro,"mesh_gain_hp_flag",0);
  if (mod_mesh_gain_hpflag == 1){
    mod_mesh_lptau = onode_getpar_flt_exit(ro,"mesh_lp_tau");
    mod_mesh_lptau /= mod_mesh_tscale;  
    mod_mesh_lpmn = mod_mesh_lptau * 7.0;
    alpha = 1.0/mod_mesh_lptau;
    mod_mesh_lp_mask = alpha_farray(0.0,alpha,1.0,mod_mesh_lpmn);
    norm_area_farray(mod_mesh_lp_mask,mod_mesh_lpmn,1.0);
    if (mod_mesh_dumpp){
      sprintf(fname,"%s.prep.dump.pl",mod_mesh_out_prefix);
      append_farray_plot(fname,"exp_lp",mod_mesh_lp_mask,mod_mesh_lpmn,1);
    }
    mod_mesh_gsig_slope = onode_getpar_flt_exit(ro,"mesh_gsig_slope");
    mod_mesh_gsig_mean  = onode_getpar_flt_exit(ro,"mesh_gsig_mean");
    if (mod_mesh_dumpp){
      int cfn,i;
      float *cf,*cfx,xxn;
      cfn = 100;
      cf = (float *)myalloc(cfn*sizeof(float));
      cfx = (float *)myalloc(cfn*sizeof(float));
      for(i=0;i<cfn;i++){
	cfx[i] = mod_mesh_gsig_mean + 
	  5.0 * (float)(i-cfn/2)/(float)(cfn/2) / mod_mesh_gsig_slope;
	cf[i] = 0.5 + 0.5*func_sigmoid_tanh(cfx[i],mod_mesh_gsig_slope,
					    mod_mesh_gsig_mean);
      }
      sprintf(fname,"%s.prep.dump.pl",mod_mesh_out_prefix);
      append_farray_xy_plot(fname,cfx,cf,cfn,"sigmoid");
      myfree(cf);
    }
  }else{
    mod_mesh_lp_mask = NULL;
  }
  mod_mesh_gain_g2in = onode_getpar_int_dflt(ro,"mesh_gain_inhib_g2",0);
  if (mod_mesh_gain_g2in == 1){
    mod_mesh_lp2tau = onode_getpar_flt_exit(ro,"mesh_lp2_tau");
    mod_mesh_lp2tau /= mod_mesh_tscale;  
    mod_mesh_lp2mn = mod_mesh_lp2tau * 7.0;
    alpha = 1.0/mod_mesh_lp2tau;
    mod_mesh_lp2_mask = alpha_farray(0.0,alpha,1.0,mod_mesh_lp2mn);
    norm_area_farray(mod_mesh_lp2_mask,mod_mesh_lp2mn,1.0);
    if (mod_mesh_dumpp){
      sprintf(fname,"%s.prep.dump.pl",mod_mesh_out_prefix);
      append_farray_plot(fname,"exp_lp2",mod_mesh_lp2_mask,mod_mesh_lp2mn,1);
    }
  }else{
    mod_mesh_lp2_mask = NULL;
  }
  if (mm_mosaic_flag == 1){
    float ch;
    model_mesh_cone_mosaic_prep(ro);
    if (mod_mesh_type == 1){
      mod_mesh_hirr = get_2d_farray(mm_mosaic_cn,mod_mesh_tmax);
      if (mod_mesh_h2_flag == 1)
	mod_mesh_h2rr = get_2d_farray(mm_mosaic_cn,mod_mesh_tmax);
      ch = mod_mesh_gh * 1000.0 * (mod_mesh_tscale / mod_mesh_nstep);
      avg_dist = 0.0;
      for(i=0;i<mm_edge_n;i++){
	avg_dist += mm_edge_w[i];
      }
      avg_dist /= (double)mm_edge_n;  
      for(i=0;i<mm_edge_n;i++){
	if (mm_edge_w[i] <= 0.0)
	  mylogx(mylogf,"MODEL_MESH_RGC_01_PREP","Edge distance <= zero");
	mm_edge_w[i] = ch * avg_dist / mm_edge_w[i];
      }
    }
    if (strcmp(mod_mesh_dump_type,"mosaic_coord")==0){
      if (strcmp(mod_mesh_dump_file,"null")==0)  
	sprintf(fname,"zz.mosaic.txt");
      else
	sprintf(fname,"%s",mod_mesh_dump_file);
      for(i=0;i<mm_mosaic_cn;i++){
	sprintf(tstr,"%5d %d %8.2f %8.2f\n",i,mm_mosaic_cid[i],mm_mosaic_cx[i],
		mm_mosaic_cy[i]);
	append_string_to_file(fname,tstr);
      }
      printf("  Appended mosaic data to:  %s\n",fname);
      printf("\n");
      exit(0);
    }
  }else{
     mm_mosaic_out_id = -1;
  }
  mod_mesh_bp_sum_init();
  mod_mesh_ad1_reset();  
  auto_cent = onode_getpar_int_dflt(ro,"stim_auto_center_mi",-1);
  if ((auto_cent >= 0) && (m->marfile == NULL)){
    if (paramfile_test_param(s->ppl,"cx") &&
	paramfile_test_param(s->ppl,"cy")){
      cx = mm_mosaic_cx[auto_cent] - (float)(mod_mesh_w-1)/2.0;  
      cy = mm_mosaic_cy[auto_cent] - (float)(mod_mesh_h-1)/2.0;  
      cx *= mod_mesh_sscale;
      cy *= mod_mesh_sscale;
      sprintf(xval,"%.4f",cx);
      sprintf(yval,"%.4f",cy);
      upflag = paramfile_list_update(s->ppl,"cx",xval);
      upflag = paramfile_list_update(s->ppl,"cy",yval);
      update_const_param(mylogf,"cx",xval,'\0',s->cname,s->cval,s->ctype,
			  s->ncon);
      update_const_param(mylogf,"cy",yval,'\0',s->cname,s->cval,s->ctype,
			 s->ncon);
    }else{
      mylogx(mylogf,"MODEL_MESH_RGC_01_PREP",
	     "Auto-center requires .stim cy and cy");
    }
  }
  if (m->marfile != NULL){
    mod_mesh_mpt_mar(m);
    return;
  }
  if (mm_mosaic_gui == 1){
    int tcn;
    int ttn;
    int nbytes;
    int tcode;
    float **rpydata;
    if (strcmp(mod_mesh_replay_file,"null")!=0){
      if (r != NULL)
	win_title = param_getc_dflt(r->ppl,"mesh_replay_title","Replay");
      else
	win_title = strdup("Replay");
      read_2d_data(mod_mesh_replay_file,&rpydata,&tcn,&ttn,&nbytes,&tcode);
      if (tcn != mm_mosaic_cn){
	printf("  ncones = %d    tn = %d\n",tcn,ttn);
	exit_error("MOD_MESH_RGC_01_PREP","Replay file differs in n cones");
      }else
	printf(" **** Read replay file\n");
    }else{
      ttn = 0;
      rpydata = NULL;
      win_title = strdup("Cone Mosiac");
    }
    mod_gui_view_cones(s,mod_mesh_w,mod_mesh_h,mod_mesh_tmax,mod_mesh_sscale,
		       mod_mesh_tscale,mm_mosaic_cx,mm_mosaic_cy,
		       mm_mosaic_cid,mm_mosaic_cn,
		       mm_mosaic_csizepix,mm_mosaic_tsizepix,mm_mosaic_out_id,
		       mod_mesh_csig,mod_mesh_csig_min,mod_mesh_gcs_code,
		       mod_mesh_gcs_distr,rpydata,ttn,win_w,win_h,win_title);
  }
  if (mod_mesh_disp){
    glplot_open_show_2d(mod_mesh_uo,n,n,mod_mesh_zoom,1,-1.0,-1.0);
  }
}
void model_mesh_rgc_01_done()
{
  int w,h,tn;
  if (mod_mesh_prep_flag == 0){  
    return;  
  }
  mylog(mylogf,"  MODEL_MESH_RGC_01_DONE\n");
  tn = mod_mesh_tn;
  w = mod_mesh_w;
  h = mod_mesh_h;
  myfree(mod_mesh_a);
  myfree(mod_mesh_b);
  myfree(mod_mesh_c);
  myfree(mod_mesh_r);
  if (mod_mesh_type == 0){
    free_3d_farray(mod_mesh_u,tn,h,w);
    free_2d_farray(mod_mesh_uo,h);
    free_2d_farray(mod_mesh_un,h);
  }else if (mod_mesh_type == 1){
    free_2d_farray(mod_mesh_hirr,mm_mosaic_cn);
    if (mod_mesh_h2rr != NULL)
      free_2d_farray(mod_mesh_h2rr,mm_mosaic_cn);
  }
  free_3d_farray(mod_mesh_stim,mod_mesh_tmax,h,w);
  free_2d_farray(mod_mesh_ts1,h);
  free_2d_farray(mod_mesh_ts2,h);
  if (mod_mesh_dump_file != (char *)NULL)
    myfree(mod_mesh_dump_file);
  if (mod_mesh_dump_type != (char *)NULL)
    myfree(mod_mesh_dump_type);
  if (mod_mesh_disp)
    glplot_open_show_2d((float **)NULL,0,0,0.0,2,-1.0,-1.0);
}
void mod_mesh_spike_gen(m,dex,din,tn,seed,samp,sgen,pop_name,dumptr,vflag,
			rs,rcnt,rv,rvn)
     struct model_struct *m;    
     float *dex;                
     float *din;                
     int tn;                    
     int seed;                  
     float samp;                
     char *sgen;                
     char *pop_name;            
     char *dumptr;              
     int vflag;                 
     float **rs;                
     int *rcnt;                 
     float **rv;                
     int *rvn;                  
{
  int i;
  struct onode *po,*spko;
  char tname[SLEN];
  po = onode_get_node_type_item_val(m->o,"pop","name",pop_name);
  if (po == NULL)
    mylog_exit(mylogf,"MOD_MESH_SPIKE_GEN  Bad pop_name.\n");
  spko = onode_child_get_unique(po,"spike_gen");
  if (strcmp(sgen,"poisson")==0){
    if (dumptr != NULL)
      vflag = 1;
    ifc_util_poisson(mylogf,m,spko,dex,tn,samp,seed,0,vflag,rs,rcnt,rv,rvn);
    if (dumptr != NULL){
      sprintf(tname,"Prob_%s",dumptr);
      printf("  *** Appending Poisson rate to 'zz.poisson.dump.pl'\n");
      append_farray_plot("zz.poisson.dump.pl",tname,*rv,*rvn,1);
    }
  }else if (strcmp(sgen,"ifc")==0){
    ifc_test(myid,m,pop_name,dex,din,samp,tn,seed,0,dumptr,
	     rs,rcnt,vflag,rv,rvn);
  }else{
    mylog_exit(mylogf,"MOD_MESH_SPIKE_GEN  Unknown 'sgen'\n");
  }
}
void model_mesh_photo_filter(d,tr_seed)
     float ***d;                   
     int tr_seed;                  
{
  int i,j,k;
  int h,w,tn,nm1,qseed;
  float *mask1,*sm,qnof,*td,*sp;
  char tstr[SLEN];
  w = mod_mesh_w;
  h = mod_mesh_h;
  tn = mod_mesh_tn;
  qseed = 29 + tr_seed + tr_seed/2;
  if (qseed > 0)
    qseed = -qseed;
  qnof = mod_mesh_qno_f;
  nm1 = mod_mesh_ph_tmask_n;
  mask1 = mod_mesh_ph_tmask;
  mylog(mylogf,"    Convolving visual stimulus w/ photoreceptor filter...\n");
  td = get_farray(tn);  
  for(i=0;i<h;i++){
    for(j=0;j<w;j++){
      sp = &(d[i+1][j+1][1]);  
      for(k=0;k<tn;k++){
	td[k] = sp[k] + sqrt(sp[k]) * qnof * nr_util_gasdev(&qseed);
	if (td[k] < 0.0)
	  td[k] = 0.0;
      }
      sm = convolve_with_mask_causal_x0(td,tn,mask1,nm1);
      for(k=0;k<tn;k++){
	mod_mesh_stim[k][i][j] = sm[k];
      }
      myfree(sm);
    }
  }
  myfree(td);
  mylog(mylogf,"      Done.\n");
}
float *mod_mesh_spatial_sum(mi,xi,yi,pflag)
     int mi;                  
     int xi,yi;               
     int pflag;               
{
  int i,j,k;
  int tn,nin;
  float csig,totw,weight,cx,cy,x,y,*d,*s;
  char tname[SLEN];
  tn = mod_mesh_tn;
  csig = mod_mesh_csig;  
  s = get_zero_farray(tn);  
  totw = 0.0;
  if (mm_mosaic_flag == 1){
    if (1){
      nin = mm_mosaic_bps_n[mi]; 
      for(i=0;i<nin;i++){         
	j      = mm_mosaic_bps_i[mi][i];  
	weight = mm_mosaic_bps_w[mi][i];  
	d = mod_mesh_diffm[j];  
	totw += weight;
	for(k=0;k<tn;k++){  
	  s[k] += weight * d[k];
	}
      }
    }else{
      cx = mm_mosaic_cx[mi];  
      cy = mm_mosaic_cy[mi];
      for(j=0;j<mm_mosaic_cn;j++){ 
	x = mm_mosaic_cx[j];     
	y = mm_mosaic_cy[j];
	d = mod_mesh_diffm[j];  
	weight = mod_util_cone_weight(mylogf,x,y,cx,cy,csig,mm_mosaic_cid[j],
				      mod_mesh_gcs_code,mod_mesh_gcs_distr);
	if (weight >= mod_mesh_csig_min){
	  totw += weight;
	  for(i=0;i<tn;i++){
	    s[i] += weight * d[i];
	  }
	}
      }
    }
    if (pflag == 1){
      sprintf(ggstr,"  Total weight (mosiac index %d) = %f\n",mi,totw);
      mylog(mylogf,ggstr);
    }
  }else{
    for(j=0;j<mod_mesh_w;j++){
      for(k=0;k<mod_mesh_h;k++){
	d = mod_mesh_diff[j][k];  
	weight = func_2d_gaussian((float)j,(float)k,(float)xi,(float)yi,
				  csig,csig,0);
	if (weight >= mod_mesh_csig_min){
	  totw += weight;
	  for(i=0;i<tn;i++){
	    s[i] += weight * d[i];
	  }
	}
      }
    }
    if (pflag == 1){
      sprintf(ggstr,"    Total weight at (%d,%d) = %f\n",xi,yi,totw);
      mylog(mylogf,ggstr);
    }
  }
  multiply_farray(s,tn,mod_mesh_csig_normw/totw);
  return s;
}
void mod_mesh_get_resp(m,mi,xi,yi,seed,pop_name,onflag,rs,rsn,rv,rvn,rgx,rgx0,
		       rgn)
     struct model_struct *m;  
     int mi;                  
     int xi,yi;               
     int seed;                
     char *pop_name;          
     int onflag;              
     float **rs;              
     int    *rsn;             
     float **rv;              
     int    *rvn;             
     float **rgx;             
     float **rgx0;            
     int    *rgn;             
{
  int i;
  int tcnt,tvn,tn;
  float *ts,*tv,*gtx,*gti,*gtx0,samp;
  char *dmpf,tname[SLEN];
  if (mm_mosaic_flag == 1){
    if ((mi < 0) || (mi >= mm_mosaic_cn))
      mylog_exit(mylogf,"MOD_MESH_GET_RESP  Mosaic index out of bounds.\n");
    sprintf(tname,"%s_pre_GTX_mi_%d",mod_mesh_dumps,mi);
  }else{
    if ((xi < 0) || (xi >= mod_mesh_w) || (yi < 0) || (yi >= mod_mesh_h))
      mylog_exit(mylogf,"MOD_MESH_GET_RESP  Grid indices out of bounds.\n");
    sprintf(tname,"%s_pre_GTX_xy_%d_%d",mod_mesh_dumps,xi,yi);
  }
  tn   = mod_mesh_tn;
  samp = 1.0/mod_mesh_tscale; 
  dmpf = NULL;  
  gti = get_zero_farray(tn);
  if (mod_mesh_csig > 0.0){
    gtx = mod_mesh_spatial_sum(mi,xi,yi,1);   
  }else{
    if (mm_mosaic_flag == 1)
      gtx = copy_farray(mod_mesh_diffm[mi],tn);    
    else
      gtx = copy_farray(mod_mesh_diff[xi][yi],tn);
  }
  if (onflag == 0)
    multiply_farray(gtx,tn,-1.0); 
  gtx0 = copy_farray(gtx,tn);  
  if (mod_mesh_dump){  
    append_farray_plot(mod_mesh_dumpf,tname,gtx,tn,1);
  }
  if (mod_mesh_gain_g2in){  
    for(i=0;i<tn;i++)
      gti[i] = mod_mesh_gain2[i];
  }else{
    for(i=0;i<tn;i++)
      gti[i] = 0.0; 
  }
  mod_mesh_spike_gen(m,gtx,gti,tn,seed,samp,mod_mesh_sgen,pop_name,NULL,0,
		     &ts,&tcnt,&tv,&tvn);
  if (dmpf != NULL)
    myfree(dmpf);
  myfree(gti);
  *rs = ts;
  *rsn = tcnt;
  *rv = tv;
  *rvn = tvn;
  *rgx = gtx;
  *rgx0 = gtx0;
  *rgn = tn;
}
void mod_mesh_resp_get_phad(m,r,i)
     struct model_struct *m;        
     struct response_struct *r;     
     int i;                         
{
  int mi,xi,yi;
  if (mm_mosaic_flag == 1)
    mi = r->xi[i];  
  else{
    xi = r->xi[i];
    yi = r->yi[i];
    mi = mod_mesh_w * yi + xi; 
  }
}
int mod_mesh_resp_count(r)
     struct response_struct *r;     
{
  int i;
  int cnt;
  cnt = 0;
  for(i=0;i<r->n;i++){ 
    if ((r->rformat[i] >= 0) && (r->rformat[i] <= 3)){
      if ((strcmp(r->datid[i],"gc_spikes")==0) ||
	  (strcmp(r->datid[i],"gc_vm")==0) ||
	  (strcmp(r->datid[i],"gc_gx_raw")==0) ||
	  (strcmp(r->datid[i],"horiz")==0) ||
	  (strcmp(r->datid[i],"photo")==0) ||
	  (strcmp(r->datid[i],"gc_gx")==0)){
	cnt += 1;
      }
    }
  }
  return cnt;
}
void mod_mesh_resp_handover(m,r)
     struct model_struct *m;        
     struct response_struct *r;     
{
  int i;
  int n,cnt,mi,tsn,tvn,tgn,**sn,**vn,**gn,xi,yi,zi,zn,si,*seedlist,nseed;
  float ***s,***v,***g,***g0,*ts,*tv,*tg,*tg0,*t;
  char *pop_name;
  zn = 2;  
  if (mm_mosaic_flag == 1) 
    n = mm_mosaic_cn;
  else
    n = mod_mesh_w * mod_mesh_h;
  s = get_3d_farray(n,zn,0);     
  v = get_3d_farray(n,zn,0);     
  g = get_3d_farray(n,zn,0);     
  g0 = get_3d_farray(n,zn,0);     
  sn = get_zero_2d_iarray(n,zn);
  vn = get_zero_2d_iarray(n,zn);
  gn = get_zero_2d_iarray(n,zn);
  nseed = mod_mesh_resp_count(r);
  seedlist = get_seeds(m->mseed[r->tsi],1000000,nseed);
  cnt = 0;
  si = 0;   
  for(i=0;i<r->n;i++){ 
    if ((r->rformat[i] >= 0) && (r->rformat[i] <= 3)){
      if ((strcmp(r->datid[i],"gc_spikes")==0) ||
	  (strcmp(r->datid[i],"gc_vm")==0) ||
	  (strcmp(r->datid[i],"gc_gx_raw")==0) ||
	  (strcmp(r->datid[i],"horiz")==0) ||
	  (strcmp(r->datid[i],"photo")==0) ||
	  (strcmp(r->datid[i],"gc_gx")==0)){
	pop_name = r->plname[i];
	if (mm_mosaic_flag == 1)
	  mi = r->xi[i];  
	else{
	  xi = r->xi[i];
	  yi = r->yi[i];
	  mi = mod_mesh_w * yi + xi; 
	}
	zi = r->zi[i];  
	if ((g[mi][zi] == NULL) && 
	    ((strcmp(r->datid[i],"gc_spikes")==0) ||
	     (strcmp(r->datid[i],"gc_vm")==0) ||
	     (strcmp(r->datid[i],"gc_gx_raw")==0) ||
	     (strcmp(r->datid[i],"gc_gx")==0))){
	  mod_mesh_get_resp(m,mi,xi,yi,seedlist[si],pop_name,zi,
			    &ts,&tsn,&tv,&tvn,&tg,&tg0,&tgn);
	  s[mi][zi] = ts;
	  v[mi][zi] = tv;
	  g[mi][zi] = tg;
	  g0[mi][zi] = tg0;
	  sn[mi][zi] = tsn;
	  vn[mi][zi] = tvn;
	  gn[mi][zi] = tgn;
	  cnt += 1;      
	  si += 1;
	}
	if (strcmp(r->datid[i],"gc_spikes")==0){
	  mod_util_resp_store_s(r,i,s[mi][zi],sn[mi][zi],1,mylogf); 
	}else if (strcmp(r->datid[i],"gc_vm")==0){
	  mod_util_resp_store_f(r,i,v[mi][zi],vn[mi][zi],1,mylogf);
	}else if (strcmp(r->datid[i],"gc_gx")==0){
	  mod_util_resp_store_f(r,i,g[mi][zi],gn[mi][zi],1,mylogf);
	}else if (strcmp(r->datid[i],"gc_gx_raw")==0){
	  mod_util_resp_store_f(r,i,g0[mi][zi],gn[mi][zi],1,mylogf);
	}else if (strcmp(r->datid[i],"horiz")==0){
	  t = mod_mesh_resp_get_h(mi,xi,yi,0);
	  mod_util_resp_store_f(r,i,t,mod_mesh_tn,0,mylogf); 
	}else if (strcmp(r->datid[i],"photo")==0){
	  if (mm_mosaic_flag == 1)
	    t = mm_mosaic_cex[mi];
	  else
	    t = mod_mesh_stim[xi][yi];
	  mod_util_resp_store_f(r,i,t,mod_mesh_tn,1,mylogf); 
	}
      }else{
	sprintf(ggstr,"  *** DataID:  %s\n",r->datid[i]);
	mylog(mylogf,ggstr);
	mylog_exit(mylogf,"MOD_MESH_RESP_HANDOVER  Unknown data ID.\n");
      }
    }
  }
  sprintf(ggstr,"    Responses computed for %d locations\n",cnt);
  mylog(mylogf,ggstr);
  free_3d_farray_null(s,n,zn,0);
  free_3d_farray_null(v,n,zn,0);
  free_3d_farray_null(g,n,zn,0);
  free_3d_farray_null(g0,n,zn,0);
  free_2d_farray(sn,n);
  free_2d_farray(vn,n);
  free_2d_farray(gn,n);
}
void mod_mesh_run()
{
  int i,j;
  int tn,ti,n,nm1,nm2,cnt;
  float alpha,alph2,beta,beta1m,gamma,cap,gh_prime;
  float *a,*b,*c,*r,dx,gh,gp,**uo,**un,**ut,*tpf1,*tpf2;
  double dt,tf,tfrac1,tfrac2;
  float *tu,*tun,*tus,*tcol,***u,***s,**ts1,**ts2,*tts1,*tts2;
  mylog(mylogf,"  MOD_MESH_RUN\n");
  n = mod_mesh_w;       
  tn = mod_mesh_tn;
  u = mod_mesh_u;       
  uo = mod_mesh_uo;     
  un = mod_mesh_un;     
  tcol = mod_mesh_tcol; 
  s = mod_mesh_stim;    
  ts1 = mod_mesh_ts1;   
  ts2 = mod_mesh_ts2;   
  gh = mod_mesh_gh;     
  gp = mod_mesh_gp;     
  cap = mod_mesh_cc;    
  dt = (double)mod_mesh_dt; 
  dx = mod_mesh_dx;
  for(i=0;i<n;i++)      
    for(j=0;j<n;j++)    
      u[0][i][j] = uo[i][j];
  gh_prime = gh / (2.0*cap);
  gamma = dt * gp/cap;
  alpha = gh_prime * dt/(dx*dx);
  alph2 = alpha/2.0;
  beta = alpha + gp*dt/(2.0*cap);
  beta1m = 1.0 - beta;
  nm1 = n-1;
  nm2 = n-2;
  a = mod_mesh_a; 
  b = mod_mesh_b;
  c = mod_mesh_c;
  r = mod_mesh_r;
  for(i=0;i<n;i++){ 
    a[i] = c[i] = -alpha/2.0;
    b[i] = 1.0 + beta;
  }
  c[0] *= 2.0; 
  a[nm2-1] *= 2.0; 
  ti = 0;   
  tf = 0.0; 
  cnt = 0;  
  while(ti < tn){
    tfrac1 = tf - (double)ti + dt/4.0;   
    tfrac2 = tfrac1 + dt/2.0; 
    for(i=0;i<n;i++){
      tpf1 = s[ti][i]; 
      if (ti >= (tn-1)) 
	tpf2 = s[ti][i];
      else
	tpf2 = s[ti+1][i];
      tts1 = ts1[i];
      tts2 = ts2[i];
      for(j=0;j<n;j++){
	tts1[j] = tpf1[j] + tfrac1 * (tpf2[j] - tpf1[j]);
	tts2[j] = tpf1[j] + tfrac2 * (tpf2[j] - tpf1[j]);
      }
    }
    for(i=1;i<nm1;i++){ 
      tu = uo[i];
      tun = uo[i-1];
      tus = uo[i+1];
      tts1 = ts1[i];
      for(j=1;j<nm1;j++) 
	r[j] = beta1m*tu[j] + alph2*(tun[j] + tus[j]) + gamma*tts1[j];
      tridag(a-1,b-1,c-1,r,un[i],nm2); 
      un[i][0] = un[i][2];
      un[i][n-1] = un[i][n-3];
    }
    for(j=0;j<n;j++){ 
      un[0][j] = un[2][j];
      un[n-1][j] = un[n-3][j];
    }
    ut = uo; uo = un; un = ut; 
    for(j=1;j<nm1;j++){ 
      for(i=1;i<nm1;i++){ 
	r[i] = beta1m*uo[i][j] + alph2*(uo[i][j-1] + uo[i][j+1]) +
               gamma*ts2[i][j];
      }
      tridag(a-1,b-1,c-1,r,tcol,nm2); 
      for(i=1;i<=nm2;i++) 
	un[i][j] = tcol[i];
      un[0][j] = un[2][j]; 
      un[n-1][j] = un[n-3][j]; 
    }
    for(i=0;i<n;i++){ 
      un[i][0] = un[i][2];
      un[i][n-1] = un[i][n-3];
    }
    tf += dt;
    if (tf >= (float)(ti+1)){
      ti += 1; 
      if (ti%1000==0){
	sprintf(ggstr,"%8d time units\n",ti);
	mylog(mylogf,ggstr);
      }
      if (ti < tn){
	for(i=0;i<n;i++) 
	  for(j=0;j<n;j++)
	    u[ti][i][j] = un[i][j];
      }
    }
    if (mod_mesh_disp){
      if ((mod_mesh_dispn > 0)&&(cnt % mod_mesh_dispn)==0){
	if (strcmp("diff",mod_mesh_outtype)==0){  
	  float **diff;
	  diff = subtract_2d_farrays(ts1,un,n,n);
	  glplot_open_show_2d(diff,n,n,4.0,0,-1.0,-1.0);
	  free_2d_farray(diff,n);
	}else if (strcmp("hc",mod_mesh_outtype)==0){ 
	  glplot_open_show_2d(un,n,n,mod_mesh_zoom,0,
			      mod_mesh_min,mod_mesh_max);
	}
      }
    }
    ut = uo; uo = un; un = ut; 
    cnt += 1;
  }
  sprintf(ggstr,"%8d time units simulated.\n",ti);
  mylog(mylogf,ggstr);
  if ((strcmp(mod_mesh_dump_type,"3d")!=0) &&
      (strcmp(mod_mesh_dump_file,"null")!=0)){
    float ***dxyt;
    if (strcmp("diff",mod_mesh_outtype)==0){  
      float ***tdiff;
      printf(" WYETH - This was developed, but never tested, does it work?\n");
      exit(0);
      tdiff = subtract_3d_farrays(s,u,0,tn,0,n,0,n);
      dxyt = get_xyt_from_txy_3d_farray(tdiff,tn,n,n);
      free_3d_farray(tdiff,tn,n,n);
      printf("  DUMPING 'diff':  stim - h-cell\n");
    }else{
      dxyt = get_xyt_from_txy_3d_farray(u,tn,n,n);
      printf("  DUMPING 'hc':  h-cell response\n");
    }
    write_3d_data(mod_mesh_dump_file,dxyt,n,n,tn,4,2,1);
    free_3d_farray(dxyt,n,n,tn);
  }
}
void mod_mesh_run_irreg(hv,gp,gh,dt,nstep)
     float **hv;
     float gp,gh,dt;   
     int nstep;        
{
  int i;
  int ti,tt,cn,tn,tim1,ne,ci0,ci1;
  float ch,cp,diff,cval,cw_cp;
  float **cex;       
  float **thv;       
  mylog(mylogf,"  MOD_MESH_RUN_IRREG\n");
  cn  = mm_mosaic_cn;    
  tn  = mod_mesh_tn;     
  ne  = mm_edge_n;       
  cex = mm_mosaic_cex;   
  ch = gh * 1000.0 * (mod_mesh_tscale / nstep);
  cp = gp * 1000.0 * (mod_mesh_tscale / nstep);
  sprintf(ggstr,"    ch,cp  %f %f   dt %f  nstep %d\n",ch,cp,dt,
	  mod_mesh_nstep);
  mylog(mylogf,ggstr);
  thv = get_2d_farray(cn,nstep);  
  for(ti=1;ti<tn;ti++){
    tim1 = ti-1;
    for(tt=0;tt<nstep;tt++){  
      if (tt == 0){  
	for(i=0;i<cn;i++){  
	  cw_cp = cp * mod_mesh_hcw[mm_mosaic_cid[i]];  
	  diff = cw_cp * (cex[i][ti] - hv[i][tim1]);
	  thv[i][tt] = hv[i][tim1] + diff;
	}
      }else{
	for(i=0;i<cn;i++){  
	  cw_cp = cp * mod_mesh_hcw[mm_mosaic_cid[i]];  
	  diff = cw_cp * (cex[i][ti] - thv[i][tt-1]);
	  thv[i][tt] = thv[i][tt-1] + diff;
	}
      }
      if (mm_mosaic_noise != 0.0){
	if (tt == 0){  
	  for(i=0;i<ne;i++){   
	    ci0 = mm_edge_0[i];
	    ci1 = mm_edge_1[i];
	    diff = mm_edge_w[i] * (hv[ci0][tim1] - hv[ci1][tim1]);
	    hv[ci0][ti] -= diff;
	    hv[ci1][ti] += diff;
	  }
	}else{
	  for(i=0;i<ne;i++){   
	    ci0 = mm_edge_0[i];
	    ci1 = mm_edge_1[i];
	    diff = mm_edge_w[i] * (thv[ci0][tt-1] - thv[ci1][tt-1]);
	    thv[ci0][tt] -= diff;
	    thv[ci1][tt] += diff;
	  }
	}
      }else{
	if (tt == 0){  
	  for(i=0;i<ne;i++){   
	    ci0 = mm_edge_0[i];
	    ci1 = mm_edge_1[i];
	    diff = ch * (hv[ci0][tim1] - hv[ci1][tim1]);
	    hv[ci0][ti] -= diff;
	    hv[ci1][ti] += diff;
	  }
	}else{
	  for(i=0;i<ne;i++){   
	    ci0 = mm_edge_0[i];
	    ci1 = mm_edge_1[i];
	    diff = ch * (thv[ci0][tt-1] - thv[ci1][tt-1]);
	    thv[ci0][tt] -= diff;
	    thv[ci1][tt] += diff;
	  }
	}
      }
    }
    for(i=0;i<cn;i++){
      hv[i][ti] = thv[i][nstep-1];   
    }
  }
  free_2d_farray(thv,cn);
  if ((strcmp(mod_mesh_dump_type,"h_v_dist")==0) ||
      (strcmp(mod_mesh_dump_type,"h2_v_dist")==0)){ 
    int cid,t0;
    char fname[SLEN];
    cid = mod_mesh_dump_cid;       
    if (mod_mesh_dump_tsec == -1.0)  
      t0 = tn - 1;
    else{
      t0 = my_rint(mod_mesh_dump_tsec/mod_mesh_tscale);  
      if ((t0 < 0) || (t0 >= tn)){
	printf("mod_mesh_dump_tsec = %f\n",mod_mesh_dump_tsec);
	printf("tn = %d   tscale = %f\n",tn,mod_mesh_tscale);
	exit_error("MOD_MESH_RUN_IRREG","  mod_mesh_dump_tsec out of bounds");
      }
    }
    if (strcmp(mod_mesh_dump_file,"null")==0)  
      sprintf(fname,"zz.dist.pl");
    else
      sprintf(fname,"%s",mod_mesh_dump_file);
    retutil_val_dist_plot(hv,cn,mm_mosaic_cx,mm_mosaic_cy,cid,t0,fname);
    printf("  Exiting after writing dump file, %s\n\n",fname);
    exit(0);
  }else if (strcmp(mod_mesh_dump_type,"time")==0){
    int cid;
    char fname[SLEN],pname[SLEN];
    cid = mod_mesh_dump_cid;
    if (strcmp(mod_mesh_dump_file,"null")==0)  
      sprintf(fname,"zz.cid_%d_v_time.pl",cid);
    else
      sprintf(fname,"%s",mod_mesh_dump_file);
    sprintf(pname,"cid_%d",cid);
    append_farray_plot(fname,pname,hv[cid],tn,1);
    printf("  Exiting after writing dump file, %s\n\n",fname);
    exit(0);
  }
  if ((strcmp(mod_mesh_dump_type,"3d_h")==0) ||  
      (mod_mesh_dump_hex == 1)){                 
    int j;
    float ***d3;
    int xn,yn,cid;
    float *xcut;
    append_farray_plot("zz.hex.cut.pl","hex_0",hv[0],tn,1);
    if (cn == 1613){
      append_farray_plot("zz.hex.cut.pl","hex_37",hv[37],tn,1);
      append_farray_plot("zz.hex.cut.pl","hex_1575",hv[1575],tn,1);
      append_farray_plot("zz.hex.cut.pl","hex_1612",hv[1612],tn,1);
      append_farray_plot("zz.hex.cut.pl","hex_806_CTR",hv[806],tn,1);
    }else if (cn == 6481){
      append_farray_plot("zz.hex.cut.pl","hex_73",hv[73],tn,1);
      append_farray_plot("zz.hex.cut.pl","hex_6407",hv[6407],tn,1);
      append_farray_plot("zz.hex.cut.pl","hex_6480",hv[6480],tn,1);
      append_farray_plot("zz.hex.cut.pl","hex_3240_CTR",hv[3240],tn,1);
    }
    if (strcmp(mm_mosaic_arrgn,"RegJit")==0){
      xn = mod_mesh_w;
      yn = mod_mesh_h;
      d3 = retutil_hex_to_3d_new(hv,cn,tn,mm_mosaic_cx,mm_mosaic_cy,xn,yn);
    }else{
      d3 = retutil_hex_to_3d(hv,cn,tn,mm_mosaic_cx,mm_mosaic_cy,&xn,&yn);
    }
    write_3d_data("zzz.hexh.3d",d3,xn,yn,tn,4,2,1);
    {
      int subn;
      float *subdata;
      char tname[SLEN];
      j = yn/2;
      xcut = get_farray(xn);
      for(i=0;i<xn;i++)
	xcut[i] = d3[i][j][tn-1];
      subsample_farray(xcut,xn,&subdata,&subn,2,0);
      sprintf(tname,"y=%d_tn-1",j);
      append_farray_plot("zz.hex.cut.pl",tname,subdata,subn,1);
      append_farray_plot("zz.hex.cut2.pl","hex_t=tn-1",xcut,xn,1);
      printf("  Exiting after writing dump files\n");
      exit(0);
    }
  }
}
void model_mesh_resp_0(m,s,r)
     struct model_struct *m;        
     struct stim_struct *s;         
     struct response_struct *r;     
{
  int i,j;
  int tn,h,w;
  mod_mesh_tn = mod_util_set_var_tn(mylogf,s,mod_mesh_tmax,mod_mesh_tscale);
  tn = mod_mesh_tn;
  w = mod_mesh_w;
  h = mod_mesh_h;
  if (mm_mosaic_flag == 0){
    model_mesh_photo_filter(s->d,m->mseed[r->tsi]); 
  }else if (mm_mosaic_flag == 1){
    model_mesh_mosaic_get_conex4(s,m->mseed[r->tsi]);
  }else
    exit_error("MODEL_MESH_RESP_0","Unknown mosaic_flag value");
  if ((r->tsi == 0) || (mod_mesh_reset == 1)){
    if (mod_mesh_type == 0){
      for(i=0;i<h;i++){
	for(j=0;j<w;j++){
	  mod_mesh_uo[i][j] = mod_mesh_stim[0][i][j];  
	}
      }
    }else if (mod_mesh_type == 1){
      for(i=0;i<mm_mosaic_cn;i++){
	mod_mesh_hirr[i][0] = mm_mosaic_cex[i][0];
      }
      if (mod_mesh_h2_flag == 1){
	for(i=0;i<mm_mosaic_cn;i++)
	  mod_mesh_h2rr[i][0] = mm_mosaic_cex[i][0];
      }
    }else{
      mylogx(mylogf,"MODEL_MESH_RESP_0","Unknown mesh type");
    }
  }
  if (mod_mesh_type == 1){
    mod_mesh_hcw = mod_mesh_h1cw;
    mod_mesh_run_irreg(mod_mesh_hirr,mod_mesh_gp,mod_mesh_gh,
		       mod_mesh_dt,mod_mesh_nstep);
    if (mod_mesh_h2_flag == 1){
      mod_mesh_hcw = mod_mesh_h2cw;
      mod_mesh_run_irreg(mod_mesh_h2rr,mod_mesh_h2_gp,mod_mesh_h2_gh,
		       mod_mesh_h2_dt,mod_mesh_h2_nstep);
    }
  }else if (mod_mesh_type == 0){
    mod_mesh_run();       
  }
  if ((r->tsi == 0) || (mod_mesh_reset == 1)){
    mod_mesh_ad1_reset();  
  }
}
void mod_mesh_resp_hp_gain(m,s,ci,cj,d,gain,dumpflag)
     struct model_struct *m;   
     struct stim_struct *s;    
     int ci,cj;                
     float *d;                 
     float *gain;              
     int dumpflag;             
{
  int i;
  int tn;
  float *dhp,*cf,*lp;
  char name[SLEN];
  tn = mod_mesh_tn;
  if (mod_mesh_gain_hpflag == 1){
    lp = convolve_with_mask_causal_x0(d,tn,mod_mesh_lp_mask,mod_mesh_lpmn);
    dhp = get_zero_farray(tn); 
    cf = (float *)myalloc(tn*sizeof(float)); 
    for(i=0;i<tn;i++){
      cf[i] = 0.5 + 0.5*func_sigmoid_tanh(gain[i],mod_mesh_gsig_slope,
					  mod_mesh_gsig_mean);
      dhp[i] = d[i] - cf[i] * lp[i];
    }
    if (dumpflag){
      sprintf(name,"%s_LP(t)",mod_mesh_dumps);
      append_farray_plot(mod_mesh_dumpf,name,lp,tn,1);
      sprintf(name,"%s_PHADG(t)",mod_mesh_dumps);
      append_farray_plot(mod_mesh_dumpf,name,dhp,tn,1);
      sprintf(name,"%s_Gain1S(t)",mod_mesh_dumps);
      append_farray_plot(mod_mesh_dumpf,name,cf,tn,1);
    }
    myfree(lp); myfree(cf);
    for(i=0;i<tn;i++)
      d[i] = dhp[i];
    myfree(dhp);
  }
}
void mod_mesh_gain_global(m,rsig,rsig2)
     struct model_struct *m;   
     float **rsig;    
     float **rsig2;   
{
  int i,j,k;
  int tn,h,w,cn,ti,tj;
  float *sig,*sig2,diff,tdiff,***u,whc,fc,avg,*lp;
  float ad1c,tad,aa,w0,w1,w2,w3,ht;
  char fname[SLEN];
  mylog(mylogf,"  MOD_MESH_GAIN_GLOBAL  Computing global power\n");
  *rsig = sig; *rsig2 = sig2;
}
void mod_mesh_compute_diff_all(m,s,r)
     struct model_struct *m;      
     struct stim_struct *s;       
     struct response_struct *r;   
{
  int i,j,ti,tj;
  int tn,xn,yn,save_flag,out_id;
  float ht,*diff,***u,whc,ad1c,dd,tad,fc,*lp,aa,w0,w1,w2,w3;
  float *save_ht,*save_tad,*save_d,*save_p;
  float *photo,*horiz,*h2,ws_h1,ws_h2,wlm_h1,wlm_h2;
  char tstr[SLEN];
  mylog(mylogf,"  MOD_MESH_COMPUTE_DIFF_ALL\n");
  model_mesh_resp_0(m,s,r);
  tn   = mod_mesh_tn;   
  whc  = mod_mesh_whc;         
  ws_h1 = mod_mesh_w_h1_s;     
  ws_h2 = mod_mesh_w_h2_s;
  wlm_h1 = mod_mesh_w_h1_lm;
  wlm_h2 = mod_mesh_w_h2_lm;
  xn   = mod_mesh_w;
  yn   = mod_mesh_h;
  u    = mod_mesh_u;
  ad1c = mod_mesh_ad1_c;
  aa   = mod_mesh_ad1_a;
  if (mod_mesh_dump == 0){
    out_id = -1;                    
  }else{
    out_id = mm_mosaic_out_id;      
    save_ht  = get_farray(tn);
    save_tad = get_farray(tn);
    if (mm_mosaic_flag == 0)
      mylog_exit(mylogf,
		 "MOD_MESH_COMPUTE_DIFF_ALL  Dump not imp'd for rect. grid.");
  }
  for(i=0;i<tn;i++){ 
    mod_mesh_gain1[i] = 0.0;
    mod_mesh_gain2[i] = 0.0;
  }
  if (mm_mosaic_flag == 1){
    if (mod_mesh_diffm == NULL) 
      mod_mesh_diffm = get_2d_farray(mm_mosaic_cn,tn);
    if (mod_mesh_type == 0){  
      for(j=0;j<mm_mosaic_cn;j++){
	if (j == out_id)  
	  save_flag = 1;
	else
	  save_flag = 0;
	diff = mod_mesh_diffm[j]; 
	model_mesh_mosaic_get_ijw_for_cid(j,&ti,&tj,&w0,&w1,&w2,&w3);
	tad = mod_mesh_ad1m[j];  
	for(i=0;i<tn;i++){
	  ht = (w0*u[i][ti  ][tj  ] + w1*u[i][ti+1][tj  ] + 
		w2*u[i][ti  ][tj+1] + w3*u[i][ti+1][tj+1]);
	  dd = mm_mosaic_cex[j][i] - whc*ht;     
	  diff[i] = dd - tad;                    
	  tad = ad1c * (tad - aa*dd) + aa*dd;    
	  if (save_flag){
	    save_ht[i]  = ht;
	    save_tad[i] = tad;
	  }
	  if (diff[i] > 0.0) 
	    mod_mesh_gain1[i] += diff[i];
	  else
	    mod_mesh_gain1[i] -= diff[i];
	  mod_mesh_gain2[i] += diff[i]*diff[i];
	}
	mod_mesh_ad1m[j] = tad;  
      }
    }else if (mod_mesh_type == 1){  
      for(j=0;j<mm_mosaic_cn;j++){
	if (j == out_id)  
	  save_flag = 1;
	else
	  save_flag = 0;
	diff = mod_mesh_diffm[j];   
	photo = mm_mosaic_cex[j];   
	horiz = mod_mesh_hirr[j];   
	if (mod_mesh_h2_flag == 1)
	  h2 = mod_mesh_h2rr[j];   
	tad   = mod_mesh_ad1m[j];   
	for(i=0;i<tn;i++){
	  if (mod_mesh_h2_flag == 0){
	    dd = photo[i] - whc*horiz[i];        
	  }else{
	    if (mm_mosaic_cid[j] == 0){ 
	      dd = photo[i] -  ws_h1*horiz[i] -  ws_h2*h2[i];    
	    }else{
	      dd = photo[i] - wlm_h1*horiz[i] - wlm_h2*h2[i];    
	    }
	  }
	  diff[i] = dd - tad;                  
	  tad = ad1c * (tad - aa*dd) + aa*dd;  
	  if (save_flag){
	    save_tad[i] = tad;
	  }
	  if (diff[i] > 0.0)
	    mod_mesh_gain1[i] += diff[i];
	  else
	    mod_mesh_gain1[i] -= diff[i];
	  mod_mesh_gain2[i] += diff[i]*diff[i];
	}
	mod_mesh_ad1m[j] = tad;  
      }
    }
    fc = (float)mm_mosaic_cn;
  }else{
    if (mod_mesh_diff == NULL) 
      mod_mesh_diff = get_3d_farray(xn,yn,tn);
    for(i=0;i<xn;i++){
      for(j=0;j<yn;j++){
	diff = mod_mesh_diff[i][j]; 
	tad = mod_mesh_ad1[i][j]; 
	for(ti=0;ti<tn;ti++){
	  ht = u[ti][i][j];
	  dd = mod_mesh_stim[ti][i][j] - whc*ht; 
	  diff[ti] = dd - tad;                   
	  tad = ad1c * (tad - aa*dd) + aa*dd;    
	  if (diff[ti] > 0.0) 
	    mod_mesh_gain1[ti] += diff[ti];
	  else
	    mod_mesh_gain1[ti] -= diff[ti];
	  mod_mesh_gain2[ti] += diff[ti]*diff[ti];
	}
	mod_mesh_ad1[i][j] = tad; 
      }
    }
    fc = (float)(xn*yn); 
  }
  if (out_id >= 0){
    save_p = mm_mosaic_cex[out_id];     
    save_d = mod_mesh_diffm[out_id];    
    sprintf(tstr,"%s_P",mod_mesh_dumps);
    append_farray_plot(mod_mesh_dumpf,tstr,save_p,tn,1);
    sprintf(tstr,"%s_H",mod_mesh_dumps);
    if (mod_mesh_type == 1){
      append_farray_plot(mod_mesh_dumpf,tstr,mod_mesh_hirr[out_id],tn,1);
      if (mod_mesh_h2_flag == 1){
	sprintf(tstr,"%s_H2",mod_mesh_dumps);
	append_farray_plot(mod_mesh_dumpf,tstr,mod_mesh_h2rr[out_id],tn,1);
      }
    }else
      append_farray_plot(mod_mesh_dumpf,tstr,save_ht,tn,1);
    sprintf(tstr,"%s_PHAD",mod_mesh_dumps);
    append_farray_plot(mod_mesh_dumpf,tstr,save_d,tn,1);
    sprintf(tstr,"%s_ad1",mod_mesh_dumps);
    append_farray_plot(mod_mesh_dumpf,tstr,save_tad,tn,1);
    myfree(save_ht);
    myfree(save_tad);
    write_2d_data("zzz.phad.2d",mod_mesh_diffm,0,0,mm_mosaic_cn,tn,4,2,0,1);
  }
  if (mod_mesh_slice_ti != -1){
    if (mod_mesh_type == 0){
      sprintf(tstr,"H_t%d_x%d",mod_mesh_slice_ti,mod_mesh_slice_xi);
      append_farray_plot("zzz.hsect.pl",tstr,
			 u[mod_mesh_slice_ti][mod_mesh_slice_xi],yn,1);
    }else{
      mylogx(mylogf,"MOD_MESH_COMPUTE_DIFF_ALL","H-slice not imp'd for irr");
    }
  }
  for(i=0;i<tn;i++){
    mod_mesh_gain1[i] /= fc;  
    mod_mesh_gain2[i] /= fc;
  }
  if (mod_mesh_lp2tau > 0.0){
    printf("********************* YWETHEHT -----\n");
    if (mod_mesh_gain2 == NULL)
      printf(". . . is NULL\n");
    else
      printf(". . . is NULL\n");
    if (mod_mesh_lp2_mask == NULL)
      printf("lp2 MASK. . . is NULL\n");
    else
      printf("lp2 MASK. . . is nnooooootttt  NULL\n");
    lp = convolve_with_mask_causal_x0(mod_mesh_gain2,tn,
				      mod_mesh_lp2_mask,mod_mesh_lp2mn);
    myfree(mod_mesh_gain2);
    mod_mesh_gain2 = lp;
  }
  if (mod_mesh_gain_hpflag == 1){
    if (mm_mosaic_flag == 1){
      printf("*-----------------****************  HERE WYETH GAIN\n");
      for(i=0;i<mm_mosaic_cn;i++){
	if (i == out_id)
	  mod_mesh_resp_hp_gain(m,s,i,-1,mod_mesh_diffm[i],mod_mesh_gain1,1);
	else
	  mod_mesh_resp_hp_gain(m,s,i,-1,mod_mesh_diffm[i],mod_mesh_gain1,0);
      }
    }else{
      if (mod_mesh_gain_hpflag == 1){
	for(i=0;i<xn;i++){
	  for(j=0;j<yn;j++){
	    mod_mesh_resp_hp_gain(m,s,i,j,mod_mesh_diff[i][j],mod_mesh_gain1,
				  0);
	  }
	}
      }
    }
  }
}
void mod_mesh_get_spikes_2d_flag(m,s,r,pop_name,onflag,xn,yn,flag,
				 rs2,rcnt2)
     struct model_struct *m;      
     struct stim_struct *s;       
     struct response_struct *r;   
     char *pop_name;              
     int onflag;                  
     int xn,yn;                   
     int **flag;                  
     float ****rs2;  
     int ***rcnt2;   
{
  int i,j,ti;
  int tn,**cnt2,unit_count,spike_count,vn,seed,*seedlist;
  float ***s2,*gti,*gtx,*v,samp,*td;
  char *sgen;
  struct onode *po,*spko;
  mylog(mylogf,"  MOD_MESH_GET_SPIKES_2D_FLAG\n");
  sprintf(ggstr,"      Layer %s\n",pop_name);
  mylog(mylogf,ggstr);
  if (mm_mosaic_flag == 1)
    mylog_exit(mylogf,"MOD_MESH_GET_SPIKES_2D_FLAG  Mosaic not imp'd.\n");
  if ((xn != mod_mesh_w) || (yn != mod_mesh_h))
    mylog_exit(mylogf,"MOD_MESH_GET_SPIKES_2D_FLAG  Dimension mismatch.\n");
  po = onode_get_node_type_item_val(m->o,"pop","name",pop_name);
  if (po == NULL)
    mylog_exit(mylogf,"MOD_MESH_GET_SPIKES_2D_FLAG  Bad pop_name.\n");
  spko = onode_child_get_unique(po,"spike_gen");
  sgen = onode_getpar_chr_exit(spko,"type");
  if (myid == -1){ 
    if (onode_test_ostr(po,"ifc_dump_coord")){
      printf("***** WYETH - 'ifc_dump_coord' is to be phased out - remove?\n");
    }
  }
  cnt2 = get_zero_2d_iarray(xn,yn);
  s2 = (float ***)myalloc(xn*sizeof(float **));
  for(i=0;i<xn;i++)
    s2[i] = (float **)myalloc(yn*sizeof(float *));
  tn   = mod_mesh_tn;
  samp = 1.0/mod_mesh_tscale; 
  gtx = get_zero_farray(tn);
  gti = get_zero_farray(tn);  
  seedlist = get_seeds(m->mseed[r->tsi],1000000,xn*yn);
  unit_count = 0;   
  spike_count = 0;  
  for(i=0;i<xn;i++){
    for(j=0;j<yn;j++){
      if (flag[i][j]){
	td = mod_mesh_diff[i][j];  
	if (onflag == 0)
	  for(ti=0;ti<tn;ti++)
	    gtx[ti] = -td[ti];  
	else
	  for(ti=0;ti<tn;ti++)
	    gtx[ti] = td[ti];
	if (mod_mesh_gain_g2in){  
	  for(ti=0;ti<tn;ti++)
	    gti[ti] = mod_mesh_gain2[ti];
	}else{
	  for(ti=0;ti<tn;ti++)
	    gti[ti] = 0.0; 
	}
	seed = seedlist[i*yn + j];
	mod_mesh_spike_gen(m,gtx,gti,tn,seed,samp,sgen,pop_name,NULL,0,
			   &(s2[i][j]),&(cnt2[i][j]),&v,&vn);
	unit_count += 1;
	spike_count += cnt2[i][j];
      }else{ 
	s2[i][j] = NULL;  
	cnt2[i][j] = -1;  
      }
    }
  }
  myfree(gtx);
  myfree(gti);
  myfree(sgen);
  myfree(seedlist);
  sprintf(ggstr,"      Spikes generated at %d of %d units, %.4f spk/cell\n",
	  unit_count,xn*yn,(float)spike_count/(float)unit_count);
  mylog(mylogf,ggstr);
  *rs2 = s2; *rcnt2 = cnt2;
}
void mod_mesh_get_spikes_3d_flag(m,s,r,pop_name,cmap,xn,yn,zn,rs,rcnt)
     struct model_struct *m;      
     struct stim_struct *s;       
     struct response_struct *r;   
     char *pop_name;              
     int ***cmap;                 
     int xn,yn,zn;                
     float *****rs;     
     int ****rcnt;      
{
  int i,j,k,ti;
  int tn,***cnt,unit_count,spike_count,vn,seed,*seedlist,dumpi,dumpk;
  float ****s1,*gti,*gtx,*v,samp,*td;
  char *sgen,*dump_ptr,dump_name[SLEN];
  struct onode *po,*spko;
  mylog(mylogf,"  MOD_MESH_GET_SPIKES_3D_FLAG\n");
  sprintf(ggstr,"      Layer %s\n",pop_name);
  mylog(mylogf,ggstr);
  if (mm_mosaic_flag != 1)
    mylogx(mylogf,"MOD_MESH_GET_SPIKES_3D_FLAG","Intended for mosaic.\n");
  if ((xn != mm_mosaic_cn) || (yn != 1) || (zn != 2))
    mylogx(mylogf,"MOD_MESH_GET_SPIKES_3D_FLAG","Bad cmap size.\n");
  po = onode_get_node_type_item_val(m->o,"pop","name",pop_name);
  if (po == NULL)
    mylog_exit(mylogf,"MOD_MESH_GET_SPIKES_3D_FLAG  Bad pop_name.\n");
  spko = onode_child_get_unique(po,"spike_gen");
  sgen = onode_getpar_chr_exit(spko,"type");
  dumpi = dumpk = -1;
  if (myid == -1){ 
    if (onode_test_ostr(po,"spike_dump_xi")){
      dumpi = onode_getpar_int_exit(po,"spike_dump_xi");
      dumpk = onode_getpar_int_exit(po,"spike_dump_zi");
      sprintf(dump_name,"%s_%d_0_%d.%s",pop_name,dumpi,dumpk,s->name);
    }
  }
  cnt = get_zero_3d_iarray(zn,xn,yn);
  s1 = (float ****)myalloc(zn*sizeof(float ***));
  for(i=0;i<zn;i++){
    s1[i] = (float ***)myalloc(xn*sizeof(float **));
    for(j=0;j<xn;j++)
      s1[i][j] = (float **)myalloc(yn*sizeof(float *));
  }
  tn   = mod_mesh_tn;
  samp = 1.0/mod_mesh_tscale; 
  gtx = get_zero_farray(tn);
  gti = get_zero_farray(tn);  
  seedlist = get_seeds(m->mseed[r->tsi],1000000,xn*zn);
  unit_count = 0;   
  spike_count = 0;  
  for(k=0;k<zn;k++){
    for(i=0;i<xn;i++){
      if (cmap[i][0][k]){  
	if (mod_mesh_csig > 0.0){
	  td = mod_mesh_spatial_sum(i,-1,-1,0);  
	}else{
	  td = mod_mesh_diffm[i];  
	}
	if (k == 0)
	  for(ti=0;ti<tn;ti++)
	    gtx[ti] = -td[ti];  
	else
	  for(ti=0;ti<tn;ti++)
	    gtx[ti] = td[ti];
	if (mod_mesh_csig > 0.0){
	  myfree(td);
	}
	if (mod_mesh_gain_g2in){  
	  for(ti=0;ti<tn;ti++)
	    gti[ti] = mod_mesh_gain2[ti];
	}else{
	  for(ti=0;ti<tn;ti++)
	    gti[ti] = 0.0; 
	}
	seed = seedlist[k*xn + i];
	if ((i == dumpi) && (k == dumpk)){
	  dump_ptr = dump_name;
	}else
	  dump_ptr = NULL;
	mod_mesh_spike_gen(m,gtx,gti,tn,seed,samp,sgen,pop_name,dump_ptr,0,
			   &(s1[k][i][0]),&(cnt[k][i][0]),&v,&vn);
	unit_count += 1;
	spike_count += cnt[k][i][0];
      }else{ 
	s1[k][i][0] = NULL;  
	cnt[k][i][0] = -1;  
      }
    }
  }
  myfree(gtx);
  myfree(gti);
  myfree(sgen);
  myfree(seedlist);
  sprintf(ggstr,"      Spikes generated at %d of %d units, %.4f spk/cell\n",
	  unit_count,xn*zn,(float)spike_count/(float)unit_count);
  mylog(mylogf,ggstr);
  *rs = s1;
  *rcnt = cnt;
}
void mod_mesh_resp_ph_diff(m,rht,rdiff,name,xi,yi)
     struct model_struct *m;    
     float **rht;               
     float **rdiff;             
     char *name;
     int xi,yi;
{
  int i,j,k;
  int tn,cid,ti,tj,tti,ttj,h,w,cn;
  float *ht,*diff,***u,whc,csig,weight,totw,*p,ad1c,*att,dd,tad;
  float w0,w1,w2,w3,tw0,tw1,tw2,tw3,aa;
  char fname[SLEN],tstr[SLEN];
  myfree(p);
  *rht = ht; *rdiff = diff;
}
void model_mesh_rgc_01_get_response(m,s,r,k)
     struct model_struct *m;        
     struct stim_struct *s;         
     struct response_struct *r;     
     int k;                         
{
  mod_mesh_dumps = s->name;  
  mod_mesh_compute_diff_all(m,s,r);
  mod_mesh_resp_handover(m,r);
}
void model_mesh_mag_01_get_response(m,s,r,k)
     struct model_struct *m;        
     struct stim_struct *s;         
     struct response_struct *r;     
     int k;                         
{
  int i,j,jj;
  int w,h,tn,rvn;
  float *rt,*diff,csig,whc,weight,totw;
  float *rv;
  csig = mod_mesh_csig;
  whc = mod_mesh_whc;
  w = mod_mesh_w;
  h = mod_mesh_h;
  tn = mod_mesh_tn;
  model_mesh_photo_filter(s->d,m->mseed[r->tsi]);
  for(i=0;i<h;i++)
    for(j=0;j<w;j++)
      mod_mesh_uo[i][j] = 0.0;
  mod_mesh_run();
  rt = get_zero_farray(tn);
  diff = get_zero_farray(tn);
  rt[0] = 0.0;
  diff[0] = 0.0;
  if (csig <= 0.0){
    for(i=1;i<tn;i++){
      rt[i] = mod_mesh_u[i][h/2][w/2]; 
      diff[i] = mod_mesh_stim[i][h/2][w/2] - whc*rt[i];
    }
  }else{
    totw = 0.0;
    for(j=0;j<h;j++)
      for(jj=0;jj<w;jj++){
	weight = func_2d_gaussian((float)j,(float)jj,(float)h/2.0,
				  (float)w/2.0,csig,csig,1);
	totw += weight;
	for(i=1;i<tn;i++){
	  rt[i] = mod_mesh_u[i][j][jj];  
	  diff[i] += weight * (mod_mesh_stim[i][j][jj] - whc*rt[i]);
	}
      }
    sprintf(ggstr,"  Total weight = %f\n",totw);
    mylog(mylogf,ggstr);
  }
  if (myid == -1){
    append_farray_plot("zz.mesh.pl","rt",rt,tn,1);
    append_farray_plot("zz.mesh.pl","diff",diff,tn,1);
  }
  {
    int ns,nmask;
    float *gti,*gtx,samp,*fs,sampling,*mask;
    float *pow,powtau,*spow;
    pow = copy_farray(diff,tn);
    square_farray(pow,tn);
    powtau = 20.0;             
    nmask = powtau * 4;
    mask = one_sided_exp_farray(0.0,powtau,1.0,nmask);
    norm_area_farray(mask,nmask,1.0);
    spow = convolve_with_mask_causal(pow,tn,mask,nmask);
    if (myid == -1){
      append_farray_plot("zz.mesh.gtx.pl","pow",pow,tn,1);
      append_farray_plot("zz.mesh.gtx.pl","spow",spow,tn,1);
    }
    gti = copy_farray(spow,tn);
    multiply_farray(gti,tn,1.0/0.071);
    gtx = diff; 
    samp = 1.0/mod_mesh_tscale;
    if (myid == -1)
      append_farray_plot("zz.mesh.gtx.pl","gtx",gtx,tn,1);
    ifc_test(myid,m,"ifc",gtx,gti,samp,tn,m->mseed[r->tsi],1,(char *)NULL,
	     &fs,&ns,0,&rv,&rvn);
    myfree(gti); myfree(gtx);
    exit_error("MODEL_MESH_MAG_01_GET_RESPONSE",
	       "Old way, m->ppl, no longer supported");
    sampling = 1000.0; 
    multiply_farray(fs,ns,sampling/1000.0);
    if (r->ns > 0){
      r->s[0][r->gtsi] = fs;
      r->cnt[0][r->gtsi] = ns; 
    }
  }
}
void mod_mesh_run_mesh_rgc_01(m,s,r,k,action)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
     int k;                     
     int action;                
{
  myid = mylog_set_id_log(m->process_id,&mylogf);  
  mylog(mylogf,"  MOD_MESH_RUN_MESH_RGC_01\n");
  if (action == 0){
    if (m->ppl == NULL)
      model_mesh_rgc_01_prep(m,s,r);
    else{ 
      mylog(mylogf,"  *** See .../libc/archive/mod_mesh_util for old code\n");
      mylog_exit(mylogf,"MOD_MESH_RUN_MESH_RGC_01  Old .mod not supported\n");
    }
  }else if (action == 1){
    model_mesh_rgc_01_get_response(m,s,r,k);
  }else if (action == -1){
    model_mesh_rgc_01_done();
  }else if (action == 10){
    model_mesh_rgc_01_prep(m,s,r); 
  }
}
void mod_mesh_run_mesh_mag_01(m,s,r,k,action)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
     int k;                     
     int action;                
{
  myid = mylog_set_id_log(m->process_id,&mylogf);  
  mylog(mylogf,"  MOD_MESH_RUN_MESH_MAG_01\n");
  if (action == 0){
    model_mesh_rgc_01_prep(m,s,r);
  }else if (action == 1){
    model_mesh_mag_01_get_response(m,s,r,k);
  }else if (action == -1){
    model_mesh_rgc_01_done();
  }
}
