/*C  (C) Copyright  Wyeth Bair 1993-2010                                     */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <X11/Xlib.h>
#include <GL/glx.h>
#include <GL/gl.h>
#include "my_util.h"
#include "nr_util.h"
#include "misc_util.h"
#include "carray_util.h"
#include "farray_util.h"
#include "spike_util.h"
#include "paramfile_util.h"
#include "glplot_util.h"
#include "stim_util.h"
#include "mod_util.h"
#include "pop_cell_util.h"
#include "pop_low_util.h"
#include "mod_gr_util.h"
#include "mod.h"
#include "ifc.h"
#include "wyplot.h" 
#include "paramfile.h"
int mod_mon_initflag = 0;
int mod_mon_winw;
int mod_mon_winh;
int mod_mon_winx;
int mod_mon_winy;
float mod_mon_zoom = 1.0;
float mod_mon_last_t = -1.0;
float mod_mon_tscale;
float mod_mon_sscale;
int mod_mon_stim_flag;
int mod_mon_stim_xn;
int mod_mon_stim_yn;
int mod_mon_stim_tn;
char *mod_mon_stim_type;
int mod_mon_stim_tsamp;         
int mod_mon_stim_i;
unsigned char **mod_mon_stim_d;
Display *mod_mon_dpy;
Window mod_mon_win;
GLXContext mod_mon_cx;
int mod_mon_dbflag;
int mod_mon_popflag = 0;           
struct pop_layer *mod_mon_pl;   
struct wyp_struct *mod_mon_wyp = NULL;
float glob_cn;
float *glob_ca;
float *glob_cr;
float *glob_cg;
float *glob_cb;
int mod_mon_pflag = 0;           
Bool mod_mon_true_test()
{
  return 1;
}
struct wyp_struct *mod_mon_get_wyp_pointer()
{
  return mod_mon_wyp;
}
void mod_mon_help()
{
  printf("  MOD_MON_HELP\n");
  printf("    h - help (print this list)\n");
  printf("    p - population mode (show voltages w/ color)\n");
  printf("    ? - help (print this list\n");
}
void mod_mon_init_color_voltage(vblack,vblue,vgreen,vyellow,vred)
     float vblack,vblue,vgreen,vyellow,vred;
{
  int nc;
  float *cr,*cg,*cb,*ca;
  nc = 5;
  cr = (float *)myalloc(nc*sizeof(float));
  cg = (float *)myalloc(nc*sizeof(float));
  cb = (float *)myalloc(nc*sizeof(float));
  ca = (float *)myalloc(nc*sizeof(float));
  ca[0] =  vblack;  cr[0] = 0.0; cg[0] = 0.0; cb[0] = 0.0;  
  ca[1] =   vblue;  cr[1] = 0.0; cg[1] = 0.0; cb[1] = 1.0;  
  ca[2] =  vgreen;  cr[2] = 0.0; cg[2] = 1.0; cb[2] = 0.0;  
  ca[3] = vyellow;  cr[3] = 1.0; cg[3] = 1.0; cb[3] = 0.0;  
  ca[4] =    vred;  cr[4] = 1.0; cg[4] = 0.0; cb[4] = 0.0;  
  glob_cn = nc;
  glob_cr = cr;
  glob_cg = cg;
  glob_cb = cb;
  glob_ca = ca;
}
void mod_mon_color_voltage(v,rr,rg,rb)
     float v;
     float *rr,*rg,*rb;
{
  int nc;
  nc = glob_cn;
  if (v < glob_ca[0])
    v = glob_ca[0];
  if (v > glob_ca[nc-1])
    v = glob_ca[nc-1];
  *rr = lin_interp_farray(glob_ca,glob_cr,nc,v);
  *rg = lin_interp_farray(glob_ca,glob_cg,nc,v);
  *rb = lin_interp_farray(glob_ca,glob_cb,nc,v);
}
void mod_mon_get_color(name,rr,rg,rb)
     char name[];
     float *rr,*rg,*rb;
{
  *rr = *rg = *rb = 1.0; 
  if (strcmp(name,"spikes")==0){
    *rr = 0.8; *rg = 0.8; *rb = 0.8;
  }else if (strcmp(name,"vm")==0){
    *rr = 1.0; *rg = 1.0; *rb = 0.0;
  }else if (strcmp(name,"rate")==0){  
    *rr = 1.0; *rg = 1.0; *rb = 0.0;
  }else if (strcmp(name,"vd")==0){
    *rr = 0.6; *rg = 0.5; *rb = 0.0;
  }else if (strcmp(name,"gad")==0){
    *rr = 0.6; *rg = 0.6; *rb = 0.6;
  }else if (strcmp(name,"in_gi")==0){
    *rr = 0.5; *rg = 0.5; *rb = 1.0;
  }else if (strcmp(name,"in_ii")==0){
    *rr = 0.8; *rg = 0.8; *rb = 1.0;
  }else if (strcmp(name,"ex_gx")==0){
    *rr = 1.0; *rg = 0.0; *rb = 0.0;
  }else if (strcmp(name,"ex_ix")==0){
    *rr = 1.0; *rg = 0.5; *rb = 0.5;
  }else if (strcmp(name,"lgn_ga")==0){
    *rr = 0.0; *rg = 0.9; *rb = 0.0;
  }else if (strcmp(name,"lgn_ia")==0){
    *rr = 0.5; *rg = 1.0; *rb = 0.5;
  }else if (strcmp(name,"lgn_gn")==0){
    *rr = 0.0; *rg = 0.4; *rb = 0.0;
  }else if (strcmp(name,"lgn_gx")==0){
    *rr = 1.0; *rg = 0.5; *rb = 0.0;
  }else if (strcmp(name,"lgn_gain")==0){
    *rr = 1.0; *rg = 0.75; *rb = 0.0;
  }else if (strcmp(name,"si_mask")==0){
    *rr = 1.0; *rg = 0.0; *rb = 1.0;
  }else if (strcmp(name,"si_mask1")==0){
    *rr = 1.0; *rg = 0.0; *rb = 1.0;
  }else if (strcmp(name,"si_mask2")==0){
    *rr = 0.5; *rg = 0.0; *rb = 0.5;
  }else if (strcmp(name,"photo")==0){
    *rr = 0.8; *rg = 0.3; *rb = 0.1;
  }else if (strcmp(name,"horiz")==0){
    *rr = 0.1; *rg = 0.3; *rb = 0.8;
  }else if (strcmp(name,"diff")==0){
    *rr = 0.7; *rg = 0.7; *rb = 0.7;
  }
}
void mod_mon_get_units(name,unit)
     char name[];
     char unit[];    
{
  if (compare_prefix_string_order("all_spk_",name)){
    strcpy(unit,"spike");
  }else if (strcmp(name,"spikes")==0){
    strcpy(unit,"spike");
  }else if (strcmp(name,"vm")==0){
    strcpy(unit,"mV");
  }else if (strcmp(name,"rate")==0){
    strcpy(unit,"Spk/s");
  }else if (strcmp(name,"vd")==0){
    strcpy(unit,"mV");
  }else if (strcmp(name,"gad")==0){
    strcpy(unit,"nS");
  }else if (strcmp(name,"in_gi")==0){
    strcpy(unit,"nS");
  }else if (strcmp(name,"in_ii")==0){
    strcpy(unit,"nA");
  }else if (strcmp(name,"ex_gx")==0){
    strcpy(unit,"nS");
  }else if (strcmp(name,"ex_ix")==0){
    strcpy(unit,"nA");
  }else if (strcmp(name,"lgn_ga")==0){
    strcpy(unit,"nS");
  }else if (strcmp(name,"lgn_ia")==0){
    strcpy(unit,"nA");
  }else if (strcmp(name,"lgn_gn")==0){
    strcpy(unit,"nS");
  }else if (strcmp(name,"lgn_gx")==0){
    strcpy(unit,"nS");
  }else if (strcmp(name,"lgn_gain")==0){
    strcpy(unit,"none");
  }else if (strcmp(name,"si_mask")==0){  
    strcpy(unit,"none");
  }else if (strcmp(name,"si_mask1")==0){  
    strcpy(unit,"none");
  }else if (strcmp(name,"si_mask2")==0){  
    strcpy(unit,"none");
  }else if (strcmp(name,"photo")==0){  
    strcpy(unit,"none");
  }else if (strcmp(name,"horiz")==0){  
    strcpy(unit,"none");
  }else if (strcmp(name,"diff")==0){  
    strcpy(unit,"none");
  }else{
    printf(" *** %s\n",name);
    exit_error("MOD_MON_GET_UNITS","Unknown name");
  }
}
struct wyp_yaxis_struct *mod_mon_get_yax_for_unit(wyp,unit)
     struct wyp_struct *wyp;
     char *unit;
{
  int i;
  struct wyp_yaxis_struct *yax;
  if (mod_mon_pflag == 1){
    printf("    MOD_MON_GET_YAX_FOR_UNIT\n");
  }
  yax = NULL;
  i = 0;
  while((i < wyp->f->nyax) && (yax == NULL)){
    if (mod_mon_pflag == 1){
      printf("      %d %s\n",i,wyp->f->yax[i].name);
    }
    if (strcmp(wyp->f->yax[i].name,unit)==0)
      yax = &(wyp->f->yax[i]);
    else
      i += 1;
  }
  return yax;
}
void mod_mon_init_yax(wyp,k,name,y0,y1)
     struct wyp_struct *wyp;
     int k;
     char *name;
     float y0,y1;
{
  wyp->f->yax[k].name = strdup(name);
  wyp->f->yax[k].ylim0 = y0;
  wyp->f->yax[k].ylim1 = y1;
  wyp->f->yax[k].yf = (wyp->f->gy1 - wyp->f->gy0)/(y1-y0);
}
struct wyp_yaxis_struct *mod_mon_get_init_yax(wyp,name,y0,y1)
     struct wyp_struct *wyp;
     char *name;
     float y0,y1;
{
  struct wyp_yaxis_struct *yax;
  yax = (struct wyp_yaxis_struct *)myalloc(sizeof
					   (struct wyp_yaxis_struct));
  yax->name = strdup(name);
  yax->ylim0 = y0;
  yax->ylim1 = y1;
  yax->yf = (wyp->f->gy1 - wyp->f->gy0)/(y1-y0);
  return yax;
}
struct wyp_struct *mod_mon_init_wyp()
{
  struct wyp_struct *wyp;
  printf("    MOD_MON_INIT_WYP\n");
  wyp = (struct wyp_struct *)myalloc(sizeof(struct wyp_struct));
  wyp->nplot = 0;
  wyp->p = NULL;
  wyp->f = (struct wyp_frame_struct *)myalloc(sizeof(struct wyp_frame_struct));
  wyp->f->name = (char *)NULL;
  wyp->f->xlim0 = 0.0;
  wyp->f->xlim1 = 0.0;
  wyp->f->nyax = 0;
  wyp->f->yax = NULL;
  return wyp;
}
void mod_mon_plot_free(p)
     struct wyp_plot_struct *p;
{
  myfree(p->name);
  if (p->nc > 1){ 
    myfree(p->clist);  
    myfree(p->nlist);
  }
  if (p->x != NULL)
    myfree(p->x);
  if (p->y != NULL)
    myfree(p->y);
  if (p->xunit != NULL)
    myfree(p->xunit);
  if (p->yunit != NULL)
    myfree(p->yunit);
  myfree(p);
}
void mod_mon_plot_insert_head(wyp,p)
     struct wyp_struct *wyp;
     struct wyp_plot_struct *p;
{
  p->prev = NULL;
  if (wyp->nplot == 0){
    p->next = NULL;
  }else{
    p->next = wyp->p;
    wyp->p->prev = p;
  }
  wyp->p = p;
  wyp->nplot += 1;
}
void mod_mon_plot_add_init_plot(wyp,c,syn,name,r,g,b,unit)
     struct wyp_struct *wyp;
     struct pop_cell *c;
     struct pop_syn *syn;
     char *name;            
     float r,g,b;
     char *unit;            
{
  struct wyp_plot_struct *p;
  if (mod_mon_pflag == 1){
    printf("  MOD_MON_PLOT_ADD_INIT_PLOT\n");
    printf("    name = %s\n",name);
  }
  p = (struct wyp_plot_struct *)myalloc(sizeof(struct wyp_plot_struct));
  p->name = strdup(name);
  p->nc = 1;
  p->c = c;
  p->syn = syn;
  p->clist = NULL;
  p->n = 0;
  p->nmax = 0;
  p->x = p->y = (float *)NULL;
  p->xlabel = p->ylabel = (char *)NULL;
  p->xunit  = p->yunit  = (char *)NULL;
  p->r = r;
  p->g = g;
  p->b = b;
  p->yunit = strdup(unit);
  p->yax = mod_mon_get_yax_for_unit(wyp,unit);
  if (p->yax == NULL){
    printf("  yax is NULL for unit: %s\n",unit);
    exit(0);
  }
  mod_mon_plot_insert_head(wyp,p);
}
void mod_mon_plot_remove(wyp,p)
     struct wyp_struct *wyp;
     struct wyp_plot_struct *p;
{
  if (p->prev == NULL)
    wyp->p = p->next;
  else
    p->prev->next = p->next;
  if (p->next != NULL)
    p->next->prev = p->prev;
  wyp->nplot -= 1;
}
void mod_mon_plot_remove_free(wyp,p,flag)
     struct wyp_struct *wyp;
     struct wyp_plot_struct *p;
     int flag;  
{
  int i;
  mod_mon_plot_remove(wyp,p); 
  if (flag){
    if (p->nc > 1){ 
      if (compare_prefix_string_order("all_spk_",p->name)){
	for(i=0;i<p->nc;i++)
	  pop_cell_unset_save(NULL,p->clist[i],"spikes");
      }else{
	for(i=0;i<p->nc;i++)
	  pop_cell_unset_save(NULL,p->clist[i],p->name);
      }
    }else{
      if (p->syn != NULL){
	pop_cell_unset_save_syn(NULL,p->syn,p->name);  
      }else{
	pop_cell_unset_save(NULL,p->c,p->name);
      }
    }
  }
  mod_mon_plot_free(p);
}
void mod_mon_plot_add_init_clist(wyp,c,clist,nc,name,r,g,b,unit)
     struct wyp_struct *wyp;
     struct pop_cell *c;        
     struct pop_cell **clist;
     int nc;
     char *name;
     float r,g,b;
     char *unit;
{
  int i,k;
  float y0,y1;
  struct wyp_plot_struct *p;
  p = (struct wyp_plot_struct *)myalloc(sizeof(struct wyp_plot_struct));
  p->name = strdup(name);
  p->nc = nc;
  p->c = c;
  p->clist = clist;
  p->nlist = get_zero_iarray(nc);
  p->nmax = 0;
  p->x = p->y = (float *)NULL;
  p->xlabel = p->ylabel = (char *)NULL;
  p->xunit  = p->yunit  = (char *)NULL;
  p->r = r;
  p->g = g;
  p->b = b;
  p->yunit = strdup(unit);
  y0 = -0.05 * (float)nc;
  y1 =  1.05 * (float)nc;
  p->yax = mod_mon_get_init_yax(wyp,"custom",y0,y1); 
  mod_mon_plot_insert_head(wyp,p);
}
void mod_mon_plot_add_init_plot_glob(c,syn,name,r,g,b,unit)
     struct pop_cell *c;
     struct pop_syn *syn;
     char *name;
     float r,g,b;
     char *unit;
{
  int i;
  int nc,nmdaflag;
  char *layname;
  struct pop_cell **clist;
  if (compare_prefix_string_order("all_spk_",name)){
    layname = &(name[8]); 
    clist = pop_cell_cellist_get_presyn_from_layer(layname,c,&nc);
    mod_mon_plot_add_init_clist(mod_mon_wyp,c,clist,nc,name,r,g,b,unit);
    for(i=0;i<nc;i++) 
      pop_cell_set_save(NULL,clist[i],"spikes",0); 
  }else{
    mod_mon_plot_add_init_plot(mod_mon_wyp,c,syn,name,r,g,b,unit);
    if (c->cifcp->g_tran > 0.0)
      nmdaflag = 1;
    else
      nmdaflag = 0;
    if (c != NULL){
      pop_cell_set_save(NULL,c,name,nmdaflag); 
    }else if (syn != NULL){
      pop_cell_syn_set_save(NULL,syn,name);
    }else{
      exit_error("MOD_MON_PLOT_ADD_INIT_PLOT_GLOB","Cell and Syn are NULL");
    }
  }
}
void mod_mon_plot_remove_plot_glob(c,name)
     struct pop_cell *c;
     char *name;
{
  struct wyp_struct *wyp;
  struct wyp_plot_struct *p,*t;
  wyp = mod_mon_wyp;
  if ((c == NULL) && (name == NULL)){  
    p = wyp->p;
    while(p != NULL){
      t = p;
      p = p->next;
      mod_mon_plot_remove_free(wyp,t,1);
    }
  }else{                               
    p = wyp->p;
    while(p != NULL){
      t = p;
      p = p->next;
      if ((t->c == c) && (strcmp(t->name,name)==0)){
	mod_mon_plot_remove_free(wyp,t,1);
      }
    }
  }
}
void mod_mon_init_plots(r,laylist,nlay,wyp)
     struct response_struct *r;    
     struct pop_layer **laylist;   
     int nlay;
     struct wyp_struct *wyp;
{
  int i;
  int nnew,n,xflag,nc,xi,yi,zi;
  float *x,*y,colr,colg,colb;
  char *dname,units[SLEN],*prelay,*clay;
  struct pop_cell *c,**cl;
  struct pop_syn *syn;
  struct param_pair *pp;
  printf("    MOD_MON_INIT_PLOTS\n");
  wyp->nplot = 0;  
  wyp->p = NULL;
  if (paramfile_test_param(r->ppl,"mon_presyn_layer_to_cell")){
    pp = paramfile_get_param_pointer(r->ppl,"mon_presyn_layer_to_cell");
    prelay = paramfile_get_nth_char_param_pp_or_exit(pp,0);
    clay = paramfile_get_nth_char_param_pp_or_exit(pp,1);
    xi = paramfile_get_nth_int_param_ptr_or_exit(pp,2);
    yi = paramfile_get_nth_int_param_ptr_or_exit(pp,3);
    zi = paramfile_get_nth_int_param_ptr_or_exit(pp,4);
    dname = paramfile_get_nth_char_param_pp_or_exit(pp,5);
    if (strcmp(dname,"spikes")!=0)
      exit_error("MOD_MON_INIT_PLOTS","clist for spike only");
    c = pop_cell_laylist_get_cell_pointer(laylist,nlay,clay,xi,yi,zi);
    cl = pop_cell_cellist_get_presyn_from_layer(prelay,c,&nc);
    colr = colg = colb = 1.0;
    mod_mon_plot_add_init_clist(wyp,c,cl,nc,"spikes",colr,colg,colb,"spike");
  }else{  
    for(i=0;i<r->n;i++){ 
      c = NULL;
      syn = NULL;
      if (r->rformat[i] == 0){
	exit_error("MOD_MON_INIT_PLOTS","Format not implemented");
      }else if (r->rformat[i] == 10){
	syn = pop_cell_laylist_get_syn_pointer(laylist,nlay,r->plname[i],
					       r->xi[i],r->yi[i],r->zi[i],
					       r->plname1[i],r->xi1[i],
					       r->yi1[i],r->zi1[i],0);
	if (syn == NULL){
	  printf("*** r->nd_name = %s\n",r->nd_name[i]);
	  exit_error("MOD_MON_INIT_PLOTS","No synapse found");
	}
      }else{
	c = pop_cell_laylist_get_cell_pointer(laylist,nlay,r->plname[i],
					      r->xi[i],r->yi[i],r->zi[i]);
	if (c == NULL){
	  printf("*** r->nd_name = %s\n",r->nd_name[i]);
	  exit_error("MOD_MON_INIT_PLOTS","No cell found");
	}
      }
      dname = r->datid[i];
      mod_mon_get_color(dname,&colr,&colg,&colb);
      mod_mon_get_units(dname,units);
      mod_mon_plot_add_init_plot(wyp,c,syn,dname,colr,colg,colb,units);
    }
  }
}
void mod_mon_init_win(plotname)
     char plotname[];
{
  printf("    MOD_MON_INIT_WIN\n");
  if (mod_mon_initflag == 0){
    glplot_init(mod_mon_winw,mod_mon_winh,mod_mon_zoom,plotname,&mod_mon_dpy,
		&mod_mon_win,&mod_mon_cx,&mod_mon_dbflag,0);
    mod_mon_initflag = 1;
    glplot_clear_double(mod_mon_dpy,mod_mon_win);
  }
}
void mod_mon_data_convert_coord_x(wyp,x,rx)
     struct wyp_struct *wyp;
     float x;
     float *rx;
{
  struct wyp_frame_struct *f;
  f = wyp->f;
  *rx = f->gx0 + f->px0 + f->pxf*(x - f->xlim0);
}
void mod_mon_data_convert_coord(wyp,p,x,y,rx,ry)
     struct wyp_struct *wyp;
     struct wyp_plot_struct *p;
     float x,y;
     float *rx,*ry;
{
  struct wyp_frame_struct *f;
  f = wyp->f;
  *rx = f->gx0 + f->px0 + f->pxf*(x - f->xlim0);
  *ry = f->gy0 + f->py0 + p->yax->yf*(y - p->yax->ylim0);
}
void mod_mon_win_draw_plot_boxes(wyp)
     struct wyp_struct *wyp;
{
  int i;
  int np;
  char **plist;
  float *colr,*colg,*colb,boxfrac,wpix,hpix,w,h,x0,y0;
  struct wyp_plot_struct *p;
  if (mod_mon_pflag == 1)
    printf("*************  MOD_MON_WIN_DRAW_PLOT_BOXES\n");
  glplot_set_xfont_generic(mod_mon_dpy,mod_mon_win,mod_mon_cx,"medium");
  colr  = (float *)myalloc(wyp->nplot * sizeof(float));
  colg  = (float *)myalloc(wyp->nplot * sizeof(float));
  colb  = (float *)myalloc(wyp->nplot * sizeof(float));
  plist = (char **)myalloc(wyp->nplot * sizeof(char *));
  np = 0;
  p = wyp->p;
  while(p != NULL){
    plist[np] = p->name;
    colr[np] = p->r;
    colg[np] = p->g;
    colb[np] = p->b;
    np += 1;
    p = p->next;
  }
  wpix = 64.0; 
  hpix = 16.0; 
  w = wpix * 2.0/(float)(wyp->f->winw);
  h = hpix * 2.0/(float)(wyp->f->winh);
  boxfrac = 0.96;
  x0 = -1.0 + 4.0 * 2.0/(float)(wyp->f->winw);
  y0 = -1.0 + 4.0 * 2.0/(float)(wyp->f->winh);
  glplot_draw_text_boxes(mod_mon_dpy,mod_mon_win,mod_mon_cx,plist,np,
			 colr,colg,colb,x0,y0,w,h,boxfrac,1);
  if (mod_mon_pflag == 1)
    printf("    Drew %d boxes\n",np);
}
float mod_mon_win_draw_scale_bar_vert(wyp,yax,r,g,b,pixthick,lrpix,tbpix,frac)
     struct wyp_struct *wyp;
     struct wyp_yaxis_struct *yax;
     float r,g,b;
     float pixthick;      
     float lrpix;         
     float tbpix;         
     float frac;          
{
  int i;
  int barlen_i;
  float barlen_f,x,y,blen,bthick,blen_pix;
  char tstr[SLEN];
  barlen_f = (yax->ylim1-yax->ylim0) * frac;   
  barlen_i = misc_util_get_round_number(barlen_f); 
  blen = yax->yf * (float)barlen_i;
  bthick = pixthick * 2.0/(float)(wyp->f->winw);
  blen_pix = blen *(float)(wyp->f->winh)/2.0;
  if (lrpix >= 0)
    x = -1.0 + lrpix * 2.0/(float)(wyp->f->winw); 
  else
    x =  1.0 + lrpix * 2.0/(float)(wyp->f->winw); 
  if (tbpix >= 0){
    y = -1.0 + tbpix * 2.0/(float)(wyp->f->winh); 
    tbpix += blen_pix; 
  }else{
    tbpix -= blen_pix; 
    y =  1.0 + tbpix * 2.0/(float)(wyp->f->winh); 
  }
  glplot_draw_box(r,g,b,x,y,bthick,blen);
  x += 1.5 * bthick;
  sprintf(tstr,"%d %s",barlen_i,yax->name);
  glplot_set_xfont_generic(mod_mon_dpy,mod_mon_win,mod_mon_cx,"medium");
  glplot_draw_text(mod_mon_dpy,mod_mon_win,mod_mon_cx,tstr,x,y,r,g,b);
  return tbpix;
}
void mod_mon_win_draw_scale_bar(wyp)
     struct wyp_struct *wyp;
{
  int i;
  int barlen_i;
  float barlen_f,r,g,b,hpix,x,y,w,h;
  float thick,lrpix,tbpix,frac,tpix;
  char tstr[SLEN];
  struct wyp_yaxis_struct *yax;
  r = g = b = 1.0;
  barlen_f = wyp->f->tdur*1000.0 / 20.0;  
  barlen_i = misc_util_get_round_number(barlen_f); 
  w = wyp->f->pxf * (float)barlen_i/1000.0;
  hpix = 6.0; 
  h = hpix * 2.0/(float)(wyp->f->winh);
  x = 1.0 - 2.0*w;
  y = -1.0 + 24.0 * 2.0/(float)(wyp->f->winh); 
  glplot_draw_box(r,g,b,x,y,w,h);
  y -= 16.0 * 2.0/(float)(wyp->f->winh); 
  sprintf(tstr,"%d ms",barlen_i);
  glplot_set_xfont_generic(mod_mon_dpy,mod_mon_win,mod_mon_cx,"medium");
  glplot_draw_text(mod_mon_dpy,mod_mon_win,mod_mon_cx,tstr,x,y,r,g,b);
  r = 1.0;
  g = 1.0;
  b = 0.0;
  thick = 6.0;  
  lrpix = 16.0;
  tbpix = -16.0;
  frac = 0.1; 
  yax = &(wyp->f->yax[0]);
  tpix = mod_mon_win_draw_scale_bar_vert(wyp,yax,r,g,b,thick,lrpix,tbpix,frac);
  r = 0.6;
  g = 0.6;
  b = 0.6;  
  r = 0.0;  
  g = 1.0;
  b = 0.0;
  thick = 6.0;  
  lrpix = 16.0;
  tbpix = tpix - 16; 
  frac = 0.1; 
  yax = &(wyp->f->yax[1]);
  tpix = mod_mon_win_draw_scale_bar_vert(wyp,yax,r,g,b,thick,lrpix,tbpix,frac);
}
void mod_mon_win_draw_stat_box(wyp)
     struct wyp_struct *wyp;
{
  float r,g,b,x,y,w,h,x0,x1;
  float t0,tn;
  if (wyp->stat_tn > 0.0){
    r = g = b = 1.0;
    t0 = wyp->stat_t0;
    tn = wyp->stat_tn;
    mod_mon_data_convert_coord_x(wyp,t0,&x0);
    mod_mon_data_convert_coord_x(wyp,t0+tn,&x1);
    x = x0;
    y = -1.0;
    w = x1-x0;
    h = 2.0;
    r = 0.1;  
    g = 0.1;
    b = 0.1;
    glplot_draw_box(r,g,b,x,y,w,h);
  }
}
void mod_mon_win_decorate(wyp)
     struct wyp_struct *wyp;
{
  int i;
  mod_mon_win_draw_plot_boxes(wyp);
  mod_mon_win_draw_scale_bar(wyp);
  if (mod_mon_dbflag == 1)
    glXSwapBuffers(mod_mon_dpy,mod_mon_win);
  else
    glFlush();
}
void mod_mon_stim_prep(s)
     struct stim_struct *s;    
{
  int i;
  int rx,ry,xn,yn,tn;
  float ***data,***dr;
  char *sform;
  if (mod_mon_stim_tsamp == -1){
    mod_mon_stim_d = NULL;
    mod_mon_stim_i = -1;  
    return;
  }
  xn = mod_mon_stim_xn;
  yn = mod_mon_stim_yn;
  tn = mod_mon_stim_tn;
  glPixelStorei(GL_UNPACK_ALIGNMENT,1);
  if (mod_mon_stim_d != NULL){  
    for(i=0;i<mod_mon_stim_tn;i++)
      myfree(mod_mon_stim_d[i]);
    myfree(mod_mon_stim_d);
  }
  sform = paramfile_get_char_param_default(s->ppl,"stim_form","3d");
  if (strcmp(sform,"3d")==0)
    data = get_stim_3d_ppl(NULL,s,xn,yn,tn,mod_mon_sscale,mod_mon_tscale,
			   mod_mon_stim_tsamp);
  else{
    get_stim_3d_b_ppl(NULL,mod_mon_stim_type,s->ppl,xn,yn,tn,
		      mod_mon_sscale,mod_mon_tscale,
		      mod_mon_stim_tsamp,&data,&dr);
    free_f3tensor(dr,1,xn,1,yn,1,tn);
    printf("    Only showing Left eye stimulus.\n");
  }
  myfree(sform);
  mod_mon_stim_d = convert_stim_to_gl_format(data,xn,yn,tn,0.0,1.0);
  free_f3tensor(data,1,xn,1,yn,1,tn);
  mod_mon_stim_i = 0;  
}
void mod_mon_reset(m,r,s)
     struct model_struct *m;        
     struct response_struct *r;     
     struct stim_struct *s;         
{
  int i;
  struct wyp_struct *wyp;
  struct wyp_plot_struct *p;
  glplot_util_make_current(mod_mon_dpy,mod_mon_win,mod_mon_cx);
  glplot_clear(mod_mon_dpy,mod_mon_win);
  wyp = mod_mon_wyp;
  mod_mon_win_draw_stat_box(wyp);
  glClear(GL_DEPTH_BUFFER_BIT);
  wyp->statflag = 0; 
  p = wyp->p;
  while(p != NULL){
    p->n = 0;
    p = p->next;
  }
  if (mod_mon_stim_flag == 1)
    mod_mon_stim_prep(s);
}
struct wyp_plot_struct *mod_mon_get_plot(wyp,name)
     struct wyp_struct *wyp;
     char *name;
{
  struct wyp_plot_struct *tp;
  struct wyp_plot_struct *p;
  tp = NULL;
  p = wyp->p;
  while((p != NULL) && (tp == NULL)){
    if (strcmp(p->name,name)==0){
      tp = p;
    }else{
      p = p->next;
    }
  }
  return p;
}
void mod_mon_plot_add_data(wyp,name,x,y)
     struct wyp_struct *wyp;
     char *name;
     float x,y;
{
  int i;
  struct wyp_plot_struct *p;
  p = mod_mon_get_plot(wyp,name);
  if (p == NULL){
    printf("*** %s\n",name);
    exit_error("MOD_MON_PLOT_ADD_DATA","Plot name not found");
  }
  i = p->n;
  if (i < p->nmax){  
    p->x[i] = x;
    p->y[i] = y;
    p->n += 1;
  }else{
    printf("*** WARNING, point not added, nmax exceeded\n");
  }
}
int mod_mon_plot_add_data_all_new(wyp,name,x,y,n)
     struct wyp_struct *wyp;
     char *name;
     float *x,*y;
     int n;
{
  int i,k;
  int nnew,nold;
  struct wyp_plot_struct *p;
  p = mod_mon_get_plot(wyp,name);
  if (p == NULL){
    printf("*** %s\n",name);
    exit_error("MOD_MON_PLOT_ADD_DATA","Plot name not found");
  }
  nold = p->n;
  nnew = n - nold;
  for(i=0;i<nnew;i++){
    k = nold + i;
    if (k < p->nmax){  
      p->x[k] = x[n-nnew+i];
      p->y[k] = y[n-nnew+i];
      p->n += 1;
    }else{
      printf("*** WARNING, point not added, nmax exceeded\n");
    }
  }
  return nnew;
}
void mod_mon_draw_update_plot(wyp,p,t)
     struct wyp_struct *wyp;
     struct wyp_plot_struct *p;
     float t;                      
{
  int i,k;
  int n,xflag,nnew,ptrflag;
  float x0,y0,x1,y1,*x,*y,tscale,sampling;
  double tt,dt;
  struct pop_cell *c;
  struct pop_syn *syn;
  int n_tmax;
  if (mod_mon_pflag == 1) printf("  MOD_MON_DRAW_UPDATE_PLOT\n");
  if (p->c != NULL){
    c = p->c;               
    pop_cell_get_data_float(c,p->name,&x,&y,&n,&xflag,&tscale,&ptrflag);
    if (mod_mon_pflag == 1) printf("  Plot name:  %s\n",p->name);
    sampling = c->samp0;  
  }else if (p->syn != NULL){
    syn = p->syn;
    pop_cell_syn_get_data_float(syn,p->name,&x,&y,&n,&xflag,&tscale,&ptrflag);
    sampling = syn->pre->samp0; 
    if (xflag == 1){ 
      n_tmax = (int)(t/tscale);
    }else{
      n_tmax = p->n;
      for(i=p->n;i<n;i++){
	if (x[i] < t)
	  n_tmax += 1;
      }
    }
    if (n_tmax < n){
      n = n_tmax;
    }
  }
  nnew = n - p->n;
  if (nnew > 0){
    if (mod_mon_pflag == 1) printf("    xflag = %d\n",xflag);
    if (xflag == 0){
      glBegin(GL_LINE_STRIP);
      glColor3f(p->r,p->g,p->b);
      if (n > nnew){ 
	mod_mon_data_convert_coord(wyp,p,x[n-nnew-1]*tscale,y[n-nnew-1],
				   &x0,&y0);
	glVertex2f(x0,y0);
      }
      for(i=0;i<nnew;i++){ 
	if (mod_mon_pflag == 1){
	  printf("i = %d\n",i);
	  printf("n = %d  nnew = %d   (%d)\n",n,nnew,n-nnew+i);
	}	  
	mod_mon_data_convert_coord(wyp,p,x[n-nnew+i]*tscale,y[n-nnew+i],
				   &x1,&y1);
	glVertex2f(x1,y1);
      }
      glEnd();
      if (mod_mon_pflag == 1) printf("    Done xflag = %d\n",xflag);
    }else if (xflag == 1){  
      glBegin(GL_LINE_STRIP);
      glColor3f(p->r,p->g,p->b);
      dt = 1.0/sampling;
      if (n > nnew){ 
	tt = (double)(n-nnew-1)*dt;
	mod_mon_data_convert_coord(wyp,p,tt,y[n-nnew-1],&x0,&y0);
	glVertex2f(x0,y0);
      }
      tt = (double)(n-nnew)*dt;
      for(i=0;i<nnew;i++){
	mod_mon_data_convert_coord(wyp,p,tt,y[n-nnew+i],&x1,&y1);
	glVertex2f(x1,y1);
	tt += dt;
      }
      glEnd();
    }else if (xflag == 2){  
      glBegin(GL_LINES);  
      glColor3f(p->r,p->g,p->b);
      for(i=0;i<nnew;i++){ 
	mod_mon_data_convert_coord(wyp,p,y[n-nnew+i]*tscale,0.0,
				   &x1,&y1);
	glVertex2f(x1,y1);
	mod_mon_data_convert_coord(wyp,p,y[n-nnew+i]*tscale,1.0,
				   &x1,&y1);
	glVertex2f(x1,y1);
      }
      glEnd();
    }
  }
  p->n = n;
  if (ptrflag == 0)
    myfree(y);
  if (mod_mon_pflag == 1) printf("  MOD_MON_DRAW_UPDATE_PLOT - Done.\n");
}
void mod_mon_draw_update_plot_clist(wyp,p)
     struct wyp_struct *wyp;
     struct wyp_plot_struct *p;
{
  int i,j;
  int n,xflag,nnew;
  float x0,y0,x1,y1,*x,*y,tscale;
  struct pop_cell *c;
  for(i=0;i<p->nc;i++){ 
    c = p->clist[i]; 
    if (compare_prefix_string_order("all_spk_",p->name)){
      pop_cell_get_ptr_data_float(c,"spikes",&x,&y,&n,&xflag,&tscale);
    }else{
      pop_cell_get_ptr_data_float(c,p->name,&x,&y,&n,&xflag,&tscale);
    }
    nnew = n - p->nlist[i];
    if (nnew > 0){
      if (xflag == 2){ 
	for(j=0;j<nnew;j++){
	  mod_mon_data_convert_coord(wyp,p,y[n-nnew+j]*tscale,(float)i,
				     &x0,&y0);
	  mod_mon_data_convert_coord(wyp,p,y[n-nnew+j]*tscale,(float)(i+1),
				     &x1,&y1);
	  glBegin(GL_LINE_STRIP);
	  glColor3f(p->r,p->g,p->b);
	  glVertex2f(x0,y0);
	  glVertex2f(x1,y1);
	  glEnd();
	}
      }else{
	printf("Only xflag 2 implemented\n");
	; 
      }
    }
    p->nlist[i] = n;
  }
}
int mod_mon_process_event(laylist,npl,pevent)
     struct pop_layer **laylist;   
     int npl;                      
     XEvent *pevent;
{
  int i,j;
  int ci,cj,ck;
  int redrawflag,winw,winh,gw,gh,gi,gj;
  float cfx0,cfy0,cfw,cfh,gdx,gdy,gx0,gy0,winfrac,gridfrac;
  char tstr[SLEN];
  struct pop_layer *tl; 
  XKeyEvent *kevent;
  XWindowAttributes xwa;
  char kbuf[10];
  Display *dpy;
  Window win;
  dpy = mod_mon_dpy; 
  win = mod_mon_win;
  XGetWindowAttributes(dpy,win,&xwa);
  winw = xwa.width;
  winh = xwa.height;
  redrawflag = 0;
  switch(pevent->type){
  case ButtonPress:
    switch(pevent->xbutton.button){
    case 1:
      break;
    case 2:
      break;
    case 3:
      break;
    }
    break;
  case MotionNotify:
    break;
  case KeyPress:
    kevent = (XKeyEvent *)pevent;
    XLookupString(kevent,kbuf,sizeof(kbuf),NULL,NULL);
    if (kbuf[0]==' '){
      redrawflag = 1;
    }else if ((kbuf[0]=='h')||(kbuf[0]=='?')){
      mod_mon_help();
    }else if (kbuf[0]=='l'){
      printf("    Layers\n");
      for(i=0;i<npl;i++)
	printf("    %4d %s\n",i,laylist[i]->name);
    }else if (kbuf[0]=='p'){
      ; 
    }else if (kbuf[0]=='q'){
      printf("  Quit from main window only.\n");
    }else if (kbuf[0]=='x'){
      exit(0);
    }
    break;
  case ConfigureNotify:
    glViewport(0,0,pevent->xconfigure.width,pevent->xconfigure.height);
    mod_mon_wyp->f->winw = pevent->xconfigure.width;
    mod_mon_wyp->f->winh = pevent->xconfigure.height;
    redrawflag = 1;
  case Expose:
    redrawflag = 1;
    break;
  }
  return redrawflag;
}
void mod_mon_stat_plot(p,t0,tn)
     struct wyp_plot_struct *p;
     float t0,tn;                  
{
  int i;
  int xflag,dn,n,ptrflag;
  float *x,*y,*d,mean,sdev,min,max,tscale,t,dt;
  char unit[SLEN],*cell_name;
  if (p->c != NULL){
    pop_cell_get_data_float(p->c,p->name,&x,&y,&n,&xflag,&tscale,&ptrflag);
    dt = 1.0/p->c->samp0;
    cell_name = p->c->name;
  }else{
    pop_cell_syn_get_data_float(p->syn,p->name,&x,&y,&n,&xflag,&tscale,
				&ptrflag);
    dt = 1.0/p->syn->pre->samp0; 
    cell_name = p->syn->pre->name;  
  }
  mod_mon_get_units(p->name,unit);
  if ((strcmp(unit,"nS")==0) || (strcmp(unit,"mV")==0) ||
      (strcmp(unit,"Spk/s")==0) ||
      (strcmp(unit,"nA")==0) || (strcmp(unit,"none")==0)){
    dn = 0;
    for(i=0;i<n;i++){
      if (xflag == 1)
   	t = (float)i * dt;   
      else
	t = x[i]*tscale;
      if ((t >= t0) && (t < (t0+tn))){
	if (dn==0) 
	  d = &(y[i]);
	dn += 1;
      }
    }
    mean_sdev_farray(d,dn,&mean,&sdev);
    get_min_max_farray(d,dn,&min,&max);
    printf("%14s %8s %10.4f %10.4f %10.4f %10.4f %10.4f %4s\n",
	   cell_name,p->name,mean,sdev,sdev*sdev,min,max,unit);
  }else if (strcmp(unit,"spike")==0){
    mean = mean_spike_rate_float(y,n,t0/tscale,tn/tscale,1.0/tscale);
    printf("%14s %8s %10.4f spikes/s\n",p->c->name,p->name,mean);
  }else{
    printf("  *** unit:  %s\n",unit);
    exit_error("MOD_MON_STAT_PLOT","Unknown unit");
  }
  if (ptrflag == 0)
    myfree(y);
}
void mod_mon_stats(m,r,laylist,nlay,t)
     struct model_struct *m;       
     struct response_struct *r;    
     struct pop_layer **laylist;   
     int nlay;                     
     float t;                      
{
  int i;
  float t0,tn;
  struct wyp_struct *wyp;
  struct wyp_plot_struct *p;
  wyp = mod_mon_wyp;
  t0 = wyp->stat_t0;
  tn = wyp->stat_tn;
  if ((tn > 0.0) && (t > (t0+tn)) && (!wyp->statflag)){
    printf("Cell             Data      Mean        SD        Var     ");
    printf("    Min        Max    units\n");
    printf("-------------- -------- ---------- ---------- ---------- ");
    printf("---------- ---------- -----\n");
    p = wyp->p;
    while(p != NULL){
      if (p->nc == 1){
	mod_mon_stat_plot(p,t0,tn);
      }else if (p->nc > 1){
	;
      }
      p = p->next;
    }
    wyp->statflag = 1;  
  }
}
void mod_mon_update_plots(m,r,laylist,nlay,t,refresh_flag)
     struct model_struct *m;       
     struct response_struct *r;    
     struct pop_layer **laylist;   
     int nlay;                     
     float t;                      
     int refresh_flag;             
{
  int fi;
  float tscale;
  struct wyp_struct *wyp;
  struct wyp_plot_struct *p;
  if (mod_mon_pflag == 1){
    printf("  MOD_MON_UPDATE_PLOTS\n");
    printf("    mod_mon_dbflag = %d\n",mod_mon_dbflag);
  }
  wyp = mod_mon_wyp;
  glDrawBuffer(GL_FRONT_AND_BACK); 
  p = wyp->p;
  while(p != NULL){
    if (refresh_flag == 1)
      p->n = 0;  
    if (p->nc == 1){
      mod_mon_draw_update_plot(wyp,p,t);
    }else if (p->nc > 1){
      mod_mon_draw_update_plot_clist(wyp,p);
    }
    p = p->next;
  }
  glDrawBuffer(GL_BACK); 
  if (mod_mon_stim_flag == 1){
    fi = t/mod_mon_tscale;
    if (fi > mod_mon_stim_i){  
      glRasterPos2f(-0.6,0.1); 
      glDrawPixels(mod_mon_stim_xn,mod_mon_stim_yn,GL_LUMINANCE,GL_BYTE,
		   mod_mon_stim_d[fi]);
      mod_mon_stim_i = fi;
    }
  }
  glDrawBuffer(GL_FRONT_AND_BACK); 
  mod_mon_win_decorate(wyp); 
  glDrawBuffer(GL_BACK); 
}
void mod_mon_monitor_check(pllist,npl)
     struct pop_layer **pllist;   
     int npl;                     
{
  XEvent peekev,event,evt;
  int redrawflag,nev,pflag,configflag;
  glplot_util_make_current(mod_mon_dpy,mod_mon_win,mod_mon_cx);
  if (XCheckIfEvent(mod_mon_dpy,&event,mod_mon_true_test,(char *)NULL)){
    nev = XQLength(mod_mon_dpy);
    while (nev > 0){
      XPeekEvent(mod_mon_dpy,&evt);
      if (evt.type == ConfigureNotify){
	XNextEvent(mod_mon_dpy,&event); 
      }else
	XNextEvent(mod_mon_dpy,&evt);   
      nev -= 1;
    }
    redrawflag = mod_mon_process_event(pllist,npl,&event);
    if (redrawflag == 1){
      glplot_clear(mod_mon_dpy,mod_mon_win);
      mod_mon_win_draw_stat_box(mod_mon_wyp); 
      glClear(GL_DEPTH_BUFFER_BIT);
      mod_mon_win_decorate(mod_mon_wyp);
    }
  }
}
void mod_mon_monitor(m,r,s,pllist,npl,t)
     struct model_struct *m;      
     struct response_struct *r;   
     struct stim_struct *s;       
     struct pop_layer **pllist;   
     int npl;                     
     float t;                     
{
  XEvent peekev,event,evt;
  int redrawflag,nev,pflag,configflag,refresh_flag;
  static float t_old = 1000.0; 
  redrawflag = 0;  
  glplot_util_make_current(mod_mon_dpy,mod_mon_win,mod_mon_cx);
  refresh_flag = 0;
  if (XCheckIfEvent(mod_mon_dpy,&event,mod_mon_true_test,(char *)NULL)){
    nev = XQLength(mod_mon_dpy);
    while (nev > 0){
      XPeekEvent(mod_mon_dpy,&evt);
      if (evt.type == ConfigureNotify){
	XNextEvent(mod_mon_dpy,&event); 
      }else
	XNextEvent(mod_mon_dpy,&evt);   
      nev -= 1;
    }
    redrawflag = mod_mon_process_event(pllist,npl,&event);
    if (redrawflag == 1){
      refresh_flag = 1;
    }
  }
  if ((t == -1.0) && (redrawflag != 1)){
    mod_mon_last_t = -1.0;
    return;
  }
  if (mod_mon_last_t == -1.0){ 
    mod_mon_last_t = t;
    refresh_flag = 1;   
  }
  if (mod_mon_pflag == 1) printf("  MOD_MON_MONITOR\n");
  if ((refresh_flag == 1) || (t < t_old)){
    glplot_clear_double(mod_mon_dpy,mod_mon_win);
  }
  if (mod_mon_popflag == 1){
    int i,j;
    int gw,gh;
    float cfx0,cfy0,cfw,cfh,winfrac,gridfrac;
    float gx0,gy0,gdx,gdy,v,vvr,vvg,vvb;
    struct pop_layer *pl;
    struct pop_cell *c;
    struct gui_gpar *gc;
    cfx0 = cfy0 = -1.0;
    cfw = cfh = 2.0;
    winfrac = 0.80;
    gridfrac = 0.80;
    pl = mod_mon_pl; 
    gw = pl->xn;
    gh = pl->yn;
    mod_gr_get_grid_params(gw,gh,cfx0,cfy0,cfw,cfh,winfrac,&gx0,&gy0,
			   &gdx,&gdy);
    gc = mod_gr_get_grid_params_lay(pl,winfrac,cfx0,cfy0,cfw,cfh,
				    gridfrac);
    glplot_clear(mod_mon_dpy,mod_mon_win);
    for(i=0;i<gw;i++){
      for(j=0;j<gh;j++){
	c = &(pl->c[i][j][0]);
	v = c->y; 
	mod_mon_color_voltage(v,&vvr,&vvg,&vvb);
	pl->icon->r = vvr;
	pl->icon->g = vvg;
	pl->icon->b = vvb;
	mod_gr_draw_grid_single(i,j,gc,pl->icon,1.0,1.0,0);
      }
    }
    {
      char tstr[SLEN];
      float x,y;
      y = 1.0 - 18.0 * 2.0/(float)(mod_mon_wyp->f->winh); 
      x = 0.0;  
      sprintf(tstr,"t = %.3f s",t);
      glplot_set_xfont_generic(mod_mon_dpy,mod_mon_win,mod_mon_cx,"medium");
      glplot_draw_text(mod_mon_dpy,mod_mon_win,mod_mon_cx,tstr,x,y,1.0,1.0,1.0);
    }
    if (mod_mon_dbflag == 1)
      glXSwapBuffers(mod_mon_dpy,mod_mon_win);
    else
      glFlush();
  }else{
    mod_mon_update_plots(m,r,pllist,npl,t,refresh_flag);  
    mod_mon_stats(m,r,pllist,npl,t);
  }
  t_old = t;  
}
void mod_mon_init(m,r,s,laylist,nlay,plotname)
     struct model_struct *m;       
     struct response_struct *r;    
     struct stim_struct *s;        
     struct pop_layer **laylist;   
     int nlay;
     char plotname[];
{
  float t,y0,y1,vd,stim_samp;
  struct wyp_struct *wyp;
  struct pop_cell *c;
  XWindowAttributes xwa;
  struct wyp_plot_struct *p;
  char *pname;
  printf("    MOD_MON_INIT\n");
  mod_mon_winw = paramfile_get_int_param_default(r->ppl,"mon_winw",1000);
  mod_mon_winh = paramfile_get_int_param_default(r->ppl,"mon_winh",500);
  mod_mon_winx = paramfile_get_int_param_default(r->ppl,"mon_win_x",5);
  mod_mon_winy = paramfile_get_int_param_default(r->ppl,"mon_win_y",545);
  mod_mon_init_win(plotname);
  glplot_set_window_loc(mod_mon_dpy,mod_mon_win,mod_mon_winx,mod_mon_winy);
  mod_mon_wyp = mod_mon_init_wyp();
  wyp = mod_mon_wyp;
  wyp->stat_t0 = paramfile_get_float_param_default(r->ppl,"mon_stat_t0",0.0);
  wyp->stat_tn = paramfile_get_float_param_default(r->ppl,"mon_stat_tn",0.0);
  wyp->statflag = 0; 
  XGetWindowAttributes(mod_mon_dpy,mod_mon_win,&xwa);
  wyp->f->winw = xwa.width;
  wyp->f->winh = xwa.height;  
  wyp->f->gx0 = -1.0;  wyp->f->gx1 = 1.0; 
  wyp->f->gy0 = -1.0;  wyp->f->gy1 = 1.0;
  wyp->f->xlim0 = 0.0;
  wyp->f->xlim1 = paramfile_get_float_param_default(r->ppl,"mon_t",-1.0);
  if (wyp->f->xlim1 == -1.0)
    wyp->f->xlim1 = 1.05 * r->tsn; 
  wyp->f->tdur = wyp->f->xlim1;
  wyp->f->px0 = 0.05; 
  wyp->f->py0 = 0.0;
  wyp->f->pxf = 2.0/(wyp->f->xlim1 - wyp->f->xlim0);
  wyp->f->nyax = 6;
  wyp->f->yax = (struct wyp_yaxis_struct *)
    myalloc(wyp->f->nyax * sizeof(struct wyp_yaxis_struct));
  y0 = paramfile_get_float_param_default(r->ppl,"mon_mV_y0",-90.0);
  y1 = paramfile_get_float_param_default(r->ppl,"mon_mV_y1",-20.0);
  mod_mon_init_yax(wyp,0,"mV",y0,y1);
  y0 = paramfile_get_float_param_default(r->ppl,"mon_Spk/s_y0",0.0);
  y1 = paramfile_get_float_param_default(r->ppl,"mon_Spk/s_y1",200.0);
  mod_mon_init_yax(wyp,1,"Spk/s",y0,y1);
  y0 = paramfile_get_float_param_default(r->ppl,"mon_nS_y0", -5.0);
  y1 = paramfile_get_float_param_default(r->ppl,"mon_nS_y1", 40.0);
  mod_mon_init_yax(wyp,2,"nS",y0,y1);
  y0 = paramfile_get_float_param_default(r->ppl,"mon_nA_y0", -1.0);
  y1 = paramfile_get_float_param_default(r->ppl,"mon_nA_y1",  2.0);
  mod_mon_init_yax(wyp,3,"nA",y0,y1);
  y0 = -0.5; 
  y1 = 2.0;
  mod_mon_init_yax(wyp,4,"spike",y0,y1);
  y0 = paramfile_get_float_param_default(r->ppl,"mon_none_y0",0.0);
  y1 = paramfile_get_float_param_default(r->ppl,"mon_none_y1",5.0);
  mod_mon_init_yax(wyp,5,"none",y0,y1);
  mod_mon_init_plots(r,laylist,nlay,wyp);
  p = wyp->p;
  while(p != NULL){
    printf("      %s\n",p->name);
    p = p->next;
  }
  mod_mon_stim_flag = paramfile_get_float_param_default(r->ppl,"mon_stim_flag",
							1);
  if (m->ppl != NULL){
    mod_mon_tscale = paramfile_get_float_param_or_exit(m->ppl,"tscale");
    mod_mon_sscale = paramfile_get_float_param_or_exit(m->ppl,"sscale");
    mod_mon_stim_xn = paramfile_get_float_param_or_exit(m->ppl,"xn");
    mod_mon_stim_yn = paramfile_get_float_param_or_exit(m->ppl,"yn");
    mod_mon_stim_tn = paramfile_get_float_param_or_exit(m->ppl,"tn");
  }else{
    mod_mon_tscale = onode_getpar_flt_exit(m->o,"tscale");
    mod_mon_sscale = onode_getpar_flt_exit(m->o,"sscale");
    mod_mon_stim_xn = onode_getpar_int_exit(m->o,"xn");
    mod_mon_stim_yn = onode_getpar_int_exit(m->o,"yn");
    mod_mon_stim_tn = onode_getpar_int_exit(m->o,"tn");
  }
  mod_mon_stim_type = paramfile_get_char_param_or_exit(s->ppl,"stim_type");
  if (strcmp(mod_mon_stim_type,"null")!=0){
    stim_samp = paramfile_get_float_param_or_exit(s->ppl,"stim_samp");
    mod_mon_stim_tsamp = my_rint(1.0/(mod_mon_sscale*stim_samp));
    if (mod_mon_stim_tsamp <= 0)
      mod_mon_stim_tsamp = 1; 
    if (mod_mon_stim_flag == 1)
      mod_mon_stim_prep(s);
  }else{
    mod_mon_stim_tsamp = -1;  
    mod_mon_stim_flag = 0;    
  }
  mod_mon_popflag = paramfile_get_int_param_default(r->ppl,"mon_pop_flag",0);
  if (mod_mon_popflag == 1){
    pname = paramfile_get_char_param_or_exit(r->ppl,"mon_pop_name");
    mod_mon_pl = pop_low_get_layer_for_name(laylist,nlay,pname);
    if (mod_mon_pl == NULL){
      printf("*** Cannot find layer for name:  %s\n",pname);
      exit_error("MOD_MON_INIT","Layer is null");
    }
    myfree(pname);
  }
  c = &(laylist[0]->c[0][0][0]); 
  vd = c->cifcp->v_th_x - c->cifcp->v_leak_x;
  mod_mon_init_color_voltage(c->cifcp->v_ad,
			     c->cifcp->v_leak_x,
			     c->cifcp->v_leak_x + 0.33*vd,
			     c->cifcp->v_leak_x + 0.66*vd,
			     c->cifcp->v_th_x);
  mod_mon_win_draw_stat_box(wyp); 
  glClear(GL_DEPTH_BUFFER_BIT);
  mod_mon_win_decorate(wyp);
}
