/*C  (C) Copyright  Wyeth Bair 1993-2010                                     */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <sys/types.h> 
#include <unistd.h>
#include "my_util.h"
#include "nr_util.h"
#include "carray_util.h"
#include "iarray_util.h"
#include "farray_util.h"
#include "func_util.h"
#include "data_util.h"
#include "paramfile_util.h"
#include "fft_util.h"
#include "kernel_util.h"
#include "stim_util.h"
#include "paramfile.h"
#include "mod.h"
#include "ndata.h"
char *mylog_get_global_fname(id)
     int id;
{
  char tstr[SLEN];
  sprintf(tstr,"/tmp/zz.%d.mm.P_%d.log",(int)getuid(),id);
  return strdup(tstr);
}
char *mylog_get_global_ja_fname()
{
  char tstr[SLEN];
  sprintf(tstr,"/tmp/zzz.%d.mm.ja",(int)getuid());
  return strdup(tstr);
}
int mylog_set_id_log(myid,rmylogf)
     int myid;
     char **rmylogf;
{
  char *mylogf;
  if ((myid == -1) || (myid == 0)){  
    mylogf = (char *)NULL;
  }else{
    mylogf = mylog_get_global_fname(myid);
  }
  if (*rmylogf == NULL){
    *rmylogf = mylogf; 
  }else{
    if (strcmp(*rmylogf,mylogf)==0){
      myfree(mylogf);    
    }else{
      myfree(*rmylogf);
      *rmylogf = mylogf; 
    }
  }
  return myid;
}
int mod_util_sampling_equal(s1,s2)
     float s1,s2;
{
  int eqflag;
  if (my_rint(1000.0*s1) == my_rint(1000.0*s2))
    eqflag = 1;  
  else
    eqflag = 0;
  return eqflag;
}
void mod_util_substitute_var_params(s,k,mylogf,nv,vname,vval)
     struct stim_struct *s;     
     int k;                     
     char mylogf[];
     int nv;         
     char **vname;   
     char **vval;    
{
  int i;
  int numflag;
  float new_val_f;
  char tstr[SLEN],*errstr,*new_val;
  struct param_pair *tp;
  if (k >= 0){
    for(i=0;i<s->nvar;i++){ 
      tp = paramfile_get_param_pointer(s->ppl,s->vname[i]);
      if (tp == NULL){
	sprintf(tstr,"  %s\n",s->vname[i]);
	mylog(mylogf,tstr);
	mylog_exit(mylogf,"MOD_UTIL_SUBSTITUTE_VAR_PARAMS  Null points\n");
      }
      myfree(tp->value);
      new_val = s->vval[k][i];
      if ((s->vtype[i] != 'c') && (!is_float_string(new_val))){
	new_val_f = mstr_evaluate(new_val,nv,vname,vval,&errstr);
	if (errstr != NULL){
	  mylog(mylogf,errstr);
	  mylog(mylogf,"\n");
	  mylog_exit(mylogf,"MOD_UTIL_SUBSTITUTE_VAR_PARAMS mstr_evaluate\n");
	}
	sprintf(tstr,"%f",new_val_f);
	tp->value = strdup(tstr);
	sprintf(tstr,"    Evaluating expression, %s = %s\n",s->vname[i],
		tp->value);
	mylog(mylogf,tstr);
      }else{
	tp->value = strdup(new_val);
      }
    }
  }
}
int mod_util_set_var_tn(mylogf,s,tn_max,tscale)
     char mylogf[];             
     struct stim_struct *s;     
     int tn_max;                
     float tscale;              
{
  int vtn;
  float stim_tn;  
  char ggstr[SLEN];
  stim_tn = param_getf_dflt(s->ppl,"stim_tn",0.0);
  if (stim_tn == 0.0){
    vtn = tn_max;    
  }else{
    vtn = (int)(stim_tn / tscale);
    sprintf(ggstr,"  Variable duration, %f sec, tn %d\n",stim_tn,vtn);
    mylog(mylogf,ggstr);
    if (vtn > tn_max){
      sprintf(ggstr,"  *** stim_tn requires %d steps, but tn is %d.\n",
	      vtn,tn_max);
      mylog(mylogf,ggstr);
      mylog_exit(mylogf,"MOD_UTIL_SET_VAR_TN  tn max exceeded.");
    }
  }
  return vtn;
}
void mod_util_var_par_rec_free(vpr)
     struct var_par_rec *vpr;
{
  free_2d_carray(vpr->name,vpr->n);
  myfree(vpr->ptype);
  free_2d_pointer_carray(vpr->val,vpr->n,vpr->nval);
  myfree(vpr);
}
struct var_par_rec *mod_util_var_par_rec_get_one(name,n,ptype,val,cpflag)
     char *name;   
     int n;        
     char ptype;   
     char **val;   
     int cpflag;   
{
  int i;
  struct var_par_rec *v;
  exit_error("(mod_util)  WYETH HERE","Unused, Untested");
  v = (struct var_par_rec *)myalloc(sizeof(struct var_par_rec));
  v->n = 1;
  v->name = (char **)myalloc(sizeof(char *));
  if (cpflag < 2)
    v->name[0] = strdup(name);
  else
    v->name[0] = name;
  v->ptype[0] = ptype;
  v->nval = n;
  v->val = (char ***)myalloc(sizeof(char **));
  if (cpflag > 0){
    v->val[0] = val;
  }else{
    v->val[0] = (char **)myalloc(n*sizeof(char *));
    for(i=0;i<n;i++)
      v->val[0][i] = strdup(val[i]);
  }
  return v;
}  
struct var_par_rec *mod_util_var_par_rec_from_onode(o)
     struct onode *o;
{
  int i,j;
  int nval,iflag;
  char *sval,*s0,*s1,tstr[SLEN];
  float v0,v1,vf;
  struct onode *t;
  struct var_par_rec *vpr;
  vpr = (struct var_par_rec *)myalloc(sizeof(struct var_par_rec));
  vpr->n = o->n;  
  vpr->val = (char ***)myalloc(vpr->n*sizeof(char **));
  vpr->name = (char **)myalloc(vpr->n*sizeof(char *));
  vpr->ptype = (char *)myalloc(vpr->n*sizeof(char));
  t = o->o;  
  for(i=0;i<vpr->n;i++){
    vpr->name[i]  = strdup(t->name);
    vpr->ptype[i] = 'c';               
    if ((strcmp(o->otype,"var_moo")==0)||(strcmp(o->otype,"var_list")==0)){
      nval = t->nval;
    }else if (strcmp(o->otype,"var_range_n")==0){
      sval = onode_get_nth_val(t,2);
      nval = atoi(sval);
      myfree(sval);
    }
    if (i==0)
      vpr->nval = nval;
    else{
      if (vpr->nval != nval)
	exit_error("MOD_UTIL_VAR_PAR_REC_FROM_ONODE","nval != nvar");
    }
    vpr->val[i] = (char **)myalloc(nval*sizeof(char *));
    if ((strcmp(o->otype,"var_moo")==0)||(strcmp(o->otype,"var_list")==0)){
      for(j=0;j<nval;j++)
	vpr->val[i][j] = onode_get_nth_val(t,j);
    }else if (strcmp(o->otype,"var_range_n")==0){
      s0 = onode_get_nth_val(t,0);
      s1 = onode_get_nth_val(t,1);
      if (is_int_string(s0) && is_int_string(s0))
	iflag = 1;
      else
	iflag = 0;
      v0 = atof(s0);
      v1 = atof(s1);
      for(j=0;j<nval;j++){
	vf = v0 + (v1-v0)*(float)j/(float)(nval-1);
	if (iflag == 1)
	  sprintf(tstr,"%d",my_rint(vf));
	else
	  sprintf(tstr,"%f",vf);
	vpr->val[i][j] = strdup(tstr);
      }
      myfree(s0);
      myfree(s1);
    }
    t = t->next;  
  }
  return vpr;
}
int mod_util_var_par_rec_check_moo(mylogf,m,vpr)
     char *mylogf;             
     struct model_struct *m;   
     struct var_par_rec *vpr;  
{
  int i;
  char ggstr[SLEN];
  for(i=0;i<vpr->n;i++){
    if (onode_test_ostr(m->o,vpr->name[i]) == 0){
      sprintf(ggstr,
	      "*** MOD_UTIL_VAR_PAR_REC_CHECK_MOO   Var name not found:  %s",
	      vpr->name[i]);
      mylog_exit(mylogf,ggstr);
    }
  }
  return 1;
}
void mod_util_var_par_free(vps)
     struct var_par_struct *vps;
{
  int i;
  for(i=0;i<vps->m_var_n;i++)
    mod_util_var_par_rec_free(vps->m_var[i]);
  for(i=0;i<vps->m_one_n;i++)
    mod_util_var_par_rec_free(vps->m_one[i]);
  myfree(vps->m_name);
  free_2d_pointer_carray(vps->m_vval,vps->m_n,vps->m_nvar);
  myfree(vps);
}
struct var_par_struct *mod_util_var_par_get_init()
{
  struct var_par_struct *v;
  v = (struct var_par_struct *)myalloc(sizeof(struct var_par_struct));
  v->m_var_n = 0;
  v->m_one_n = 0;
  v->m_var = NULL;
  v->m_one = NULL;
  return v;
}
void mod_util_var_par_cross_table(mylogf,ndim,vlist,rn,rlist)
     char *mylogf;
     int ndim;                    
     struct var_par_rec **vlist;  
     int *rn;                     
     char ****rlist;              
{
  int i,j,k,l;
  int **list,nlist,*cnt,npar,pi;
  char ***vv;
  cnt = (int *)myalloc(ndim*sizeof(int)); 
  npar = 0;
  for(i=0;i<ndim;i++){
    cnt[i] = vlist[i]->nval;
    npar  += vlist[i]->n;
  }
  get_nd_cross_product_list_iarray(ndim,cnt,&list,&nlist);
  vv = get_2d_pointer_carray(nlist,npar);
  for(i=0;i<nlist;i++){
    pi = 0;  
    for(j=0;j<ndim;j++){  
      for(k=0;k<vlist[j]->n;k++){  
	l = list[i][j];
	vv[i][pi] = strdup(vlist[j]->val[k][l]);
	pi += 1;
      }
    }
  }
  free_2d_iarray(list,nlist);
  myfree(cnt);
  *rn = nlist;
  *rlist = vv;
}
struct var_par_struct *mod_util_var_par(mylogf,m,vpo)
     char *mylogf;            
     struct model_struct *m;  
     struct onode *vpo;       
{
  int i,j,k;
  int tn;
  char ggstr[SLEN],***vval;
  struct var_par_struct *v;
  struct onode *t;
  mylog(mylogf,"  MOD_UTIL_VAR_PAR\n");
  v = mod_util_var_par_get_init();
  v->m_var_n = onode_count_otype(vpo,"var_moo");
  sprintf(ggstr,"    %d <var_moo> records found\n",v->m_var_n);
  mylog(mylogf,ggstr);
  tn = onode_count_otype(vpo,"var_list");  
  sprintf(ggstr,"    %d <var_list> records found\n",tn);
  mylog(mylogf,ggstr);
  v->m_var_n += tn;
  tn = onode_count_otype(vpo,"var_range_n");
  sprintf(ggstr,"    %d <var_range_n> records found\n",tn);
  mylog(mylogf,ggstr);
  v->m_var_n += tn;
  v->m_var = (struct var_par_rec **)myalloc(v->m_var_n*
					    sizeof(struct var_par_rec *));
  k = 0;
  t = onode_get_next_type(vpo->o,"var_moo");
  while(t != NULL){
    v->m_var[k] = mod_util_var_par_rec_from_onode(t);
    if (m != NULL) 
      (void)mod_util_var_par_rec_check_moo(mylogf,m,v->m_var[k]);
    k += 1;
    t = onode_get_next_type(t->next,"var_moo");
  }
  t = onode_get_next_type(vpo->o,"var_list");
  while(t != NULL){
    v->m_var[k] = mod_util_var_par_rec_from_onode(t);
    if (m != NULL) 
      (void)mod_util_var_par_rec_check_moo(mylogf,m,v->m_var[k]);
    k += 1;
    t = onode_get_next_type(t->next,"var_list");
  }
  t = onode_get_next_type(vpo->o,"var_range_n");
  while(t != NULL){
    v->m_var[k] = mod_util_var_par_rec_from_onode(t);
    if (m != NULL) 
      (void)mod_util_var_par_rec_check_moo(mylogf,m,v->m_var[k]);
    k += 1;
    t = onode_get_next_type(t->next,"var_range_n");
  }
  v->m_n = 1;      
  v->m_nvar = 0;   
  for(i=0;i<v->m_var_n;i++){
    v->m_n *= v->m_var[i]->nval;
    v->m_nvar += v->m_var[i]->n;
  }
  sprintf(ggstr,"    %d total model configurations\n",v->m_n);
  mylog(mylogf,ggstr);
  sprintf(ggstr,"    %d total model variable parameters\n",v->m_nvar);
  mylog(mylogf,ggstr);
  v->m_name = (char **)myalloc(v->m_nvar*sizeof(char *));
  k = 0;
  for(i=0;i<v->m_var_n;i++){
    for(j=0;j<v->m_var[i]->n;j++){
      v->m_name[k] = v->m_var[i]->name[j];  
      k += 1;
    }
  }
  for(i=0;i<v->m_nvar;i++){
    sprintf(ggstr,"      %d %s\n",i,v->m_name[i]);
    mylog(mylogf,ggstr);
  }
  mod_util_var_par_cross_table(mylogf,v->m_var_n,v->m_var,&tn,&vval);
  if (tn != v->m_n)
    exit_error("MOD_UTIL","This should not happen");
  v->m_vval = vval;
  return v;
}
int mod_util_resp_unfilled_count(r)
     struct response_struct *r;
{
  int i;
  int n,ri,ti;
  ti = r->gtsi;   
  n = 0;
  for(i=0;i<r->n;i++){
    ri = r->ri[i];  
    if (strcmp(r->rtype[i],"s")==0){
      if (r->cnt[ri][ti] == -1)
	n += 1;
    }else if (strcmp(r->rtype[i],"f")==0){
      if (r->fcnt[ri][ti] == -1)
	n += 1;
    }else{
      exit_error("MOD_UTIL_RESP_UNFILLED_COUNT","Unknown response type.");
    }
  }
  return n;
}
void mod_util_resp_unfilled_exit(r,mylogf)
     struct response_struct *r;
     char *mylogf;
{
  int i;
  int n,ri,ti;
  ti = r->gtsi;   
  n = 0;
  for(i=0;i<r->n;i++){
    ri = r->ri[i];  
    if (strcmp(r->rtype[i],"s")==0){
      if (r->cnt[ri][ti] == -1){
	printf("  UNFILLED RESPONSE  %s %s\n",r->nd_name[i],r->datid[i]);
	n += 1;
      }
    }else if (strcmp(r->rtype[i],"f")==0){
      if (r->fcnt[ri][ti] == -1){
	printf("  UNFILLED RESPONSE  %s %s\n",r->nd_name[i],r->datid[i]);
	n += 1;
      }
    }else{
      exit_error("MOD_UTIL_RESP_UNFILLED_EXIT","Unknown response type.");
    }
  }
  if (n > 0)
    mylog_exit(mylogf,"MOD_UTIL_RESP_UNFILLED_EXIT  Unfilled responses.");
}
char *mod_util_resp_get_rtype_ptr(r,name)
     struct response_struct *r;
     char name[];
{
  int k,ri;
  char *rtype;
  k = search_2d_carray(r->plname,name,r->n);
  if (k >= 0)
    rtype = r->rtype[k];
  else
    rtype = (char *)NULL;
  return rtype;
}
int mod_util_resp_get_ri(r,name)
     struct response_struct *r;
     char name[];
{
  int k,ri;
  k = search_2d_carray(r->plname,name,r->n);
  if (k >= 0)
    ri = r->ri[k];
  else
    ri = -1;
  return ri;
}
float mod_util_resp_get_samp(r,name)
     struct response_struct *r;
     char name[];
{
  int k;
  float samp;
  k = search_2d_carray(r->plname,name,r->n);
  if (k >= 0){
    samp = r->samp[k];
  }else
    samp = 0.0;
  return samp;
}
void mod_util_resp_set_samp(r,name,samp)
     struct response_struct *r;
     char name[];
     float samp;
{
  int k;
  k = search_2d_carray(r->plname,name,r->n);
  if (k >= 0)
    r->samp[k] = samp;
}
int mod_util_resp_check_name(r,name,rtype,mylogf)
     struct response_struct *r;
     char name[];
     char rtype[];
     char mylogf[];
{
  int flag;
  char tstr[SLEN],*rp;
  rp = mod_util_resp_get_rtype_ptr(r,name);
  if (rp != NULL){
    flag = 1;
    if (strcmp(rp,rtype)!=0){
      sprintf(tstr,"*** rsp file:  %s   should be:  %s\n",rp,rtype);
      mylog(mylogf,tstr);
      sprintf(tstr,"MOD_UTIL_RESP_CHECK_NAME Wrong rtype for %s\n",name);
      mylog_exit(mylogf,tstr);
    }
  }else
    flag = 0;
  return flag;
}
int mod_util_resp_get_check_name(r,name,rtype,mylogf,rri)
     struct response_struct *r;
     char name[];
     char rtype[];
     char mylogf[];
     int *rri;
{
  int ri,flag;
  char tstr[SLEN],*rp;
  ri = mod_util_resp_get_ri(r,name);
  if (ri >= 0){
    flag = 1;
    rp = mod_util_resp_get_rtype_ptr(r,name);
    if (strcmp(rp,rtype)!=0){
      sprintf(tstr,"*** rsp file:  %s   should be:  %s\n",rp,rtype);
      mylog(mylogf,tstr);
      sprintf(tstr,"MOD_UTIL_RESP_GET_CHECK_NAME Wrong rtype for %s\n",name);
      mylog_exit(mylogf,tstr);
    }
  }else
    flag = 0;
  *rri = ri;
  return flag;
}
int mod_util_resp_check_store_f(r,name,mylogf,data,n,cpflag)
     struct response_struct *r;
     char name[];
     char mylogf[];
     float *data;
     int n;
     int cpflag;
{
  int ri,ti,flag;
  char tstr[SLEN];
  exit_error("MOD_UTIL.C","THIS NOT USED - WYETH - REMOVE");
  flag = mod_util_resp_get_check_name(r,name,"f",mylogf,&ri);
  if (flag){
    ti = r->gtsi;  
    if (r->f[ri][ti] != NULL){
      sprintf(tstr,"MOD_UTIL_RESP_CHECK_STORE_F Already stored %s\n",name);
      mylog_exit(mylogf,tstr);
    }
    if (cpflag == 1)
      r->f[ri][ti] = copy_farray(data,n);
    else
      r->f[ri][ti] = data;
    r->fcnt[ri][ti] = n;
  }
  return flag;
}
int mod_util_resp_check_store_s(r,name,mylogf,s,cnt,cpflag)
     struct response_struct *r;
     char name[];
     char mylogf[];
     float *s;
     int cnt;
     int cpflag;
{
  int ri,ti,flag;
  char tstr[SLEN];
  flag = mod_util_resp_get_check_name(r,name,"s",mylogf,&ri);
  if (flag == 0){
    printf("  Looking for name:  %s\n",name);
    exit_error("MOD_UTIL_RESP_CHECK_STORE_S","flag is 0");
  }if (ri < 0)
    exit_error("MOD_UTIL_RESP_CHECK_STORE_S","ri < 0");
  if (flag){
    ti = r->gtsi;  
    if (r->s[ri][ti] != NULL){
      sprintf(tstr,"MOD_UTIL_RESP_CHECK_STORE_S Already stored %s\n",name);
      mylog_exit(mylogf,tstr);
    }
    if (cpflag == 1)
      r->s[ri][ti] = copy_farray(s,cnt);
    else
      r->s[ri][ti] = s;
    r->cnt[ri][ti] = cnt;
  }
  return flag;
}
float *mod_util_resp_derive_current(g,gsamp,gx,gn,tscale,v,vx,vn,vmax,vrev,
				    mylogf,rn)
     float *g;        
     float gsamp;     
     float *gx;       
     int  gn;         
     float tscale;    
     float *v;        
     float *vx;       
     int  vn;         
     float vmax;      
     float  vrev;     
     char mylogf[];
     int *rn;         
{
  int i,k;
  int done;
  float *di,*vt,vm,t;
  vt = copy_farray(v,vn);
  for(i=0;i<vn;i++)
    if (vt[i] > vmax)
      vt[i] = vmax;
  di = (float *)myalloc(gn*sizeof(float));
  k = 0;
  i = 0;
  done = 0;
  if (gsamp > 0.0){     
    while(!done && (k<gn)){
      t = tscale * (float)i / gsamp;  
      if (t <= (vx[vn-1] + 0.00001)){ 
	vm = lin_interp_farray(vx,vt,vn,t);
	di[k] = g[i] * (vrev - vm) / 1000.0; 
	k += 1;
      }else{
	done = 1;  
      }
      i += 1;
    }
  }else{                
    while(!done && (i<gn)){
      t = tscale * gx[i];  
      if (t <= vx[vn-1]){
	vm = lin_interp_farray(vx,vt,vn,t);
	di[i] = g[i] * (vrev - vm) / 1000.0; 
	k += 1;
      }else{
	done = 1;
      }
      i += 1;
    }
  }
  myfree(vt);
  *rn = k;
  return di;
}
void mod_util_resp_store_s(r,k,s,cnt,cpflag,mylogf)
     struct response_struct *r;
     int k;          
     float *s;
     int cnt;
     int cpflag;
     char mylogf[];
{
  int ri,ti;
  char tstr[SLEN];
  if (strcmp(r->rtype[k],"s")!=0)  
    exit_error("MOD_UTIL_RESP_STORE_S",
	       "In .rsp file, 'spikes' must have type 's'");
  ti = r->gtsi;    
  ri = r->ri[k];  
  if (r->s[ri][ti] != NULL){
    sprintf(tstr,"*** WARNING:  MOD_UTIL_RESP_STORE_S Already stored %s\n",
	    r->nd_name[k]);
    mylog(mylogf,tstr);
    sprintf(tstr,"    Trial %d results are being over-written\n",ti);
    mylog(mylogf,tstr);
    myfree(r->s[ri][ti]);
  }
  if (cpflag == 1){
    r->s[ri][ti] = copy_farray(s,cnt);
  }else{
    r->s[ri][ti] = s;
  }
  r->cnt[ri][ti] = cnt;
}
void mod_util_resp_store_f(r,k,data,n,cpflag,mylogf)
     struct response_struct *r;
     int k;          
     float *data;
     int n;
     int cpflag;
     char mylogf[];
{
  int ri,ti;
  char tstr[SLEN];
  if (data == NULL)  
    return;
  ti = r->gtsi;   
  ri = r->ri[k]; 
  if (r->f[ri][ti] != NULL){
    sprintf(tstr,"*** WARNING:  MOD_UTIL_RESP_STORE_F Already stored %s\n",
	    r->nd_name[k]);
    mylog(mylogf,tstr);
    sprintf(tstr,"    Trial %d results are being over-written\n",ti);
    mylog(mylogf,tstr);
    myfree(r->f[ri][ti]);
  }
  if (cpflag == 1)
    r->f[ri][ti] = copy_farray(data,n);
  else
    r->f[ri][ti] = data;
  r->fcnt[ri][ti] = n;
}
void mod_util_resp_store_f_samp(r,k,data,n,samp,mylogf)
     struct response_struct *r;
     int k;          
     float *data;
     int n;
     float samp;     
     char mylogf[];
{
  int xfact,nn;
  float ssamp,fxfact,diff,*odata;
  if (data == NULL)  
    return;
  ssamp = r->samp[k]; 
  if (samp != ssamp){  
    fxfact = ssamp/samp;     
    xfact = my_rint(fxfact); 
    if (fxfact < 1.0){
      mylog_exit(mylogf,"MOD_UTIL_RESP_STORE_F_SAMP  response subsampling\n");
    }
    diff = fxfact - (float)xfact;
    if ((diff > -0.0001) && (diff < 0.0001)){
      odata = over_sample_farray_interp(data,n,xfact,&nn);
    }else{
      mylog_exit(mylogf,"MOD_UTIL_RESP_STORE_F_SAMP  non-integer factor\n");
    }
  }else{
    odata = copy_farray(data,n);
    nn = n;
  }
  mod_util_resp_store_f(r,k,odata,nn,0,mylogf); 
}
void mod_util_resp_store_f_reg(r,k,xdata,ydata,n,samp_in,mylogf)
     struct response_struct *r;
     int k;           
     float *xdata;    
     float *ydata;    
     int n;
     float samp_in;  
     char mylogf[];
{
  int i;
  int nsamp;
  float *tx,*regx,*regy,samp_out,xf,*xtx,*xty;
  samp_out = r->samp[k];     
  if (samp_in != samp_out){
    tx = (float *)myalloc(n*sizeof(float));
    xf = samp_out/samp_in;
    for(i=0;i<n;i++)
      tx[i] = xdata[i] * xf;
  }else
    tx = xdata;
  nsamp = r->tsn * samp_out; 
  regx = (float *)myalloc(nsamp * sizeof(float));
  for(i=0;i<nsamp;i++)
    regx[i] = (float)i;
  if (tx[n-1] < regx[nsamp-1]){ 
    xtx = (float *)myalloc((n+1)*sizeof(float));
    xty = (float *)myalloc((n+1)*sizeof(float));
    for(i=0;i<n;i++){
      xtx[i] = tx[i];
      xty[i] = ydata[i];
    }
    xtx[n] = 1.0 + regx[nsamp-1];
    xty[n] = xty[n-1];
    regy = resample_farray(xtx,xty,n+1,regx,nsamp);
    myfree(xtx); myfree(xty);
  }else
    regy = resample_farray(tx,ydata,n,regx,nsamp);
  mod_util_resp_store_f(r,k,regy,nsamp,0,mylogf);  
  if (samp_in != samp_out)
    myfree(tx);
  myfree(regx);
}
int mod_util_resp_pop_unit(r,mylogf,pop_name,xi,yi,zi)
     struct response_struct *r;
     char mylogf[];
     char pop_name[];
     int xi,yi,zi;
{
  int i;
  int ti;
  ti = -1;
  for(i=0;i<r->n;i++){
    if ((r->rformat[i] == 1)||(r->rformat[i] == 2)||(r->rformat[i] == 3)){
      if ((strcmp(r->plname[i],pop_name)==0) && 
	  (r->xi[i] == xi) && (r->yi[i] == yi) && (r->zi[i] == zi)){
	ti = i;
      }
    }
  }
  return ti;
}
float mod_util_cone_weight(mylogf,x,y,cx,cy,sd,cid,ccode,distrib)
     char mylogf[];
     float x,y;        
     float cx,cy;      
     float sd;         
     int cid;          
     int ccode;        
     int distrib;      
{
  int tc,sflag,mflag,lflag;
  float w,dx,dy;
  sflag = mflag = lflag = 0;
  tc = ccode;
  if (tc >= 100){
    sflag = 1;
    tc -= 100;
  }
  if (tc >= 10){
    mflag = 1;
    tc -= 10;
  }
  if (tc >= 1)
    lflag = 1;
  if (((cid == 0) && sflag) ||
      ((cid == 1) && mflag) ||
      ((cid == 2) && lflag)){
    if (distrib == 0){
      w = func_2d_gaussian(x,y,cx,cy,sd,sd,0);   
    }else if (distrib == 1){
      dx = cx - x;
      dy = cy - y;
      if ((dx*dx + dy*dy) < (sd*sd))
	w = 1.0;
      else
	w = 0.0;
    }
  }else{
    w = 0.0;
  }
  return w;
}
float **mod_util_o_get_filt2d_gabor(mylogf,fo,sscale,rxn,ryn)
     char mylogf[];
     struct onode *fo;  
     float sscale;      
     int *rxn;          
     int *ryn;          
{
  int xn,yn,hidnum;
  float theta,sdp_deg,sdo_deg,sf_deg,phase,xc_deg,yc_deg;
  float xc,yc,sdp,sdo,sf,a,**fdata;
  if (*rxn == -1){
    xn = onode_getpar_int_exit(fo,"xn");
  }else
    xn = *rxn;
  if (*ryn == -1){
    yn = onode_getpar_int_exit(fo,"yn");
  }else
    yn = *ryn;
  hidnum  = onode_getpar_int_dflt(fo,"hidden",0);   
  if (hidnum == 0){
    theta   = onode_getpar_flt_exit(fo,"theta");      
    sdp_deg = onode_getpar_flt_exit(fo,"sd_par");     
    sdo_deg = onode_getpar_flt_exit(fo,"sd_orth");    
    sf_deg  = onode_getpar_flt_exit(fo,"sf");         
    phase   = onode_getpar_flt_exit(fo,"phase");      
    xc_deg  = onode_getpar_flt_dflt(fo,"xc",0.0);     
    yc_deg  = onode_getpar_flt_dflt(fo,"yc",0.0);     
  }else if (hidnum == 1){
    theta   = 260.0;    
    sdp_deg = 0.110;    
    sdo_deg = 0.075;    
    sf_deg  = 6.0;      
    phase   = 0.0;      
    xc_deg  = (float)(*rxn)/2.0 * sscale - sdp_deg*3.0;  
    yc_deg  = (float)(*ryn)/2.0 * sscale - sdp_deg*3.0;  
  }else
    mylog_exit(mylogf,"MOD_UTIL_O_GET_FILT2D_GABOR  Bad 'hidden' index\n");
  xc  =  xc_deg/sscale;   
  yc  =  yc_deg/sscale;
  sdp = sdp_deg/sscale;
  sdo = sdo_deg/sscale;
  sf  =  sf_deg*sscale;
  xc += (float)(xn-1)/2.0;  
  yc += (float)(yn-1)/2.0;  
  fdata = gabor_2d_space_raw(xn,yn,xc,yc,sdo,sdp,sf,theta,phase);
  if (onode_item(fo,"max")==1){
    a = onode_getpar_flt_exit(fo,"max");
    make_max_const_2d_farray(fdata,xn,yn,a);
  }else if (onode_item(fo,"area")==1){
    a = onode_getpar_flt_exit(fo,"area");
    norm_area_2d_farray(fdata,xn,yn,a);
  }else{
    norm_area_2d_farray(fdata,xn,yn,1.0);  
  }
  *rxn = xn;
  *ryn = yn;
  return fdata;
}
float **mod_util_o_get_filter_2d(mylogf,fo,sscale,rxn,ryn)
     char mylogf[];
     struct onode *fo;  
     float sscale;      
     int *rxn,*ryn;     
{
  char *ftype,*dumpfile;
  float **fdata;
  mylog(mylogf,"  MOD_UTIL_O_GET_FILTER_2D\n");
  if (fo == NULL)
    mylogx(mylogf,"MOD_UTIL_O_GET_FILTER_2D","Null filter onode");
  ftype = onode_getpar_chr_exit(fo,"type");
  if (strcmp(ftype,"Gabor")==0){
    fdata = mod_util_o_get_filt2d_gabor(mylogf,fo,sscale,rxn,ryn);
  }else{
    mylogx(mylogf,"MOD_UTIL_O_GET_FILTER_2D","Unknown 2d <filter> type");
  }
  dumpfile = onode_getpar_chr_dflt(fo,"plot_filename",NULL);
  if (dumpfile != NULL){
    if ((strcmp(dumpfile,"null")!=0)&&(strcmp(dumpfile,"NULL")!=0))
      write_2d_data(dumpfile,fdata,0,0,*rxn,*ryn,4,2,1,0);
    myfree(dumpfile);
  }
  myfree(ftype);
  return fdata;
}
void mod_util_stim_smooth(s,xn,yn,tn,sscale,tscale,pflag,mylogf)
     struct stim_struct *s;  
     int xn,yn,tn;
     float sscale,tscale;
     int pflag;
     char *mylogf;
{
  float ***smooth;
  char ggstr[SLEN],*sform;
  sform = paramfile_get_char_param_default(s->ppl,"stim_form","3d");
  if (strcmp(sform,"3d")!=0){
    myfree(sform);
    return;
  }
  smooth = stim_util_blur(mylogf,s->ppl,s->d,xn,yn,tn,sscale,tscale);
  if (smooth != NULL){
    free_f3tensor(s->d,1,xn,1,yn,1,tn);  
    s->d = smooth;                       
  }
  myfree(sform);
}
void mod_util_get_3d_stim(s,k,xn,yn,tn,sscale,tscale,tsamp,mylogf)
     struct stim_struct *s;  
     int k,xn,yn,tn;
     float sscale,tscale;
     int tsamp;
     char *mylogf;
{
  int pflag;
  float ***d;
  char *stimtype,*stimadapt,ggstr[LONG_SLEN];
  pflag = 0;
  if (mylogf == NULL)
    pflag = 1;
  mod_util_substitute_var_params(s,k,mylogf,0,NULL,NULL);
  d = get_stim_3d_ppl(mylogf,s,xn,yn,tn,sscale,tscale,tsamp);
  stimtype = paramfile_get_char_param_or_exit(s->ppl,"stim_type");
  if (d == NULL){
    if (strcmp(stimtype,"null")==0){
      s->d = d;
      return;
    }else{
      sprintf(ggstr,"stimtype:  %s\n",stimtype);
      mylog(mylogf,ggstr);
      mylog_exit(mylogf,"MOD_UTIL_GET_3D_STIM  Stim is NULL\n");
    }
  }
  myfree(stimtype);
  s->d = d;
  mod_util_stim_smooth(s,xn,yn,tn,sscale,tscale,pflag,mylogf);
  d = s->d;  
  stimadapt = paramfile_get_char_param_default(s->ppl,"stim_adapt","none");
  if (strcmp(stimadapt,"meangray")==0){
    int i,j,k;
    int nmask,cn;
    float mu,adtau,*emask,*td,*ad;
    mylog(mylogf,"  *** Subjecting stimulus to adaptation.\n");
    adtau = paramfile_get_float_param_default(s->ppl,"stim_adapt_tau",-1.0);
    if (adtau < 0.0){
      for(i=1;i<=xn;i++){
	for(j=1;j<=yn;j++){
	  mu = mean_farray(&(d[i][j][1]),tn);
	  for(k=1;k<=tn;k++)
	    d[i][j][k] += 0.5 - mu;
	}
      }
    }else{
      nmask = (int)(adtau / tscale) * 10 + 1; 
      cn = (nmask-1)/2;
      emask = get_zero_farray(nmask);
      for(i=cn;i<nmask;i++)
	emask[i] = func_one_sided_exp((double)(i-cn),0.0,
				      (double)(adtau/tscale));
      norm_area_farray(emask,nmask,1.0);
      append_farray_plot("zzz.emask","emask",emask,nmask,1);
      td = (float *)myalloc((cn+tn)*sizeof(float));
      for(i=1;i<=xn;i++){
	for(j=1;j<=yn;j++){
	  for(k=0;k<cn;k++){  
	    td[k] = d[i][j][1];
	  }
	  for(k=1;k<=tn;k++)  
	    td[k+cn-1] = d[i][j][k];
	  if ((i==10)&&(j==10))
	    append_farray_plot("zzz.emask","before",td+cn,tn,1);
	  ad = fft_convolve(td,cn+tn,emask,nmask,1);
	  if ((i==10)&&(j==10))
	    append_farray_plot("zzz.emask","adstim",ad+cn,tn,1);
	  for(k=1;k<=tn;k++)
	    d[i][j][k] += 0.5 - ad[cn+k-1];
	  if ((i==10)&&(j==10))
	    append_farray_plot("zzz.emask","FINAL",&(d[i][j][1]),tn,1);
	  myfree(ad);
	}
      }
      myfree(emask);
      myfree(td);
    }
  }
  myfree(stimadapt);
  s->d = d;
  s->d_r  = NULL; 
  s->dc   = NULL;
  s->dc_r = NULL;
}
void mod_util_get_3d_stim_binoc(s,k,xn,yn,tn,sscale,tscale,tsamp,mylogf)
     struct stim_struct *s;  
     int k,xn,yn,tn;
     float sscale,tscale;
     int tsamp;
     char *mylogf;
{
  int pflag;
  char *stimtype,ggstr[LONG_SLEN];
  pflag = 0;
  if (mylogf == NULL)
    pflag = 1;
  mod_util_substitute_var_params(s,k,mylogf,0,NULL,NULL);
  stimtype = paramfile_get_char_param_or_exit(s->ppl,"stim_type");
  get_stim_3d_b_ppl(mylogf,stimtype,s->ppl,xn,yn,tn,sscale,tscale,tsamp,
		    &(s->d),&(s->d_r));
  if ((s->d == NULL)||(s->d_r == NULL)){
    sprintf(ggstr,"stimtype %s\n",stimtype);
    mylog(mylogf,ggstr);
    mylog_exit(mylogf,"MOD_UTIL_GET_3D_STIM_BINOC  Stim is NULL\n");
  }
  myfree(stimtype);
  s->dc   = NULL;
  s->dc_r = NULL;
}
void mod_util_get_3c_stim(s,k,xn,yn,tn,sscale,tscale,tsamp,mylogf)
     struct stim_struct *s;  
     int k,xn,yn,tn;
     float sscale,tscale;
     int tsamp;
     char *mylogf;
{
  int pflag;
  int ***d;
  char *stimtype,*stimadapt,ggstr[LONG_SLEN];
  pflag = 0;
  if (mylogf == NULL)
    pflag = 1;
  mod_util_substitute_var_params(s,k,mylogf,0,NULL,NULL);
  stimtype = paramfile_get_char_param_or_exit(s->ppl,"stim_type");
  d = get_stim_3c_ppl(mylogf,stimtype,s->ppl,xn,yn,tn,sscale,tscale,tsamp);
  if (d == NULL){
    sprintf(ggstr,"stimtype %s\n",stimtype);
    mylog(mylogf,ggstr);
    mylog_exit(mylogf,"MOD_UTIL_GET_3C_STIM  Stim is NULL\n");
  }
  s->dc = d;
  mod_util_stim_smooth(s,xn,yn,tn,sscale,tscale,pflag,mylogf);  
  s->dc_r = NULL;
  s->d    = NULL;
  s->d_r  = NULL; 
}
float *mod_util_get_1d_stim(s,k,tn,tscale,tsamp,mylogf)
     struct stim_struct *s;  
     int k,tn;
     float tscale;
     int tsamp;
     char *mylogf;
{
  float *d;
  char *stimtype,ggstr[LONG_SLEN];
  mod_util_substitute_var_params(s,k,mylogf,0,NULL,NULL); 
  stimtype = paramfile_get_char_param_or_exit(s->ppl,"stim_type");
  if (strcmp(stimtype,"pulse1d")==0){
    d = get_stim_1d_ppl_pulse(s->ppl,tn,tscale,tsamp);
  }else if (strcmp(stimtype,"sine1d")==0){
    d = get_stim_1d_ppl_sine(s->ppl,tn,tscale,tsamp);
  }else if (strcmp(stimtype,"vsksos1d")==0){
    d = get_stim_1d_ppl_vsksos(s->ppl,tn,tscale,tsamp);
  }else if (strcmp(stimtype,"noise1d")==0){
    d = get_stim_1d_ppl_noise(s->ppl,tn,tscale,tsamp);
  }else if (strcmp(stimtype,"stat1")==0){
    d = get_stim_1d_ppl_stat1(s->ppl,tn,tscale,tsamp);
  }else{
    d = NULL;
    sprintf(ggstr,"stimtype %s\n",stimtype);
    mylog(mylogf,ggstr);
    mylog_exit(mylogf,"MOD_UTIL_GET_1D_STIM_DATA  Unknown stim_type\n");
  }
  myfree(stimtype);
  return d;
}
