/*C  (C) Copyright  Wyeth Bair 2014                                          */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>  
#include <math.h>
#include <string.h>
#include "my_util.h"
#include "nr_util.h"
#include "iarray_util.h"
#include "carray_util.h"
#include "farray_util.h"
#include "myrand_util.h"
#include "data_util.h"
#include "min_util.h"
#include "spike_util.h"
#include "paramfile_util.h"
#include "fft_util.h"
#include "stim_util.h"
#include "stm_util.h"
#include "kernel_util.h"
#include "mod_util.h"
#include "mm_util.h"
#include "pop_cell_util.h"
#include "pop_util.h"      
#include "ifc.h"           
#include "mod.h"           
#include "paramfile.h"
#define KSMALL 0.0001   
#define MAX_PAR  100    
static int myid = -1;         
static int numproc = -1;      
static char *mylogf = NULL;   
char ggstr[LONG_SLEN];        
int mod_vhf_action;           
struct vhf_grid{
  char *name;       
  int   xn;         
  int   yn;         
  int   dx;         
  int   dy;         
  int   w;          
  int   h;          
  int   ntile;      
  int  *tile_list;  
  int    totpixw;   
  int    totpixh;   
  int   *s1xn;      
  int   *s1yn;      
  int ***s1x0;      
  int ***s1y0;      
  float  avgtw;     
  int    ndx0;      
};
struct vhf_c1w{
  int gi;            
  int xi;            
  int yi;            
  int ci;            
  float w;           
};
struct vhf_s2_par{
  char  *nltype;        
  float  s;             
  float  a;             
  float  b;             
  float  eps2;          
  int    nw;            
  struct vhf_c1w **c1w; 
};
struct vhf_s2{
  float *****c1rs;  
};
struct vhf_c2{
  int s2_xn;            
  int s2_dx;            
  struct vhf_s2 ***s2;  
};
struct vhf_chans{
  char *name;
  char *type;
  int nori;
  int nph;
  float ph0;
  int maxph_flag;      
  int nch;             
  int nch0;            
  float       f_o;     
  float       f_p;     
  float       f_f;     
  float  *****f;       
  float ******ft;      
  float  *****fts;     
  float  *****r;       
  int     norm_flag;   
  float   norm_eps;    
  int   **norm_mask_x; 
  int   **norm_mask_y; 
  int    *norm_mask_n; 
};
int         mod_vhf_xn;      
int         mod_vhf_yn;      
int         mod_vhf_tn;      
float       mod_vhf_tscale;  
float       mod_vhf_sscale;  
char       *mod_vhf_outfile_prefix;  
int         mod_vhf_nsz;     
int        *mod_vhf_tile_w;  
int        *mod_vhf_tile_id; 
int        *mod_vhf_tile_x0; 
int        *mod_vhf_tile_y0; 
int        *mod_vhf_tile_xn; 
int        *mod_vhf_tile_yn; 
int         mod_vhf_ft_resp_flag;  
int                 mod_vhf_s1_nchans;  
struct vhf_chans  **mod_vhf_chans;      
int     mod_vhf_s1_norm_flag;   
float **mod_vhf_s1_norm_t2;     
int         mod_vhf_c1_nch;   
int         mod_vhf_c1_ntot;  
int         mod_vhf_c1_gridn; 
float ******mod_vhf_c1_r;     
struct vhf_grid  **mod_vhf_c1_grid;   
int       **mod_vhf_c1_ndx;   
int        *mod_vhf_c1_flag;  
int         mod_vhf_c1_s1_x0;  
int         mod_vhf_c1_s1_y0;  
int         mod_vhf_c1_s1_xn;  
int         mod_vhf_c1_s1_yn;  
struct vhf_s2_par  *mod_vhf_s2;      
float         **mod_vhf_s2_r;    
struct vhf_c2  *mod_vhf_c2;      
float           mod_vhf_c2_r;    
int         mod_vhf_fit_c1_max_n; 
int         mod_vhf_fit_nc1;      
int         mod_vhf_fit_nrsp;     
float      *mod_vhf_fit_r;        
float   ****mod_vhf_fit_c1r = NULL;  
int         mod_vhf_fit_xn;     
float      *mod_vhf_fit_x;      
float      *mod_vhf_fit_dw;     
float    ***mod_vhf_fit_dj;     
float      *mod_vhf_fit_opt = NULL;  
int        *mod_vhf_fit_ndx;    
float      *mod_vhf_fit_mse;    
float      *mod_vhf_fit_mse_ts; 
float      *mod_vhf_fit_rvl;    
float      *mod_vhf_fit_rvl_ts; 
int         mod_vhf_boot_split_i; 
int        *mod_vhf_boot_shuff;   
float      *mod_vhf_fit_train_r;  
int         mod_vhf_fit_train_n;  
struct vhf_mmfit{
  int    n;        
  int    ndone;    
  int    nci;      
  int  **ci;       
  int   *stat;     
  float *mse;      
  float  mse_min;  
  int    nxti;     
  int   *pstat;    
};
struct vhf_mmfit *mod_vhf_mmfit;
void mod_vhf_fname(o,pname,suffix,rname)
     struct onode *o;  
     char *pname;      
     char *suffix;     
     char  rname[];    
{
  char *outfile;
  outfile = onode_getpar_chr_dflt(o,pname,"*");
  if (strcmp(outfile,"*")==0)
    sprintf(rname,"%s%s",mod_vhf_outfile_prefix,suffix);
  else if (strcmp(outfile,"NULL")==0){
    rname[0] = '\0';  
  }else
    sprintf(rname,"%s",outfile);
  myfree(outfile);
}
void mod_vhf_chan_index(gci,rci,ri)
     int  gci;  
     int *rci;  
     int *ri;   
{
  int i;
  int done,max_ci;
  *rci = -1;
  *ri = -1;
  i = 0;
  done = 0;
  while(done == 0){
    max_ci = mod_vhf_chans[i]->nch0 + mod_vhf_chans[i]->nch - 1;
    if (gci <= max_ci){
      *rci = i;
      *ri = gci - mod_vhf_chans[i]->nch0;  
      done = 1;
    }else
      i += 1;
  }
}
void mod_vhf_ndx_for_grid(gi,r0,rn)
     int gi;   
     int *r0;  
     int *rn;  
{
  int i;
  int gxn,gyn,c0,cn;
  if ((gi < 0) || (gi >= mod_vhf_c1_gridn))
    exit_error("MOD_VHF_NDX_FOR_GRID","Grid index out of range");
  c0 = 0;
  for(i=0;i<gi;i++){
    gxn = mod_vhf_c1_grid[i]->xn;      
    gyn = mod_vhf_c1_grid[i]->yn;      
    c0 += gxn * gyn * mod_vhf_c1_nch;  
  }
  gxn = mod_vhf_c1_grid[gi]->xn;       
  gyn = mod_vhf_c1_grid[gi]->yn;       
  cn  = gxn * gyn * mod_vhf_c1_nch;    
  *rn = cn;
  *r0 = c0;
}
int mod_vhf_c1_ndx_get(gi,xi,yi,ci)
     int gi;  
     int xi;  
     int yi;  
     int ci;  
{
  int i;
  int i0,gxn,gyn,nch;
  i0  = mod_vhf_c1_grid[gi]->ndx0;
  gxn = mod_vhf_c1_grid[gi]->xn;
  gyn = mod_vhf_c1_grid[gi]->yn;
  nch = mod_vhf_c1_nch;
  i = i0 + gxn*(gyn*nch) + gyn*nch + ci;
  if ((mod_vhf_c1_ndx[i][0] != xi)||
      (mod_vhf_c1_ndx[i][1] != yi)||
      (mod_vhf_c1_ndx[i][2] != ci)||
      (mod_vhf_c1_ndx[i][3] != gi))
    exit_error("MOD_VHF_C1_NDX_GET","Mismatch - should not happen");
  return i;
}
void mod_vhf_c1_ndx_print(k)
     int k;  
{
  printf("      GCI %d =  Grid %d  (%d, %d)  Chan %d\n",k,mod_vhf_c1_ndx[k][3],
	 mod_vhf_c1_ndx[k][0],mod_vhf_c1_ndx[k][1],mod_vhf_c1_ndx[k][2]);
}
float *mod_vhf_c1_resp_gci(s2i,s2j,gci)
     int s2i,s2j;  
     int gci;      
{
  int xi,yi,ci,gi,i;
  float *tdata,*****trs;
  trs = mod_vhf_c2->s2[s2i][s2j]->c1rs;
  tdata = get_farray(mod_vhf_fit_nrsp);
  xi = mod_vhf_c1_ndx[gci][0];
  yi = mod_vhf_c1_ndx[gci][1];
  ci = mod_vhf_c1_ndx[gci][2];
  gi = mod_vhf_c1_ndx[gci][3];
  for(i=0;i<mod_vhf_fit_nrsp;i++)  
    tdata[i] = trs[i][gi][xi][yi][ci]; 
  return tdata;
}
void mod_vhf_relate_c1_targ()
{
  int i;
  int nst,nc1,vmax_i,vmin_i,s2i,s2j;
  float *targ,*tc1,*c1vtarg,x,vmax,vmin;
  char tstr[SLEN];
  printf("  MOD_VHF_RELATE_C1_TARG\n");
  s2i = s2j = mod_vhf_c2->s2_xn / 2;
  printf("    *** WARNING:  Using s2 unit at location %d %d\n",s2i,s2j);
  nst   = mod_vhf_fit_nrsp;  
  nc1   = mod_vhf_c1_ntot;   
  targ = mod_vhf_fit_r;       
  c1vtarg = get_farray(nc1);  
  remove_file("zzz.c1.table.txt");
  for(i=0;i<nc1;i++){
    sprintf(tstr,"%4d   Grid %d  (%d, %d)  Chan %d\n",i,mod_vhf_c1_ndx[i][3],
	    mod_vhf_c1_ndx[i][0],mod_vhf_c1_ndx[i][1],mod_vhf_c1_ndx[i][2]);
    append_string_to_file("zzz.c1.table.txt",tstr);
  }
  vmax = -2.0;  
  vmin =  2.0;  
  for(i=0;i<nc1;i++){
    tc1 = mod_vhf_c1_resp_gci(s2i,s2j,i);
    if (sum_farray(tc1,nst,0,nst) == 0){
      printf("  *** Channel %d has all zero responses.\n",i);
      x = -2.0;  
    }else{
      simple_pearsn(targ-1,tc1-1,nst,&x);  
      if (x > vmax){
	vmax = x;
	vmax_i = i;
      }else if (x < vmin){
	vmin = x;
	vmin_i = i;
      }
    }
    c1vtarg[i] = x;
    myfree(tc1);
  }
  printf("    Largest r-value:   %5.2f  (gci = %d)\n",vmax,vmax_i);
  mod_vhf_c1_ndx_print(vmax_i);
  printf("    Smallest r-value:  %5.2f  (gci = %d)\n",vmin,vmin_i);
  mod_vhf_c1_ndx_print(vmin_i);
  remove_file("zzz.c1vtarg.pl");
  append_farray_plot("zzz.c1vtarg.pl","r__c1_vs_targ",c1vtarg,nc1,1);
  tc1 = mod_vhf_c1_resp_gci(s2i,s2j,vmax_i);
  sprintf(tstr,"c1_%d__v__targ",vmax_i);
  append_farray_xy_plot("zzz.c1vtarg.pl",targ,tc1,nst,tstr);
  myfree(tc1);
  exit(0);
}
void mod_vhf_norm_mask(maskr,rxi,ryi,rn)
     float maskr;  
     int **rxi;    
     int **ryi;    
     int  *rn;     
{
  int i,j,k;
  int *xi,*yi,d2,dmax,n,r;
  dmax = (int)(maskr*maskr);
  r = my_rint(maskr);
  n = 0;
  for(i=-r;i<=r;i++){
    for(j=-r;j<=r;j++){
      d2 = i*i + j*j;
      if (d2 <= dmax)
	n += 1;
    }
  }
  xi = (int *)myalloc(n*sizeof(int));
  yi = (int *)myalloc(n*sizeof(int));
  k = 0;
  for(i=-r;i<=r;i++){
    for(j=-r;j<=r;j++){
      d2 = i*i + j*j;
      if (d2 <= dmax){
	xi[k] = i;
	yi[k] = j;
	k += 1;
      }
    }
  }
  *rxi = xi;
  *ryi = yi;
  *rn  = n;
}
void mod_vhf_resp_op(optype,nn)
     char *optype;      
     int nn;            
{
  int ii,jj,ci,i,j,k;
  int gxn,gyn,nsz,nori,nph,s2n;
  float *****r;
  if (strcmp(optype,"s1_init")==0){
    for(ci=0;ci<mod_vhf_s1_nchans;ci++){
      nsz  = mod_vhf_nsz;                
      nori = mod_vhf_chans[ci]->nori;
      nph  = mod_vhf_chans[ci]->nph;
      r = (float *****)myalloc(nsz*sizeof(float ****));
      for(i=0;i<nsz;i++){
	r[i] = (float ****)myalloc(nori*sizeof(float ***));
	for(j=0;j<nori;j++){
	  r[i][j] = (float ***)myalloc(nph*sizeof(float **));
	  for(k=0;k<nph;k++){
	    r[i][j][k] = get_2d_farray(mod_vhf_xn,mod_vhf_yn);
	  }
	}
      }
      mod_vhf_chans[ci]->r = r;
      mod_vhf_s1_norm_t2 = get_2d_farray(mod_vhf_xn,mod_vhf_yn);
    }
  }else if (strcmp(optype,"c1s_init")==0){
    s2n = mod_vhf_c2->s2_xn;
    for(ii=0;ii<s2n;ii++){
      for(jj=0;jj<s2n;jj++){
	r = (float *****)myalloc(nn*sizeof(float ****));  
	for(i=0;i<nn;i++){
	  r[i] = (float ****)myalloc(mod_vhf_c1_gridn*sizeof(float ***));
	  for(j=0;j<mod_vhf_c1_gridn;j++){
	    gxn = mod_vhf_c1_grid[j]->xn;
	    gyn = mod_vhf_c1_grid[j]->yn;
	    r[i][j] = get_3d_farray(gxn,gyn,mod_vhf_c1_nch);
	  }
	}
	mod_vhf_c2->s2[ii][jj]->c1rs = r;   
      }
    }
  }else{
    printf("  optype:  %s\n",optype);
    mylog_exit(mylogf,"MOD_VHF_RESP_OP  Unknoown optype.");
  }
}
void mod_vhf_resp_s1_norm(ci)
     int ci;  
{
  int i,j,k;
  int oi,pi,si,xi,yi,xn,yn,nsz,nori,nph,x0,x1,y0,y1,*maskx,*masky,maskn;
  int s2n,s2dx,adj0,adj1;
  float ****tr1,tot,eps;
  struct vhf_chans *chns;
  chns = mod_vhf_chans[ci];
  if (chns->norm_flag != 1)
    exit_error("MOD_VHF_RESP_S1_NORM","Mask norm flag - bad value");
  xn   = mod_vhf_xn;
  yn   = mod_vhf_yn;
  nsz  = mod_vhf_nsz;
  nori = chns->nori;
  nph  = chns->nph;
  eps  = chns->norm_eps;
  s2n  = mod_vhf_c2->s2_xn;     
  s2dx = mod_vhf_c2->s2_dx;     
  adj0 = -s2dx * (int)(s2n/2);  
  adj1 =  s2dx * (int)(s2n-1);  
  for(k=0;k<nsz;k++){  
    maskx = chns->norm_mask_x[k]; 
    masky = chns->norm_mask_y[k]; 
    maskn = chns->norm_mask_n[k]; 
    tr1 = chns->r[k];  
    x0  = adj0 + mod_vhf_tile_x0[k];  
    x1  = x0 + adj1 + mod_vhf_tile_xn[k] - 1;
    y0  = adj0 + mod_vhf_tile_y0[k];
    y1  = y0 + adj1 + mod_vhf_tile_yn[k] - 1;
    for(i=x0;i<=x1;i++){
      for(j=y0;j<=y1;j++){  
	if ((i < 0) || (j < 0)){
	  printf("  k = %d\n",k);
	  printf("  mod_vhf_tile_x0[k] = %d\n",mod_vhf_tile_x0[k]);
	  printf("  adj0 = %d\n",adj0);
	  printf("  i = %d   j = %d\n",i,j);
	  exit_error("MOD_VHF_RESP_S1_NORM","index error");
	}
	tot = 0.0;
	for(si=0;si<maskn;si++){  
	  xi = i + maskx[si];
	  yi = j + masky[si];
	  tot += mod_vhf_s1_norm_t2[xi][yi];  
	}
	tot = sqrt(tot);
	tot += eps; 
	for(oi=0;oi<nori;oi++){
	  for(pi=0;pi<nph;pi++){
	    tr1[oi][pi][i][j] /= tot;
	  }
	}
      }
    }
  }
}
void mod_vhf_fft_resp(stim1)
     float ***stim1;  
{
  int i,j,k;
  int ci,xi,yi,xn,yn,tn,nsz,nori,nph;
  float **speq,***ft,**fts,fc,***r,**rs,**tr;
  struct vhf_chans *chns;
  xn   = mod_vhf_xn;
  yn   = mod_vhf_yn;
  tn   = mod_vhf_tn;
  nsz  = mod_vhf_nsz;
  fc = 2.0/((float)(xn*yn));
  speq = matrix(1,1,1,2*xn);
  contort_real_3d_farray(stim1,1,1,1,1,xn,yn);
  rlft3(stim1,speq,1,xn,yn,1);
  for(ci=0;ci<mod_vhf_s1_nchans;ci++){  
    chns = mod_vhf_chans[ci];
    nori = chns->nori;
    nph  = chns->nph;
    for(i=0;i<nsz;i++){
      for(j=0;j<nori;j++){
	for(k=0;k<nph;k++){
	  ft  = chns->ft[i][j][k];
	  fts = chns->fts[i][j][k];
	  three_d_fft_prod(stim1,speq,ft,fts,1,xn,yn,&r,&rs);
	  rlft3(r,rs,1,xn,yn,-1);
	  free_matrix(rs,1,1,1,2*xn);
	  multiply_3d_farray(r,1,1,1,xn,1,yn,fc);
	  contort_real_3d_farray(r,1,1,1,1,xn,yn);
	  tr = chns->r[i][j][k];  
	  for(xi=0;xi<xn;xi++){
	    for(yi=0;yi<yn;yi++){
	      tr[xi][yi] = r[1][xi+1][yi+1];
	    }
	  }
	  free_f3tensor(r,1,1,1,xn,1,yn);
	}
      }
    }
  }
  free_matrix(speq,1,1,1,2*xn);
}
void mod_vhf_resp_s1(stim1)
     float ***stim1;   
{
  int i,j;
  if (mod_vhf_s1_norm_flag == 1){
    for(i=0;i<mod_vhf_xn;i++){
      for(j=0;j<mod_vhf_yn;j++){
	mod_vhf_s1_norm_t2[i][j] = stim1[1][1+i][1+j] * stim1[1][1+i][1+j];
      }
    }
  }
  if (mod_vhf_ft_resp_flag == 1){
    mod_vhf_fft_resp(stim1);  
  }else
    mylogx(ggstr,"MOD_VHF_01_GET_RESPONSE",
	   "non-FFT method not implemented yet");
  for(i=0;i<mod_vhf_s1_nchans;i++)  
    if (mod_vhf_chans[i]->norm_flag != 0)
      mod_vhf_resp_s1_norm(i);  
}
void mod_vhf_resp_c1_all(resp,ii,jj)
     float ****resp;   
     int ii;           
     int jj;           
{
  int i,j,k,l;
  int ti,xi,yi,si,pi,ci,gn,gxn,gyn,x0,x1,y0,y1,tin,nori,nph,s2xn,x_offset,ch0;
  float smax,**rxy;
  struct vhf_grid *gt;
  struct vhf_chans *chns;
  s2xn     = mod_vhf_c2->s2_xn;  
  x_offset = mod_vhf_c2->s2_dx;  
  gn       = mod_vhf_c1_gridn;   
  for(ci=0;ci<mod_vhf_s1_nchans;ci++){
    chns = mod_vhf_chans[ci];
    nori = chns->nori;
    nph  = chns->nph;
    ch0 = chns->nch0;
    for(i=0;i<gn;i++){  
      gt = mod_vhf_c1_grid[i];
      gxn = gt->xn;
      gyn = gt->yn;
      tin = gt->ntile;
      for(j=0;j<gxn;j++){
	for(k=0;k<gyn;k++){
	  for(l=0;l<nori;l++){  
	    smax = 0.0;  
	    for(pi=0;pi<nph;pi++){  
	      if (chns->maxph_flag == 0)
		smax = 0.0;
	      for(ti=0;ti<tin;ti++){  
		si = get_index_search_iarray(mod_vhf_tile_id,mod_vhf_nsz,
					     gt->tile_list[ti]);
		if ((s2xn != 3)&&(s2xn != 0)&&(s2xn != 1)&&(s2xn != 5))
		  exit_error("WYETH EXIT","Must fix this ???");
		x0 = gt->s1x0[ti][j][k] + (ii-(s2xn/2))*x_offset;
		x1 = x0 + gt->s1xn[ti] - 1;
		y0 = gt->s1y0[ti][j][k] + (jj-(s2xn/2))*x_offset;;
		y1 = y0 + gt->s1yn[ti] - 1;
		if ((x0 < 0)||(y0 < 0))
		  exit_error("MOD_VHF_RESP_C1_ALL",
			     "Index into response array is negative");
		rxy = chns->r[si][l][pi];  
		for(xi=x0;xi<=x1;xi++){  
		  for(yi=y0;yi<=y1;yi++){  
		    if (rxy[xi][yi] > smax){
		      smax = rxy[xi][yi];
		    }
		  }
		}
	      }
	      if (chns->maxph_flag == 0){
		resp[i][j][k][ch0+l*nph+pi] = smax;  
	      }
	    }
	    if (chns->maxph_flag == 1){
	      resp[i][j][k][ch0+l] = smax;  
	      if (ch0 + l >= mod_vhf_c1_nch)
		exit_error("WYETH","This should not happen");
	    }
	  }
	}
      }
    }
  }
}
void mod_vhf_file_c1(fito,fmode)
     struct onode *fito;
     char *fmode;
{
  FILE *fopen(),*fin,*fout;
  int i,j,k,ii,jj;
  int si,gi,gn,gxn,gyn,nch,nstm,rv,s2n,ti;
  float ***r;
  char *fname,ts[SLEN],vers[SLEN];
  mylog(mylogf,"  MOD_VHF_FILE_C1\n");
  fname = onode_getpar_chr_exit(fito,"file_c1");
  nch  = mod_vhf_c1_nch;
  nstm = mod_vhf_fit_nrsp;
  gn   = mod_vhf_c1_gridn;
  s2n  = mod_vhf_c2->s2_xn;
  if (strcmp(fmode,"write")==0){
    if ((fout = fopen(fname,"w")) == NULL){
      sprintf(ggstr,"  *** %s\n",fname);
      mylog(mylogf,ggstr);
      mylogx(ggstr,"MOD_VHF_FILE_C1","Could not open file to write");
    }
    sprintf(ggstr,"    Write C1 responses to file:  %s\n",fname);
    mylog(mylogf,ggstr);
    fprintf(fout,"Version 2.0\n");
    fprintf(fout,"Stimuli %d\n",nstm);
    fprintf(fout,"Grids %d\n",gn);
    fprintf(fout,"S2_size %d\n",s2n);
    for(si=0;si<nstm;si++){  
      fprintf(fout,"Stimulus %d\n",si);
      for(ii=0;ii<s2n;ii++){
	for(jj=0;jj<s2n;jj++){  
	  for(gi=0;gi<gn;gi++){  
	    gxn = mod_vhf_c1_grid[gi]->xn;   
	    gyn = mod_vhf_c1_grid[gi]->yn;   
	    r = mod_vhf_c2->s2[ii][jj]->c1rs[si][gi]; 
	    for(i=0;i<gxn;i++){
	      for(j=0;j<gyn;j++){
		for(k=0;k<nch;k++){
		  fprintf(fout," %f",r[i][j][k]);
		}
	      }
	    }
	  }
	}
      }
      fprintf(fout,"\n");
    }
    fclose(fout);
  }else if (strcmp(fmode,"read")==0){
    if ((fin = fopen(fname,"r")) == NULL){
      sprintf(ggstr,"  *** %s\n",fname);
      mylog(mylogf,ggstr);
      mylogx(ggstr,"MOD_VHF_FILE_C1","Could not open file to read");
    }
    sprintf(ggstr,"    Reading C1 responses from file:  %s\n",fname);
    mylog(mylogf,ggstr);
    rv = fscanf(fin,"%s %s",ts,vers);
    check_string_exit_carray(ts,"Version");
    rv = fscanf(fin,"%s %d",ts,&nstm);
    check_string_exit_carray(ts,"Stimuli");
    rv = fscanf(fin,"%s %d",ts,&gn);
    check_string_exit_carray(ts,"Grids");
    if (strcmp(vers,"1.0")==0){
      s2n = 1;
    }else{
      rv = fscanf(fin,"%s %d",ts,&ti);
      check_string_exit_carray(ts,"S2_size");
      if (ti != s2n){
	mylogx(mylogf,"MOD_VHF_FILE_C1","Mismatch of S2 grid size");
      }
    }
    for(si=0;si<nstm;si++){  
      rv = fscanf(fin,"%s %d",ts,&si);  
      check_string_exit_carray(ts,"Stimulus");
      for(ii=0;ii<s2n;ii++){
	for(jj=0;jj<s2n;jj++){  
	  for(gi=0;gi<gn;gi++){  
	    gxn = mod_vhf_c1_grid[gi]->xn;   
	    gyn = mod_vhf_c1_grid[gi]->yn;   
	    r = mod_vhf_c2->s2[ii][jj]->c1rs[si][gi]; 
	    for(i=0;i<gxn;i++){
	      for(j=0;j<gyn;j++){
		for(k=0;k<nch;k++){
		  rv = fscanf(fin,"%f",&(r[i][j][k]));
		}
	      }
	    }
	  }
	}
      }
    }
    fclose(fin);
  }
  myfree(fname);
}
float mod_vhf_resp_s2(nltype,s,a,b,eps,w,x,n,ru)
     char *nltype; 
     float s,a,b;  
     float eps;    
     float *w;     
     float *x;     
     int n;        
     float *ru;    
{
  int i;
  float sum,sumx2,u,gu;
  sum = 0.0;
  sumx2 = 0.0;
  for(i=0;i<n;i++){  
    sum += w[i] * x[i];    
    sumx2 += x[i] * x[i];  
  }
  u = sum / (sqrt(sumx2) + eps);
  if (strcmp(nltype,"sigmoid0")==0){
    gu = s / (1.0 + exp(-a*(u-b)));
  }else{
    gu = u;
  }
  *ru = u;  
  return gu;
}
float mod_vhf_resp_c2_maxij(s,a,b,eps,w,x,s2n,n,ri,rj)
     float s,a,b;  
     float eps;    
     float *w;     
     float ***x;   
     int s2n;      
     int n;        
     int *ri,*rj;  
{
  int i,ii,jj;
  int maxi,maxj,midi;
  float sum,sumx2,u,gu,s2max,*tx;
  s2max = -1000.0;  
  midi = s2n/2;
  maxi = maxj = -1;
  for(ii=0;ii<s2n;ii++){
    for(jj=0;jj<s2n;jj++){
      tx = x[ii][jj];  
      sum = 0.0;
      sumx2 = 0.0;
      for(i=0;i<n;i++){  
	sum += w[i] * tx[i];     
	sumx2 += tx[i] * tx[i];  
      }
      u = sum / (sqrt(sumx2) + eps);
      gu = s / (1.0 + exp(-a*(u-b)));
      if (gu > s2max){
	s2max = gu;
	maxi = ii;
	maxj = jj;
      }else if ((ii == midi) && (jj == midi)){
	if (gu == s2max){  
	  maxi = ii;
	  maxj = jj;
	}
      }
    }
  }
  if ((maxi == -1)||(maxj == -1))
    exit_error("MOD_VHF_RESP_C2_MAXIJ","Negative index value");
  *ri = maxi;
  *rj = maxj;
  return s2max;
}
void mod_vhf_resp_max_ij_quick(s,a,b,eps,w,x,s2n,n,ri,rj)
     float s,a,b;  
     float eps;    
     float *w;     
     float ***x;   
     int s2n;      
     int n;        
     int *ri,*rj;  
{
  int i,ii,jj;
  int maxi,maxj,midi;
  float sum,sumx2,u,gu,s2max,*tx;
  s2max = -1000.0;  
  midi = s2n/2;
  maxi = maxj = -1;
  for(ii=0;ii<s2n;ii++){
    for(jj=0;jj<s2n;jj++){
      tx = x[ii][jj];  
      sum = 0.0;
      sumx2 = 0.0;
      for(i=0;i<n;i++){  
	sum += w[i] * tx[i];     
	sumx2 += tx[i] * tx[i];  
      }
      if (1){
	u = sum / (sqrt(sumx2) + eps);
      }else{
	if (sum >= 0.0)   
	  u = sum*sum / sumx2;
	else
	  u = -sum*sum / sumx2;
      }
      if (a >= 0.0)
	gu = u;
      else
	gu = -u;
      if (gu > s2max){
	s2max = gu;
	maxi = ii;
	maxj = jj;
      }else if ((ii == midi) && (jj == midi)){
	if (gu == s2max){  
	  maxi = ii;
	  maxj = jj;
	}
      }
    }
  }
  if ((maxi == -1)||(maxj == -1)){
    mylog(mylogf,"******************  MOD_VHF_RESP_C2_MAXIJ - Negative**\n");
    printf(" (s,a,b) %f %f %f   w[0] = %f\n",s,a,b,w[0]);
    exit_error("MOD_VHF_RESP_C2_MAX_IJ_QUICK","Negative index value");
  }
  *ri = maxi;
  *rj = maxj;
}
float mod_vhf_resp_c2(s,a,b,eps,w,x,dj,s2n,n)
     float s,a,b;  
     float eps;    
     float *w;     
     float ***x;   
     float **dj;   
     int s2n;      
     int n;        
{
  int i,ii,jj;
  float sum,sumx2,u,gu,s2max,*tx;
  s2max = -100000.0;  
  for(ii=0;ii<s2n;ii++){
    for(jj=0;jj<s2n;jj++){
      tx = x[ii][jj];  
      sum = 0.0;
      sumx2 = 0.0;
      for(i=0;i<n;i++){  
	sum += w[i] * tx[i];  
      }
      u = sum / dj[ii][jj];
      gu = s / (1.0 + exp(-a*(u-b)));
      if (gu > s2max)
	s2max = gu;
    }
  }
  return s2max;
}
float mod_vhf_resp_c2_fast(s,a,b,eps,w,x,dj,s2n,n)
     float s,a,b;  
     float eps;    
     float *w;     
     float ***x;   
     float **dj;   
     int s2n;      
     int n;        
{
  int i,ii,jj;
  float sum,u,gu,s2max,*tx;
  s2max = -100000.0;  
  for(ii=0;ii<s2n;ii++){
    for(jj=0;jj<s2n;jj++){
      tx = x[ii][jj];  
      sum = 0.0;
      for(i=0;i<n;i++){  
	sum += w[i] * tx[i];  
      }
      u = sum / dj[ii][jj];
      if (a*s < 0.0)  
	u = -u;
      if (u > s2max)
	s2max = u;
    }
  }
  if (a*s < 0.0)  
    s2max = -s2max;
  gu = s / (1.0 + exp(-a*(s2max-b)));
  return gu;
}
float mod_vhf_func_min_01(x)
     float *x;
{
  int i;
  int nrsp,nc1,s2n;
  float mse,d,s,a,b,eps,*w,*targ,****c1r;
  float **dj;
  nc1  = mod_vhf_fit_nc1;      
  nrsp = mod_vhf_fit_train_n;  
  targ = mod_vhf_fit_train_r;  
  c1r  = mod_vhf_fit_c1r;      
  s2n = mod_vhf_c2->s2_xn;     
  s = x[0];     
  a = x[1];
  b = x[2];
  w = &(x[3]);  
  eps = mod_vhf_s2->eps2;
  mse =  0.0;
  for(i=0;i<nrsp;i++){  
    dj = mod_vhf_fit_dj[i];
    d = targ[i] - mod_vhf_resp_c2_fast(s,a,b,eps,w,c1r[i],dj,s2n,nc1);
    mse += d*d;
  }
  mse /= nrsp;
  return mse;
}
int mod_vhf_func_min_01_d(x,rd)
     float *x;   
     float *rd;  
{
  int i,j;
  int nrsp,nc1,ii,jj,s2n;
  float s,a,b,*w,*targ,****c1r,***d,*tr,pod,n2,n2s,n2sa,eps,maxv;
  float uj,fj,hj,vj,pj,sum,d_s,d_a,d_b,*d_w;
  nc1  = mod_vhf_fit_nc1;      
  nrsp = mod_vhf_fit_train_n;  
  targ = mod_vhf_fit_train_r;  
  c1r  = mod_vhf_fit_c1r;      
  d_w  = mod_vhf_fit_dw;       
  d    = mod_vhf_fit_dj;       
  s2n  = mod_vhf_c2->s2_xn;
  eps  = mod_vhf_s2->eps2;
  s = x[0];     
  a = x[1];
  b = x[2];
  w = &(x[3]);  
  d_s = 0.0;
  d_a = 0.0;
  d_b = 0.0;
  for(i=0;i<nc1;i++)
    d_w[i] = 0.0;
  if ((s > 100.0) || (s < -100.0)){
    printf("  *** MOD_VHF_FUNC_MIN_01_D  Note, 's' is too big, stopping.");
    printf("    s= %f  a= %f  b= %f\n",s,a,b);
    printf("    w[0] = %f\n",w[0]);
    return -10;  
  }
  for(j=0;j<nrsp;j++){  
    mod_vhf_resp_max_ij_quick(s,a,b,eps,w,c1r[j],s2n,nc1,&ii,&jj);
    tr = c1r[j][ii][jj];
    sum = 0.0;  
    for(i=0;i<nc1;i++)
      sum += w[i] * tr[i];  
    uj = sum/d[j][ii][jj];  
    fj = exp(-a*(uj - b));
    hj = 1.0 + fj;
    vj = s / hj - targ[j];  
    pj = fj * vj/(hj*hj);
    d_s += vj/hj;
    d_a += pj*(uj - b);
    d_b += pj;
    pod = pj/d[j][ii][jj];
    for(i=0;i<nc1;i++)
      d_w[i] += pod * tr[i];
  }
  n2   = 2.0/(float)nrsp;  
  n2s  = n2*s;
  n2sa = n2s*a;
  rd[0] =  n2   * d_s;  
  rd[1] =  n2s  * d_a;  
  rd[2] = -n2sa * d_b;  
  for(i=0;i<nc1;i++){
    rd[3+i] = n2sa * d_w[i];  
  }
  return 1;
}
void mod_vhf_fit_prep(nw)
     int nw;
{
  mylog(mylogf,"  MOD_VHF_FIT_PREP\n");
  sprintf(ggstr,"    nw = %d\n",nw);
  mylog(mylogf,ggstr);
  mod_vhf_fit_nc1 = nw;      
  mod_vhf_fit_xn  = nw + 3;  
  if (mod_vhf_fit_dw != NULL)
    myfree(mod_vhf_fit_dw);
  mod_vhf_fit_dw = (float *)myalloc(mod_vhf_fit_nc1*sizeof(float));
  if (mod_vhf_fit_x != NULL)
    myfree(mod_vhf_fit_x);
  mod_vhf_fit_x = (float *)myalloc(mod_vhf_fit_xn*sizeof(float));
}
void mod_vhf_fit_prep_c1rs(i1,i2,wi,sqs)
     int i1;     
     int i2;     
     int wi;     
     float ***sqs;  
{
  int i,j,k,ii,fi;
  int gi1,gi2,xi1,xi2,yi1,yi2,ci1,ci2,s2n,ks,nstm,n0;
  float *****tc1rs,****t,tr0,tr1;
  s2n  = mod_vhf_c2->s2_xn;
  nstm = mod_vhf_fit_train_n;
  t    = mod_vhf_fit_c1r;
  if (i1 >= 0){
    xi1 = mod_vhf_c1_ndx[i1][0];
    yi1 = mod_vhf_c1_ndx[i1][1];
    ci1 = mod_vhf_c1_ndx[i1][2];
    gi1 = mod_vhf_c1_ndx[i1][3];
  }
  if (i2 >= 0){
    xi2 = mod_vhf_c1_ndx[i2][0];
    yi2 = mod_vhf_c1_ndx[i2][1];
    ci2 = mod_vhf_c1_ndx[i2][2];
    gi2 = mod_vhf_c1_ndx[i2][3];
  }
  for(i=0;i<s2n;i++){
    for(j=0;j<s2n;j++){
      tc1rs = mod_vhf_c2->s2[i][j]->c1rs;
      if ((i1 >= 0) && (i2 >= 0)){
	for(k=0;k<nstm;k++){
	  ks = mod_vhf_boot_shuff[k];  
	  tr0 = tc1rs[ks][gi1][xi1][yi1][ci1];
	  tr1 = tc1rs[ks][gi2][xi2][yi2][ci2];
	  t[k][i][j][0] = tr0;
	  t[k][i][j][1] = tr1;
	  mod_vhf_fit_dj[k][i][j] = sqrt(tr0*tr0 + tr1*tr1) + KSMALL;
	}
      }else if ((i1 >= 0) && (i2 == -1)){
	for(k=0;k<nstm;k++){
	  ks = mod_vhf_boot_shuff[k];  
	  tr0 = tc1rs[ks][gi1][xi1][yi1][ci1];  
	  t[k][i][j][wi] = tr0;
	  mod_vhf_fit_dj[k][i][j] = sqrt(sqs[k][i][j] + tr0*tr0) + KSMALL;
	}
      }else{
	n0 = wi;  
	for(ii=0;ii<n0;ii++){  
	  fi = mod_vhf_fit_ndx[ii];  
	  xi1 = mod_vhf_c1_ndx[fi][0];
	  yi1 = mod_vhf_c1_ndx[fi][1];
	  ci1 = mod_vhf_c1_ndx[fi][2];
	  gi1 = mod_vhf_c1_ndx[fi][3];
	  for(k=0;k<nstm;k++){
	    ks = mod_vhf_boot_shuff[k];  
	    t[k][i][j][ii] = tc1rs[ks][gi1][xi1][yi1][ci1];
	  }
	}
	for(k=0;k<nstm;k++){
	  sqs[k][i][j] = 0.0;
	  for(ii=0;ii<n0;ii++){  
	    sqs[k][i][j] += t[k][i][j][ii] * t[k][i][j][ii];
	  }
	}
      }
    }
  }
}
void mod_vhf_test_derivs()
{
  int i;
  int i1,i2,oi1,oi2,xi1,xi2,yi1,yi2,gi,nx,nstm,s2n,dflag;
  float fv,*y,*xx,*deriv,*dd;
  float *x;   
  printf("  MOD_VHF_TEST_DERIVS\n");
  mod_vhf_fit_prep(2);  
  nstm = mod_vhf_fit_nrsp;
  mod_vhf_fit_train_n = nstm;
  printf("  *** Over-riding ..._train_n for ..._prep_c1rs()\n");
  s2n  = mod_vhf_c2->s2_xn;
  x = mod_vhf_fit_x;
  mod_vhf_fit_c1r = get_4d_farray(nstm,s2n,s2n,2);  
  oi1 = 0;
  oi2 = 0;
  xi1 = 0;
  xi2 = 1;  
  yi1 = 0;
  yi2 = 0;
  gi = 1;  
  i1 = mod_vhf_c1_ndx_get(gi,xi1,yi1,oi1);
  i2 = mod_vhf_c1_ndx_get(gi,xi2,yi2,oi2);
  mod_vhf_fit_prep_c1rs(i1,i2,-1,NULL);
  x[0] = 1.0;  
  x[1] = 1.0;  
  x[2] = 1.0;  
  x[3] = 1.0;  
  x[4] = 1.0;  
  nx = 100;
  xx = (float *)myalloc(nx*sizeof(float));
  y  = (float *)myalloc(nx*sizeof(float));
  dd = (float *)myalloc(nx*sizeof(float));
  deriv = (float *)myalloc(mod_vhf_fit_xn*sizeof(float));
  for(i=0;i<nx;i++){
    fv = -4.0 + 10.0*(float)i/(float)(nx-1);  
    x[0] = fv;  
    xx[i] = fv;
    y[i] = mod_vhf_func_min_01(x);
    dflag = mod_vhf_func_min_01_d(x,deriv);
    dd[i] = deriv[0];
  }
  append_farray_xy_plot("zzz.test_deriv.pl",xx,y,nx,"MSE_v_s");
  append_farray_xy_plot("zzz.test_deriv.pl",xx,dd,nx,"dds_v_s");
  x[0] = x[1] = x[2] = x[3] = x[4] = 1.0;  
  for(i=0;i<nx;i++){
    fv = -30.0 + 60.0*(float)i/(float)(nx-1);  
    x[1] = fv; 
    xx[i] = fv;
    y[i] = mod_vhf_func_min_01(x);
    dflag = mod_vhf_func_min_01_d(x,deriv);
    dd[i] = deriv[1];
  }
  append_farray_xy_plot("zzz.test_deriv.pl",xx,y,nx,"MSE_v_a");
  append_farray_xy_plot("zzz.test_deriv.pl",xx,dd,nx,"dds_v_a");
  x[0] = x[1] = x[2] = x[3] = x[4] = 1.0;  
  for(i=0;i<nx;i++){
    fv = -10.0 + 20.0*(float)i/(float)(nx-1);  
    x[2] = fv; 
    xx[i] = fv;
    y[i] = mod_vhf_func_min_01(x);
    dflag = mod_vhf_func_min_01_d(x,deriv);
    dd[i] = deriv[2];
  }
  append_farray_xy_plot("zzz.test_deriv.pl",xx,y,nx,"MSE_v_b");
  append_farray_xy_plot("zzz.test_deriv.pl",xx,dd,nx,"dds_v_b");
  x[0] = x[1] = x[2] = x[3] = x[4] = 1.0;  
  for(i=0;i<nx;i++){
    fv = -20.0 + 40.0*(float)i/(float)(nx-1);  
    x[3] = fv;  
    xx[i] = fv;
    y[i] = mod_vhf_func_min_01(x);
    dflag = mod_vhf_func_min_01_d(x,deriv);
    dd[i] = deriv[3];
  }
  append_farray_xy_plot("zzz.test_deriv.pl",xx,y,nx,"MSE_v_w0");
  append_farray_xy_plot("zzz.test_deriv.pl",xx,dd,nx,"dds_v_w0");
  x[0] = x[1] = x[2] = x[3] = x[4] = 1.0;  
  for(i=0;i<nx;i++){
    fv = -20.0 + 40.0*(float)i/(float)(nx-1);  
    x[4] = fv;  
    xx[i] = fv;
    y[i] = mod_vhf_func_min_01(x);
    dflag = mod_vhf_func_min_01_d(x,deriv);
    dd[i] = deriv[4];
  }
  append_farray_xy_plot("zzz.test_deriv.pl",xx,y,nx,"MSE_v_w1");
  append_farray_xy_plot("zzz.test_deriv.pl",xx,dd,nx,"dds_v_w1");
  myfree(xx);
  myfree(y);
  myfree(dd);
  myfree(deriv);
  free_4d_farray(mod_vhf_fit_c1r,nstm,s2n,s2n,2);
}
void mod_vhf_deriv_test_s2()
{
  int i,j,ii,jj;
  int nw,gi,xi,yi,oi,nx,nstm,s2n,dflag;
  float fv,*y,*xx,****t,*deriv,*dd,ssq,*x,vold;
  float *****tc1rs;
  char tstr[SLEN];
  printf("  MOD_VHF_DERIV_TEST_S2\n");
  s2n = mod_vhf_c2->s2_xn;
  nw = mod_vhf_s2->nw;
  mod_vhf_fit_prep(nw);  
  nstm = mod_vhf_fit_nrsp;
  x = mod_vhf_fit_x;
  t = get_4d_farray(nstm,s2n,s2n,nw); 
  mod_vhf_fit_c1r = t;
  for(ii=0;ii<s2n;ii++){
    for(jj=0;jj<s2n;jj++){
      tc1rs = mod_vhf_c2->s2[ii][jj]->c1rs;  
      for(j=0;j<nw;j++){
	gi = mod_vhf_s2->c1w[j]->gi;
	xi = mod_vhf_s2->c1w[j]->xi;
	yi = mod_vhf_s2->c1w[j]->yi;
	oi = mod_vhf_s2->c1w[j]->ci;
	for(i=0;i<nstm;i++){
	  t[i][ii][jj][j] = tc1rs[i][gi][xi][yi][oi];
	}
      }
      for(i=0;i<nstm;i++){
	ssq = 0.0;
	for(j=0;j<nw;j++){
	  ssq += t[i][ii][jj][j] * t[i][ii][jj][j];
	}
	mod_vhf_fit_dj[i][ii][jj] = sqrt(ssq) + KSMALL;
      }
    }
  }
  if (strcmp(mod_vhf_s2->nltype,"sigmoid0")!=0)
    exit_error("MOD_VHF_DERIV_TEST_S2","Only works for 'sigmoid0' s2 nonlin");
  x[0] = mod_vhf_s2->s;  
  x[1] = mod_vhf_s2->a;  
  x[2] = mod_vhf_s2->b;  
  for(i=0;i<nw;i++)
    x[3+i] = mod_vhf_s2->c1w[i]->w;  
  nx = 100;
  xx = (float *)myalloc(nx*sizeof(float));
  y  = (float *)myalloc(nx*sizeof(float));
  dd = (float *)myalloc(nx*sizeof(float));
  deriv = (float *)myalloc(mod_vhf_fit_xn*sizeof(float));
  vold = x[0];
  for(i=0;i<nx;i++){
    fv = -5.0 + 10.0*(float)i/(float)(nx-1);  
    x[0] = vold + fv;  
    xx[i] = fv;
    y[i] = mod_vhf_func_min_01(x);
    dflag = mod_vhf_func_min_01_d(x,deriv);
    dd[i] = deriv[0];
  }
  x[0] = vold;  
  append_farray_xy_plot("zzz.test_deriv.pl",xx,y,nx,"MSE_v_s");
  append_farray_xy_plot("zzz.test_deriv.pl",xx,dd,nx,"dds_v_s");
  vold = x[1];
  for(i=0;i<nx;i++){
    fv = -20.0 + 40.0*(float)i/(float)(nx-1);  
    x[1] = vold + fv; 
    xx[i] = fv;
    y[i] = mod_vhf_func_min_01(x);
    dflag = mod_vhf_func_min_01_d(x,deriv);
    dd[i] = deriv[1];
  }
  x[1] = vold;  
  append_farray_xy_plot("zzz.test_deriv.pl",xx,y,nx,"MSE_v_a");
  append_farray_xy_plot("zzz.test_deriv.pl",xx,dd,nx,"dds_v_a");
  vold = x[2];
  for(i=0;i<nx;i++){
    fv = -10.0 + 20.0*(float)i/(float)(nx-1);  
    x[2] = vold + fv; 
    xx[i] = fv;
    y[i] = mod_vhf_func_min_01(x);
    dflag = mod_vhf_func_min_01_d(x,deriv);
    dd[i] = deriv[2];
  }
  x[2] = vold;  
  append_farray_xy_plot("zzz.test_deriv.pl",xx,y,nx,"MSE_v_b");
  append_farray_xy_plot("zzz.test_deriv.pl",xx,dd,nx,"dds_v_b");
  for(j=0;j<nw;j++){
    vold = x[3+j];
    for(i=0;i<nx;i++){
      fv = -10.0 + 20.0*(float)i/(float)(nx-1);  
      x[3+j] = vold + fv;  
      xx[i] = fv;
      y[i] = mod_vhf_func_min_01(x);
      dflag = mod_vhf_func_min_01_d(x,deriv);
      dd[i] = deriv[3+j];
    }
    x[3+j] = vold;  
    sprintf(tstr,"MSE_v_w[%d]",j);
    append_farray_xy_plot("zzz.test_deriv.pl",xx,y,nx,tstr);
    sprintf(tstr,"D_v_w[%d]",j);
    append_farray_xy_plot("zzz.test_deriv.pl",xx,dd,nx,tstr);
  }
  myfree(xx);
  myfree(y);
  myfree(dd);
  myfree(deriv);
  free_4d_farray(t,nstm,s2n,s2n,nw);
}
void mod_vhf_s2_resp_all()
{
  int i,j;
  int nw,gi,xi,yi,oi,nx,nstm,s2i,s2j;
  float *x,*w,*r,u;
  float *****tc1rs;
  struct vhf_s2_par *s2;
  printf("  MOD_VHF_S2_RESP_ALL\n");
  printf("  *** WARNING:  Using only central S2 unit\n");
  s2i = s2j = mod_vhf_c2->s2_xn / 2;
  tc1rs = mod_vhf_c2->s2[s2i][s2j]->c1rs;   
  s2 = mod_vhf_s2;     
  nw = s2->nw;
  x = (float *)myalloc(nw*sizeof(float));
  w = (float *)myalloc(nw*sizeof(float));
  nstm = mod_vhf_fit_nrsp;
  r = (float *)myalloc(nstm*sizeof(float));  
  for(i=0;i<nstm;i++){  
    for(j=0;j<nw;j++){
      gi = s2->c1w[j]->gi;
      xi = s2->c1w[j]->xi;
      yi = s2->c1w[j]->yi;
      oi = s2->c1w[j]->ci;
      x[j] = tc1rs[i][gi][xi][yi][oi];  
      w[j] = s2->c1w[j]->w;                     
    }
    r[i] = mod_vhf_resp_s2(s2->nltype,s2->s,s2->a,s2->b,s2->eps2,w,x,nw,&u);
  }
  append_farray_xy_plot("zzz.s2_v_targ.pl",mod_vhf_fit_r,r,nstm,"S2_v_targ");
  printf("    Mean neuronal response:  %f\n",mean_farray(mod_vhf_fit_r,nstm));
  printf("    Mean    S2    response:  %f\n",mean_farray(r,nstm));
  printf("\n");
  myfree(r);
  myfree(x);
  myfree(w);
}
void mod_vhf_pp_write(outfile,fitflag)
     char *outfile;
     int fitflag;
{
  int i,k;
  int n,xi,yi,ci,gi,chi;
  float w,pp_x,pp_y,pp_ori,pp_w,pp_h,pp_lw,plw_in,ppin,xdeg,icon_w,icon_l;
  float faw,wmin,wmax,wrange,lw_min,lw_d;
  char tstr[SLEN],cstr[SLEN];
  struct vhf_grid *gt;
  lw_min = 0.5;  
  lw_d   = 5.0;  
  plw_in = 3.0;  
  ppin = (float)mod_vhf_xn / plw_in;  
  xdeg = (float)mod_vhf_xn * mod_vhf_sscale; 
  if (fitflag == 1)
    n = mod_vhf_fit_nc1;  
  else
    n = mod_vhf_s2->nw;   
  for(i=0;i<n;i++){
    if (fitflag == 1)
      w = mod_vhf_fit_opt[3+i];
    else
      w =  mod_vhf_s2->c1w[i]->w;
    faw = fabs(w);
    if ((i==0)||(faw < wmin))
      wmin = faw;
    if ((i==0)||(faw > wmax))
      wmax = faw;
  }
  wrange = wmax - wmin;
  remove_file(outfile);
  append_string_to_file(outfile,"beginheader\n");
  append_string_to_file(outfile,"plots 1\n");
  append_string_to_file(outfile,"x 3.0\n");
  append_string_to_file(outfile,"y 6.0\n");
  sprintf(tstr,"width %.2f\n",plw_in);
  append_string_to_file(outfile,tstr);
  sprintf(tstr,"height %.2f\n",plw_in);
  append_string_to_file(outfile,tstr);
  append_string_to_file(outfile,"axis_fontsize 12\n");
  append_string_to_file(outfile,"axis_fontsize_num 10\n");
  sprintf(tstr,"htext 1.0 1.0 14 %s\n",outfile);
  append_string_to_file(outfile,tstr);
  append_string_to_file(outfile,"endheader\n\n");
  append_string_to_file(outfile,"type normal\n");
  for(i=0;i<n;i++){
    if (fitflag == 1){
      k  = mod_vhf_fit_ndx[i];  
      xi = mod_vhf_c1_ndx[k][0];
      yi = mod_vhf_c1_ndx[k][1];
      ci = mod_vhf_c1_ndx[k][2];  
      gi = mod_vhf_c1_ndx[k][3];
      w = mod_vhf_fit_opt[3+i];
    }else{
      xi = mod_vhf_s2->c1w[i]->xi;
      yi = mod_vhf_s2->c1w[i]->yi;
      ci = mod_vhf_s2->c1w[i]->ci;
      gi = mod_vhf_s2->c1w[i]->gi;
      w = mod_vhf_s2->c1w[i]->w;
    }
    gt = mod_vhf_c1_grid[gi];
    pp_x = gt->s1x0[0][xi][yi] + gt->s1xn[0]/2;   
    pp_y = gt->s1y0[0][xi][yi] + gt->s1yn[0]/2;   
    pp_x /= ppin;  
    pp_y /= ppin;  
    mod_vhf_chan_index(ci,&chi,&k);
    pp_ori = k * 180.0 / mod_vhf_chans[chi]->nori;  
    icon_w = 4.0 * gt->avgtw / mod_vhf_chans[chi]->f_o;  
    icon_l = 4.0 * gt->avgtw / mod_vhf_chans[chi]->f_p;  
    pp_w = icon_w / ppin;    
    pp_h = icon_l / ppin;    
    pp_lw = lw_min + lw_d * (fabs(w) - wmin)/wrange; 
    if (w >= 0.0){
      sprintf(cstr,"0.8 0 0 -1 -1 -1");  
    }else{
      sprintf(cstr,"0 0 1.0 -1 -1 -1");  
    }
    sprintf(tstr,"ellipse  %.3f %.3f  %3.0f %.3f %.3f  %.1f  %s\n",
	    pp_x,pp_y,pp_ori,pp_w,pp_h,pp_lw,cstr);
    append_string_to_file(outfile,tstr);
  }
  append_string_to_file(outfile,"begin_axis\n");
  sprintf(tstr,"  range 0 %.2f\n",xdeg);
  append_string_to_file(outfile,tstr);
  append_string_to_file(outfile,"  label Visual angle (deg)\n");
  append_string_to_file(outfile,"  div_size 1\n");  
  append_string_to_file(outfile,"  div_minor 1\n");
  append_string_to_file(outfile,"end_axis\n");
  append_string_to_file(outfile,"begin_axis vertical\n");
  sprintf(tstr,"  range 0 %.2f\n",xdeg);
  append_string_to_file(outfile,tstr);
  append_string_to_file(outfile,"  label Visual angle (deg)\n");
  append_string_to_file(outfile,"  div_size 1\n");
  append_string_to_file(outfile,"  div_minor 1\n");
  append_string_to_file(outfile,"end_axis\n");
  append_string_to_file(outfile,"data_pair 0\n\n");
}
float mod_vhf_fit_run_var(vps,xinit,plotflag)
     struct var_par_struct *vps;
     float *xinit;
     int plotflag;
{
  int i,j;
  int niter,n,nv,nst,i_min,xi;
  float tlrnc,v_min,minv,*x,*p;
  char tstr[SLEN];
  tlrnc = 0.00001;     
  n = mod_vhf_fit_xn;  
  x = mod_vhf_fit_x;   
  nst = vps->m_n;      
  nv = vps->m_nvar;    
  i_min = -1;          
  for(i=0;i<nst;i++){  
    for(j=0;j<n;j++) 
      x[j] = xinit[j];  
    for(j=0;j<nv;j++){ 
      xi = atoi(vps->m_name[j]);  
      if (xi == 5){
	xi = n-1;
      }
      if (xi < n)  
	x[xi] = atof(vps->m_vval[i][j]); 
    }
    //*** WYETH HACK - DON'T START AT SLOPE ZERO ***//
    //*** WYETH HACK - DON'T START AT SLOPE ZERO ***//
    //*** WYETH HACK - DON'T START AT SLOPE ZERO ***//
    if (x[1] == 0.0)
      printf("*** STARTING WITH SLOPE ZERO\n");
    minu_pr(x,n,tlrnc,mod_vhf_func_min_01,mod_vhf_func_min_01_d,&niter,&minv);
    if (niter >= 0){
      if ((i_min == -1) || (minv < v_min)){  
	v_min = minv;
	i_min = i;
      }
      if (plotflag == 1){
	sprintf(tstr,"%d %f\n",i,minv);
	append_string_to_file("zzz.iter.pl",tstr);
      }
    }else if (niter == -2){
      mylog(mylogf,"*** NaN was encountered.  This start is ignored.\n");
    }else if (niter == -1){
      ;  
    }else if (niter == -10){
      mylog(mylogf,"*** MOD_VHF_FIT_RUN_VAR  Param out of bounds, skipped.\n");
    }else{ 
      ; 
    } 
  }
  if (i_min == -1)
    exit_error("MOD_VHF_FIT_RUN_VAR","No valid starts");
  for(j=0;j<n;j++)
    x[j] = xinit[j];
  for(j=0;j<nv;j++){
    xi    = atoi(vps->m_name[j]);  
    if (xi == 5){
      xi = n-1;
    }
    x[xi] = atof(vps->m_vval[i_min][j]);
  }
  minu_pr(x,n,tlrnc,mod_vhf_func_min_01,mod_vhf_func_min_01_d,&niter,&minv);
  if (niter > 1)
    printf("      Number of iterations:  %d\n",niter);
  return minv;
}
void mod_vhf_fit_perf(ntrain,tflag,outfile,si,rr,rmse)
     int ntrain;     
     int tflag;      
     char *outfile;  
     int si;         
     float *rr;      
     float *rmse;    
{
  int i,j,k,ii,jj;
  int i0,xi,yi,oi,gi,ish,nc1,nresp,s2n;
  float sig_s,sig_a,sig_b,eps,mse,totsq;
  float ***x,*w,*r,*rtarg,rval,*****tc1rs,**tdj;
  char plname[SLEN];
  s2n = mod_vhf_c2->s2_xn;
  nc1 = mod_vhf_fit_nc1;
  x   = get_3d_farray(s2n,s2n,nc1);
  tdj = get_2d_farray(s2n,s2n);  
  w   = (float *)myalloc(nc1*sizeof(float));
  if (tflag == 0){
    i0 = 0;
    nresp = ntrain;
  }else{
    i0 = ntrain;
    nresp = mod_vhf_fit_nrsp - ntrain;
  }
  r     = (float *)myalloc(nresp*sizeof(float)); 
  rtarg = (float *)myalloc(nresp*sizeof(float)); 
  mse = 0.0;
  for(i=0;i<nresp;i++){  
    ish = mod_vhf_boot_shuff[i+i0];
    for(j=0;j<nc1;j++){
      k = mod_vhf_fit_ndx[j];  
      xi = mod_vhf_c1_ndx[k][0];
      yi = mod_vhf_c1_ndx[k][1];
      oi = mod_vhf_c1_ndx[k][2];
      gi = mod_vhf_c1_ndx[k][3];
      for(ii=0;ii<s2n;ii++){
	for(jj=0;jj<s2n;jj++){
	  tc1rs = mod_vhf_c2->s2[ii][jj]->c1rs;
	  x[ii][jj][j] = tc1rs[ish][gi][xi][yi][oi]; 
	}
      }
      w[j] = mod_vhf_fit_opt[3+j];             
    }
    for(ii=0;ii<s2n;ii++){
      for(jj=0;jj<s2n;jj++){
	totsq = 0.0;
	for(j=0;j<nc1;j++)
	  totsq += x[ii][jj][j] * x[ii][jj][j];
	tdj[ii][jj] = sqrt(totsq) + KSMALL;
      }
    }
    sig_s = mod_vhf_fit_opt[0];
    sig_a = mod_vhf_fit_opt[1];
    sig_b = mod_vhf_fit_opt[2];
    eps = mod_vhf_s2->eps2;
    r[i] = mod_vhf_resp_c2_fast(sig_s,sig_a,sig_b,eps,w,x,tdj,s2n,nc1);
    rtarg[i] = mod_vhf_fit_r[ish];
    mse += (r[i] - rtarg[i]) * (r[i] - rtarg[i]);
  }
  mse /= (float)nresp;
  if (outfile != NULL){
    if (tflag == 0)
      sprintf(plname,"Train_s2_v_targ_%d",si);
    else
      sprintf(plname,"Test_s2_v_targ_%d",si);
    append_farray_xy_plot(outfile,rtarg,r,nresp,plname);
  }
  simple_pearsn(rtarg-1,r-1,nresp,&rval);  
  free_3d_farray(x,s2n,s2n,nc1);
  myfree(w);
  myfree(r);
  myfree(rtarg);
  free_2d_farray(tdj,s2n);
  *rr = rval;
  *rmse = mse;
}
void mod_vhf_fit_perf_save(k)
     int k;  
{
  int i;
  float tr,tmse;
  i = mod_vhf_boot_split_i;
  mod_vhf_fit_perf(mod_vhf_fit_train_n,0,NULL,i,&tr,&tmse);  
  mod_vhf_fit_rvl[k] = tr;
  mod_vhf_fit_mse[k] = tmse;
  mod_vhf_fit_perf(mod_vhf_fit_train_n,1,NULL,i,&tr,&tmse);  
  mod_vhf_fit_rvl_ts[k] = tr;
  mod_vhf_fit_mse_ts[k] = tmse;
}
void mod_vhf_var_config(fito,stage,npar,rxinit,rvps)
     struct onode *fito;              
     int stage;                       
     int npar;                        
     float **rxinit;                  
     struct var_par_struct **rvps;    
{
  int i;
  float *xinit;
  struct onode *stgo,*inito,*varo;
  if (stage == 1)
    stgo = onode_child_get_unique(fito,"stage_1");  
  else if (stage == 2)
    stgo = onode_child_get_unique(fito,"stage_2");  
  inito = onode_child_get_unique(stgo,"initial_values");
  xinit = (float *)myalloc(npar*sizeof(float));
  if (stage == 1){
    if (npar != 5)
      mylogx(mylogf,"MOD_VHF_VAR_CONFIG","Hack - hardcoded to 2 weights");
    xinit[0] = onode_getpar_flt_exit(inito,"s");
    xinit[1] = onode_getpar_flt_exit(inito,"a");
    xinit[2] = onode_getpar_flt_exit(inito,"b");
    xinit[3] = onode_getpar_flt_exit(inito,"w0");
    xinit[4] = onode_getpar_flt_exit(inito,"w1");
  }else if (stage == 2){
    for(i=0;i<npar-1;i++)  
      xinit[i] = mod_vhf_fit_opt[i];
    xinit[npar-1] = onode_getpar_flt_exit(inito,"wn");  
  }else{
    mylogx(mylogf,"MOD_VHF_VAR_CONFIG","Bad 'stage' number");
  }
  if (*rvps == NULL){
    varo = onode_child_get_unique(inito,"var_param");
    if (varo != NULL){
      *rvps = mod_util_var_par(mylogf,NULL,varo);
    }else
      mylogx(mylogf,"MOD_VHF_VAR_CONFIG","No <var_param> found in <fit>");
  }
  *rxinit = xinit;
}
float mod_vhf_fit_slave_min2(i1,i2,vps,xinit)
     int i1,i2;
     struct var_par_struct *vps;  
     float *xinit;                
{
  float mse;
  mod_vhf_fit_prep_c1rs(i1,i2,-1,NULL);
  mse = mod_vhf_fit_run_var(vps,xinit,0);
  return mse;
}
float mod_vhf_fit_slave_next(i1,vps,xinit,sqs)
     int i1;
     struct var_par_struct *vps;  
     float *xinit;                
     float ***sqs;
{
  int n0;
  float mse;
  n0 = mod_vhf_fit_nc1 - 1;    
  mod_vhf_fit_prep_c1rs(i1,-1,n0,sqs);
  mse = mod_vhf_fit_run_var(vps,xinit,0);
  return mse;
}
void mod_vhf_fit_slave_top(fito)
     struct onode *fito;
{
  int i,j;
  int tn,nprep,*clist,nci,s2n;
  float *xinit1,*xinit2,***sqs,mse;
  char *cstr;
  struct var_par_struct *vps1,*vps2;
  xinit1 = NULL;
  xinit2 = NULL;
  vps1 = NULL;
  vps2 = NULL;
  s2n = mod_vhf_c2->s2_xn;
  clist = (int *)myalloc(mod_vhf_c1_ntot*sizeof(int));
  sqs = get_3d_farray(mod_vhf_fit_train_n,s2n,s2n);
  mod_vhf_fit_c1r = get_4d_farray(mod_vhf_fit_train_n,s2n,s2n,
				  mod_vhf_fit_c1_max_n);
  while(1){
    mylog(mylogf,"  Waiting to receive a command ...\n");
    cstr = mm_cmd_recv(0,mylogf);
    if (strcmp(cstr,"get_shuffle_index")==0){
      mm_data_recv_iarray(0,mylogf,mod_vhf_boot_shuff,mod_vhf_fit_nrsp,&tn);
      if (tn != mod_vhf_fit_nrsp)
	mylogx(mylogf,"MOD_VHF_FIT_SLAVE_TOP","Bad shuffle index length");
      for(i=0;i<mod_vhf_fit_train_n;i++){  
	j = mod_vhf_boot_shuff[i];
	mod_vhf_fit_train_r[i] = mod_vhf_fit_r[j];
      }
    }else if (strcmp(cstr,"prep_n")==0){
      mm_data_recv_iarray(0,mylogf,&nprep,1,&tn);
      mod_vhf_fit_prep(nprep);
    }else if (strcmp(cstr,"prep_stage_1")==0){
      if (xinit1 != NULL)
	myfree(xinit1);
      if (vps1 != NULL)
	mylogx(mylogf,"MOD_VHF_FIT_SLAVE_TOP","Shouldn't prep vps1 twice");
      mod_vhf_var_config(fito,1,mod_vhf_fit_xn,&xinit1,&vps1);
    }else if (strcmp(cstr,"prep_stage_2")==0){
      if (xinit2 != NULL)
	myfree(xinit2);
      mod_vhf_var_config(fito,2,mod_vhf_fit_xn,&xinit2,&vps2);
    }else if (strcmp(cstr,"get_c1_list")==0){
      mm_data_recv_iarray(0,mylogf,clist,mod_vhf_c1_ntot,&nci);
      if (nci == 2){
	if (nci != nprep){
	  printf(" nci = %d  nprep = %d\n",nci,nprep);
	  mylogx(mylogf,"MOD_VHF_FIT_SLAVE_TOP","Array length mismatch");
	}
	mse = mod_vhf_fit_slave_min2(clist[0],clist[1],vps1,xinit1);  
      }else if (nci == 1){
	mse = mod_vhf_fit_slave_next(clist[0],vps2,xinit2,sqs);  
      }else
	mylogx(mylogf,"MOD_VHF_FIT_SLAVE_TOP","Only works for 2 weights");
      mm_data_send_farray(0,1,&mse,1,mylogf);
    }else if (strcmp(cstr,"prep_c1_base")==0){
      mm_data_recv_iarray(0,mylogf,mod_vhf_fit_ndx,mod_vhf_c1_ntot,&nci);
      if ((nci + 1) != mod_vhf_fit_nc1)
	mylogx(mylogf,"MOD_VHF_FIT_SLAVE_TOP","Base n+1 not prepared");
      mm_data_recv_farray(0,mylogf,mod_vhf_fit_opt,MAX_PAR,&tn,NULL);
      if ((tn+1) != mod_vhf_fit_xn)
	mylogx(mylogf,"MOD_VHF_FIT_SLAVE_TOP","Total param mismatch");
      mod_vhf_fit_prep_c1rs(-1,-1,nci,sqs);
    }else if (strcmp(cstr,"get_par_val")==0){
      mm_data_send_farray(0,1,mod_vhf_fit_x,mod_vhf_fit_xn,mylogf);
    }else if (strcmp(cstr,"exit")==0){
      exit(0);  
    }else{
      sprintf(ggstr,"  *** command string:  %s\n",cstr);
      mylog(mylogf,ggstr);
      mylogx(mylogf,"MOD_VHF_FIT_SLAVE_TOP","Unknown command");
    }
    myfree(cstr);
  }
  free_3d_farray(sqs,mod_vhf_fit_train_n,s2n,s2n);
}
void mod_vhf_fit_master_assign(mmfit,pid)
     struct vhf_mmfit *mmfit;
     int pid;
{
  int k;
  k = mmfit->nxti; 
  if (k < mmfit->n){
    mm_cmd_send(pid,1,"get_c1_list",mylogf);
    mm_data_send_iarray(pid,1,mmfit->ci[k],mmfit->nci,mylogf);
    mmfit->stat[k] = 1;     
    mmfit->pstat[pid] = k;  
    mmfit->nxti += 1;
  }
}
void mod_vhf_fit_master_run(mmfit,ri,rmse)
     struct vhf_mmfit *mmfit;     
     int *ri;                     
     float *rmse;                 
{
  int i;
  int min_i,done,tn,pid;
  float mse,mse_min;
  for(i=1;i<numproc;i++)  
    mod_vhf_fit_master_assign(mmfit,i);  
  min_i = -1;
  done = 0;
  while(done == 0){
    mm_data_recv_farray(-1,mylogf,&mse,1,&tn,&pid);  
    if ((min_i == -1) || (mse < mse_min)){ 
      mse_min = mse;  
      min_i = mmfit->pstat[pid];  
      if (mmfit->nci == 1){
	printf("    new min at (%d)  %f\n",mmfit->ci[min_i][0],mse);
      }else if (mmfit->nci == 2)
	printf("    new min at (%d, %d)  %f\n",mmfit->ci[min_i][0],
	       mmfit->ci[min_i][1],mse);
      mm_cmd_send(pid,1,"get_par_val",mylogf); 
      mm_data_recv_farray(pid,mylogf,mod_vhf_fit_x,mod_vhf_fit_xn,&tn,NULL);
      if (tn != mod_vhf_fit_xn)
	mylogx(mylogf,"MOD_VHF_FIT_MASTER_RUN","Param count error");
    }
    mmfit->stat[mmfit->pstat[pid]] = 2;   
    mmfit->ndone += 1;  
    mod_vhf_fit_master_assign(mmfit,pid);  
    if (mmfit->ndone == mmfit->n)
      done = 1;
  }
  *ri = min_i;
  *rmse = mse_min;
}
void mod_vhf_fit_master_mmfit_free(mmfit)
     struct vhf_mmfit *mmfit;
{
  free_2d_iarray(mmfit->ci,mmfit->n);
  myfree(mmfit->stat);
  myfree(mmfit->mse);
  myfree(mmfit->pstat);
  myfree(mmfit);
}
void mod_vhf_fit_master_min2(cil0,ciln,ri1,ri2,rmse)
     int cil0;   
     int ciln;   
     int *ri1;   
     int *ri2;   
     float *rmse;   
{
  int i,j,k;
  int min_i;
  float mse_min;
  struct vhf_mmfit *mmfit;
  mm_cmd_send(1,numproc-1,"prep_n",mylogf);
  i = 2;
  mm_data_send_iarray(1,numproc-1,&i,1,mylogf);
  if (mod_vhf_boot_split_i == 0)
    mm_cmd_send(1,numproc-1,"prep_stage_1",mylogf);
  mmfit = (struct vhf_mmfit *)myalloc(sizeof(struct vhf_mmfit));
  mmfit->n       = (ciln * ciln - ciln)/2;
  mmfit->ndone   = 0;
  mmfit->nci     = 2;
  mmfit->ci      = get_2d_iarray(mmfit->n,mmfit->nci);
  mmfit->stat    = get_zero_iarray(mmfit->n);
  mmfit->mse     = (float *)myalloc(mmfit->n*sizeof(float));
  mmfit->mse_min = -1.0;
  mmfit->nxti    = 0;
  mmfit->pstat   = get_const_iarray(numproc,-1);
  k = 0;
  for(i=0;i<(ciln-1);i++){
    for(j=i+1;j<ciln;j++){
      mmfit->ci[k][0] = i + cil0;
      mmfit->ci[k][1] = j + cil0;
      k += 1;
    }
  }
  if (k != mmfit->n)
    exit_error("MOD_VHF_FIT_MASTER_MIN2","Counting error");
  mod_vhf_fit_master_run(mmfit,&min_i,&mse_min);
  *ri1 = mmfit->ci[min_i][0];
  *ri2 = mmfit->ci[min_i][1];
  *rmse = mse_min;
  mod_vhf_fit_master_mmfit_free(mmfit);
}
void mod_vhf_fit_min2(fito)
     struct onode *fito;
{
  int i,j,k;
  int nstm,gi1,gi2,gi,min_i,min_j,s2n,**cilist,cil0,ciln;
  float **mse,minval,*minpar,*xinit;
  struct var_par_struct *vps;
  struct onode *stgo;
  printf("  MOD_VHF_FIT_MIN2\n");
  stgo = onode_child_get_unique(fito,"stage_1");  
  gi = onode_getpar_int_dflt(stgo,"grid_index",1); 
  if (gi >= 0)
    mod_vhf_ndx_for_grid(gi,&cil0,&ciln);  
  else{
    cil0 = 0;
    ciln = mod_vhf_c1_ntot;
  }
  mod_vhf_fit_prep(2);  
  minpar = (float *)myalloc(mod_vhf_fit_xn*sizeof(float));
  if (myid == 0){
    mod_vhf_fit_master_min2(cil0,ciln,&min_i,&min_j,&minval);
    for(k=0;k<5;k++)
      minpar[k] = mod_vhf_fit_x[k];
  }else{
    nstm = mod_vhf_fit_train_n;
    s2n = mod_vhf_c2->s2_xn;
    mod_vhf_fit_c1r = get_4d_farray(nstm,s2n,s2n,2);  
    mse = get_const_2d_farray(ciln,ciln,-1.0);  
    vps = NULL;  
    mod_vhf_var_config(fito,1,mod_vhf_fit_xn,&xinit,&vps);
    for(i=0;i<(ciln-1);i++){
      for(j=i+1;j<ciln;j++){
	mod_vhf_fit_prep_c1rs(i+cil0,j+cil0,-1,NULL);
	mse[i][j] = mod_vhf_fit_run_var(vps,xinit,0); 
	if (((i==0)&&(j==1)) || (mse[i][j] < minval)){
	  min_i = i + cil0;
	  min_j = j + cil0;
	  minval = mse[i][j];
	  for(k=0;k<5;k++)
	    minpar[k] = mod_vhf_fit_x[k];
	  printf("    new min at (%d, %d)  %f\n",min_i,min_j,minval);
	}
      }
    }
    free_2d_farray(mse,ciln);
  }
  cilist = mod_vhf_c1_ndx;  
  gi1 = cilist[min_i][3];  
  gi2 = cilist[min_j][3];  
  sprintf(ggstr,"    Minimum MSE found for pair:  %d %d  in grid %d %d\n",
	  min_i,min_j,gi1,gi2);
  mylog(mylogf,ggstr);
  sprintf(ggstr,"     %3d:  xi, yi, oi =  %d %d %d\n",min_i,cilist[min_i][0],
	  cilist[min_i][1],cilist[min_i][2]);
  mylog(mylogf,ggstr);
  sprintf(ggstr,"     %3d:  xi, yi, oi =  %d %d %d\n",min_j,cilist[min_j][0],
	  cilist[min_j][1],cilist[min_j][2]);
  mylog(mylogf,ggstr);
  for(k=0;k<5;k++){
    sprintf(ggstr,"     param[%d] = %f\n",k,minpar[k]);
    mylog(mylogf,ggstr);
  }
  for(i=0;i<5;i++)  
    mod_vhf_fit_opt[i] = minpar[i];
  mod_vhf_c1_flag[min_i] = 1;
  mod_vhf_c1_flag[min_j] = 1;
  mod_vhf_fit_ndx[0] = min_i;
  mod_vhf_fit_ndx[1] = min_j;
  mod_vhf_fit_perf_save(0);  
  mod_vhf_fit_mse[1]    = mod_vhf_fit_mse[0];
  mod_vhf_fit_rvl[1]    = mod_vhf_fit_rvl[0];
  mod_vhf_fit_mse_ts[1] = mod_vhf_fit_mse_ts[0];
  mod_vhf_fit_rvl_ts[1] = mod_vhf_fit_rvl_ts[0];
  if (mod_vhf_fit_mse[0] != minval)
    exit_error("MOD_VHF_FIT_MIN2","Inconsistent 'minval' should not happen.");
  if (mod_vhf_fit_c1r != NULL)
    free_4d_farray(mod_vhf_fit_c1r,nstm,s2n,s2n,2);
  myfree(minpar);
}
void mod_vhf_fit_master_next(nw,ri,rmse)
     int nw;        
     int *ri;       
     float *rmse;   
{
  int i,j,k;
  int min_i;
  float mse_min;
  struct vhf_mmfit *mmfit;
  mm_cmd_send(1,numproc-1,"prep_n",mylogf);
  mm_data_send_iarray(1,numproc-1,&nw,1,mylogf);
  mm_cmd_send(1,numproc-1,"prep_c1_base",mylogf);
  mm_data_send_iarray(1,numproc-1,mod_vhf_fit_ndx,nw-1,mylogf);
  mm_data_send_farray(1,numproc-1,mod_vhf_fit_opt,mod_vhf_fit_xn-1,mylogf);
  mm_cmd_send(1,numproc-1,"prep_stage_2",mylogf);
  k = 0;
  for(i=0;i<mod_vhf_c1_ntot;i++){
    if (mod_vhf_c1_flag[i] == 0){  
      k += 1;
    }
  }
  mmfit = (struct vhf_mmfit *)myalloc(sizeof(struct vhf_mmfit));
  mmfit->n       = k;
  mmfit->ndone   = 0;
  mmfit->nci     = 1;
  mmfit->ci      = get_2d_iarray(mmfit->n,mmfit->nci);
  mmfit->stat    = get_zero_iarray(mmfit->n);
  mmfit->mse     = (float *)myalloc(mmfit->n*sizeof(float));
  mmfit->mse_min = -1.0;
  mmfit->nxti    = 0;
  mmfit->pstat   = get_const_iarray(numproc,-1);
  k = 0;
  for(i=0;i<mod_vhf_c1_ntot;i++){
    if (mod_vhf_c1_flag[i] == 0){  
      mmfit->ci[k][0] = i;
      k += 1;
    }
  }
  mod_vhf_fit_master_run(mmfit,&min_i,&mse_min);
  *ri = mmfit->ci[min_i][0];
  *rmse = mse_min;
  mod_vhf_fit_master_mmfit_free(mmfit);
}
int mod_vhf_fit_next(fito)
     struct onode *fito;
{
  int i,k;
  int nstm,cn,min_i,n0,n1,npar,s2n;
  float *mse,minval,*minpar,*xinit,***sqs;
  struct var_par_struct *vps;
  printf("  MOD_VHF_FIT_NEXT\n");
  s2n = mod_vhf_c2->s2_xn;
  if (mod_vhf_fit_nc1 >= mod_vhf_fit_c1_max_n)  
    return 1;  
  cn = mod_vhf_c1_ntot;
  nstm = mod_vhf_fit_train_n;
  n0 = mod_vhf_fit_nc1;    
  n1 = n0 + 1;             
  mod_vhf_fit_prep(n1);  
  npar = mod_vhf_fit_xn;  
  minpar = (float *)myalloc(npar*sizeof(float));
  if (myid == 0){
    mod_vhf_fit_master_next(n1,&min_i,&minval);
    for(k=0;k<npar;k++)
      minpar[k] = mod_vhf_fit_x[k];
  }else{
    vps = NULL; 
    mod_vhf_var_config(fito,2,npar,&xinit,&vps);
    sqs = get_3d_farray(nstm,s2n,s2n);
    mod_vhf_fit_c1r = get_4d_farray(nstm,s2n,s2n,n1);
    mod_vhf_fit_prep_c1rs(-1,-1,n0,sqs);
    mse = get_const_farray(cn,-1.0);  
    minval = -1.0;
    for(i=0;i<cn;i++){
      if (mod_vhf_c1_flag[i] == 0){  
	mod_vhf_fit_prep_c1rs(i,-1,n0,sqs);
	mse[i] = mod_vhf_fit_run_var(vps,xinit,0); 
	if ((minval < 0.0) || (mse[i] < minval)){
	  min_i = i;
	  minval = mse[i];
	  for(k=0;k<npar;k++)
	    minpar[k] = mod_vhf_fit_x[k];
	  printf("    new min for unit %d,  %f\n",i,minval);
	}
      }
    }
    myfree(mse); 
    mod_util_var_par_free(vps);
    free_4d_farray(mod_vhf_fit_c1r,nstm,s2n,s2n,n1);
    free_3d_farray(sqs,nstm,s2n,s2n);
    myfree(xinit);
  }
  for(i=0;i<npar;i++)  
    mod_vhf_fit_opt[i] = minpar[i];
  mod_vhf_c1_flag[min_i] = 1;   
  mod_vhf_fit_ndx[n0] = min_i;  
  mod_vhf_fit_perf_save(n0);
  printf("    Minimum MSE found for unit %d (of %d)\n",min_i,cn);
  printf("     %3d:  xi, yi, oi =  %d %d %d\n",min_i,mod_vhf_c1_ndx[min_i][0],
	 mod_vhf_c1_ndx[min_i][1],mod_vhf_c1_ndx[min_i][2]);
  for(k=0;k<npar;k++)
    printf("     param[%d] = %f\n",k,minpar[k]);
  myfree(minpar);
  return 0;  
}
void mod_vhf_fit_write_param(outfile,si)
     char *outfile;   
     int si;          
{
  int i,k;
  int nc1,xi,yi,oi,gi;
  float w,mse;
  char tstr[SLEN];
  struct vhf_grid *gt;
  nc1 = mod_vhf_fit_nc1;
  printf("    Done fitting split %d\n",si);
  printf("      %d C1 units have been chosen.\n",nc1);
  printf("      Writing weights and MSE values to:  %s\n",outfile);
  printf("  -------------------------------------------------------------\n");
  sprintf(tstr,"==================== SPLIT %d ====================\n",si);
  append_string_to_file(outfile,tstr);
  sprintf(tstr,"  sigmoid_s      %7.4f\n",mod_vhf_fit_opt[0]);
  append_string_to_file(outfile,tstr);
  sprintf(tstr,"  sigmoid_alpha  %7.4f\n",mod_vhf_fit_opt[1]);
  append_string_to_file(outfile,tstr);
  sprintf(tstr,"  sigmoid_beta   %7.4f\n",mod_vhf_fit_opt[2]);
  append_string_to_file(outfile,tstr);
  for(i=0;i<nc1;i++){
    k = mod_vhf_fit_ndx[i];  
    xi = mod_vhf_c1_ndx[k][0];
    yi = mod_vhf_c1_ndx[k][1];
    oi = mod_vhf_c1_ndx[k][2];
    gi = mod_vhf_c1_ndx[k][3];
    gt = mod_vhf_c1_grid[gi];
    w = mod_vhf_fit_opt[3+i];
    mse = mod_vhf_fit_mse[i];  
    sprintf(tstr,"  %s_%d_%d_%d    %7.4f   # MSE_%d: %6.4f\n",gt->name,xi,yi,oi,
	    w,i,mse);
    append_string_to_file(outfile,tstr);
  }
  append_string_to_file(outfile,"\n");
}
void mod_vhf_fit_split_out(fito,ntrain,ntest,spli,rtr,mtr,rts,mts)
     struct onode *fito;  
     int ntrain;          
     int ntest;           
     int spli;            
     float *rtr;          
     float *mtr;          
     float *rts;          
     float *mts;          
{
  int nc1;
  char tname[SLEN],t1[SLEN],t2[SLEN],tstr[SLEN];
  mod_vhf_fname(fito,"outfile_boot",".boot.rval",t1); 
  mod_vhf_fname(fito,"outfile_boot",".boot.mse" ,t2); 
  mod_vhf_fname(fito,"outfile_s2vtarg",".s2vtarg.pl",tname);
  mod_vhf_fit_perf(ntrain,0,tname,spli,rtr,mtr);  
  mod_vhf_fit_perf(ntrain,1,tname,spli,rts,mts);  
  printf("    TRAIN  r %f  mse %f (n=%d)\n",*rtr,*mtr,ntrain);
  printf("    TEST   r %f  mse %f (n=%d)\n",*rts,*mts,ntest);
  if (spli == 0){
    append_string_to_file(t1,"  TRAIN    TEST\n");
    append_string_to_file(t2, "  TRAIN    TEST\n");
  }
  sprintf(tstr,"%f %f\n",*rtr,*rts);
  append_string_to_file(t1,tstr);
  sprintf(tstr,"%f %f\n",*mtr,*mts);
  append_string_to_file(t2,tstr);
  mod_vhf_fname(fito,"outfile_best",".best.fit",tname); 
  if (tname[0] == '\0')
    exit_error("MOD_VHF_FIT_SPLIT_OUT","NULL filename for 'outfile_best'");
  if (spli == 0)
    remove_file(tname);
  mod_vhf_fit_write_param(tname,spli);
  sprintf(tstr,".%d.pp",spli);
  mod_vhf_fname(fito,"outfile_pp",tstr,tname); 
  if (tname[0] != '\0')
    mod_vhf_pp_write(tname,1);
  mod_vhf_fname(fito,"outfile_mse",".mse",tname); 
  if (tname[0] != '\0'){
    nc1 = mod_vhf_fit_nc1;
    if (spli == 0)
      remove_file(tname);
    sprintf(tstr,"MSE_vs_C1cnt_Split_%d.pp",spli);
    append_farray_plot(tname,tstr,mod_vhf_fit_mse,nc1,1);
    sprintf(tstr,"rVal_vs_C1cnt_Split_%d.pp",spli);
    append_farray_plot(tname,tstr,mod_vhf_fit_rvl,nc1,1);
    sprintf(tstr,"Test__MSE_vs_C1cnt_Split_%d.pp",spli);
    append_farray_plot(tname,tstr,mod_vhf_fit_mse_ts,nc1,1);
    sprintf(tstr,"Test__rVal_vs_C1cnt_Split_%d.pp",spli);
    append_farray_plot(tname,tstr,mod_vhf_fit_rvl_ts,nc1,1);
  }
}
void mod_vhf_fit_boot(fito)
     struct onode *fito;
{
  int i,j;
  int js,flag,nfb,fracn,ntrain,ntest,seed,nshuffle;
  float trfrac,*mse_trn,*mse_tst,*rvl_trn,*rvl_tst,mu_tr,mu_ts,sd_tr,sd_ts;
  char tstr[SLEN],tname[SLEN],*s1;
  struct onode *boo,*stgo;
  mylog(mylogf,"  MOD_VHF_FIT_BOOT\n");
  mod_vhf_boot_split_i = -1;
  nshuffle = 5;
  boo = onode_child_get_unique(fito,"bootstrap");
  nfb    = onode_getpar_int_exit(boo,"split_n");
  fracn  = onode_getpar_int_exit(boo,"split_frac");
  seed   = onode_getpar_int_exit(boo,"split_seed");
  trfrac = (float)(fracn-1)/(float)fracn;  
  ntrain = my_rint(trfrac * (float)mod_vhf_fit_nrsp);
  ntest  = mod_vhf_fit_nrsp - ntrain;
  sprintf(ggstr,"    ntrain = %d   ntest = %d\n",ntrain,ntest);
  mylog(mylogf,ggstr);
  mse_trn = get_farray(nfb);
  rvl_trn = get_farray(nfb);
  mse_tst = get_farray(nfb);
  rvl_tst = get_farray(nfb);
  mod_vhf_fit_train_n = ntrain;  
  mod_vhf_boot_shuff = get_permutation_iarray(mod_vhf_fit_nrsp);
  stgo = onode_child_get_unique(fito,"stage_2");
  mod_vhf_fit_c1_max_n = onode_getpar_int_exit(stgo,"max_c1_n");
  if (myid > 0){ 
    mod_vhf_fit_slave_top(fito);  
  }
  for(i=0;i<nfb;i++){  
    mod_vhf_boot_split_i = i;
    zero_iarray(mod_vhf_c1_flag,mod_vhf_c1_ntot);  
    if (ntrain < mod_vhf_fit_nrsp){
      shuffle_iarray_return_seed(mod_vhf_boot_shuff,mod_vhf_fit_nrsp,nshuffle,
				 &seed);
      for(j=0;j<ntrain;j++){
	js = mod_vhf_boot_shuff[j];
	mod_vhf_fit_train_r[j] = mod_vhf_fit_r[js];
      }
    }else
      mod_vhf_fit_train_r = mod_vhf_fit_r; 
    if (myid == 0){ 
      mm_cmd_send(1,numproc-1,"get_shuffle_index",mylogf);  
      mm_data_send_iarray(1,numproc-1,mod_vhf_boot_shuff,mod_vhf_fit_nrsp,
			  mylogf);
    }
    mod_vhf_fit_min2(fito); 
    flag = 0;
    while(flag == 0)
      flag = mod_vhf_fit_next(fito);  
    mod_vhf_fit_split_out(fito,ntrain,ntest,i,&(rvl_trn[i]),&(mse_trn[i]),
			  &(rvl_tst[i]),&(mse_tst[i]));
  }
  mean_sdev_farray(rvl_trn,nfb,&mu_tr,&sd_tr);
  mean_sdev_farray(rvl_tst,nfb,&mu_ts,&sd_ts);
  printf("    Average performance:  %f (train) %f (test)\n",mu_tr,mu_ts);
  mod_vhf_fname(fito,"outfile_avgperf",".avg",tname); 
  sprintf(tstr,"%s  %f %f\n",mod_vhf_outfile_prefix,mu_tr,mu_ts);
  append_string_to_file(tname,tstr);
  myfree(mod_vhf_boot_shuff);
}
void mod_vhf_01_fit(m,s,r,fito)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
     struct onode *fito;
{
  int i,j,k,ii,jj;
  int xn,yn,tn,n,tdn,xi,yi,fit_flag,tflag,nstim,tsamp,nrpt,s2n;
  float w,tscale,sscale,stim_samp,mse,*tdata,***stm,***stim1,**tframe;
  char *infile,tstr[SLEN],*fmode,*filemode,*outfile;
  struct vhf_grid *gt;
  mylog(mylogf,"  MOD_VHF_01_FIT\n");
  fit_flag = onode_getpar_int_dflt(fito,"fit",0);
  if (fit_flag == 0){
    mylog(mylogf,"    Fitting is turned off\n");
    return;
  }
  fmode = onode_getpar_chr_exit(fito,"mode");
  xn     = mod_vhf_xn;
  yn     = mod_vhf_yn;
  tn     = mod_vhf_tn;
  tscale = mod_vhf_tscale;
  sscale = mod_vhf_sscale;
  s2n    = mod_vhf_c2->s2_xn;
  mod_vhf_fit_x  = NULL;     
  mod_vhf_fit_dw = NULL;
  infile = onode_getpar_chr_exit(fito,"data_file");
  tflag = read_farray(infile,&tdata,&tdn);
  if (tflag == 0){
    sprintf(ggstr,"    'data_file' = %s\n",infile);
    mylog(mylogf,ggstr);
    mylog_exit(mylogf,"MOD_VHF_01_FIT  Could not open data file");
  }
  sprintf(ggstr,"    %d responses in file:  %s\n",tdn,infile);
  mylog(mylogf,ggstr);
  mod_vhf_fit_r = tdata;  
  filemode = onode_getpar_chr_dflt(fito,"file_c1_mode","none");
  if (strcmp(filemode,"read")==0){
    mod_vhf_fit_nrsp = tdn;  
    mod_vhf_resp_op("c1s_init",tdn); 
    mod_vhf_file_c1(fito,"read");
    nstim = tdn;
  }else{
    nrpt = param_geti_exit(s->ppl,"stim_nrpt");
    nstim = s->ntr / nrpt;
    sprintf(ggstr,"    NSTIM = %d  (nrpt = %d)\n",nstim,nrpt);
    mylog(mylogf,ggstr);
    if (nstim != tdn)
      mylogx(mylogf,"MOD_VHF_01_FIT","Response count not equal to stimuli");
    if (nstim != tdn)
      mylogx(mylogf,"MOD_VHF_01_FIT","Number of stimuli and responses differ");
    stim_samp = param_getf_exit(s->ppl,"stim_samp"); 
    tsamp = stm_get_tsamp(tscale,stim_samp);  
    stm = (float ***)myalloc(nstim*sizeof(float **));
    for(i=0;i<nstim;i++){
      mod_util_get_3d_stim(s,i,xn,yn,tn,sscale,tscale,tsamp,NULL);
      tframe = get_2d_farray(xn,yn);
      for(xi=0;xi<xn;xi++)
	for(yi=0;yi<yn;yi++)
	  tframe[xi][yi] = s->d[xi+1][yi+1][1];
      stm[i] = tframe;
      free_f3tensor(s->d,1,xn,1,yn,1,tn);
    }
    sprintf(ggstr,"    Number of stimuli:  %d\n",nstim);
    mylog(mylogf,ggstr);
    sprintf(ggstr,"    Size of each image:  %d x %d\n",xn,yn);
    mylog(mylogf,ggstr);
    mod_vhf_resp_op("c1s_init",nstim); 
    for(i=0;i<nstim;i++){
      stim1 = f3tensor(1,1,1,xn,1,yn);
      for(j=0;j<xn;j++){
	for(k=0;k<yn;k++){
	  stim1[1][j+1][k+1] = stm[i][j][k];
	}
      }
      mod_vhf_resp_s1(stim1);  
      for(ii=0;ii<s2n;ii++){
	for(jj=0;jj<s2n;jj++){
	  mod_vhf_resp_c1_all(mod_vhf_c2->s2[ii][jj]->c1rs[i],ii,jj);
	}
      }
      free_f3tensor(stim1,1,1,1,xn,1,yn);
      sprintf(ggstr,"  Done stim %d\n",i);
      mylog(mylogf,ggstr);
    }
    mod_vhf_fit_nrsp = nstim;  
  }
  mod_vhf_fit_dj = get_3d_farray(mod_vhf_fit_nrsp,s2n,s2n);
  mod_vhf_fit_train_r = (float *)myalloc(mod_vhf_fit_nrsp*sizeof(float));
  filemode = onode_getpar_chr_dflt(fito,"file_c1_mode","none");
  if (strcmp(filemode,"write")==0){
    mod_vhf_file_c1(fito,"write");
    printf("  Exiting after writing response file.\n\n");
    exit(0);
  }
  myfree(filemode);
  if (strcmp(fmode,"c1_stat")==0)
    mod_vhf_relate_c1_targ();  
  if (0){
    mod_vhf_test_derivs();
    exit(0);
  }
  if (strcmp(fmode,"test_s2")==0){
    mod_vhf_deriv_test_s2();
    mod_vhf_s2_resp_all();
    exit(0);
  }
  mod_vhf_fit_boot(fito);
  myfree(infile);
  if (fit_flag == 1){
    printf("  Exiting after fit.\n");
    if (myid == 0){ 
      mm_cmd_send(1,numproc-1,"exit",mylogf);
      sleep(2); 
    }
    printf("\n");
    exit(0);
  }
}
void mod_vhf_make_mpt(m,s,r)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
{
  int i,j,k;
  int xi,yi,stype,xn,yn,*ctx,*cty,ctn,txn,tyn,tzn,nori,nph;
  short inindex;
  float w,tdelay,**f;
  char tstr[SLEN];
  struct pop_top *mpt;
  struct pop_layer *pl;
  struct pop_syn *tsyn;
  struct pop_cell *pre,*post;
  struct onode *ot,*o;
  struct vhf_grid *gt;
  int nsz,gn;
  mylog(mylogf,"  MOD_VHF_MAKE_MPT\n");
  mpt = (struct pop_top *)myalloc(sizeof(struct pop_top));
  if  (mylogf == NULL){
    mpt->logf = NULL;
  }else
    mpt->logf = strdup(mylogf);
  mpt->tscale = onode_getpar_flt_exit(m->o,"tscale");
  mpt->sscale = onode_getpar_flt_exit(m->o,"sscale");
  mpt->xn = onode_getpar_int_exit(m->o,"xn");
  mpt->yn = onode_getpar_int_exit(m->o,"yn");
  mpt->tn = onode_getpar_int_exit(m->o,"tn");
  mpt->x1 = 0.0;
  mpt->x2 = mpt->tscale * (float)mpt->tn;
  mpt->out_prefix = NULL;
  if (r != NULL){
    if (r->ppl != NULL)
      mpt->out_prefix = param_getc_dflt(r->ppl,"outfile","zz");
  }
  mpt->binoc = 0;   
  mpt->retflag = 0; 
  mpt->conn_rw = NULL;
  mpt->conn_read_dir = NULL;
  mpt->narea = 1;
  mpt->area = (struct pop_area **)myalloc(sizeof(struct pop_area *));
  printf(" WYETH *********** TESTING NEW CODE HERE\n");
  mpt->area[0] = popu_make_area_default("v1",mpt->xn,mpt->yn,mpt->sscale,20.0);
  mpt->nmap = 0;
  mpt->map = NULL;
  nsz  = mod_vhf_nsz;
  exit_error("MOD_VHF_MAKE_MPT","WYETH - must fix for <channels>");
  gn   = mod_vhf_c1_gridn;
  mpt->nlay = 1 + nsz + gn;  
  mpt->lay = (struct pop_layer **)myalloc(mpt->nlay*
					  sizeof(struct pop_layer *));
  pl = popu_make_layer_cart("stim",mpt->xn,mpt->yn,1);
  myfree(pl->laytype);
  pl->laytype = strdup("stim");
  pl->geomt = strdup("default");
  pl->x0 = pl->y0 = 0.0;
  pl->xf = pl->yf = 1.0;
  mpt->lay[0] = pl;
  mpt->lay[0]->ninlist = 0;
  mpt->lay[0]->inlist = NULL;
  for(i=0;i<nsz;i++){
    sprintf(tstr,"s1_%d",mod_vhf_tile_w[i]);
    txn = mpt->xn - mod_vhf_tile_w[i] + 1;
    tyn = mpt->yn - mod_vhf_tile_w[i] + 1;
    tzn = nori * nph;
    pl = popu_make_layer_cart(tstr,txn,tyn,tzn);
    pl->geomt = strdup("default");
    pl->area = mpt->area[0];
    pl->x0 = pl->y0 = (int)(mod_vhf_tile_w[i]/2.0);
    pl->xf = pl->yf = 1.0;
    mpt->lay[i+1] = pl;
    mpt->lay[i+1]->ninlist = 1;
    mpt->lay[i+1]->inlist = (struct onode **)myalloc(sizeof(struct onode *));
    ot = paramfile_onode_create_onode();
    ot->otype = strdup("input");
    o = paramfile_onode_get_init_onode("item",NULL,"pop_origin","stim",
				       1,NULL,NULL,1);
    onode_insert_child_at_end(ot,o);
    o = paramfile_onode_get_init_onode("item",NULL,"type","template",
				       1,NULL,NULL,1);
    onode_insert_child_at_end(ot,o);
    mpt->lay[i+1]->inlist[0] = ot;
    stype = 1;
    tdelay = 0.0;
    inindex = 0;
    w = 1.0;
    xn = mod_vhf_xn;
    yn = mod_vhf_yn;
    post = &(mpt->lay[i+1]->c[0][0][0]);
    exit_error("MOD_VHF_MAKE_MPT","WYETH - 2 must 2 fix 2 for 2 <channels>");
    for(xi=0;xi<xn;xi++){
      for(yi=0;yi<yn;yi++){
	if (fabs(f[xi][yi]) > 0.05){
	  w = 0.5*(1.0 + f[xi][yi]);
	  pre = &(mpt->lay[0]->c[xi][yi][0]);
	  tsyn = pop_cell_add_synapse(pre,post,stype,w,tdelay,inindex);
	}
      }
    }
  }
  k = nsz + 1;  
  for(i=0;i<gn;i++){
    gt = mod_vhf_c1_grid[i];
    sprintf(tstr,"%s",gt->name);
    txn = gt->xn;
    tyn = gt->yn;
    tzn = nori;
    pl = popu_make_layer_cart(tstr,txn,tyn,tzn);
    pl->geomt = strdup("default");
    pl->area = mpt->area[0];
    pl->x0 = 10; 
    pl->y0 = 20; 
    pl->xf = gt->dx;
    pl->yf = gt->dy;
    mpt->lay[i+k] = pl;
    mpt->lay[i+k]->ninlist = 1;
    mpt->lay[i+k]->inlist = (struct onode **)myalloc(sizeof(struct onode *));
    ot = paramfile_onode_create_onode();
    ot->otype = strdup("input");
    sprintf(tstr,"s1_%d",32);  
    o = paramfile_onode_get_init_onode("item",NULL,"pop_origin",tstr,
				       1,NULL,NULL,1);
    onode_insert_child_at_end(ot,o);
    o = paramfile_onode_get_init_onode("item",NULL,"type","template",
				       1,NULL,NULL,1);
    onode_insert_child_at_end(ot,o);
    mpt->lay[i+k]->inlist[0] = ot;
    stype = 1;
    tdelay = 0.0;
    inindex = 0;
    w = 1.0;
    post = &(mpt->lay[i+k]->c[0][0][0]);
    for(xi=0;xi<10;xi++){
      for(yi=0;yi<10;yi++){
	pre = &(mpt->lay[1]->c[xi+45][yi+45][0]); 
	tsyn = pop_cell_add_synapse(pre,post,stype,w,tdelay,inindex);
      }
    }
  }
  popu_mar_write(mpt,m->marfile,4);  
}
void mod_vhf_config_s1_tile(s1o)
     struct onode *s1o;  
{
  int i,k;
  int xn,yn,nsz,*ntile;
  struct onode *to;
  mylog(mylogf,"  MOD_VHF_CONFIG_S1_TILE\n");
  xn   = mod_vhf_xn;  
  yn   = mod_vhf_yn;
  nsz  = mod_vhf_nsz  = onode_count_otype(s1o,"tile");
  sprintf(ggstr,"    %d S1 tile sizes\n",nsz);
  mylog(mylogf,ggstr);
  mod_vhf_tile_w  = (int *)myalloc(nsz*sizeof(int));
  mod_vhf_tile_id = (int *)myalloc(nsz*sizeof(int));
  mod_vhf_tile_x0 = (int *)myalloc(nsz*sizeof(int));
  mod_vhf_tile_y0 = (int *)myalloc(nsz*sizeof(int));
  mod_vhf_tile_xn = (int *)myalloc(nsz*sizeof(int));
  mod_vhf_tile_yn = (int *)myalloc(nsz*sizeof(int));
  k = 0;
  to = onode_get_next_type(s1o->o,"tile");
  while(to != NULL){
    mod_vhf_tile_w[k]  = onode_getpar_int_exit(to,"size");
    mod_vhf_tile_id[k] = onode_getpar_int_exit(to,"name");
    k += 1;
    to = onode_get_next_type(to->next,"tile");
  }
  ntile = (int *)myalloc(nsz*sizeof(int));
  for(i=0;i<nsz;i++)
    ntile[i] = 1 + xn - mod_vhf_tile_w[i];
  k = 0;
  for(i=0;i<nsz;i++){
    k += ntile[i] * ntile[i];  
    sprintf(ggstr,"    tile %d  %3d pix:    %d x %d\n",mod_vhf_tile_id[i],
	   mod_vhf_tile_w[i],ntile[i],ntile[i]);
    mylog(mylogf,ggstr);
  }
}
struct vhf_chans *mod_vhf_config_s1_chans(co)
     struct onode *co;  
{
  int i,j,k,ii,jj;
  int xn,yn,nori,nph,nsz,*ntile,ntot,dumpflag;
  float theta,phase,sdo,sdp,sf,xc,yc,fw,**t,maskr,norm_mask_sd_f,norm_targ;
  float *****f,******ft,*****fts,***tft,**tfts,*****rr,sump,sumn,*tcol;
  char tname[SLEN];
  struct vhf_chans *ch;
  mylog(mylogf,"  MOD_VHF_CONFIG_S1_CHANS\n");
  ch = (struct vhf_chans *)myalloc(sizeof(struct vhf_chans));
  ch->name   = onode_getpar_chr_exit(co,"name");
  ch->type   = onode_getpar_chr_dflt(co,"type","gabor");
  ch->nori   = onode_getpar_int_dflt(co,"nori",1);
  ch->nph    = onode_getpar_int_exit(co,"nphase");
  ch->ph0    = onode_getpar_flt_dflt(co,"phase0",0.0);
  ch->maxph_flag  = onode_getpar_int_dflt(co,"max_over_phase",1);
  dumpflag   = onode_getpar_int_dflt(co,"write_filters_exit",0);
  if (ch->maxph_flag == 1)
    ch->nch = ch->nori;
  else
    ch->nch = ch->nph * ch->nori;
  if (strcmp(ch->type,"dog")==0){
    ch->f_o       = onode_getpar_flt_exit(co,"dog_sd_surr_f");
    ch->f_p       = onode_getpar_flt_exit(co,"dog_sd_center_f");
    ch->f_f       = onode_getpar_flt_dflt(co,"dog_amp_surr",1.0);
  }else{
    ch->f_o       = onode_getpar_flt_exit(co,"gabor_sd_orth_f");
    ch->f_p       = onode_getpar_flt_exit(co,"gabor_sd_para_f");
    ch->f_f       = onode_getpar_flt_exit(co,"gabor_sf_f");
  }
  norm_targ       = onode_getpar_flt_exit(co,"filter_norm_targ");
  norm_mask_sd_f  = onode_getpar_flt_dflt(co,"norm_mask_sd_f",2.5);
  ch->norm_flag   = onode_getpar_int_dflt(co,"norm_type",0);
  ch->norm_eps    = onode_getpar_flt_exit(co,"norm_eps");
  xn   = mod_vhf_xn;
  yn   = mod_vhf_yn;
  nori = ch->nori;
  nph  = ch->nph;
  nsz  = mod_vhf_nsz;
  if (ch->norm_flag != 0){
    ch->norm_mask_x = (int **)myalloc(nsz*sizeof(int *));
    ch->norm_mask_y = (int **)myalloc(nsz*sizeof(int *));
    ch->norm_mask_n = (int  *)myalloc(nsz*sizeof(int));
    mod_vhf_s1_norm_flag = 1;  
  }
  f = (float *****)myalloc(nsz*sizeof(float ****));
  ft = (float ******)myalloc(nsz*sizeof(float *****));
  fts = (float *****)myalloc(nsz*sizeof(float ****));
  for(i=0;i<nsz;i++){
    fw = (float)mod_vhf_tile_w[i];
    sdo = fw / ch->f_o;  
    sdp = fw / ch->f_p;  
    sf  = ch->f_f / fw;  
    xc = xn / 2.0;
    yc = yn / 2.0;
    f[i]   = (float  ****)myalloc(nori*sizeof(float ***));
    ft[i]  = (float *****)myalloc(nori*sizeof(float ****));
    fts[i] = (float  ****)myalloc(nori*sizeof(float ***));
    for(j=0;j<nori;j++){
      f[i][j]   = (float  ***)myalloc(nph*sizeof(float **));
      ft[i][j]  = (float ****)myalloc(nph*sizeof(float ***));
      fts[i][j] = (float  ***)myalloc(nph*sizeof(float **));
      theta = j * 180.0/nori;
      for(k=0;k<nph;k++){
	phase = ch->ph0 + k * (360.0/(float)nph);
	if (strcmp(ch->type,"dog")==0){
	  f[i][j][k] = dog_2d_space_raw(xn,yn,xc,yc,sdp,sdo,ch->f_f);
	  if (my_rint(phase) == 180)
	    multiply_2d_farray(f[i][j][k],xn,yn,-1.0);
	  else if (my_rint(phase) != 0)
	    exit_error("MOD_VHF_CONFIG_S1_TILE","DoG phase must be 0 or 180");
	}else{
	  f[i][j][k] = gabor_2d_space_raw(xn,yn,xc,yc,sdo,sdp,sf,theta,phase);
	}
	if (norm_targ != 0.0)
	  kernu_norm_2d_filter(f[i][j][k],xn,yn,norm_targ,&sump,&sumn);
	ft[i][j][k] = f3tensor(1,1,1,xn,1,yn);
	fts[i][j][k] = matrix(1,1,1,2*xn);
	t    =   f[i][j][k];
	tft  =  ft[i][j][k];
	tfts = fts[i][j][k];
	for(ii=1;ii<=xn;ii++){
	  for(jj=1;jj<=yn;jj++){
	    tft[1][ii][jj] = t[ii-1][jj-1];
	  }
	}
	contort_real_3d_farray(tft,1,1,1,1,xn,yn);
	rlft3(tft,tfts,1,xn,yn,1);
      }
    }
    if (ch->norm_flag != 0){
      if (sdp >= sdo)  
	maskr = sdp * norm_mask_sd_f;
      else
	maskr = sdo * norm_mask_sd_f;
      mod_vhf_norm_mask(maskr,&(ch->norm_mask_x[i]),
                              &(ch->norm_mask_y[i]),
                              &(ch->norm_mask_n[i]));
      sprintf(ggstr,"    maskr = %f   tile_w = %f\n",maskr,fw);
      mylog(mylogf,ggstr);
    }
  }
  ch->f = f;
  ch->ft = ft;
  ch->fts = fts;
  if (dumpflag == 1){
    remove_file("zzz.f_xcut.pl");
    for(i=0;i<nsz;i++){
      for(j=0;j<nori;j++){
	for(k=0;k<nph;k++){
	  t = f[i][j][k];  
	  sprintf(tname,"zzz.f_%d_%d_%d.2d",i,j,k);
	  write_2d_data(tname,t,0,0,xn,yn,4,2,1,0);
	  printf("    %s  Area = %f\n",tname,sum_2d_farray(t,0,xn,0,yn));
	  tcol = get_column_2d_farray(t,xn,yn,yn/2);
	  append_farray_plot("zzz.f_xcut.pl",tname,tcol,xn,1);
	  myfree(tcol);
	}
      }
    }
    printf("  Wrote filters to 'zzz.f_...2d'.  Exiting.\n\n");
    exit(0);
  }
  return ch;
}
void mod_vhf_config_s1_top(s1o)
     struct onode *s1o;  
{
  int i;
  int nchans;
  struct onode *to;
  mylog(mylogf,"  MOD_VHF_CONFIG_S1_TOP\n");
  mod_vhf_config_s1_tile(s1o);
  nchans = onode_count_otype(s1o,"channels");
  mod_vhf_chans = (struct vhf_chans **)myalloc(nchans*
					       sizeof(struct vhf_chans *));
  mod_vhf_s1_nchans = nchans;  
  sprintf(ggstr,"    Number of <channels> objects:  %d\n",nchans);
  mylog(mylogf,ggstr);
  to = onode_get_next_type(s1o->o,"channels");
  i = 0;
  mod_vhf_c1_nch = 0;
  while(to != NULL){
    mod_vhf_chans[i] = mod_vhf_config_s1_chans(to); 
    mod_vhf_chans[i]->nch0 = mod_vhf_c1_nch;
    mod_vhf_c1_nch += mod_vhf_chans[i]->nch;
    to = onode_get_next_type(to->next,"channels");
    i += 1;
  }
  sprintf(ggstr,"    %d channels at each C1 grid point\n",mod_vhf_c1_nch);
  mylog(mylogf,ggstr);
  if (mod_vhf_c1_nch == 0)
    mylog_exit(mylogf,"MOD_VHF_CONFIG_S1_TOP  No <channels> object found.");
  mod_vhf_resp_op("s1_init",0);
}
void mod_vhf_config_c1(c1o)
     struct onode *c1o;  
{
  int i,j,k,ii,jj;
  int xi,yi,ti,gi,ci,gn,gxn,gyn,gw,gov,ntot,nch,ntile,s1w,xx0,yy0,s2xn;
  float ******rr,s1w_avg;
  struct onode *to;
  struct vhf_grid **g,*gt;
  mylog(mylogf,"  MOD_VHF_CONFIG_C1\n");
  nch = mod_vhf_c1_nch;  
  gn = onode_count_otype(c1o,"grid");  
  sprintf(ggstr,"    %d C1 grids\n",gn);  
  mylog(mylogf,ggstr);
  g = (struct vhf_grid **)myalloc(gn*sizeof(struct vhf_grid *));
  k = 0;
  ntot = 0;
  to = onode_get_next_type(c1o->o,"grid");  
  while(to != NULL){  
    gt = g[k] = (struct vhf_grid *)myalloc(sizeof(struct vhf_grid));
    gt->xn = onode_getpar_int_exit(to,"xn");  
    gt->yn = onode_getpar_int_dflt(to,"yn",gt->xn);  
    gt->name = onode_getpar_chr_exit(to,"name");
    gxn = gt->xn;
    gyn = gt->yn;
    ntot += gxn * gyn;  
    gt->dx = onode_getpar_int_exit(to,"dx");  
    gt->dy = onode_getpar_int_dflt(to,"dy",gt->dx);
    gt->w = onode_getpar_int_exit(to,"width");
    gt->h = onode_getpar_int_dflt(to,"height",gt->w);
    gt->totpixw = gt->w + (gxn - 1)*gt->dx;
    gt->totpixh = gt->h + (gyn - 1)*gt->dy;
    sprintf(ggstr,"    %d x %d  size %d  (%d pix total width)\n",gxn,gyn,gt->w,
	    gt->totpixw);
    mylog(mylogf,ggstr);
    gt->tile_list = onode_getpar_int_list(to,"tiles",&ntile);
    gt->ntile = ntile;
    gt->s1xn = (int   *)myalloc(ntile*sizeof(int));
    gt->s1yn = (int   *)myalloc(ntile*sizeof(int));
    gt->s1x0 = get_3d_iarray(ntile,gxn,gyn);
    gt->s1y0 = get_3d_iarray(ntile,gxn,gyn);
    s1w_avg = 0.0;
    for(i=0;i<ntile;i++){
      ti = get_index_search_iarray(mod_vhf_tile_id,mod_vhf_nsz,
				   gt->tile_list[i]);
      s1w = mod_vhf_tile_w[ti];  
      gt->s1xn[i] = gt->w - s1w + 1;
      gt->s1yn[i] = gt->h - s1w + 1;  
      if ((gt->s1xn[i] < 1) || (gt->s1yn[i] < 1))
	mylog_exit(mylogf,"MOD_VHF_CONFIG_C1  Impossible grid geometry.");
      s1w_avg += (float)s1w;
      xx0 = (mod_vhf_xn - gt->totpixw)/2 + (int)(s1w/2);
      yy0 = (mod_vhf_yn - gt->totpixh)/2 + (int)(s1w/2);
      mod_vhf_tile_x0[ti] = xx0;  
      mod_vhf_tile_y0[ti] = yy0;
      mod_vhf_tile_xn[ti] = gt->s1xn[i] + (gxn-1)*gt->dx;  
      mod_vhf_tile_yn[ti] = gt->s1yn[i] + (gyn-1)*gt->dy;  
      if ((xx0 < 0) || (yy0 < 0))
	mylog_exit(mylogf,"MOD_VHF_CONFIG_C1  grid exceeds stimulus area.");
      sprintf(ggstr,
	      "      tile %d   %d x %d S1 units (lower left S1: %d, %d)\n",
	      gt->tile_list[i],gt->s1xn[i],gt->s1yn[i],xx0,yy0);
      mylog(mylogf,ggstr);
      for(xi=0;xi<gxn;xi++){
	for(yi=0;yi<gyn;yi++){
	  gt->s1x0[i][xi][yi] = xx0 + xi*gt->dx;
	  gt->s1y0[i][xi][yi] = yy0 + yi*gt->dy;
	}
      }
    }
    gt->avgtw = s1w_avg / (float)ntile;  
    k += 1;
    to = onode_get_next_type(to->next,"grid");
  }
  mod_vhf_c1_ntot = ntot * nch;
  sprintf(ggstr,"    C1 has %d total units\n",mod_vhf_c1_ntot);
  mylog(mylogf,ggstr);
  s2xn = mod_vhf_c2->s2_xn;    
  rr = (float ******)myalloc(s2xn*sizeof(float *****));
  for(ii=0;ii<s2xn;ii++){
    rr[ii] = (float *****)myalloc(s2xn*sizeof(float ****));
    for(jj=0;jj<s2xn;jj++){
      rr[ii][jj] = (float ****)myalloc(gn*sizeof(float ***));
      for(i=0;i<gn;i++){
	gxn = g[i]->xn;
	rr[ii][jj][i] = (float ***)myalloc(gxn*sizeof(float **));
	for(j=0;j<gxn;j++){
	  gyn = g[i]->yn;
	  rr[ii][jj][i][j] = (float **)myalloc(gyn*sizeof(float *));
	  for(k=0;k<gyn;k++){
	    rr[ii][jj][i][j][k] = (float *)myalloc(nch*sizeof(float));
	  }
	}
      }
    }
  }
  mod_vhf_c1_ndx = get_2d_iarray(mod_vhf_c1_ntot,4);
  k = 0;
  for(gi=0;gi<gn;gi++){  
    gxn = g[gi]->xn;     
    gyn = g[gi]->yn;     
    g[gi]->ndx0 = k;     
    for(i=0;i<gxn;i++){
      for(j=0;j<gyn;j++){
	for(ci=0;ci<nch;ci++){
	  mod_vhf_c1_ndx[k][0] = i;   
	  mod_vhf_c1_ndx[k][1] = j;   
	  mod_vhf_c1_ndx[k][2] = ci;  
	  mod_vhf_c1_ndx[k][3] = gi;  
	  k += 1;
	}
      }
    }
  }
  mod_vhf_c1_flag = get_const_iarray(mod_vhf_c1_ntot,0);
  mod_vhf_fit_ndx = (int *)myalloc(mod_vhf_c1_ntot*sizeof(int));
  mod_vhf_fit_mse = (float *)myalloc(mod_vhf_c1_ntot*sizeof(float));
  mod_vhf_fit_mse_ts = (float *)myalloc(mod_vhf_c1_ntot*sizeof(float));
  mod_vhf_fit_rvl    = (float *)myalloc(mod_vhf_c1_ntot*sizeof(float));
  mod_vhf_fit_rvl_ts = (float *)myalloc(mod_vhf_c1_ntot*sizeof(float));
  mod_vhf_c1_grid  = g;   
  mod_vhf_c1_gridn = gn;
  mod_vhf_c1_r     = rr;
}
void mod_vhf_config_s2(s2o)
     struct onode *s2o;  
{
  int i,k;
  int ng,n,sn,*ival;
  float sig_s,sig_a,sig_b;
  char *outfile;
  struct onode *to;
  struct vhf_grid  **g;
  struct vhf_s2_par  *s2;
  mylog(mylogf,"  MOD_VHF_CONFIG_S2\n");
  s2 = (struct vhf_s2_par *)myalloc(sizeof(struct vhf_s2_par));
  s2->nltype = onode_getpar_chr_dflt(s2o,"nonlin","sigmoid0"); 
  if (strcmp(s2->nltype,"sigmoid0")==0){
    s2->s    = onode_getpar_flt_exit(s2o,"sigmoid_s");
    s2->a    = onode_getpar_flt_exit(s2o,"sigmoid_alpha");
    s2->b    = onode_getpar_flt_exit(s2o,"sigmoid_beta");
  }else if (strcmp(s2->nltype,"none")==0){
    ; 
  }else
    exit_error("MOD_VHF_CONFIG_S2","Unknown 'nonlin' in <s2>");
  s2->eps2 = onode_getpar_flt_dflt(s2o,"norm_eps",0.0001);
  outfile = onode_getpar_chr_dflt(s2o,"postplot_file",NULL);
  if (outfile != NULL){
    if (strcmp(outfile,"NULL")==0){  
      myfree(outfile);
      outfile = NULL;
    }
  }
  if (0){
    float x,s;
    char tstr[SLEN];
    if (strcmp(s2->nltype,"sigmoid0")!=0)
      exit_error("MOD_VHF_CONFIG_S2","Only works for 'sigmoid0' s2 nonlin");
    n = 200;
    for(i=0;i<n;i++){
      x = (float)(i-n/2)/(float)(n/10);
      s = s2->s / (1.0 + exp(-s2->a*(x-s2->b)));
      sprintf(tstr,"%f %f\n",x,s);
      append_string_to_file("zzz.sigmoid.pl",tstr);
    }
    exit(0);
  }
  ng = mod_vhf_c1_gridn;
  g  = mod_vhf_c1_grid;
  s2->nw = 0;
  to = onode_get_next_type(s2o->o,"item");
  while(to != NULL){
    for(i=0;i<ng;i++){
      if (compare_prefix_string_order(g[i]->name,to->name) == 1){
	s2->nw += 1;
      }
    }
    to = onode_get_next_type(to->next,"item");
  }
  s2->c1w = (struct vhf_c1w **)myalloc(s2->nw*sizeof(struct vhf_c1w *));
  for(i=0;i<s2->nw;i++)
    s2->c1w[i] = (struct vhf_c1w *)myalloc(sizeof(struct vhf_c1w));
  k = 0;
  to = onode_get_next_type(s2o->o,"item");
  while(to != NULL){
    for(i=0;i<ng;i++){
      if (compare_prefix_string_order(g[i]->name,to->name) == 1){
	sn = strlen(g[i]->name);
	ival = carray_util_parse_underscore(&(to->name[sn+1]),&n);
	if (n != 3)
	  mylog_exit(mylogf,"MOD_VHF_CONFIG_S2  Expecting 3 indices.");
	s2->c1w[k]->gi = i;
	s2->c1w[k]->xi = ival[0];
	s2->c1w[k]->yi = ival[1];
	s2->c1w[k]->ci = ival[2];
	s2->c1w[k]->w  = atof(to->val);
	k += 1;
      }
    }
    to = onode_get_next_type(to->next,"item");
  }
  mylog(mylogf,"    S2 configuration:\n");
  if (strcmp(s2->nltype,"sigmoid0")==0){
    mylog(mylogf,"      Sigmoid\n");
    sprintf(ggstr,"        s  %f\n",s2->s);
    mylog(mylogf,ggstr);
    sprintf(ggstr,"        a  %f\n",s2->a);
    mylog(mylogf,ggstr);
    sprintf(ggstr,"        b  %f\n",s2->b);
    mylog(mylogf,ggstr);
  }else if (strcmp(s2->nltype,"none")==0){
    mylog(mylogf,"      No nonlinearity applied\n");
  }
  sprintf(ggstr,"      C1 inputs: %d\n",s2->nw);
  mylog(mylogf,ggstr);
  mylog(mylogf,"        # grid xi yi chan  weight\n");
  for(i=0;i<s2->nw;i++){
    sprintf(ggstr,"       %2d  %2d  %2d %2d %2d  %9.5f\n",i,s2->c1w[i]->gi,
	    s2->c1w[i]->xi,s2->c1w[i]->yi,s2->c1w[i]->ci,s2->c1w[i]->w);
    mylog(mylogf,ggstr);
  }
  mod_vhf_s2 = s2;  
  if (outfile != NULL)
    mod_vhf_pp_write(outfile,0);
}
void mod_vhf_config_c2(c2o)
     struct onode *c2o;  
{
  int i,j;
  int gxn,dx; 
  struct onode *go;
  mylog(mylogf,"  MOD_VHF_CONFIG_C2\n");
  mod_vhf_c2 = (struct vhf_c2 *)myalloc(sizeof(struct vhf_c2));
  if (c2o != NULL){
    go = onode_child_get_unique(c2o,"grid");  
    gxn = onode_getpar_int_exit(go,"xn"); 
    dx  = onode_getpar_int_exit(go,"dx"); 
  }else{
    gxn = 1;
    dx = 0;
  }
  mod_vhf_c2->s2 = (struct vhf_s2 ***)myalloc(gxn*sizeof(struct vhf_s2 **));
  for(i=0;i<gxn;i++){
    mod_vhf_c2->s2[i] = (struct vhf_s2 **)myalloc(gxn*sizeof(struct vhf_s2 *));
    for(j=0;j<gxn;j++){
      mod_vhf_c2->s2[i][j] = (struct vhf_s2 *)myalloc(sizeof(struct vhf_s2));
    }
  }
  mod_vhf_c2->s2_xn = gxn;  
  mod_vhf_c2->s2_dx = dx;
  mod_vhf_s2_r = get_2d_farray(gxn,gxn);
  sprintf(ggstr,"    Grid is  %d x %d\n",gxn,gxn);
  mylog(mylogf,ggstr);
  sprintf(ggstr,"    dx = %d pixels\n",dx);
  mylog(mylogf,ggstr);
}
void mod_vhf_01_prep(m,s,r)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
{
  int xn,yn,tn;
  float tscale,sscale;
  struct onode *fito,*s1o,*c1o,*s2o,*c2o;
  myid = mylog_set_id_log(m->process_id,&mylogf);  
  mylog(mylogf,"  MOD_VHF_01_PREP\n");
  xn     = mod_vhf_xn     = onode_getpar_int_exit(m->o,"xn");
  yn     = mod_vhf_yn     = onode_getpar_int_exit(m->o,"yn");
  tn     = mod_vhf_tn     = onode_getpar_int_exit(m->o,"tn");
  tscale = mod_vhf_tscale = onode_getpar_flt_exit(m->o,"tscale");
  sscale = mod_vhf_sscale = onode_getpar_flt_exit(m->o,"sscale");
  mod_vhf_ft_resp_flag = 1;  
  if (mod_vhf_fit_opt == NULL)
    mod_vhf_fit_opt = (float *)myalloc(MAX_PAR*sizeof(float));
  mod_vhf_outfile_prefix = param_getc_dflt(r->ppl,"outfile","zz");
  s1o = onode_child_get_unique(m->o,"s1");
  mod_vhf_config_s1_top(s1o);
  c2o = onode_child_get_unique(m->o,"c2");
  mod_vhf_config_c2(c2o);  
  c1o = onode_child_get_unique(m->o,"c1");
  if (c1o == NULL)
    mylog_exit(mylogf,"MOD_VHF_01_PREP  <c1> not found in .moo file.");
  else
    mod_vhf_config_c1(c1o);
  s2o = onode_child_get_unique(m->o,"s2");
  if (s2o != NULL)
    mod_vhf_config_s2(s2o);
  if ((m->action == 10) && (m->marfile != NULL)){
    mod_vhf_make_mpt(m,s,r);
    return;
  }
  fito = onode_child_get_unique(m->o,"fit");
  if (fito != NULL)
    mod_vhf_01_fit(m,s,r,fito);
}
void mod_vhf_01_done(m)
     struct model_struct *m;        
{
  mylog(mylogf,"  MOD_VHF_01_DONE\n");
}
void mod_vhf_handover(r)
     struct response_struct *r; 
{
  int i;
  int ii,jj,xi,yi,ci,gi,tn,s2n,*s2i,rn;
  float tscale,*t,fval;
  tscale = mod_vhf_tscale;
  tn     = mod_vhf_tn;
  s2n    = mod_vhf_c2->s2_xn;
  mod_vhf_c2_r = max_of_2d_farray(mod_vhf_s2_r,s2n,s2n);
  for(i=0;i<r->n;i++){ 
    t = NULL;
    if (r->rformat[i] == 0){  
      fval = mod_vhf_c2_r;
    }else if (r->rformat[i] == 1){  
      s2i = carray_util_parse_underscore(&(r->plname[i][3]),&rn);
      if (rn != 3)
	mylog_exit(mylogf,"MOD_VHF_HANDOVER  c1_x_y_z needs 3 indices");
      ii = s2i[0];
      jj = s2i[1];
      gi = s2i[2];
      myfree(s2i);
      xi = r->xi[i];
      yi = r->yi[i];
      ci = r->zi[i];
      fval = mod_vhf_c1_r[ii][jj][gi][xi][yi][ci];
    }
    t = get_const_farray(tn,fval);
    mod_util_resp_store_f_samp(r,i,t,tn,1.0/tscale,mylogf);
    myfree(t);
  }
}
void mod_vhf_01_get_response(m,s,r)
     struct model_struct *m;        
     struct stim_struct *s;         
     struct response_struct *r;     
{
  int i,j,ii,jj;
  int xn,yn,xi,yi,gi,oi,nw,s2n;
  float *w,*x,***stim,u;
  char tstr[SLEN];
  struct vhf_s2_par *s2;
  xn = mod_vhf_xn;
  yn = mod_vhf_yn;
  stim = f3tensor(1,1,1,xn,1,yn);  
  for(i=0;i<xn;i++){
    for(j=0;j<yn;j++){
      stim[1][i+1][j+1] = s->d[i+1][j+1][1];  
    }
  }
  mod_vhf_resp_s1(stim);  
  if (0){
    float **t2;
    t2 = mod_vhf_chans[0]->r[0][0][0];  
    write_2d_data("zz.rs.2d",t2,0,0,xn,yn,4,2,1,0);
    exit(0);
  }
  s2n = mod_vhf_c2->s2_xn;
  for(ii=0;ii<s2n;ii++){
    for(jj=0;jj<s2n;jj++){
      mod_vhf_resp_c1_all(mod_vhf_c1_r[ii][jj],ii,jj);
    }
  }
  s2 = mod_vhf_s2;
  nw = s2->nw;
  w = get_farray(nw);
  x = get_farray(nw);
  for(j=0;j<s2n;j++){
    jj = (s2n-1) - j;
    for(ii=0;ii<s2n;ii++){
      for(i=0;i<nw;i++){
	w[i] = s2->c1w[i]->w;  
	gi   = s2->c1w[i]->gi;
	xi   = s2->c1w[i]->xi;
	yi   = s2->c1w[i]->yi;
	oi   = s2->c1w[i]->ci;
	x[i] = mod_vhf_c1_r[ii][jj][gi][xi][yi][oi];
      }
      mod_vhf_s2_r[ii][jj] = mod_vhf_resp_s2(s2->nltype,s2->s,s2->a,s2->b,
					     s2->eps2,w,x,nw,&u);
      if (0){
	sprintf(tstr,"%f\n",u);
	append_string_to_file("zzz.u.data",tstr);
      }
    }
  }
  myfree(w);
  myfree(x);
  free_f3tensor(stim,1,1,1,xn,1,yn);
  mod_vhf_handover(r);
}
void mod_vhf_run_01(m,s,r,action)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
     int action;                
{
  myid = mylog_set_id_log(m->process_id,&mylogf);  
  numproc = m->process_n;
  mod_vhf_action = action;
  if ((action == 0) || (action == 2) || (action == 10)){
    mod_vhf_01_prep(m,s,r);
  }else if (action == 1){
    mod_vhf_01_get_response(m,s,r);
  }else if (action == -1){
    mod_vhf_01_done(m);
  }
}
