/*C  (C) Copyright  Wyeth Bair 1993-2010                                     */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "my_util.h"
#include "iarray_util.h"
#include "farray_util.h"
#include "spike_util.h"
#include "paramfile_util.h"
#include "mod_util.h"
#include "mod.h" 
#include "paramfile.h"
static int myid = -1;         
static char *mylogf = NULL;   
char ggstr[LONG_SLEN];        
int mod_x_xn;
int mod_x_yn;
int mod_x_tn;
float mod_x_tscale;
int mod_x_xi;
int mod_x_yi;
int mod_x_toff;
int mod_x_eye;    
void mod_x_01_prep(m,r)
     struct model_struct *m;    
     struct response_struct *r; 
{
  int xn,yn,tn,xi,yi,toff;
  float tscale;
  myid = mylog_set_id_log(m->process_id,&mylogf);  
  mylog(mylogf,"  MOD_X_01_PREP\n");
  xn     = onode_getpar_int_exit(m->o,"xn");
  yn     = onode_getpar_int_exit(m->o,"yn");
  tn     = onode_getpar_int_exit(m->o,"tn");
  tscale = onode_getpar_flt_exit(m->o,"tscale");
  xi = onode_getpar_int_exit(m->o,"xi");
  yi = onode_getpar_int_exit(m->o,"yi");
  toff = onode_getpar_int_dflt(m->o,"toff",0);  
  mod_x_eye = onode_getpar_int_dflt(m->o,"eye_flag",0);  
  mod_x_xn = xn;
  mod_x_yn = yn;
  mod_x_tn = tn;
  mod_x_tscale = tscale;
  mod_x_xi = xi;
  mod_x_yi = yi;
  mod_x_toff = toff;
}
void mod_x_01_done(m)
     struct model_struct *m;        
{
  mylog(mylogf,"  MOD_X_01_DONE\n");
}
void mod_x_01_get_response(m,s,r)
     struct model_struct *m;        
     struct stim_struct *s;         
     struct response_struct *r;     
{
  int i;
  int xi,yi,ss,pn;
  int tn,flag,seed,*spk,cnt,cpflag;
  float *d,*prob,mu,tscale,*fs;
  tscale = mod_x_tscale;
  tn = mod_x_tn;
  xi = mod_x_xi;
  yi = mod_x_yi;
  d = (float *)myalloc(tn*sizeof(float));
  if (mod_x_eye == 0){  
    for(i=0;i<tn;i++)
      d[i] = s->d[1+xi][1+yi][i+1];
  }else if (mod_x_eye == 1){  
    if (s->d_r == NULL)
      mylog_exit(mylogf,"MOD_X_01_GET_RESPONSE  Right eye stimulus is NULL\n");
    mylog(mylogf,"    Using Right Eye stimulus\n");
    for(i=0;i<tn;i++)
      d[i] = s->d_r[1+xi][1+yi][i+1];
  }
  if (r->gtsi == 0) 
    remove_file("zz.mod_x.pl");
  append_farray_plot("zz.mod_x.pl","raw_stim",d,tn,1);
  mu = mean_farray(d,tn);
  multiply_farray(d,tn,0.1/mu);  
  if (tscale > 0.001){
    ss = tscale/0.001;  
    prob = over_sample_farray(d,tn,ss);
    pn = tn*ss;
  }else if (tscale == 0.001){
    prob = copy_farray(d,tn);
    pn = tn;
  }else{
    mylog_exit(mylogf,"MOD_X_01_GET_RESPONSE  tscale < 1ms\n");
  }
  append_farray_plot("zz.mod_x.pl","prob",prob,pn,1);
  seed = m->mseed[r->tsi];  
  make_poisson_spikes_from_prob(prob,pn,1000.0,&seed,&spk,&cnt);
  add_const_iarray(spk,cnt,mod_x_toff);
  fs = i2farray(spk,cnt);  
  cpflag = 0;              
  mod_util_resp_store_s(r,0,fs,cnt,cpflag,mylogf);
  myfree(spk);
  myfree(prob);
  myfree(d);
}
void mod_x_run_01(m,s,r,action)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
     int action;                
{
  myid = mylog_set_id_log(m->process_id,&mylogf);  
  if (action == 0){
    mod_x_01_prep(m,r);
  }else if (action == 1){
    mod_x_01_get_response(m,s,r);
  }else if (action == -1){
    mod_x_01_done(m);
  }
}
