/*C  (C) Copyright  Wyeth Bair 1993-2010                                     */
#include <stdio.h>
#include <X11/Xlib.h>
#include <GL/glx.h>
#include <GL/gl.h>
#include <unistd.h>
#include "my_util.h"
void xwin_get_gc(display,win,fg,bg,gc)
     Display *display;
     Window win;
     int fg,bg;
     GC *gc;
{
  unsigned long gc_valuemask; 
  XGCValues gc_values;        
  gc_values.foreground = fg;
  gc_values.background = bg;
  gc_valuemask         = GCForeground | GCBackground;
  *gc = XCreateGC(display,win,gc_valuemask,&gc_values);
}
void xwin_init(display,win,width,height,x,y,gc,gc_erase,name)
     Display **display;
     Window *win;
     int width,height,x,y;
     GC *gc,*gc_erase;
     char name[];
{
  int           screen;         
  Window        parent;		
  unsigned long gc_valuemask;	
  XGCValues     gc_values;	
  int           border_width,border_color,background_color;
  if ((*display = XOpenDisplay(NULL)) == NULL) {
    fprintf(stderr,"*** XWIN_INIT: Can't open display %s\n",
	    XDisplayName(NULL));
    exit_error("XWIN_INIT","Cannot open display");
  }
  screen = XDefaultScreen(*display);
  parent = XRootWindow(*display,screen);
  border_width = 4;
  background_color = XBlackPixel(*display,screen);
  border_color = XBlackPixel(*display,screen);
  *win = XCreateSimpleWindow(*display,parent,x,y,width,height,
			    border_width,border_color,background_color);
  XStoreName(*display,*win,name);
  XSelectInput(*display,*win,
	       ExposureMask|KeyPressMask|ButtonPressMask|Button1MotionMask);
  gc_values.foreground = XWhitePixel(*display,screen);
  gc_values.background = background_color;
  gc_valuemask         = GCForeground | GCBackground;
  *gc = XCreateGC(*display,*win,gc_valuemask,&gc_values);
  gc_values.background = XWhitePixel(*display,screen); 
  gc_values.foreground = background_color;
  gc_valuemask         = GCForeground | GCBackground;
  *gc_erase = XCreateGC(*display,*win,gc_valuemask,&gc_values);
  XMapWindow(*display,*win);   
}
void xwin_util_event_clear(dpy)
     Display *dpy;
{
  int nev;
  XEvent event;
  nev = 0;
  while (XPending(dpy)){
    nev += 1;
    XNextEvent(dpy,&event); 
  }
}
void xwin_util_event_get_arrow_lr(dpy,clearflag,rr)
     Display *dpy;
     int clearflag;   
     int *rr;         
{
  int r,done;
  char kbuf[10];
  XEvent event;
  XKeyEvent *kevent;
  KeySym ks;
  if (clearflag == 1)
    xwin_util_event_clear(dpy);
  done = 0;
  while(!done){
    usleep(1000); 
    if (XCheckIfEvent(dpy,&event,my_true_test,(char *)NULL)){
      switch(event.type){
      case ButtonPress:
	switch(event.xbutton.button){
	case 1:
	  break;
	case 2:
	  break;
	case 3:
	  break;
	}
	break;
      case MotionNotify:
	break;
      case KeyPress:
	kevent = (XKeyEvent *)&event;
	XLookupString(kevent,kbuf,sizeof(kbuf),&ks,NULL);
	if (ks==65363){             
	  r = 1;
	  done = 1;
	}else if (ks==65361){       
	  r = 0;
	  done = 1;
	}else if (ks==65362){       
	  ;
	}else if (ks==65364){       
	  ;
	}else if (kbuf[0]==' '){
	  ;
	}
	break;
      case ConfigureNotify:
	break;
      case Expose:  
	break;
      }
    }
  }
  *rr = r;
}
