/*C  (C) Copyright  Wyeth Bair 1993-2010                                     */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <sys/types.h>
#include <unistd.h>
#include "my_util.h"
#include "nr_util.h"
#include "carray_util.h"
#include "iarray_util.h"
#include "farray_util.h"
#include "myrand_util.h"
#include "data_util.h"
#include "paramfile_util.h"
#include "ndata_util.h"
#include "mctrl_util.h"
#include "mod_conn_util.h"
#include "mod_util.h"
#include "wm_util.h"
#include "paramfile.h"
#include "ndata.h"
#include "mod.h"
#include "ifc.h"
char *mylogf = NULL;
char *wm_make_name_for_trial(s,r)
     struct stim_struct *s;
     struct response_struct *r;
{
  int i,j,k;
  int n;
  char *tname,*tval;
  char tstr[LONG_SLEN];
  n = s->nvar;
  if ((s->d == NULL) && (s->dc == NULL)){
    tstr[0] = 'N';
    tstr[1] = 'u';
    tstr[2] = 'l';
    tstr[3] = 'l';
    k = 4;
  }else{
    k = 0;
  }
  for(i=0;i<n;i++){ 
    tname = s->vname[i];
    tval  = s->vval[r->tri][i];
    for(j=0;j<strlen(tname);j++){
      tstr[k] = tname[j];
      k += 1;
    }
    tstr[k] = '=';
    k += 1;
    for(j=0;j<strlen(tval);j++){
      tstr[k] = tval[j];
      k += 1;
    }
    if (i < (n-1)){
      tstr[k] = '_';
      k += 1;
    }
  }
  tstr[k] = '\0';
  return strdup(tstr);
}
void wm_write_3d_stim(stimfile,outfile,arglist,narg,stim_num,frame_num,fstflag)
     char stimfile[],outfile[];
     char **arglist;
     int narg;
     int stim_num;    
     int frame_num;   
     int fstflag;     
{
  int i,j,k;
  int xn,yn,tn,tsamp,dxn,***idata,fst_binoc,fst_tn;
  float sscale,tscale,stim_samp,***data,**t,dxa;
  char *sform;
  struct stim_struct *s;  
  printf("  WM_WRITE_3D_STIM\n");
  s = (struct stim_struct *)myalloc(sizeof(struct stim_struct));
  s->ppl = paramfile_get_initial_params_update_only(stimfile,arglist,narg,1);
  strcpy(s->paramfile,stimfile);
  s->name = (char *)NULL;
  s->stimno = -1; 
  if (!paramfile_list_update(s->ppl,"stim_nrpt","1"))
    exit_error("WM_WRITE_3D_STIM","Could not set 'stim_nrpt' to 1\n");
  wm_prep_var_const_gen(NULL,s,mylogf,NULL,0,NULL); 
  if ((stim_num < 0) || (stim_num > (s->ntr-1))){
    printf("  Valid stimulus range is 0..%d\n",s->ntr-1);
    exit_error("WM_WRITE_3D_STIM","Stimulus number out of range");
  }
  xn = paramfile_get_int_param_or_exit(s->ppl,"stim_frame_xn");
  yn = paramfile_get_int_param_or_exit(s->ppl,"stim_frame_yn");
  tn = paramfile_get_int_param_or_exit(s->ppl,"stim_frame_tn");
  sscale = paramfile_get_float_param_or_exit(s->ppl,"stim_frame_sscale");
  tscale = paramfile_get_float_param_or_exit(s->ppl,"stim_frame_tscale");
  stim_samp = paramfile_get_float_param_or_exit(s->ppl,"stim_samp");
  tsamp = my_rint(1.0/(tscale*stim_samp)); 
  if (tsamp <= 0)
    tsamp = 1; 
  fst_binoc = 0;  
  fst_tn = tn;    
  printf("  Will write data for stimulus %d (0..%d)\n",stim_num,s->ntr-1);
  sform = paramfile_get_char_param_default(s->ppl,"stim_form","3d");
  if (strcmp(sform,"3d")==0){
    mod_util_get_3d_stim(s,stim_num,xn,yn,tn,sscale,tscale,tsamp,mylogf);
    data = s->d;
  }else if (strcmp(sform,"3d_b")==0){
    dxn = paramfile_get_int_param_default(s->ppl,"stim_frame_binoc_dxn",10);
    dxa = param_getf_dflt(s->ppl,"stim_frame_binoc_amp",0.5);
    printf("    Getting binoc data...\n");
    mod_util_get_3d_stim_binoc(s,stim_num,xn,yn,tn,sscale,tscale,tsamp,mylogf);
    printf("    done.\n");
    if (fstflag == 1){
      fst_binoc = 2;
      data = f3tensor(1,xn,1,yn,1,2*tn); 
      for(i=1;i<=xn;i++)
	for(j=1;j<=yn;j++)
	  for(k=1;k<=tn;k++){
	    data[i][j][2*k-1] = s->d[i][j][k];
	    data[i][j][2*k]   = s->d_r[i][j][k];
	  }
      fst_tn = 2*tn;
    }else{
      data = f3tensor(1,2*xn+dxn,1,yn,1,tn); 
      for(i=1;i<=xn;i++)
	for(j=1;j<=yn;j++)
	  for(k=1;k<=tn;k++){
	    data[i       ][j][k] = s->d[i][j][k];
	    data[i+xn+dxn][j][k] = s->d_r[i][j][k];
	  }
      for(j=1;j<=yn;j++){
	for(k=1;k<=tn;k++){
	  for(i=1;i<=dxn;i++){
	    data[xn+i][j][k] = dxa;
	  }
	}
      }
      xn = 2*xn + dxn;
    }
  }else if (strcmp(sform,"3c")==0){
    mod_util_get_3c_stim(s,stim_num,xn,yn,tn,sscale,tscale,tsamp,mylogf);
    idata = s->dc;
    data = NULL;
  }else{
    printf("  *** stim_form  %s\n",sform);
    exit_error("WM_WRITE_3D_STIM","Unknown 'stim_form'");
  }
  if (frame_num < 0){
    if (strcmp(sform,"3c")==0){
      write_3d_data_part(outfile,idata,0,xn,0,yn,0,tn,4,11,1); 
    }else{ 
      if (fstflag == 1){
	printf(" *********** WYETH ASSUMING 0..1 value range MUST CHECK\n");
	data_util_fst_write(outfile,data,1,xn,1,yn,1,fst_tn,0,2,fst_binoc);
      }else
	write_3d_data_part(outfile,data,1,xn,1,yn,1,tn,4,2,1); 
    }
  }else{
    if (frame_num > (tn-1)){
      printf("  stim_frame_tn  %d\n",tn);
      printf("  stim_frame     %d\n",frame_num);
      exit_error("WM_WRITE_3D_STIM","Frame number too large");
    }
    t = get_2d_farray(xn,yn);
    for(i=0;i<xn;i++)
      for(j=0;j<yn;j++)
	t[i][j] = data[1+i][1+j][1+frame_num];
    printf("  Will write frame %d to 2d data file.\n",frame_num);
    write_2d_data(outfile,t,0,0,xn,yn,4,2,0,1); 
    free_2d_farray(t,xn);
  }
}
void wm_write_stim_ppm_files(stimfile,outfile,arglist,narg,frame_num)
     char stimfile[],outfile[];
     char **arglist;
     int narg,frame_num;
{
  int xn,yn,tn,tsamp;
  float sscale,tscale,stim_samp,***data;
  struct stim_struct *s; 
  printf("  WM_WRITE_STIM_PPM_FILES\n");
  s = (struct stim_struct *)myalloc(sizeof(struct stim_struct));
  s->ppl = paramfile_get_initial_params_update_only(stimfile,arglist,narg,1);
  strcpy(s->paramfile,stimfile);
  xn = paramfile_get_int_param_or_exit(s->ppl,"stim_frame_xn");
  yn = paramfile_get_int_param_or_exit(s->ppl,"stim_frame_yn");
  tn = paramfile_get_int_param_or_exit(s->ppl,"stim_frame_tn");
  sscale = paramfile_get_float_param_or_exit(s->ppl,"stim_frame_sscale");
  tscale = paramfile_get_float_param_or_exit(s->ppl,"stim_frame_tscale");
  stim_samp = paramfile_get_float_param_or_exit(s->ppl,"stim_samp");
  tsamp = my_rint(1.0/(tscale*stim_samp)); 
  if (tsamp <= 0)
    tsamp = 1; 
  mod_util_get_3d_stim(s,-1,xn,yn,tn,sscale,tscale,tsamp,mylogf);
  write_ppm_6_3d_gray_frames(outfile,s->d,xn,yn,tn,1); 
}
void run_indefinite(m,s,r)
     struct model_struct *m;     
     struct stim_struct *s;      
     struct response_struct *r;  
{
  int n,nchan;
  long nd_ntr_addr;
  struct ndtrial_struct *t;
  struct ndata_struct *nd;
  char *outfile,*outfile2,*prefix,*format;
  printf("  RUN_INDEFINITE\n");
  wm_get_nd_t1_outfile(r,mylogf,-1,&prefix,&format,&outfile,&outfile2);
  nd = get_ndata();                  
  nd->class = strdup("WM");          
  write_ndata(outfile,nd);   
  nd_ntr_addr = ndata_get_file_pos_ntr(outfile);  
  t = (struct ndtrial_struct *)myalloc(sizeof(struct ndtrial_struct));
  nchan = r->ns + r->nf;
  n = 0;  
  while(m->run_mode == 8){
    wm_slave_action(m,s,r,1,mylogf); 
    wm_response_check_trial_full(r,0,mylogf,NULL);  
    wm_make_ndtrial(m,s,r,mylogf,-1,0,nchan,nd,t);  
    ndata_append_trial(outfile,t);
    n += 1;
    ndata_overwrite_ntr(outfile,nd_ntr_addr,n);
    printf("    Appended %s, trials %d\n",outfile,n);
  }
}
void run_gen_tuning_curve(m,s,r)
     struct model_struct *m;     
     struct stim_struct *s;      
     struct response_struct *r;  
{
  int i,j;
  int xn,yn,tn,nstim,nrpt,write_stim_num; 
  char *sform;
  printf("  RUN_GEN_TUNING_CURVE\n");
  wm_get_sform_xn_yn_tn(m,s,&sform,&xn,&yn,&tn);
  write_stim_num = param_geti_dflt(s->ppl,"write_stim_num",-1);
  nrpt           = param_geti_exit(s->ppl,"stim_nrpt");
  nstim = s->ntr / nrpt;
  for(i=0;i<nstim;i++){
    get_stimulus_data_tuning_curve(m,s,r,i,r->tri,mylogf);
    if (write_stim_num == i){
      char tname[SLEN];
      if ((strcmp(sform,"3d")==0) && (s->d != NULL)){
	sprintf(tname,"zzz.stim_%d.3d",i);
	write_3d_data_part(tname,s->d,1,xn,1,yn,1,tn,4,2,1);
      }else if ((strcmp(sform,"3d_b")==0) && (s->d != NULL)){
	sprintf(tname,"zzz.stim_%d.3d",i);
	write_3d_data_part(tname,s->d,1,xn,1,yn,1,tn,4,2,1);
	sprintf(tname,"zzz.stim_%d_R.3d",i);
	write_3d_data_part(tname,s->d_r,1,xn,1,yn,1,tn,4,2,1);
      }else if (strcmp(sform,"1d")==0){
	sprintf(tname,"zzz.stim_%d.pl",i);
	append_farray_plot(tname,tname,s->d1,tn,1);
      }
    }
    if (r->tname != NULL)
      myfree(r->tname);
    r->tname = wm_make_name_for_trial(s,r);
    for(j=0;j<nrpt;j++){
      s->repno = j; 
      printf("  _________________________\n");
      if (r->tname != NULL)
	printf("  Stim %d (%s) Rpt %d\n",i+1,r->tname,j+1);
      else
	printf("  Stim %d  Rpt %d\n",i+1,j+1);
      r->gtsi = m->m_i * s->ntr + r->tsi; 
      wm_slave_action(m,s,r,1,mylogf); 
      wm_response_check_trial_full(r,r->gtsi,mylogf,NULL);
      r->dflag[r->gtsi] = 1; 
      s->tribyx[r->gtsi] = r->tri;  
      r->tsi += 1;          
      r->tri = r->tsi;      
    }
    if (strcmp(sform,"3d")==0){
      if (s->d != NULL)
	free_f3tensor(s->d,1,xn,1,yn,1,tn);
    }else if (strcmp(sform,"3d_b")==0){
      if (s->d != NULL)
	free_f3tensor(s->d,1,xn,1,yn,1,tn);
      if (s->d_r != NULL)
	free_f3tensor(s->d_r,1,xn,1,yn,1,tn);
    }else if (strcmp(sform,"3c")==0){
      if (s->dc != NULL)
	free_3d_iarray(s->dc,xn,yn,tn);
    }else if (strcmp(sform,"1d")==0){
      myfree(s->d1);
    }else{
      exit_error("WM_RUN_GEN_TUNING_CURVE","Unknown stimulus form");
    }
  }
  if (r->tname != NULL)  myfree(r->tname);
  if (sform    != NULL)  myfree(sform);
}
void run_gen_tuning_curve_rand(m,s,r,shuff_seed)
     struct model_struct *m;     
     struct stim_struct *s;      
     struct response_struct *r;  
     int shuff_seed;             
{
  int i,j;
  int xn,yn,tn,nstim,nrpt,si,**randi;
  char *sform;
  printf("  RUN_GEN_TUNING_CURVE_RAND\n");
  wm_get_sform_xn_yn_tn(m,s,&sform,&xn,&yn,&tn);
  nrpt = paramfile_get_int_param_or_exit(s->ppl,"stim_nrpt");
  nstim = s->ntr / nrpt;
  randi = (int **)myalloc(nrpt*sizeof(int *));
  for(i=0;i<nrpt;i++)
    randi[i] = get_shuffle_index_return_seed(nstim,3,&shuff_seed);
  for(j=0;j<nrpt;j++){
    for(i=0;i<nstim;i++){
      si = randi[j][i];     
      r->tri = si*nrpt + j; 
      get_stimulus_data_tuning_curve(m,s,r,si,r->tri,mylogf);
      if (r->tname != NULL)
	myfree(r->tname);
      r->tname = wm_make_name_for_trial(s,r);
      s->repno = j; 
      if (r->tname != NULL)
	printf("  Stim %d (%s) Rpt %d\n",si+1,r->tname,j+1);
      else
	printf("  Stim %d  Rpt %d\n",si+1,j+1);
      wm_slave_action(m,s,r,1,mylogf); 
      wm_response_check_trial_full(r,r->tri,mylogf,NULL);
      r->dflag[r->tri] = 1;  
      s->tribyx[r->tsi] = r->tri;  
      r->tsi += 1;           
      if (strcmp(sform,"3d")==0){
	free_f3tensor(s->d,1,xn,1,yn,1,tn);
      }else if (strcmp(sform,"3c")==0){
	free_3d_iarray(s->dc,xn,yn,tn);
      }else if (strcmp(sform,"3d_b")==0){
	free_f3tensor(s->d,1,xn,1,yn,1,tn);
	free_f3tensor(s->d_r,1,xn,1,yn,1,tn);
      }else if (strcmp(sform,"1d")==0){
	myfree(s->d1);
      }
    }
  }
  free_2d_iarray(randi,nrpt);
}
void run_interactive(m,s,r)
     struct model_struct *m;     
     struct stim_struct *s;      
     struct response_struct *r;  
{
  int k;
  int xn,yn,tn,done,told,sold,nrpt;
  char *sform;
  printf("  RUN_INTERACTIVE\n");
  wm_get_sform_xn_yn_tn(m,s,&sform,&xn,&yn,&tn);
  nrpt = paramfile_get_int_param_or_exit(s->ppl,"stim_nrpt");
  done = 0;
  while(!done){
    if (s->stimno < 0){
      printf("  *** WARNING:  setting stimno to zero\n");
      s->stimno = 0;  
    }
    r->tri = s->stimno * nrpt; 
    get_stimulus_data_tuning_curve(m,s,r,s->stimno,r->tri,mylogf);
    sold = s->stimno;
    told = r->tri;
    s->repno = 0; 
    printf("    ");
    for(k=0;k<s->nvar;k++)
      printf("  %s=%s",s->vname[k],s->vval[r->tri][k]);
    printf("\n");
    while(sold == s->stimno){
      wm_slave_action(m,s,r,1,mylogf); 
    }
    if (strcmp(sform,"3d")==0){
      free_f3tensor(s->d,1,xn,1,yn,1,tn);
    }else if (strcmp(sform,"3c")==0){
      free_3d_iarray(s->dc,xn,yn,tn);
    }else if (strcmp(sform,"3d_b")==0){
      free_f3tensor(s->d,1,xn,1,yn,1,tn);
      free_f3tensor(s->d_r,1,xn,1,yn,1,tn);
    }else if (strcmp(sform,"1d")==0){
      myfree(s->d1);
    }else{
      exit_error("RUN_INTERACTIVE","Bad sform");
    }
  }
}
void model_read_m(paramfile,arglist,narg,rm)
     char paramfile[];
     char **arglist;
     int narg;
     struct model_struct **rm;    
{
  int i;
  int *ulist;                
  struct model_struct *m;    
  m = (struct model_struct *)myalloc(sizeof(struct model_struct));
  m->marfile = NULL;
  m->action = -999;   
  if (is_suffix_string(paramfile,".mod")){
    m->ppl = paramfile_get_initial_params_update_only(paramfile,arglist,narg,
						      1);
    m->o = NULL;
  }else{
    m->ppl = NULL;
    m->o = paramfile_onode_file_read(paramfile,1);
    paramfile_onode_resolve(m->o,mylogf); 
    ulist = onode_update_from_slist(m->o,mylogf,arglist,narg);
    myfree(ulist);
  }
  strcpy(m->paramfile,paramfile);
  m->process_id = -1; 
  m->run_mode = 0;    
  if (m->ppl != NULL){
    for(i=0;i<narg;i+=2)
      if (!paramfile_test_param(m->ppl,arglist[i])){
	printf("  *** Parameter name:  %s\n",arglist[i]);
	exit_error("MODEL_READ_M","Command line param not found");
      }
  }else{
    for(i=0;i<narg;i+=2)
      if (!onode_test_ostr(m->o,arglist[i])){
	printf("  *** Parameter name:  %s\n",arglist[i]);
	exit_error("MODEL_READ_M","Command line param not found");
      }
  }
  *rm = m;
}
void model_read_description(paramfile,stimfile,respfile,arglist,narg,rm,rs,rr,
			    rulist)
     char paramfile[],stimfile[],respfile[];
     char **arglist;
     int narg;
     struct model_struct **rm;    
     struct stim_struct **rs;     
     struct response_struct **rr; 
     int **rulist;   
{
  int i;
  int *ulist;                
  struct model_struct *m;    
  struct stim_struct *s;     
  struct response_struct *r; 
  if (strcmp(stimfile,"NULL")==0){
    s = NULL;
  }else{
    s = (struct stim_struct *)myalloc(sizeof(struct stim_struct));
    s->ppl = paramfile_get_initial_params_update_only(stimfile,arglist,narg,1);
    strcpy(s->paramfile,stimfile);
    s->name = (char *)NULL;
    s->stimno = -1;
  }
  m = (struct model_struct *)myalloc(sizeof(struct model_struct));
  m->marfile = NULL;
  m->action = -999;   
  if (is_suffix_string(paramfile,".mod")){
    m->ppl = paramfile_get_initial_params_update_only(paramfile,arglist,narg,
						      1);
    m->o = NULL;
    ulist = get_zero_iarray(narg); 
  }else{
    m->ppl = NULL;
    m->o = paramfile_onode_file_read(paramfile,1);
    paramfile_onode_resolve(m->o,mylogf); 
    ulist = onode_update_from_slist(m->o,mylogf,arglist,narg);
  }
  strcpy(m->paramfile,paramfile);
  m->process_id = -1; 
  m->run_mode = 0;    
  m->nrun = 1;        
  m->vps = NULL;
  r = (struct response_struct *)myalloc(sizeof(struct response_struct));
  r->ppl = paramfile_get_initial_params_update_only(respfile,arglist,narg,1);
  strcpy(r->paramfile,respfile);
  r->ns = -1;      
  r->nf = -1;      
  r->tname = NULL; 
  if (m->ppl != NULL){
    for(i=0;i<narg;i+=2)
      if (!(paramfile_test_param(m->ppl,arglist[i])||
	    paramfile_test_param(s->ppl,arglist[i])||
	    paramfile_test_param(r->ppl,arglist[i]))){
	printf("  *** Parameter name:  %s\n",arglist[i]);
	exit_error("MODEL_READ_DESCRIPTION","Command line param not found");
      }
  }else{
    if (s != NULL){
      for(i=0;i<narg;i+=2)
	if (!(onode_test_ostr(m->o,arglist[i])||
	      paramfile_test_param(s->ppl,arglist[i])||
	      paramfile_test_param(r->ppl,arglist[i]))){
	  printf("  *** Parameter name:  %s\n",arglist[i]);
	  exit_error("MODEL_READ_DESCRIPTION","Command line param not found");
	}
    }else{
      for(i=0;i<narg;i+=2)
	if (!(onode_test_ostr(m->o,arglist[i])||
	      paramfile_test_param(r->ppl,arglist[i]))){
	  printf("  *** Parameter name:  %s\n",arglist[i]);
	  exit_error("MODEL_READ_DESCRIPTION","Command line param not found");
	}
    }
  }
  *rm = m; *rs = s; *rr = r;
  *rulist = ulist;
}
void model_main(paramfile,stimfile,respfile,arglist,narg)
     char paramfile[],stimfile[],respfile[];
     char **arglist;
     int narg;
{
  int i,k;
  int *parflag;               
  int sseed;                  
  struct model_struct *m;     
  struct stim_struct *s;      
  struct response_struct *r;  
  model_read_description(paramfile,stimfile,respfile,arglist,narg,&m,&s,&r,
			 &parflag);
  wm_prep_var_const_gen(m,s,mylogf,arglist,narg,parflag);
  wm_response_init(m,s,r,mylogf);
  sseed = param_geti_dflt(s->ppl,"stim_shuff_seed",0);
  if (m->vps != NULL){ 
    wm_moo_var_par_set(mylogf,m,0);
  }
  m->m_i = 0;
  wm_slave_action(m,s,r,0,mylogf);   
  if (m->run_mode == 0){
    for(i=0;i<m->nrun;i++){ 
      if (i > 0){  
	printf("  ________________________________________________________\n");
	printf("\n");
	wm_moo_var_par_set(mylogf,m,i); 
	m->m_i = i;
	wm_slave_action(m,s,r,0,mylogf);   
	r->tri = 0;  
	r->tsi = 0;
	r->tname = NULL;
      }
      if (sseed == 0)
	run_gen_tuning_curve(m,s,r);             
      else
	run_gen_tuning_curve_rand(m,s,r,sseed);  
      wm_slave_action(m,s,r,-1,mylogf);   
    }
    wm_write_response(m,s,r,mylogf,-1); 
  }else if (m->run_mode == 8){
    run_indefinite(m,s,r);        
  }else
    run_interactive(m,s,r);             
}
void model_mar(paramfile,marfile,arglist,narg)
     char paramfile[];
     char marfile[];
     char **arglist;
     int narg;
{
  struct model_struct *m;     
  struct stim_struct *s;      
  struct response_struct *r;  
  s = NULL;
  r = NULL;
  model_read_m(paramfile,arglist,narg,&m);
  m->marfile = marfile;
  wm_slave_action(m,s,r,10,mylogf);   
}
void model_rsp_gen(paramfile,respfile,outfile,arglist,narg)
     char paramfile[];
     char respfile[];    
     char outfile[];     
     char **arglist;
     int narg;
{
  struct model_struct *m;     
  struct stim_struct *s;      
  struct response_struct *r;  
  s = NULL;
  model_read_m(paramfile,arglist,narg,&m);
  r = (struct response_struct *)myalloc(sizeof(struct response_struct));
  strcpy(r->paramfile,respfile);
  r->ppl = NULL;
  r->tname = NULL;
  r->ns = r->nf = -1;
  m->marfile = outfile; 
  wm_slave_action(m,s,r,20,mylogf);   
}
int main(argc,argv)
     int argc;
     char *argv[];
{
  int fnum,snum;
  char infile[SLEN],outfile[SLEN],option[SLEN],marfile[SLEN];
  char paramfile[SLEN],paramfile2[SLEN],stimfile[SLEN],respfile[SLEN];
  if (argc == 1){
    printf("\n  wm <option>\n");
    printf("    where <option> is\n");
    printf("      mod <model_file> <stimfile> <respfile>");
    printf(" [<pname> <pval> ...]\n");
    printf("      modm <model_file> <stimfile> <respfile>");
    printf(" [<pname> <pval> ...]\n");
    printf("      diff <model_file_1> <model_file_2>\n");
    printf("      write_3d_stim <stim_file> <outfile> <stim_num> ");
    printf("[<pname> <pval> ...]\n");
    printf("      write_3d_stim_ppm <stimfile> <outfile> ");
    printf("[<pname> <pval>..]\n");
    printf("      write_fst <stim_file> <outfile> <stim_num> ");
    printf("[<pname> <pval> ...]\n");
    printf("      write_2d_stim_frame <stim_file> <outfile> <stim_num> ");
    printf(" <frame_num> [<pname> <pval> ...]\n");
    printf("      conn2txt <infile> <outfile>\n");
    printf("      mar <model_file> <outfile>");
    printf(" [<pname> <pval> ...]\n");
    printf("      rsp_gen <model_file> <rsp_gen_file> <outfile>");
    printf(" [<pname> <pval> ...]\n");
    printf("\n");
    printf("  Size of pop_cell struct  %ld bytes\n",sizeof(struct pop_cell));
    printf("  Size of pop_syn  struct  %ld bytes\n",sizeof(struct pop_syn));
    printf("\n");
    printf("  Version 1.0.0\n");
    printf("\n");
    exit(0);
  }
  printf("\nWM.C\n");
  strcpy(option,argv[1]);
  if (strcmp(option,"mod")==0){
    strcpy(paramfile,argv[2]);
    strcpy(stimfile,argv[3]);
    strcpy(respfile,argv[4]);
    model_main(paramfile,stimfile,respfile,&(argv[5]),argc-5);
  }else if (strcmp(option,"mar")==0){
    strcpy(paramfile,argv[2]);
    strcpy(marfile,argv[3]);
    model_mar(paramfile,marfile,&(argv[4]),argc-4);
  }else if (strcmp(option,"rsp_gen")==0){
    strcpy(paramfile,argv[2]);
    strcpy(respfile,argv[3]);
    strcpy(marfile,argv[4]);
    model_rsp_gen(paramfile,respfile,marfile,&(argv[4]),argc-5);
  }else if (strcmp(option,"modm")==0){
    printf("<br>\n<pre>\n");
    mctrl_util_determine_dir_structure();
    mctrl_util_report_pid_run();
    strcpy(paramfile,argv[2]);
    strcpy(stimfile,argv[3]);
    strcpy(respfile,argv[4]);
    model_main(paramfile,stimfile,respfile,&(argv[5]),argc-5);
  }else if (strcmp(option,"diff")==0){
    strcpy(paramfile,argv[2]);
    strcpy(paramfile2,argv[3]);
    paramfile_read_diff(paramfile,paramfile2);
  }else if (strcmp(option,"write_2d_stim_frame")==0){
    strcpy(infile,argv[2]);
    strcpy(outfile,argv[3]);
    snum = atoi(argv[4]);
    fnum = atoi(argv[5]);
    wm_write_3d_stim(infile,outfile,&(argv[6]),argc-6,snum,fnum,0);
  }else if (strcmp(option,"write_3d_stim")==0){
    strcpy(infile,argv[2]);
    strcpy(outfile,argv[3]);
    snum = atoi(argv[4]);
    wm_write_3d_stim(infile,outfile,&(argv[5]),argc-5,snum,-1,0);
  }else if (strcmp(option,"write_fst")==0){
    strcpy(infile,argv[2]);
    strcpy(outfile,argv[3]);
    snum = atoi(argv[4]);
    wm_write_3d_stim(infile,outfile,&(argv[5]),argc-5,snum,-1,1);
  }else if (strcmp(option,"write_3d_stim_ppm")==0){
    strcpy(infile,argv[2]);
    strcpy(outfile,argv[3]);
    wm_write_stim_ppm_files(infile,outfile,&(argv[4]),argc-4,-1);
  }else if (strcmp(option,"conn2txt")==0){
    strcpy(infile,argv[2]);
    strcpy(outfile,argv[3]);
    mod_conn_conn_to_text(mylogf,infile,outfile);
  }else
    printf("  *** Unknown option.\n");
  printf("\n");
  return 0;
}
