/*C  (C) Copyright  Wyeth Bair 1993-2010                                     */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "my_util.h"
#include "nr_util.h"
#include "iarray_util.h"
#include "farray_util.h"
#include "carray_util.h"
#include "myrand_util.h"
#include "data_util.h"
#include "paramfile_util.h"
#include "fft_util.h"
#include "sig_util.h"
#include "kernel_util.h"
#include "stim_util.h"
#include "mod_util.h"
#include "pop_cell_util.h"  
#include "mod_conn_util.h"  
#include "pop_util.h"       
#include "ifc_util.h"
#include "mod.h"            
#include "ifc.h"            
#include "paramfile.h"      
int ORIG_FLAG = 0;  
static int myid = -1;         
static char *mylogf = NULL;   
char ggstr[LONG_SLEN];        
struct mod_me_fstruct{
  struct onode *fo; 
  int flag;         
  float ***f;       
  float **s;        
  float ***r;       
  float normc;      
};
struct mod_me_noise{
  char *type;      
  float mu;        
  float sd;        
  float tsd;       
  int seed;        
  int sflag;       
  int nseed;       
  int *seedlist;   
  int currseed;    
};
struct mod_mem{
  int nf;             
  float *theta;       
  float *ssd;         
  float *sf;          
  float *tsd;         
  float *tf;          
  float *scale;       
  float *****f;       
  float ****fs;       
  float *****r;       
  float wf;           
  int dumpflag;       
  int nr;             
  int *xi,*yi;        
  float ***mp;        
  float ***ma;        
};
struct mod_mem *mod_me_mem; 
float ***mod_reich_lp;      
float ***mod_reich_hp;      
float  **mod_reich_lp_s;    
float  **mod_reich_hp_s;    
float ***mod_reich_rlp = NULL;   
float ***mod_reich_rhp = NULL;   
int      mod_reich_uxn;     
int      mod_reich_uyn;     
int      mod_reich_ux0;     
int      mod_reich_uy0;     
int      mod_reich_dx;      
int      mod_reich_dy;      
int      mod_reich_dump;    
int      mod_rd_2gabor_dti;  
int      mod_rd_2gabor_rect; 
int mod_me_fre = 0;                        
int mod_me_fn = 0;                         
struct mod_me_fstruct **mod_me_ff = NULL;  
char *mod_me_binoc_rsign = NULL;   
int   mod_me_binoc_srect;          
float mod_me_binoc_sthresh;        
float mod_me_binoc_athresh;        
char *mod_me_binoc_nonlin = NULL;  
int      me_xflag = 0;      
float ***mod_me_fpe = NULL; 
float ***mod_me_fpo = NULL;
float ***mod_me_fpx = NULL; 
float ***mod_me_fne = NULL;
float ***mod_me_fno = NULL;
float ***mod_me_fnx = NULL; 
float ***mod_me_fg0 = NULL; 
float ***mod_me_fg1 = NULL;
float  **mod_me_fpe_s; 
float  **mod_me_fpo_s;
float  **mod_me_fpx_s; 
float  **mod_me_fne_s;
float  **mod_me_fno_s;
float  **mod_me_fnx_s; 
float  **mod_me_fg0_s;
float  **mod_me_fg1_s;
float ***mod_me_rpe = NULL;   
float ***mod_me_rpo = NULL;
float ***mod_me_rpx = NULL; 
float ***mod_me_rne = NULL;
float ***mod_me_rno = NULL;
float ***mod_me_rnx = NULL; 
float ***mod_me_rg0 = NULL;
float ***mod_me_rg1 = NULL;
float mod_me_sscale;
float mod_me_tscale;
int   mod_me_xn;
int   mod_me_yn;
int   mod_me_tn;
char *mod_me_modtype;           
char *mod_me_filt;              
float mod_me_tdelay    = 0.0;   
int   mod_me_oppflag   = 0;     
float mod_me_opp_w     = 1.0;   
float mod_me_pow       = 1.0;   
int   mod_me_normflag  = 0;     
int   mod_me_norm_app  = 1;     
float mod_me_norm_pow  = 1.0;   
float mod_me_norm_c    = 1.0;   
float mod_me_norm_f    = 1.0;   
float mod_me_norm_xn   = 1;     
float mod_me_norm_tsd  = 0.0;   
float mod_me_norm_toff = 0.0;   
int mod_me_stimno_prev = -2;    
struct mod_me_v1resp{
  float ***raw;   
  float  **me;    
  float   *sum;   
  float ***norm;  
  float ***opp;   
  float ***bde;   
  float   *mt;    
};
struct mod_me_v1_input{
  int                   flag;   
  struct mod_me_v1resp *dl;     
  struct mod_me_v1resp *dr;     
  float                *mtb;    
};
struct mod_me_v5_pop{
  float ***ssum;      
  float ***nl;        
  int    **seed;      
  int      nsamp;     
  int      stackflag; 
  float  *w;          
  float  *w_r;        
  float   r_bias;     
  char   *nl_type;    
  float   nl_a;       
  float   nl_b;       
};
struct mod_me_v5_struct{
  int     binoc;    
  int     n;        
  float  *w;        
  float  *w_r;      
  float   alph1;    
  float   alph2;    
  float   alph3;    
  float   alph4;    
  float   v1_opp_w; 
  int     v1_recto; 
  float   L;        
  float   v1_bin_w; 
  float   v1_mix_f; 
  char   *v1_mix_s; 
  float   mt_a;     
  float   mt_b;     
  float   bin_hack; 
  int     v1_dflag; 
  int     v1_dnorm; 
  int     v1_nc;    
  struct mod_me_v1_input ***v1resp;  
  float  *mt_raw;   
  float  *mt_raw_l; 
  float  *mt_raw_r; 
  float  *mt_norm;  
  int mtli0;           
  int mt_npop;         
  struct mod_me_v5_pop **mtp;  
  struct mod_me_noise *noise_v1_out;
};
struct mod_me_v5_struct *mod_me_v5;
struct pop_top *mod_me_mpt;          
int mod_me_tsi;     
float mod_me_util_bar_resp(xt,xn,tn,bx0,bxn,bt0)
     float **xt;      
     int xn,tn;       
     int bx0,bxn;     
     int bt0;         
{
  int i;
  int bx1;
  float r;
  if ((bt0 < 0) || (bt0 >= tn))
    return 0.0;
  bx1 = bx0 + bxn - 1;  
  if (bx0 < 0)
    bx0 = 0;
  if (bx1 >= xn)
    bx1 = xn - 1;
  r = 0.0;
  for(i=bx0;i<=bx1;i++)
    r += xt[i][bt0];
  return r;
}
void mod_me_util_bar_sim(xte,xto,xn,tn)
     float **xte,**xto;
     int xn,tn;
{
  int i,j,k;
  int dn,ntot,dt,bwid,dx,dx2,bx0;
  float *xdata,*tww,*tbb,*twb,*tbw,b1,b2,b1o,b2o;
  write_2d_data("zzz.e.2d",xte,0,0,xn,tn,4,2,0,0);
  write_2d_data("zzz.o.2d",xto,0,0,xn,tn,4,2,0,0);
  dn = 2*xn - 1;
  dt = 5;    
  bwid = 16;  
  tww = get_zero_farray(dn);
  tbb = get_zero_farray(dn);
  twb = get_zero_farray(dn);
  tbw = get_zero_farray(dn);
  xdata = get_zero_farray(dn);
  ntot = 0;
  for(i=0;i<dn;i++){  
    dx = i - (dn-1)/2;  
    dx2 = (int)(dx/2);  
    xdata[i] = (float)dx;
    for(j=0;j<xn;j++){  
      bx0 = j-dx2;  
      for(k=(tn/2 - dt/2-1);k<=(tn/2 - dt/2);k++){  
	b1 = mod_me_util_bar_resp(xte,xn,tn,bx0,bwid,k);
	b2 = mod_me_util_bar_resp(xte,xn,tn,bx0+dx,bwid,k+dt);
	b1o = mod_me_util_bar_resp(xto,xn,tn,bx0,bwid,k);
	b2o = mod_me_util_bar_resp(xto,xn,tn,bx0+dx,bwid,k+dt);
	tww[i] += ( b1 + b2) * ( b1 + b2);
	tbb[i] += (-b1 - b2) * (-b1 - b2);
	twb[i] += ( b1 - b2) * ( b1 - b2);
	tbw[i] += (-b1 + b2) * (-b1 + b2);
	ntot += 1;
      }
    }
  }
  append_farray_xy_plot("zz.tune.pl",xdata,tww,dn,"W_W");
  append_farray_xy_plot("zz.tune.pl",xdata,tbb,dn,"B_B");
  append_farray_xy_plot("zz.tune.pl",xdata,twb,dn,"W_B");
  append_farray_xy_plot("zz.tune.pl",xdata,tbw,dn,"B_W");
}
void mod_me_get_quad_opp_k(mo,fo,rpe,rpo,rne,rno,rnc)
     struct onode *mo;
     struct onode *fo;
     float ****rpe,****rpo,****rne,****rno;
     float *rnc;  
{
  int xn,yn,tn,write_filt;
  float ssd,tsd,sf,tf,theta;
  char *tfilt;
  xn = mod_me_xn;
  yn = mod_me_yn;
  tn = mod_me_tn;
  theta = onode_getpar_flt_exit(fo,"direction");
  sf    = onode_getpar_flt_exit(fo,"sf");
  ssd   = onode_getpar_flt_exit(fo,"ssd");
  tfilt = onode_getpar_chr_exit(mo,"me_tfilt");
  if ((strcmp(tfilt,"gaussian")==0)||(strcmp(tfilt,"maxwell")==0)){
    tsd   = onode_getpar_flt_exit(fo,"tsd");
    tf    = onode_getpar_flt_exit(fo,"tf");
    get_quad_opponent_gabor(xn,yn,tn,mod_me_sscale,
			    mod_me_tscale,ssd,tsd,sf,tf,theta,tfilt,
			    rpe,rpo,rne,rno);
    write_filt = onode_getpar_int_dflt(fo,"write_filter",-1);
    if ((write_filt == 1)||(write_filt == 5))
      write_3d_data_part("zzz.fpe.3d",*rpe,1,xn,1,yn,1,tn,4,2,1);
    if ((write_filt == 2)||(write_filt == 5))
      write_3d_data_part("zzz.fpo.3d",*rpo,1,xn,1,yn,1,tn,4,2,1);
    if ((write_filt == 3)||(write_filt == 5))
      write_3d_data_part("zzz.fne.3d",*rne,1,xn,1,yn,1,tn,4,2,1);
    if ((write_filt == 4)||(write_filt == 5))
      write_3d_data_part("zzz.fno.3d",*rno,1,xn,1,yn,1,tn,4,2,1);
    *rnc = ssd*10.0 * ssd*10.0 * tsd*10.0;
  }else{
    mylog_exit(mylogf,"MOD_ME_GET_QUAD_OPP_K  unknown 'me_tfilt' value\n");
  }
  myfree(tfilt);
}
void mod_me_get_quad_opp_filters(mppl,rpe,rpo,rne,rno)
     struct param_pair_list *mppl;
     float ****rpe,****rpo,****rne,****rno;
{
  int n1,n2,xn,yn,tn;
  int wrflag,tilt_flag;
  float k,ssd,tsd,sf,tf,sscale,tscale,theta,shift_frac,ph;
  char *tfilt;
  sscale = paramfile_get_float_param_or_exit(mppl,"sscale");
  tscale = paramfile_get_float_param_or_exit(mppl,"tscale");
  xn = paramfile_get_int_param_or_exit(mppl,"xn");
  yn = paramfile_get_int_param_or_exit(mppl,"yn");
  tn = paramfile_get_int_param_or_exit(mppl,"tn");
  tilt_flag = paramfile_get_int_param_default(mppl,"me_tilt",0);
  if (tilt_flag == 1)
    shift_frac = paramfile_get_float_param_default(mppl,"me_tilt_frac",1.0);
  ph = paramfile_get_float_param_default(mppl,"me_phase_shift",90.0);
  mod_me_sscale = sscale;
  mod_me_tscale = tscale;
  mod_me_xn = xn;
  mod_me_yn = yn;
  mod_me_tn = tn;
  tfilt = NULL; 
  if ((strcmp(mod_me_modtype,"gabor_comp")==0)){
    ;
  }else if ((strcmp(mod_me_modtype,"me_ab_01")==0)){
    theta = paramfile_get_float_param_or_exit(mppl,"me_theta");
    sf = paramfile_get_float_param_or_exit(mppl,"me_sf");
    ssd = paramfile_get_float_param_or_exit(mppl,"me_ssd");
  }else{
    theta = paramfile_get_float_param_or_exit(mppl,"me_theta");
    sf = paramfile_get_float_param_or_exit(mppl,"me_sf");
    ssd = paramfile_get_float_param_or_exit(mppl,"me_ssd");
    tfilt = paramfile_get_char_param_default(mppl,"me_tfilt","gaussian");
  }
  if ((strcmp(mod_me_modtype,"me_gabor_01")==0) ||
      (strcmp(mod_me_modtype,"ds_liv3")==0) ||
      (strcmp(mod_me_modtype,"ds_simp_01")==0)){
    tsd = paramfile_get_float_param_or_exit(mppl,"gabor_tsd");
    tf = paramfile_get_float_param_or_exit(mppl,"gabor_tf");
    if (tilt_flag == 0){
      if (ph != 90.0){
	get_arb_opponent_gabor(xn,yn,tn,sscale,tscale,ssd,tsd,sf,tf,theta,
			       tfilt,ph,rpe,rpo,rne,rno);
      }else{
	get_quad_opponent_gabor(xn,yn,tn,sscale,tscale,ssd,tsd,sf,tf,theta,
				tfilt,rpe,rpo,rne,rno);
      }
    }else if (tilt_flag == 1){ 
      get_quad_opp_tilt_gabor(xn,yn,tn,sscale,tscale,ssd,tsd,sf,tf,theta,tfilt,
			      shift_frac,0,rpe,rpo,rne,rno);
    }else if (tilt_flag == 2){  
      get_quad_opp_tilt_gabor(xn,yn,tn,sscale,tscale,ssd,tsd,sf,tf,theta,tfilt,
			      0.0,1,rpe,rpo,rne,rno);
    }
  }else if (strcmp(mod_me_modtype,"me_ab_01")==0){
    n1 = paramfile_get_int_param_or_exit(mppl,"me_ab_n1");
    n2 = paramfile_get_int_param_or_exit(mppl,"me_ab_n2");
    k = paramfile_get_float_param_or_exit(mppl,"me_ab_k");
    wrflag = paramfile_get_int_param_default(mppl,"model_write_tfilt",0);
    quad_opponent_causal_stf3d_01_tensor(xn,yn,tn,sscale,tscale,ssd,sf,n1,n2,k,
					 theta,rpo,rpe,rno,rne,wrflag);
  }else if (strcmp(mod_me_modtype,"gabor_comp")==0){
    get_quad_gabor(mppl,NULL,xn,yn,tn,sscale,tscale,rpe,rpo);
  }else
    exit_error("ME_MOD_GET_QUAD_OPP_FILTERS","Unknown model type");
  if (tfilt != NULL)
    myfree(tfilt);
}
struct mod_me_fstruct **mod_me_fs_create(fn)
     int fn;
{
  int i;
  struct mod_me_fstruct **fs;
  fs = (struct mod_me_fstruct **)myalloc(fn*sizeof(struct mod_me_fstruct *));
  for(i=0;i<fn;i++){
    fs[i] = (struct mod_me_fstruct *)myalloc(sizeof(struct mod_me_fstruct));
    fs[i]->flag = 1;
    fs[i]->fo = NULL;
    fs[i]->f = NULL;
    fs[i]->s = NULL;
    fs[i]->r = NULL;
    fs[i]->normc = -1.0;
  }
  return fs;
}
void mod_me_get_filt_work(fo,xn,yn,tn,sscale,tscale,sdo,sf,theta,tf_off,
			  tfilt,ph,tilt_flag,shift_frac,rpe,rpo,rne,rno)
     struct onode *fo;
     int xn,yn,tn;
     float sscale,tscale;
     float sdo,sf,theta;
     float tf_off;           
     char *tfilt;
     float ph;
     char *tilt_flag;
     float shift_frac;
     float ****rpe,****rpo,****rne,****rno;
{
  char *ftype;
  float tsd,tf;
  ftype = onode_getpar_chr_dflt(fo,"type","none");
  if (strcmp(ftype,"Gabor_curve_t")!=0){  
    tsd = onode_getpar_flt_exit(fo,"tsd");
    tf  = onode_getpar_flt_exit(fo,"tf");
  }
  if (strcmp(tilt_flag,"none")==0){
    if (ph != 90.0){
      get_arb_opponent_gabor(xn,yn,tn,sscale,tscale,sdo,tsd,sf,tf,theta,
			     tfilt,ph,rpe,rpo,rne,rno);
    }else{
      if (strcmp(ftype,"Gabor_curve_t")==0){
	get_quad_opponent_gabor_tshift(mylogf,fo,xn,yn,tn,sscale,tscale,
				       rpe,rpo,rne,rno);
      }else{
	get_quad_opponent_gabor(xn,yn,tn,sscale,tscale,sdo,tsd,sf,tf+tf_off,
				theta,tfilt,rpe,rpo,rne,rno);
      }
    }
  }else if (strcmp(tilt_flag,"shift")==0){ 
    get_quad_opp_tilt_gabor(xn,yn,tn,sscale,tscale,sdo,tsd,sf,tf,theta,
			    tfilt,shift_frac,0,rpe,rpo,rne,rno);
  }else if (strcmp(tilt_flag,"rotate")==0){ 
    get_quad_opp_tilt_gabor(xn,yn,tn,sscale,tscale,sdo,tsd,sf,tf,theta,
			    tfilt,0.0,1,rpe,rpo,rne,rno);
  }
}
void mod_me_prep_basic(mo,rss,rts,rxn,ryn,rtn)
     struct onode *mo;
     float *rss;        
     float *rts;        
     int *rxn;          
     int *ryn;          
     int *rtn;          
{
  mod_me_modtype        = onode_getpar_chr_exit(mo,"mod_type");
  *rss = mod_me_sscale  = onode_getpar_flt_exit(mo,"sscale");
  *rts = mod_me_tscale  = onode_getpar_flt_exit(mo,"tscale");
  *rxn = mod_me_xn      = onode_getpar_int_exit(mo,"xn");
  *ryn = mod_me_yn      = onode_getpar_int_exit(mo,"yn");
  *rtn = mod_me_tn      = onode_getpar_int_exit(mo,"tn");
}
void mod_me_filt_template(fi,zn,rfx,rfy,rfw,rfn)
     int fi;
     int zn;           
     int   ***rfx;     
     int   ***rfy;     
     float ***rfw;     
     int    **rfn;     
{
  int i,j,k;
  int zi,xn,yn,tn,minx,miny,mint,maxx,maxy,maxt,ti,n;
  int **tmplt,**fx,**fy,*fn;
  float ***f,vmin,vmax,z,amax,**fw,v11;
  xn = mod_me_xn;
  yn = mod_me_yn;
  tn = mod_me_tn;
  fx = (int **)myalloc(zn*sizeof(int *));
  fy = (int **)myalloc(zn*sizeof(int *));
  fw = (float **)myalloc(zn*sizeof(float *));
  fn = (int *)myalloc(zn*sizeof(int));
  for(zi=0;zi<zn;zi++){
    if (zn == 1)
      f = mod_me_ff[fi]->f;
    else
      f = mod_me_ff[zi]->f;  
    get_min_max_coord_3d_farray(f,1,xn,1,yn,1,tn,&minx,&miny,&mint,
				&maxx,&maxy,&maxt);
    vmin = f[minx][miny][mint];
    vmax = f[maxx][maxy][maxt];
    if (vmax > -vmin){
      ti = maxt;
      amax = fabs(vmax);
    }else{
      ti = mint;
      amax = fabs(vmin);
    }
    tmplt = get_zero_2d_iarray(xn,yn);
    n = 0; 
    for(i=0;i<xn;i++){
      for(j=0;j<yn;j++){
	z = fabs(f[i+1][j+1][ti]) / amax;
	if (z > 0.02){
	  tmplt[i][j] = 1;
	  n += 1;
	}
      }
    }
    fx[zi] = (int *)myalloc(n*sizeof(int));
    fy[zi] = (int *)myalloc(n*sizeof(int));
    fw[zi] = (float *)myalloc(n*sizeof(float));
    fn[zi] = n;
    k = 0;
    for(i=0;i<xn;i++){
      for(j=0;j<yn;j++){
	if (tmplt[i][j] == 1){
	  fx[zi][k] = i;
	  fy[zi][k] = j;
	  v11 = f[i+1][j+1][ti] / amax;  
	  fw[zi][k] = 0.5*(1.0 + v11);       
	  k += 1;
	}
      }
    }
    free_2d_iarray(tmplt,xn);
  }
  *rfx = fx;
  *rfy = fy;
  *rfw = fw;
  *rfn = fn;
}
struct mod_me_fstruct **mod_me_get_quad_opp_filters_o(mo,rpe,rpo,rpx,rne,
						      rno,rnx,rfn)
     struct onode *mo;
     float ****rpe,****rpo,****rpx,****rne,****rno,****rnx;
     int *rfn;
{
  int n1,n2,xn,yn,tn;
  int wrflag,seed,phopp,qsopp,ndir;
  float k,sdo,sdp,tsd,sf,tf,sscale,tscale,theta,shift_frac,ph,nsd_r,nsd_t;
  float binoc_shift,phas,quadshift,pwr,phase1,tf_off;
  char *tfilt,*tilt_flag,*ftype;
  struct onode *fo,*v1o;
  int i;
  int fn;  
  struct mod_me_fstruct **fs;  
  sscale = mod_me_sscale;
  tscale = mod_me_tscale;
  xn = mod_me_xn;
  yn = mod_me_yn;
  tn = mod_me_tn;
  fs = NULL;
  phopp = onode_getpar_int_dflt(mo,"phase_shift_opp",0);
  qsopp = onode_getpar_int_dflt(mo,"quad_shift_opp",0);
  fo = onode_child_get_unique(mo,"filter");
  ftype = onode_getpar_chr_dflt(fo,"type","none");
  tilt_flag = onode_getpar_chr_dflt(fo,"tilt_type","none");
  if (strcmp(tilt_flag,"shift")==0)
    shift_frac = onode_getpar_int_dflt(fo,"tilt_frac",1.0);
  ph = onode_getpar_flt_dflt(fo,"phase_shift",90.0);
  if (qsopp == 0)
    quadshift = 90.0;
  else
    quadshift = -90.0;
  tfilt = NULL; 
  if (strcmp(mod_me_modtype,"gabor_comp")==0){
    ;
  }else if (strcmp(mod_me_modtype,"rd_2gabor")==0){
      float dtsec;
      dtsec = onode_getpar_flt_exit(fo,"dt_even");  
      mod_rd_2gabor_dti = dtsec / mod_me_tscale;
      mod_rd_2gabor_rect = onode_getpar_int_exit(fo,"rectify");  
  }else if ((strcmp(mod_me_modtype,"me_ab_01")==0)){
    theta = onode_getpar_flt_exit(fo,"direction");
    sf = onode_getpar_flt_exit(fo,"sf");
    sdo = onode_getpar_flt_exit(fo,"ssd");
  }else if ((strcmp(mod_me_modtype,"random_filter")==0)){
    mylog(mylogf,"  (mod_me_util) - random filter\n");
    sdo = onode_getpar_flt_exit(fo,"ssd");
  }else if (strcmp(ftype,"Gabor_CWQ")==0){
    ;
  }else{
    if (strcmp(mod_me_modtype,"me_v5")==0)
      theta = 0.0;  
    else
      theta = onode_getpar_flt_exit(fo,"direction");
    sf = onode_getpar_flt_exit(fo,"sf");
    if (onode_get_item_child(fo,"ssd") != NULL){
      sdo = onode_getpar_flt_exit(fo,"ssd");
      sdp = sdo;
    }else{
      sdo = onode_getpar_flt_exit(fo,"sd_orth");
      sdp = onode_getpar_flt_exit(fo,"sd_par");
    }
    tfilt = onode_getpar_chr_dflt(fo,"tfilt","gaussian");
  }
  if ((strcmp(mod_me_modtype,"binoc_filter")==0)){
    if (strcmp(ftype,"Gabor")==0){
      tf_off = onode_getpar_flt_dflt(mo,"tf_offset",0.0);
      binoc_shift = onode_getpar_flt_exit(mo,"phase_shift");
      tsd = onode_getpar_flt_exit(fo,"tsd");
      tf  = onode_getpar_flt_exit(fo,"tf");
      phase1  = onode_getpar_flt_dflt(fo,"phase",0.0);
      phas = phase1;
      *rpe = gabor_space_time_tensor(xn,yn,tn,sscale,tscale,sdo,sdp,tsd,
				     sf,tf,theta,phas,tfilt);
      phas = phase1 + quadshift; 
      *rpo = gabor_space_time_tensor(xn,yn,tn,sscale,tscale,sdo,sdp,tsd,
				     sf,tf,theta,phas,tfilt);
      phas = phase1 + binoc_shift;
      *rne = gabor_space_time_tensor(xn,yn,tn,sscale,tscale,sdo,sdp,tsd,
				     sf,tf+tf_off,theta,phas,tfilt);
      if (phopp == 0){
	phas = phase1 + binoc_shift + quadshift;
      }else if (phopp == 1){
	phas = phase1 - binoc_shift + quadshift;
      }else
	exit_error("ME_MOD_GET_QUAD_OPP_FILTERS_O","Bad phase_shift_opp val");
      *rno = gabor_space_time_tensor(xn,yn,tn,sscale,tscale,sdo,sdp,tsd,
				     sf,tf+tf_off,theta,phas,tfilt);
    }else if (strcmp(ftype,"Gabor_CWQ")==0){
      bde_cwq_stf3d_tensor(fo,mo,xn,yn,tn,sscale,tscale,rpe,rne,rpo,rno);
    }
    fn = 4;
  }else if ((strcmp(mod_me_modtype,"me_gabor_01")==0) ||
	    (strcmp(mod_me_modtype,"ds_liv3")==0) ||
	    (strcmp(mod_me_modtype,"ds_simp_01")==0)){
    mod_me_get_filt_work(fo,xn,yn,tn,sscale,tscale,sdo,sf,theta,0.0,
			 tfilt,ph,tilt_flag,shift_frac,rpe,rpo,rne,rno);
    fn = 4;
  }else if (strcmp(mod_me_modtype,"random_filter")==0){
    nsd_r = onode_getpar_flt_exit(fo,"noise_ssd");
    nsd_t = onode_getpar_flt_exit(fo,"noise_tsd");
    seed  = onode_getpar_int_exit(fo,"noise_seed");
    tsd = onode_getpar_flt_exit(fo,"tsd");
    if (me_xflag == 0){
      get_opponent_random(xn,yn,tn,sscale,tscale,sdo,tsd,nsd_r,nsd_t,seed,
			  rpe,rpo,rne,rno);
      fn = 4;
    }else{
      get_opponent_random_x(xn,yn,tn,sscale,tscale,sdo,tsd,nsd_r,nsd_t,seed,
			    rpe,rpo,rpx,rne,rno,rnx);
      fn = 6;
    }
  }else if (strcmp(mod_me_modtype,"me_ab_01")==0){
    n1 = onode_getpar_int_exit(fo,"ab_n1");
    n2 = onode_getpar_int_exit(fo,"ab_n2");
    k  = onode_getpar_flt_exit(fo,"ab_k");
    wrflag = onode_getpar_int_dflt(fo,"write_tfilt",0);
    quad_opponent_causal_stf3d_01_tensor(xn,yn,tn,sscale,tscale,sdo,sf,n1,n2,
					 k,theta,rpo,rpe,rno,rne,wrflag);
    fn = 4;
  }else if ((strcmp(mod_me_modtype,"gabor_comp")==0) ||
	    (strcmp(mod_me_modtype,"rd_2gabor")==0)){
    get_quad_gabor(NULL,fo,xn,yn,tn,sscale,tscale,rpe,rpo);
    fn = 2;
  }else if (strcmp(mod_me_modtype,"me_v5")==0){
    v1o = onode_child_get_unique(mo,"v1");
    ndir = onode_getpar_int_exit(v1o,"n_dir_chan");
    tf_off = onode_getpar_flt_dflt(v1o,"tf_offset",0.0);  
    if (tf_off != 0.0)
      mod_me_fre = 1;  
    if (mod_me_fre == 0)
      fn = ndir * 2;  
    else{
      fn = ndir * 4;  
    }
    fs = mod_me_fs_create(fn);
    for(i=0;i<ndir/2;i++){
      theta = (float)i * 360.0 / (float)ndir;
      mod_me_get_filt_work(fo,xn,yn,tn,sscale,tscale,sdo,sf,theta,0.0,
			   tfilt,ph,tilt_flag,shift_frac,rpe,rpo,rne,rno);
      fs[i*4  ]->f = *rpe;
      fs[i*4+1]->f = *rpo;
      fs[i*4+2]->f = *rne;
      fs[i*4+3]->f = *rno;
    }
    if (mod_me_fre == 1){  
      for(i=0;i<ndir/2;i++){
	theta = (float)i * 360.0 / (float)ndir;
	mod_me_get_filt_work(fo,xn,yn,tn,sscale,tscale,sdo,sf,theta,tf_off,
			     tfilt,ph,tilt_flag,shift_frac,rpe,rpo,rne,rno);
	fs[i*4   + ndir*2]->f = *rpe;
	fs[i*4+1 + ndir*2]->f = *rpo;
	fs[i*4+2 + ndir*2]->f = *rne;
	fs[i*4+3 + ndir*2]->f = *rno;
      }
    }
  }else
    exit_error("MOD_ME_GET_QUAD_OPP_FILTERS_O","Unknown model type");
  if (tfilt != NULL)
    myfree(tfilt);
  if (ftype != NULL)  
    myfree(ftype);
  if (tilt_flag != NULL)
    myfree(tilt_flag);
  if (fs == NULL){
    fs = mod_me_fs_create(fn);
    if (fn == 2){
      fs[0]->f = *rpe;
      fs[1]->f = *rpo;
    }else if (fn == 4){
      fs[0]->f = *rpe;
      fs[1]->f = *rpo;
      fs[2]->f = *rne;
      fs[3]->f = *rno;
    }else if (fn == 6){
      fs[0]->f = *rpe;
      fs[1]->f = *rpo;
      fs[2]->f = *rpx;
      fs[3]->f = *rne;
      fs[4]->f = *rno;
      fs[5]->f = *rnx;
    }else{
      exit_error("MOD_ME_GET_QUAD_OPP_FILTERS_O","Unknown 'fn' value");
    }
  }
  *rfn = fn;
  return fs;
}
void mod_me_get_norm_filters(mppl,o,rg0,rg1)
     struct param_pair_list *mppl;
     struct onode *o;
     float ****rg0,****rg1;
{
  int xn,yn,tn,tabn,normtype,pflag,hilbert,t0flag;
  float sscale,tscale,sig1,sig2,amp1,amp2,tsig,tabk,csdt,csx,csy,tcent;
  float ***g0,***g1,sump,sumn,c,sum,toff;
  char *outfile;
  normtype = paramfile_get_int_param_or_exit(mppl,"me_norm_type");
  sscale = paramfile_get_float_param_or_exit(mppl,"sscale");
  tscale = paramfile_get_float_param_or_exit(mppl,"tscale");
  xn = paramfile_get_int_param_or_exit(mppl,"xn");
  yn = paramfile_get_int_param_or_exit(mppl,"yn");
  tn = paramfile_get_int_param_or_exit(mppl,"tn");
  sig1 = paramfile_get_float_param_or_exit(mppl,"me_dog_sig1");
  sig2 = paramfile_get_float_param_or_exit(mppl,"me_dog_sig2");
  amp1 = paramfile_get_float_param_or_exit(mppl,"me_dog_amp1");
  amp2 = paramfile_get_float_param_or_exit(mppl,"me_dog_amp2");
  tsig = paramfile_get_float_param_or_exit(mppl,"me_dog_tsig");
  tabk = paramfile_get_float_param_or_exit(mppl,"me_dog_tab_k");
  tabn =   paramfile_get_int_param_or_exit(mppl,"me_dog_tab_n");
  csdt = paramfile_get_float_param_or_exit(mppl,"me_dog_cs_delay");
  if (normtype == 1){
    csx = csy = 0.0;
    tcent = 0.0;      
    outfile = NULL;
    pflag = 0;
    t0flag = 1;       
    hilbert = 0;
    toff = mod_me_norm_toff;
    exit_error("MOD_ME_GET_NORM_FILTERS","WYETH - broken, can't send tabk/n");
    mod_me_fg0 = g0;
    mod_me_fg1 = g1;
  }else
    exit_error("ME_MOD_GET_NORM_FILTERS","Unknown me_norm_type");
  c = (sscale/0.1)*(sscale/0.1)*(tscale/0.002);
  sum = sum_square_3d_farray(g0,1,xn,1,yn,1,tn);
  multiply_3d_farray(g0,1,xn,1,yn,1,tn,sqrt(c/sum));
  sum = sum_square_3d_farray(g1,1,xn,1,yn,1,tn);
  multiply_3d_farray(g1,1,xn,1,yn,1,tn,sqrt(c/sum));
}
void mod_me_normalize_filter(f,x0,xn,y0,yn,z0,zn,sscale,tscale,norm_const)
     float ***f;
     int x0,xn,y0,yn,z0,zn;
     float sscale,tscale;
     float norm_const;  
{
  float sum,c;
  c = (sscale/0.1)*(sscale/0.1)*(tscale/0.002);
  c /= norm_const;
  sum = sum_square_3d_farray(f,x0,xn,y0,yn,z0,zn);
  multiply_3d_farray(f,x0,xn,y0,yn,z0,zn,sqrt(c/sum));
}
void mod_me_normalize_filters(x0,xn,y0,yn,z0,zn,sscale,tscale,norm_const)
     int x0,xn,y0,yn,z0,zn;
     float sscale,tscale;
     float norm_const;       
{
  int i;
  float c,nc,sum;
  c = (sscale/0.1)*(sscale/0.1)*(tscale/0.002);
  for(i=0;i<mod_me_fn;i++){
    if (norm_const == -1.0)
      nc = c / mod_me_ff[i]->normc;  
    else
      nc = c / norm_const;
    sum = sum_square_3d_farray(mod_me_ff[i]->f,x0,xn,y0,yn,z0,zn);
    multiply_3d_farray(mod_me_ff[i]->f,x0,xn,y0,yn,z0,zn,sqrt(nc/sum));
    sprintf(ggstr,"    Filter %d norm:  %f  sum %f  nc %f\n",i,
	    sqrt(c/sum),sum,nc);
    mylog(mylogf,ggstr);
  }
}
void mod_me_binoc_set_thresh(){
  int i;
  double dsum;
  mylog(mylogf,"  MOD_ME_BINOC_SET_THRESH\n");
  if (mod_me_binoc_sthresh == 0.0){
    mod_me_binoc_athresh = 0.0;
  }else{
    dsum = 0.0;
    for(i=0;i<mod_me_fn;i++){
      dsum += sum_abs_3d_farray(mod_me_ff[i]->f,1,mod_me_xn,1,mod_me_yn,
				1,mod_me_tn);
    }
    mod_me_binoc_athresh = (float)(mod_me_binoc_sthresh * dsum / mod_me_fn);
  }
  sprintf(ggstr,"    Threshold fraction of total filter area:  %f\n",
	  mod_me_binoc_sthresh);
  mylog(mylogf,ggstr);
  sprintf(ggstr,"    Threshold actual value:  %f\n",mod_me_binoc_athresh);
  mylog(mylogf,ggstr);
}
void model_me_01_prep_o(m)
     struct model_struct *m; 
{
  int xn,yn,tn,write_filt,fn;
  float ***fpe,***fpo,***fpx,***fne,***fno,***fnx,sscale,tscale;
  char *oppstr;
  struct param_pair_list *mppl; 
  struct onode *fo,*sgen;
  struct mod_me_fstruct **fs;  
  mylog(mylogf,"  MODEL_ME_01_PREP_O\n");
  mylog(mylogf,"    Computing even and odd, pref and null, filters.\n");
  mod_me_prep_basic(m->o,&sscale,&tscale,&xn,&yn,&tn); 
  if (strcmp(mod_me_modtype,"binoc_filter")==0){
    mod_me_binoc_rsign   = onode_getpar_chr_dflt(m->o,"right_sign","++++");
    mod_me_binoc_srect   = onode_getpar_int_dflt(m->o,"simp_rect",0);
    mod_me_binoc_sthresh = onode_getpar_flt_dflt(m->o,"simp_thresh",0.0);
    mod_me_binoc_nonlin  = onode_getpar_chr_dflt(m->o,"binoc_nonlin","halfsq");
  }
  fs = mod_me_get_quad_opp_filters_o(m->o,&mod_me_fpe,&mod_me_fpo,
				     &mod_me_fpx,&mod_me_fne,
				     &mod_me_fno,&mod_me_fnx,
				     &fn); 
  mod_me_ff = fs;
  mod_me_fn = fn;
  fpe = fs[0]->f; 
  fpo = fs[1]->f; 
  fne = fno = fpx = fnx = NULL;
  if (fn == 4){
    fne = fs[2]->f; 
    fno = fs[3]->f; 
  }else if (fn == 6){
    fpx = fs[2]->f; 
    fne = fs[3]->f; 
    fno = fs[4]->f; 
    fnx = fs[5]->f; 
  }
  mod_me_normalize_filters(1,xn,1,yn,1,tn,sscale,tscale,1.0);
  if (strcmp(mod_me_modtype,"binoc_filter")==0){
    mod_me_binoc_set_thresh();
  }
  fo = onode_child_get_unique(m->o,"filter");
  mod_me_pow = onode_getpar_flt_dflt(fo,"exponent",1.0);
  mod_me_normflag = onode_getpar_int_dflt(fo,"norm_type",0);
  if (mod_me_normflag == 1){
    mod_me_norm_pow  = onode_getpar_flt_dflt(fo,"norm_pow",1.0);
    mod_me_norm_c    = onode_getpar_flt_dflt(fo,"norm_c",1.0);
    mod_me_norm_f    = onode_getpar_flt_dflt(fo,"norm_f",1.0);
    mod_me_norm_app  = onode_getpar_int_dflt(fo,"norm_app",1);
    mod_me_norm_xn   = onode_getpar_int_dflt(fo,"norm_xn",1);
    mod_me_norm_tsd  = onode_getpar_flt_dflt(fo,"norm_tsd",0.0);
    mod_me_norm_toff = onode_getpar_flt_dflt(fo,"norm_toff",0.0);
    mod_me_get_norm_filters(mppl,m->o,&mod_me_fg0,&mod_me_fg1);
  }
  write_filt = onode_getpar_int_dflt(fo,"write_filter",-1);
  if ((write_filt == 1)||(write_filt == 5))
    write_3d_data_part("zzz.fpe.3d",fpe,1,xn,1,yn,1,tn,4,2,1);
  if ((write_filt == 2)||(write_filt == 5))
    write_3d_data_part("zzz.fpo.3d",fpo,1,xn,1,yn,1,tn,4,2,1);
  if ((write_filt == 3)||(write_filt == 5))
    write_3d_data_part("zzz.fne.3d",fne,1,xn,1,yn,1,tn,4,2,1);
  if ((write_filt == 4)||(write_filt == 5))
    write_3d_data_part("zzz.fno.3d",fno,1,xn,1,yn,1,tn,4,2,1);
  if ((write_filt == 5) && (me_xflag == 1)){
    write_3d_data_part("zzz.fpx.3d",fpx,1,xn,1,yn,1,tn,4,2,1);
    write_3d_data_part("zzz.fnx.3d",fnx,1,xn,1,yn,1,tn,4,2,1);
  }
  if (write_filt == 6){
    write_3d_data_part("zzz.fg0.3d",mod_me_fg0,1,xn,1,yn,1,tn,4,2,1);
    write_3d_data_part("zzz.fg1.3d",mod_me_fg1,1,xn,1,yn,1,tn,4,2,1);
  }
  sgen = onode_child_get_unique(m->o,"spike_gen");
  if (onode_test_chr(sgen,"type","poisson")){
    if (onode_get_item_child(sgen,"tdelay") != NULL){
      exit_error("WYETH","don't use 'tdelay', use toffset instead");
    }
  }else{
    mod_me_tdelay = onode_getpar_flt_dflt(sgen,"tdelay",0.0);
  }
  if (strcmp(mod_me_modtype,"ds_simp_01")==0){
    mod_me_oppflag = onode_getpar_int_dflt(fo,"opp_flag",3);
    mod_me_filt = onode_getpar_chr_dflt(fo,"branch","odd");
  }else if (strcmp(mod_me_modtype,"ds_liv3")==0){
    mod_me_oppflag = onode_getpar_int_dflt(fo,"opp_flag",3);
    mod_me_filt = onode_getpar_chr_dflt(fo,"filt","odd");
  }else{
    oppstr = onode_getpar_chr_ptr(fo,"opponent");
    if (oppstr == NULL){
      mod_me_oppflag = 0; 
    }else if (strcmp(oppstr,"no")==0){
      mod_me_oppflag = 3; 
    }else if (strcmp(oppstr,"ei")==0){
      mod_me_oppflag = 2; 
    }else if (strcmp(oppstr,"yes")==0){
      mod_me_oppflag = 0; 
    }
    mod_me_opp_w = onode_getpar_flt_dflt(fo,"opponent_w",1.0);
    if (mod_me_opp_w != 1.0) 
      exit_error("MODEL_ME_01_PREP_O","The param 'opponent_w' does nothing");
  }
}
void model_me_01_prep(m)
     struct model_struct *m; 
{
  int xn,yn,tn,write_filt;
  float ***fpe,***fpo,***fne,***fno;
  struct param_pair_list *mppl; 
  mylog(mylogf,"  MODEL_ME_01_PREP\n");
  mylog(mylogf,"    Computing even and odd, pref and null, filters.\n");
  mylog(mylogf,"  *** WYETH - THIS IS OLD WAY, consider using 'moo' file\n");
  mylog(mylogf,"  *** WYETH - THIS IS OLD WAY, consider using 'moo' file\n");
  mylog(mylogf,"  *** WYETH - THIS IS OLD WAY, consider using 'moo' file\n");
  mppl = m->ppl;
  mod_me_modtype = paramfile_get_char_param_or_exit(mppl,"mod_type");
  mod_me_get_quad_opp_filters(mppl,&mod_me_fpe,&mod_me_fpo,
			      &mod_me_fne,&mod_me_fno);
  xn = mod_me_xn;
  yn = mod_me_yn;
  tn = mod_me_tn;
  fpe = mod_me_fpe;
  fpo = mod_me_fpo;
  fne = mod_me_fne;
  fno = mod_me_fno;
  exit_error("WYETH HERE","Must put filters in a list, '..._ff'");
  mod_me_normalize_filters(1,xn,1,yn,1,tn,mod_me_sscale,mod_me_tscale,1.0);
  mod_me_pow = paramfile_get_float_param_default(mppl,"me_power",1.0);
  mod_me_normflag = paramfile_get_int_param_default(mppl,"me_norm_type",0);
  if (mod_me_normflag == 1){
    mod_me_norm_pow = paramfile_get_float_param_default(mppl,"me_norm_pow",
							1.0);
    mod_me_norm_c = paramfile_get_float_param_default(mppl,"me_norm_c",1.0);
    mod_me_norm_f = paramfile_get_float_param_default(mppl,"me_norm_f",1.0);
    mod_me_norm_app = paramfile_get_int_param_default(mppl,"me_norm_app",1);
    mod_me_norm_xn = paramfile_get_int_param_default(mppl,"me_norm_xn",1);
    mod_me_norm_tsd = paramfile_get_float_param_default(mppl,"me_norm_tsd",
							0.0);
    mod_me_norm_toff = paramfile_get_float_param_default(mppl,"me_norm_toff",
							 0.0);
    exit_error("MODEL_ME_01_PREP",
	       "WYETH these filters not supported, since change to fs?");
    mod_me_get_norm_filters(mppl,m->o,&mod_me_fg0,&mod_me_fg1);
  }
  write_filt = paramfile_get_int_param_default(mppl,"model_write_filter",-1);
  if ((write_filt == 0)||(write_filt == 4))
    write_3d_data_part("zzz.fpe.3d",fpe,1,xn,1,yn,1,tn,4,2,1);
  if ((write_filt == 1)||(write_filt == 4))
    write_3d_data_part("zzz.fpo.3d",fpo,1,xn,1,yn,1,tn,4,2,1);
  if ((write_filt == 2)||(write_filt == 4))
    write_3d_data_part("zzz.fne.3d",fne,1,xn,1,yn,1,tn,4,2,1);
  if ((write_filt == 3)||(write_filt == 4))
    write_3d_data_part("zzz.fno.3d",fno,1,xn,1,yn,1,tn,4,2,1);
  if (write_filt == 5){
    write_3d_data_part("zzz.fg0.3d",mod_me_fg0,1,xn,1,yn,1,tn,4,2,1);
    write_3d_data_part("zzz.fg1.3d",mod_me_fg1,1,xn,1,yn,1,tn,4,2,1);
  }
  mod_me_tdelay = paramfile_get_float_param_default(mppl,"tdelay",0.0);
  if ((strcmp(mod_me_modtype,"ds_simp_01")==0) ||
      (strcmp(mod_me_modtype,"ds_liv3")==0)){
    mod_me_oppflag = paramfile_get_int_param_default(mppl,"opp_flag",3);
    mod_me_filt = paramfile_get_char_param_default(mppl,"me_filt","odd");
  }else{
    mod_me_oppflag = paramfile_get_int_param_default(mppl,"opp_flag",0);
  }
}
struct mod_me_noise *mod_me_noise_init(no,nseed)
     struct onode *no;
     int nseed;           
{
  struct mod_me_noise *noise;
  noise = (struct mod_me_noise *)myalloc(sizeof(struct mod_me_noise));
  noise->type = onode_getpar_chr_exit(no,"type");
  noise->mu   = onode_getpar_flt_dflt(no,"mean",0.0);
  noise->sd   = onode_getpar_flt_exit(no,"sd");
  noise->tsd  = onode_getpar_flt_dflt(no,"tsd",0.0);
  noise->seed = onode_getpar_int_exit(no,"seed");
  noise->sflag = 1;  
  noise->tsd /= (mod_me_tscale * 1000.0);  
  noise->nseed = nseed;
  if (nseed > 0){
    noise->seedlist = get_seeds(noise->seed,100000,nseed);
  }
  noise->currseed = 0;
  return noise;
}
void mod_me_noise_add(d,n,np)
     float *d;  
     int n;     
     struct mod_me_noise *np;  
{
  int i;
  float *gt;
  struct mod_me_noise *noise;
  if (np->sflag == 1){  
    np->currseed = np->seedlist[mod_me_tsi];
    if (np->currseed > 0)
      np->currseed *= -1;
    np->sflag = 0;      
  }
  gt = gaussian_corr_noise_pseed(np->tsd,np->mu,np->sd,n,&(np->currseed));
  for(i=0;i<n;i++)
    d[i] += gt[i];
  myfree(gt);
}
struct mod_me_v1resp *model_me_v5_resp_init(n,nc,tn)
     int n;     
     int nc;    
     int tn;    
{
  struct mod_me_v1resp *r;
  r = (struct mod_me_v1resp *)myalloc(sizeof(struct mod_me_v1resp));
  r->raw  = get_3d_farray(n,nc,tn);
  r->me   = get_2d_farray(n,tn);
  r->sum  = (float  *)myalloc(tn*sizeof(float));
  r->norm = get_3d_farray(n,nc,tn);
  r->opp  = get_3d_farray(n,nc*2,tn); 
  r->bde  = get_3d_farray(n,7,0);     
  r->mt   = (float  *)myalloc(tn*sizeof(float));
  return r;
}
void mod_me_v5_pop_conn(mtpop,pl,io,disto)
     struct mod_me_v5_pop *mtpop;  
     struct pop_layer *pl;     
     struct onode *io;         
     struct onode *disto;      
{
  int i,j,k;
  int mxn,myn,mx0,my0,xn,yn,nposs,nn,xi,yi,zi,even_out,pflag;
  int seed,maxrep,evflag,stype,nfi,nseed,nsamp;
  int *cx,*cy,cn,*seedlist,cnt;
  short inindex;
  float cdist,minw,normw,sdo,sdp,xc,yc,ori,w,tdelay,x0,y0;
  char *shape,*dconf;
  struct mod_me_v5_struct *mv5;
  struct pop_cell *pre,*post;
  struct pop_syn *tsyn;
  mv5 = mod_me_v5;
  xn = mod_me_xn;
  yn = mod_me_yn;
  mxn = pl->xn;
  myn = pl->yn;
  if ((mxn > xn) || (myn > yn))
    mylog_exit(mylogf,"MOD_ME_V5_PREP  MT popolation is too large");
  shape = onode_getpar_chr_dflt(disto,"shape","Gaussian");
  cdist = onode_getpar_flt_dflt(disto,"cdist",0.0);
  minw  = onode_getpar_flt_dflt(disto,"minw",0.0);
  normw = onode_getpar_flt_dflt(disto,"normw",0.0);
  evflag= onode_getpar_int_dflt(disto,"even_out",0);
  seed  = onode_getpar_int_dflt(disto,"seed",1777);
  nsamp = onode_getpar_int_exit(disto,"nsamp");
  dconf = onode_getpar_chr_dflt(io,"dir_config","stacked");
  pflag = onode_getpar_int_dflt(io,"print_connections",0);
  mtpop->nsamp = nsamp;
  sprintf(ggstr,"    %s  cdist %f  minw %f  normw %f  seed %d\n",
	  shape,cdist,minw,normw,seed);
  mylog(mylogf,ggstr);
  sdo = sdp = cdist / mod_me_sscale;  
  xc = yc = 0.0;
  ori = 0.0;
  maxrep = 1;
  stype = 1;     
  tdelay = 0.0;  
  inindex = 0;   
  if (strcmp(dconf,"stacked")==0){  
    nseed = mxn*myn;
    nfi = 1;
    mtpop->stackflag = 1;
  }else if (strcmp(dconf,"random")==0){  
    nseed = mxn*myn*mv5->n;
    nfi = mv5->n;
    mtpop->stackflag = 0;
  }else{
    mylog_exit(mylogf,"MOD_ME_V5_PREP  Unknown 'dir_config' value");
  }
  seedlist = get_seeds(seed,99999,nseed);
  x0 = pl->area->x0 + pl->x0;
  y0 = pl->area->y0 + pl->y0;
  cnt = 0;
  for(i=0;i<mxn;i++){
    for(j=0;j<myn;j++){  
      post = &(pl->c[i][j][0]);
      xc = x0 + (float)post->layx;
      yc = y0 + (float)post->layy;
      for(zi=0;zi<nfi;zi++){
	if (nsamp == 2){
	  cn = 2;
	  cx = get_zero_iarray(cn);
	  cy = get_zero_iarray(cn);
	  cx[0] = xn/4+1;
	  cy[0] = yn/2;
	  cx[1] = xn/4 + xn/2 - 2;
	  cy[1] = yn/2;
	}else{
	  nposs = mod_conn_gauss_02(mylogf,xn,yn,xc,yc,sdo,sdp,ori,
				    seedlist[cnt],
				    maxrep,minw,nsamp,evflag,&cx,&cy,&cn);
	}
	for(k=0;k<cn;k++){  
	  xi = cx[k];
	  yi = cy[k];
	  pre = &(mod_me_mpt->lay[1]->c[xi][yi][zi]);  
	  if (pflag == 1){
	    sprintf(ggstr,"    Connecting V1 (%d,%d,%d) to %s (%d,%d)\n",
		  xi,yi,zi,pl->name,i,j);
	    mylog(mylogf,ggstr);
	  }
	  w = 1.0; 
	  tsyn = pop_cell_add_synapse(pre,post,stype,w,tdelay,inindex);
	}
	cnt += 1;
	myfree(cx);
	myfree(cy);
      }
    }
  }
  myfree(seedlist);
}
void model_me_v5_pop_prep(m)
     struct model_struct *m; 
{
  int i,j;
  int **fx,**fy,*fn,zn,popcnt;
  float **fw;
  char *pname;
  struct onode *ao,*po,*io,*disto,*v5o,*nlo,*sgen;
  struct pop_layer *pl;
  struct mod_me_v5_struct *mv5;
  struct pop_top *mpt;
  struct mod_me_v5_pop *mtpop;
  mylog(mylogf,"  MODEL_ME_V5_POP_PREP\n");
  mv5 = mod_me_v5;
  popcnt = onode_count_otype(m->o,"pop");
  if (popcnt < 1){
    mod_me_mpt = NULL;
    mylog(mylogf,"    No MT populations.\n");
    return;
  }else{
    if (mv5->w != NULL)
      exit_error("MODLE_ME_V5_POP_PREP","Remove old format '<v5>' in .moo");
  }
  printf("    Found %d population(s).\n",popcnt);
  mod_me_mpt = popu_make_pop_top(mylogf,mod_me_sscale,mod_me_tscale,
				 mod_me_xn,mod_me_yn,mod_me_tn);
  mpt = mod_me_mpt;  
  ao = onode_child_get_unique(m->o,"area");  
  if (ao == NULL)
    mylog_exit(mylogf,"MOD_ME_V5_POP_PREP  Must define <area> at top level.");
  mpt->narea = 2;  
  mpt->area = (struct pop_area **)myalloc(mpt->narea*
					  sizeof(struct pop_area *));
  mpt->area[0] = popu_make_area_default("v1",mpt->xn,mpt->yn,mpt->sscale,20.0);
  mpt->area[1] = popu_make_area(logf,ao,mod_me_sscale);
  mv5->mtli0 = 2;   
  mpt->nlay = mv5->mtli0 + popcnt;  
  mpt->lay = (struct pop_layer **)myalloc(mpt->nlay*
					  sizeof(struct pop_layer *));
  pl = popu_make_layer_cart("stim",mpt->xn,mpt->yn,1);
  myfree(pl->laytype);
  pl->laytype = strdup("stim");
  pl->geomt = strdup("default");
  pl->x0 = pl->y0 = 0.0;
  pl->xf = pl->yf = 1.0;
  mpt->lay[0] = pl;
  mpt->lay[0]->ninlist = 0;
  mpt->lay[0]->inlist = NULL;
  if (mod_me_fre == 1)  
    zn = mod_me_fn/2;
  else
    zn = mod_me_fn;  
  mod_me_filt_template(0,zn,&fx,&fy,&fw,&fn);
  pl = popu_make_layer_template("v1",mpt->xn,mpt->yn,zn,mpt->area[0],
				mpt->lay[0],fx,fy,fw,fn);
  mpt->lay[1] = pl;
  free_2d_iarray(fx,zn);
  free_2d_iarray(fy,zn);
  free_2d_farray(fw,zn);
  myfree(fn);
  mv5->mtp = (struct mod_me_v5_pop **)myalloc(popcnt*
					      sizeof(struct mod_me_v5_pop *));
  po = onode_get_next_type(m->o->o,"pop");
  for(i=0;i<popcnt;i++){
    mtpop = (struct mod_me_v5_pop *)myalloc(sizeof(struct mod_me_v5_pop));
    v5o   = onode_child_get_unique(po,"me_v5");
    io    = onode_child_get_unique(po,"input");
    disto = onode_child_get_unique(io,"distrib");
    if (v5o == NULL)
      mylog_exit(mylogf,"MOD_ME_V5_POP_PREP  Missing <me_v5> in <pop>.");
    if (io == NULL)
      mylog_exit(mylogf,"MOD_ME_V5_POP_PREP  Missing <input> in <pop>.");
    if (disto == NULL)
      mylog_exit(mylogf,"MOD_ME_V5_POP_PREP  Missing <distrib> in <input>.");
    nlo = onode_child_get_unique(v5o,"nonlin");
    if (nlo == NULL)
      mylog_exit(mylogf,"MOD_ME_V5_POP_PREP  Missing <nonlin> in <me_v5>.");
    pname = onode_getpar_chr_exit(po,"name");
    pl = popu_make_pop_layer(pname);
    pl->laytype = strdup("default");
    mpt->lay[mv5->mtli0 + i] = pl;
    popu_init_geom(mylogf,m->o,po,pl,-1);  
    mtpop->ssum = get_3d_farray(pl->xn,pl->yn,0); 
    mtpop->nl   = get_3d_farray(pl->xn,pl->yn,0); 
    mtpop->seed = NULL;
    pl->area = mpt->area[1];
    pl->c = popu_make_init_cells(pl->xn,pl->yn,pl->zn,pl); 
    sprintf(ggstr,"    Created layer %s with %d x %d x %d units.\n",pl->name,
	    pl->xn,pl->yn,pl->zn);
    mylog(mylogf,ggstr);
    mtpop->r_bias  = onode_getpar_flt_dflt(v5o,"right_eye_w",1.0);
    mtpop->w   = get_farray(mv5->n);
    mtpop->w_r = get_farray(mv5->n);
    if (onode_getpar_nvals(v5o,"w") != mv5->n)
      exit_error("MODEL_ME_V5_POP_PREP","Bad length of 'w' list");
    for(j=0;j<mv5->n;j++)
      mtpop->w[j] = onode_getpar_nth_flt_exit(v5o,"w",j);
    if (onode_item(v5o,"w_r") == 1){  
      if (onode_getpar_nvals(v5o,"w_r") != mv5->n)
	exit_error("MODEL_ME_V5_POP_PREP","Bad length of 'w_r' list");
      for(j=0;j<mv5->n;j++)
	mtpop->w_r[j] = onode_getpar_nth_flt_exit(v5o,"w_r",j);
    }else{
      for(j=0;j<mv5->n;j++)
	mtpop->w_r[j] = mtpop->w[j];
    }
    mtpop->nl_type = onode_getpar_chr_exit(nlo,"type");
    if (strcmp(mtpop->nl_type,"rmsm")==0){
      mtpop->nl_a = onode_getpar_flt_exit(nlo,"A");
      mtpop->nl_b = onode_getpar_flt_exit(nlo,"B");
    }else if (strcmp(mtpop->nl_type,"half-rect")==0){
      mtpop->nl_a = 0.0;
      mtpop->nl_b = 0.0;
    }else{
      exit_error("MODEL_ME_V5_POP_PREP","Unknown 'type' in <nonlin>");
    }
    pl->ninlist = 1;  
    pl->inlist = (struct onode **)myalloc(pl->ninlist*sizeof(struct onode *));
    pl->inlist[0] = io;         
    mod_me_v5_pop_conn(mtpop,pl,io,disto);
    sgen = onode_child_get_unique(po,"spike_gen");
    if (onode_test_chr(sgen,"type","poisson")){
      ; 
    }else
      exit_error("MODEL_ME_V5_POP_PREP","Unknown <spike_gen> type");
    mv5->mtp[i] = mtpop;
    myfree(pname);
    po = onode_get_next_type(po->next,"pop");
  }
  mv5->mt_npop = popcnt;  
  if ((m->action == 10) && (m->marfile != NULL)){
    popu_mar_write(mpt,m->marfile,4);  
  }
}
void model_me_v5_prep(m,s)
     struct model_struct *m;  
     struct stim_struct *s;   
{
  int i,j,k;
  int xn,yn,tn,write_filt,fn,ndir,***cmap,txn,tyn,tzn,nsyn;
  float ***fpe,***fpo,***fne,***fno,*w,fsc,sscale,tscale;
  char *oppstr;
  struct onode *fo,*v1o,*mto,*sgen,*io,*disto;
  struct mod_me_fstruct **fs;  
  struct mod_me_v5_struct *mv5;
  struct onode *no;
  struct pop_layer *pl,*pls;
  struct pop_top *mpt;
  struct mod_me_v5_pop *mtpop;
  mylog(mylogf,"  MODEL_ME_V5_PREP\n");
  mod_me_prep_basic(m->o,&sscale,&tscale,&xn,&yn,&tn); 
  mod_me_tsi = -1;
  if (m->ppl != NULL)
    exit_error("MODEL_ME_V5_PREP","m->ppl is not NULL");
  mylog(mylogf,"    Creating all filters\n");
  fs = mod_me_get_quad_opp_filters_o(m->o,&mod_me_fpe,&mod_me_fpo,
				     &mod_me_fpx,&mod_me_fne,
				     &mod_me_fno,&mod_me_fnx,
				     &fn); 
  mod_me_ff = fs;  
  mod_me_fn = fn;  
  fo = onode_child_get_unique(m->o,"filter");
  fsc = onode_getpar_flt_dflt(fo,"scale_sqrt",1.0);
  if (fsc != 1.0)
    fsc = 1.0/fsc;
  mod_me_normalize_filters(1,xn,1,yn,1,tn,sscale,tscale,fsc);
  write_filt = onode_getpar_int_dflt(fo,"write_filter",-1);
  if ((write_filt > 0) && write_filt <= 5){
    fpe = fs[0]->f;
    fpo = fs[1]->f;
    fne = fs[2]->f;
    fno = fs[3]->f;
    if ((write_filt == 1)||(write_filt == 5))
      write_3d_data_part("zzz.fpe.3d",fpe,1,xn,1,yn,1,tn,4,2,1);
    if ((write_filt == 2)||(write_filt == 5))
      write_3d_data_part("zzz.fpo.3d",fpo,1,xn,1,yn,1,tn,4,2,1);
    if ((write_filt == 3)||(write_filt == 5))
      write_3d_data_part("zzz.fne.3d",fne,1,xn,1,yn,1,tn,4,2,1);
    if ((write_filt == 4)||(write_filt == 5))
      write_3d_data_part("zzz.fno.3d",fno,1,xn,1,yn,1,tn,4,2,1);
  }
  oppstr = onode_getpar_chr_ptr(fo,"opponent");
  if (oppstr != NULL){
    if (strcmp(oppstr,"no")==0){
      mod_me_oppflag = 3; 
    }
  }
  mto = onode_child_get_unique(m->o,"v5");
  if (mto != NULL){
    sgen = onode_child_get_unique(m->o,"spike_gen");
    if (onode_test_chr(sgen,"type","poisson")){
      ; 
    }else
      exit_error("MODEL_ME_V5_PREP","Unknown <spike_gen> type");
  }
  mv5 = (struct mod_me_v5_struct *)myalloc(sizeof(struct mod_me_v5_struct));
  mod_me_v5 = mv5;
  v1o = onode_child_get_unique(m->o,"v1");
  mv5->n         = onode_getpar_int_exit(v1o,"n_dir_chan");
  mv5->alph1     = onode_getpar_flt_exit(v1o,"rmsm_alpha_1");
  mv5->alph2     = onode_getpar_flt_exit(v1o,"rmsm_alpha_2");
  mv5->alph3     = onode_getpar_flt_exit(v1o,"rmsm_alpha_3");
  mv5->alph4     = onode_getpar_flt_dflt(v1o,"alpha_4",0.0);
  mv5->L         = onode_getpar_flt_exit(v1o,"rmsm_L");
  mv5->v1_opp_w  = onode_getpar_flt_dflt(v1o,"opponent_w",0.0);
  mv5->v1_recto  = onode_getpar_int_dflt(v1o,"opponent_rect",0);
  mv5->v1_bin_w  = onode_getpar_flt_dflt(v1o,"right_eye_w",1.0);
  mv5->v1_mix_f  = onode_getpar_flt_dflt(v1o,"binoc_balance",1.0);
  if (onode_get_item_child(v1o,"early_mix_f") != NULL){
    exit_error("MODEL_ME_V5_PREP","Convert 'early_mix_f' to 'binoc_balance'");
  }
  mv5->v1_dflag  = onode_getpar_int_dflt(v1o,"disparity_flag",0);
  mv5->v1_mix_s  = onode_getpar_chr_dflt(v1o,"early_mix_stage","none");
  if ((mv5->v1_dflag == 1) && (strcmp(mv5->v1_mix_s,"none")!=0)){
    printf("*** disparity_flag = 1\n");
    exit_error("MODEL_ME_V5_PREP","'early_mix_stage' should be 'none'");
  }
  mv5->v1_dnorm  = onode_getpar_int_dflt(v1o,"disparity_norm",0);
  mv5->binoc = 0;  
  if ((mv5->v1_mix_f < 0.5) || (mv5->v1_mix_f > 1.0))
    exit_error("MODEL_ME_V5_PREP","'binoc_balance' must be in [0.5,1.0]");
  mv5->noise_v1_out = NULL;
  no = onode_get_node_type_item_val(v1o,"noise","name","output");
  if (no != NULL){
    mv5->noise_v1_out = mod_me_noise_init(no,s->ntr);
  }
  if (mto != NULL){
    printf("  *** WARNING:  Old format file contains a top-level <v5> node.\n");
    mv5->w   = get_farray(mv5->n);  
    mv5->w_r = get_farray(mv5->n);  
    if (onode_getpar_nvals(mto,"rmsm_w") != mv5->n)
      exit_error("MODEL_ME_V5_PREP","Bad length of 'rmsm_w' list");
    for(i=0;i<mv5->n;i++)
      mv5->w[i] = onode_getpar_nth_flt_exit(mto,"rmsm_w",i);
    if (onode_item(mto,"rmsm_w_r") == 1){  
      if (onode_getpar_nvals(mto,"rmsm_w_r") != mv5->n)
	exit_error("MODEL_ME_V5_PREP","Bad length of 'rmsm_w_r' list");
      for(i=0;i<mv5->n;i++)
	mv5->w_r[i] = onode_getpar_nth_flt_exit(mto,"rmsm_w_r",i);
    }else{
      for(i=0;i<mv5->n;i++)
	mv5->w_r[i] = mv5->w[i];
    }
    mv5->mt_a = onode_getpar_flt_exit(mto,"rmsm_A");
    mv5->mt_b = onode_getpar_flt_exit(mto,"rmsm_B");
    mv5->bin_hack = onode_getpar_flt_dflt(mto,"tailby_weight",-1.0);
  }else{
    mv5->w   = NULL;  
    mv5->w_r = NULL;  
  }
  if (mv5->v1_dflag == 1)
    mv5->v1_nc = 2;  
  else
    mv5->v1_nc = 1;  
  model_me_v5_pop_prep(m);
  mpt = mod_me_mpt;
  if (mpt != NULL){  
    pls = pop_util_get_layer_by_name(mpt,"v1");   
    cmap = get_zero_3d_iarray(xn,yn,pls->zn);
    for(i=mv5->mtli0;i<mpt->nlay;i++){
      pl = mpt->lay[i];
      nsyn = popc_flag_accum_lay_to_lay(pls,pl,cmap,0.0);
      if (i == 2)
	sprintf(ggstr,"    %d V1 units (of %d) are pre-syn to MT pop %s.\n",
		nsyn,xn*yn,pl->name);
      else
	sprintf(ggstr,"    %d additional V1 units are pre-syn to MT pop %s.\n",
		nsyn,pl->name);
      mylog(mylogf,ggstr);
    }
    txn = xn;
    tyn = yn;
    tzn = pls->zn;
  }else{
    txn = tyn = tzn = 1;
    cmap = get_3d_iarray(1,1,1);  
    cmap[0][0][0] = 1;
  }
  mv5->v1resp = (struct mod_me_v1_input ***)
    myalloc(txn*sizeof(struct mod_me_v1_input **));
  for(i=0;i<txn;i++){
    mv5->v1resp[i] = (struct mod_me_v1_input **)
      myalloc(tyn*sizeof(struct mod_me_v1_input *));
    for(j=0;j<tyn;j++){
      mv5->v1resp[i][j] = (struct mod_me_v1_input *)
	myalloc(sizeof(struct mod_me_v1_input));
      mv5->v1resp[i][j]->flag = 0;  
    }
  }
  for(i=0;i<txn;i++){
    for(j=0;j<tyn;j++){
      for(k=0;k<tzn;k++){
	if ((cmap[i][j][k] > 0) && (mv5->v1resp[i][j]->flag == 0)){
	  mv5->v1resp[i][j]->flag = 2;
	  mv5->v1resp[i][j]->dl = model_me_v5_resp_init(mv5->n,mv5->v1_nc,tn);
	  mv5->v1resp[i][j]->dr = model_me_v5_resp_init(mv5->n,mv5->v1_nc,tn);
	  mv5->v1resp[i][j]->mtb  = (float  *)myalloc(tn*sizeof(float));
	}
      }
      if (mv5->v1resp[i][j]->flag == 0){  
	mv5->v1resp[i][j]->dl = NULL;
	mv5->v1resp[i][j]->dr = NULL;
	mv5->v1resp[i][j]->mtb = NULL;
      }
    }
  }
  free_3d_iarray(cmap,txn,tyn,tzn);
  if (mpt == NULL){
    mv5->mt_raw  = (float  *)myalloc(tn*sizeof(float));
    mv5->mt_raw_l  = (float  *)myalloc(tn*sizeof(float));
    mv5->mt_raw_r  = (float  *)myalloc(tn*sizeof(float));
    mv5->mt_norm = (float  *)myalloc(tn*sizeof(float));
  }
  mylog(mylogf,"    ME_V5 params\n");
  sprintf(ggstr,"      N_dir = %d\n",mv5->n);             mylog(mylogf,ggstr);
  sprintf(ggstr,"      alpha_1 = %f\n",mv5->alph1);       mylog(mylogf,ggstr);
  sprintf(ggstr,"      alpha_2 = %f\n",mv5->alph2);       mylog(mylogf,ggstr);
  sprintf(ggstr,"      alpha_3 = %f\n",mv5->alph3);       mylog(mylogf,ggstr);
  sprintf(ggstr,"      alpha_4 = %f\n",mv5->alph4);       mylog(mylogf,ggstr);
  sprintf(ggstr,"      opponent_w = %f\n",mv5->v1_opp_w); mylog(mylogf,ggstr);
  if (mod_me_mpt == NULL){
    sprintf(ggstr,"      r_eye_w = %f\n",mv5->v1_bin_w);  mylog(mylogf,ggstr);
    sprintf(ggstr,"      MT nonlin A = %f\n",mv5->mt_a);  mylog(mylogf,ggstr);
    sprintf(ggstr,"      MT nonlin B = %f\n",mv5->mt_b);  mylog(mylogf,ggstr);
    mylog(mylogf,"      Weights:\n       ");
    for(i=0;i<mv5->n;i++){
      sprintf(ggstr," %.2f",mv5->w[i]);  mylog(mylogf,ggstr);
    }
    mylog(mylogf,"\n");
  }else{
    sprintf(ggstr,"      MT populations: %d\n",mv5->mt_npop);
    mylog(mylogf,ggstr);
    for(j=0;j<mv5->mt_npop;j++){
      mtpop = mv5->mtp[j];
      sprintf(ggstr,"       Name: %s\n",mod_me_mpt->lay[2+j]->name);
      mylog(mylogf,ggstr);
      sprintf(ggstr,"         r_eye_w = %f\n",mtpop->r_bias);
      mylog(mylogf,ggstr);
      sprintf(ggstr,"         MT nonlin A = %f\n",mtpop->nl_a);
      mylog(mylogf,ggstr);
      sprintf(ggstr,"         MT nonlin B = %f\n",mtpop->nl_b);
      mylog(mylogf,ggstr);
      mylog(mylogf,"         Weights:\n       ");
      for(i=0;i<mv5->n;i++){
	sprintf(ggstr," %.2f",mtpop->w[i]);  mylog(mylogf,ggstr);
      }
      mylog(mylogf,"\n");
    }
  }
}
void model_filter_xyt_prep(m)
     struct model_struct *m; 
{
  int i,j,k;
  int xn,yn,tn,write_filt;
  float **xyfilt,*tfilt,sscale,tscale;
  struct onode *mo,*fso,*fto;
  mylog(mylogf,"  MODEL_FILTER_XYT_PREP\n");
  mo = m->o;
  if (mo != NULL)
    mod_me_modtype = onode_getpar_chr_exit(m->o,"mod_type");
  else
    exit_error("MODEL_FILTER_XYT_PREP","Head onode is null");
  sscale = onode_getpar_flt_exit(mo,"sscale");
  tscale = onode_getpar_flt_exit(mo,"tscale");
  xn     = onode_getpar_int_exit(mo,"xn");
  yn     = onode_getpar_int_exit(mo,"yn");
  tn     = onode_getpar_int_exit(mo,"tn");
  mod_me_sscale = sscale;
  mod_me_tscale = tscale;
  mod_me_xn     = xn;
  mod_me_yn     = yn;
  mod_me_tn     = tn;
  fso = onode_get_node_type_item_val(mo,"filter","name","spatial");
  xyfilt = mod_util_o_get_filter_2d(mylogf,fso,sscale,&xn,&yn);
  fto = onode_get_node_type_item_val(mo,"filter","name","temporal");
  tfilt = kernu_o_filter(mylogf,fto,tscale,&tn);
  mod_me_fpe = f3tensor(1,xn,1,yn,1,tn);  
  for(i=0;i<xn;i++)
    for(j=0;j<yn;j++)
      for(k=0;k<tn;k++)
	mod_me_fpe[i+1][j+1][k+1] = xyfilt[i][j] * tfilt[k];
  mod_me_normalize_filter(mod_me_fpe,1,xn,1,yn,1,tn,
			  mod_me_sscale,mod_me_tscale,1.0);
  write_filt = onode_getpar_int_dflt(mo,"model_write_filter",-1);
  if (write_filt == 1)
    write_3d_data_part("zzz.filter.3d",mod_me_fpe,1,xn,1,yn,1,tn,4,2,1);
  mod_me_pow = onode_getpar_flt_dflt(mo,"power",1.0);
  mod_me_fpe_s = matrix(1,xn,1,2*yn);
  contort_real_3d_farray(mod_me_fpe,1,1,1,xn,yn,tn);
  rlft3(mod_me_fpe,mod_me_fpe_s,xn,yn,tn,1);
}
void model_gabor_comp_prep(m)
     struct model_struct *m; 
{
  int xn,yn,tn,write_filt;
  float ***fpe,***fpo,sscale,tscale;
  struct param_pair_list *mppl; 
  struct mod_me_fstruct **fs;  
  mylog(mylogf,"  MODEL_GABOR_COMP_PREP\n");
  mylog(mylogf,"    Computing even and odd, pref and null, filters.\n");
  mod_me_prep_basic(m->o,&sscale,&tscale,&xn,&yn,&tn); 
  mppl = m->ppl;
  if (m->o != NULL)
    mod_me_modtype = onode_getpar_chr_exit(m->o,"mod_type");
  else
    mod_me_modtype = paramfile_get_char_param_or_exit(mppl,"mod_type");
  if (m->o != NULL){
    fs = mod_me_get_quad_opp_filters_o(m->o,&mod_me_fpe,&mod_me_fpo,&mod_me_fpx,
				       &mod_me_fne,&mod_me_fno,&mod_me_fnx,
				       &mod_me_fn);
    mod_me_ff = fs;
  }else{
    mod_me_get_quad_opp_filters(mppl,&mod_me_fpe,&mod_me_fpo,
				&mod_me_fne,&mod_me_fno);
    exit_error("WYETH---","filters need to be put in a list, ...ff");
  }
  fpe = mod_me_fpe;  
  fpo = mod_me_fpo;  
  mod_me_normalize_filters(1,xn,1,yn,1,tn,sscale,tscale,1.0);
  if (m->o != NULL)
    write_filt = onode_getpar_int_dflt(m->o,"model_write_filter",-1);
  else
    write_filt = paramfile_get_int_param_default(mppl,"model_write_filter",-1);
  if ((write_filt == 0)||(write_filt == 4))
    write_3d_data_part("zzz.fe.3d",fpe,1,xn,1,yn,1,tn,4,2,1);
  if ((write_filt == 1)||(write_filt == 4))
    write_3d_data_part("zzz.fo.3d",fpo,1,xn,1,yn,1,tn,4,2,1);
  if (m->o != NULL)
    mod_me_tdelay = onode_getpar_flt_dflt(m->o,"tdelay",0.0);
  else
    mod_me_tdelay = paramfile_get_float_param_default(mppl,"tdelay",0.0);
  if (m->o != NULL)
    mod_me_pow = onode_getpar_flt_dflt(m->o,"power",1.0);
  else
    mod_me_pow = paramfile_get_float_param_default(mppl,"power",1.0);
  mod_me_fpe_s = matrix(1,xn,1,2*yn);
  mod_me_fpo_s = matrix(1,xn,1,2*yn);
  contort_real_3d_farray(mod_me_fpe,1,1,1,xn,yn,tn);
  contort_real_3d_farray(mod_me_fpo,1,1,1,xn,yn,tn);
  rlft3(mod_me_fpe,mod_me_fpe_s,xn,yn,tn,1);
  rlft3(mod_me_fpo,mod_me_fpo_s,xn,yn,tn,1);
}
void model_me_ft(f0,f1,f2,f3,xn,yn,tn,rf0s,rf1s,rf2s,rf3s)
     float ***f0,***f1,***f2,***f3;
     int xn,yn,tn;
     float ***rf0s,***rf1s,***rf2s,***rf3s;
{
  float **f0_s,**f1_s,**f2_s,**f3_s;
  mylog(mylogf,"  MODEL_ME_FT\n");
  f0_s = matrix(1,xn,1,2*yn);
  f1_s = matrix(1,xn,1,2*yn);
  f2_s = matrix(1,xn,1,2*yn);
  f3_s = matrix(1,xn,1,2*yn);
  contort_real_3d_farray(f0,1,1,1,xn,yn,tn);
  contort_real_3d_farray(f1,1,1,1,xn,yn,tn);
  contort_real_3d_farray(f2,1,1,1,xn,yn,tn);
  contort_real_3d_farray(f3,1,1,1,xn,yn,tn);
  rlft3(f0,f0_s,xn,yn,tn,1);
  rlft3(f1,f1_s,xn,yn,tn,1);
  rlft3(f2,f2_s,xn,yn,tn,1);
  rlft3(f3,f3_s,xn,yn,tn,1);
  *rf0s = f0_s;
  *rf1s = f1_s;
  *rf2s = f2_s;
  *rf3s = f3_s;
}
void model_me_01_prep_ft()
{
  int i;
  int xn,yn,tn,fn;
  struct mod_me_fstruct **fs;
  mylog(mylogf,"  MODEL_ME_01_PREP_FT\n");
  xn = mod_me_xn;
  yn = mod_me_yn;
  tn = mod_me_tn;
  fn = mod_me_fn;
  fs = mod_me_ff;
  for(i=0;i<fn;i++){
    fs[i]->s = matrix(1,xn,1,2*yn);
    contort_real_3d_farray(fs[i]->f,1,1,1,xn,yn,tn);
    rlft3(fs[i]->f,fs[i]->s,xn,yn,tn,1);
  }
}
void model_mem_prep(m)
     struct model_struct *m; 
{
  int i;
  int xn,yn,tn,write_filt,n,rtype,fn;
  float ***fpe,***fpo,***fne,***fno,sscale,tscale,norm_const;
  char ggstr[LONG_SLEN],tstr[SLEN];
  struct param_pair_list *mppl; 
  struct mod_mem *mem;
  struct mod_me_fstruct **fs;  
  struct onode *fo;
  mylog(mylogf,"  MODEL_MEM_PREP\n");
  mylog(mylogf,"    Building filters.\n");
  mod_me_prep_basic(m->o,&sscale,&tscale,&xn,&yn,&tn); 
  n =  onode_count_otype(m->o,"filter");
  sprintf(ggstr,"    Found %d filter definitions.\n",n);
  mylog(mylogf,ggstr);
  mem = (struct mod_mem *)myalloc(sizeof(struct mod_mem));
  mem->nf = n;
  mem->theta = (float *)myalloc(n*sizeof(float));
  mem->ssd = (float *)myalloc(n*sizeof(float));
  mem->sf = (float *)myalloc(n*sizeof(float));
  mem->tsd = (float *)myalloc(n*sizeof(float));
  mem->tf = (float *)myalloc(n*sizeof(float));
  mem->scale = (float *)myalloc(n*sizeof(float));
  mem->f = (float *****)myalloc(n*sizeof(float ****));
  mem->fs = (float ****)myalloc(n*sizeof(float ***));
  mem->r = (float *****)myalloc(n*sizeof(float ****));
  mem->dumpflag = onode_getpar_int_dflt(m->o,"mem_dump_wr",0);
  mod_me_fn = fn = n*4;
  mod_me_ff = fs = mod_me_fs_create(fn);
  fo = onode_get_next_type(m->o->o,"filter");
  for(i=0;i<n;i++){ 
    mem->f[i] = (float ****)myalloc(4*sizeof(float ***));
    mem->fs[i] = (float ***)myalloc(4*sizeof(float **));
    mem->r[i] = (float ****)myalloc(4*sizeof(float ***));
    mem->r[i][0] = NULL;
    mem->r[i][1] = NULL;
    mem->r[i][2] = NULL;
    mem->r[i][3] = NULL;
    mod_me_get_quad_opp_k(m->o,fo,&(mem->f[i][0]),&(mem->f[i][1]),
			  &(mem->f[i][2]),&(mem->f[i][3]),&norm_const);
    fs[i*4  ]->f = mem->f[i][0];  
    fs[i*4+1]->f = mem->f[i][1];
    fs[i*4+2]->f = mem->f[i][2];
    fs[i*4+3]->f = mem->f[i][3];
    fs[i*4  ]->normc = norm_const;
    fs[i*4+1]->normc = norm_const;
    fs[i*4+2]->normc = norm_const;
    fs[i*4+3]->normc = norm_const;
    mem->scale[i] = onode_getpar_flt_exit(fo,"ampl");
    fo = onode_get_next_type(fo->next,"filter");
  }
  mod_me_normalize_filters(1,xn,1,yn,1,tn,sscale,tscale,-1.0);
  mem->wf = onode_getpar_flt_exit(m->o,"mem_w_f");
  rtype = onode_getpar_int_exit(m->o,"mem_rtype");
  if (rtype == 1){  
    mem->nr = 1;             
    mem->xi = (int *)myalloc(mem->nr * sizeof(int));
    mem->yi = (int *)myalloc(mem->nr * sizeof(int));
    mem->xi[0] = xn/2;
    mem->yi[0] = yn/2;
  }else if (rtype == 2){
    mem->nr = 10;             
    mem->xi = (int *)myalloc(mem->nr * sizeof(int));
    mem->yi = (int *)myalloc(mem->nr * sizeof(int));
    for(i=0;i<mem->nr;i++){
      mem->xi[i] = xn/2 - mem->nr/2 + i;
      mem->yi[i] = yn/2;
    }
  }
  mem->mp = get_3d_farray(n,mem->nr,tn);
  mem->ma = get_3d_farray(n,mem->nr,tn);
  mod_me_mem = mem; 
}
void model_reich_prep(m)
     struct model_struct *m; 
{
  int xn,yn,tn,write_filt,xc,yc,tc;
  float hp_tau,lp_tau,sscale,tscale;
  struct onode *rdo;
  mylog(mylogf,"  MODEL_REICH_PREP\n");
  mod_me_modtype = onode_getpar_chr_exit(m->o,"mod_type");
  sscale = onode_getpar_flt_exit(m->o,"sscale");
  tscale = onode_getpar_flt_exit(m->o,"tscale");
  xn = onode_getpar_int_exit(m->o,"xn");
  yn = onode_getpar_int_exit(m->o,"yn");
  tn = onode_getpar_int_exit(m->o,"tn");
  mod_me_sscale = sscale;
  mod_me_tscale = tscale;
  mod_me_xn = xn;
  mod_me_yn = yn;
  mod_me_tn = tn;
  rdo = onode_child_get_unique(m->o,"filter");
  lp_tau = onode_getpar_flt_exit(rdo,"lp_tau");
  hp_tau = onode_getpar_flt_exit(rdo,"hp_tau");
  mod_reich_lp = exp_time_tensor(mylogf,xn,yn,tn,sscale,tscale,lp_tau);
  mod_reich_hp = exp_time_tensor(mylogf,xn,yn,tn,sscale,tscale,hp_tau);
  xc = (xn-1)/2; 
  yc = (yn-1)/2;
  tc = (tn-1)/2;
  multiply_3d_farray(mod_reich_hp,1,xn,1,yn,1,tn,-1.0);
  mod_reich_hp[xc+1][yc+1][tc+1] += 1.0;
  write_filt = onode_getpar_int_dflt(rdo,"model_write_filter",-1);
  if (write_filt == 0)
    write_3d_data_part("zzz.lp.3d",mod_reich_lp,1,xn,1,yn,1,tn,4,2,1);
  if (write_filt == 1)
    write_3d_data_part("zzz.hp.3d",mod_reich_hp,1,xn,1,yn,1,tn,4,2,1);
  mod_reich_lp_s = matrix(1,xn,1,2*yn);
  mod_reich_hp_s = matrix(1,xn,1,2*yn);
  contort_real_3d_farray(mod_reich_lp,1,1,1,xn,yn,tn);
  contort_real_3d_farray(mod_reich_hp,1,1,1,xn,yn,tn);
  rlft3(mod_reich_lp,mod_reich_lp_s,xn,yn,tn,1);
  rlft3(mod_reich_hp,mod_reich_hp_s,xn,yn,tn,1);
  mod_me_tdelay = onode_getpar_flt_dflt(rdo,"tdelay",0.0);
  mod_me_oppflag = onode_getpar_int_dflt(rdo,"opp_flag",1);
  mod_reich_uxn = onode_getpar_int_exit(rdo,"n_unit_x");
  mod_reich_uyn = onode_getpar_int_dflt(rdo,"n_unit_y",1);
  mod_reich_dx  = onode_getpar_int_dflt(rdo,"dx",1);
  mod_reich_dy  = 0;
  mod_reich_ux0 = (xn - mod_reich_uxn) / 2;
  mod_reich_uy0 = (xn - mod_reich_uyn) / 2;
  if ((mod_reich_ux0 < 0) ||
      (mod_reich_uy0 < 0) ||
      (mod_reich_ux0 + mod_reich_uxn + mod_reich_dx > xn) ||
      (mod_reich_uy0 + mod_reich_uyn + mod_reich_dy > yn)){
    mylog_exit(mylogf,"MODEL_REICH_PREP  integration bounds error\n");
  }
  mod_reich_dump  = onode_getpar_int_dflt(rdo,"dump",0);
}
void model_me_01_done(mppl)
     struct param_pair_list *mppl; 
{
  int xn,yn,tn;
  mylog(mylogf,"  MODEL_ME_01_DONE\n");
  xn = mod_me_xn;
  yn = mod_me_yn;
  tn = mod_me_tn;
  if (mod_me_fpe_s != NULL){ 
    free_matrix(mod_me_fpe_s,1,xn,1,2*yn); mod_me_fpe_s = (float **)NULL;
    free_matrix(mod_me_fpo_s,1,xn,1,2*yn); mod_me_fpo_s = (float **)NULL;
    free_matrix(mod_me_fne_s,1,xn,1,2*yn); mod_me_fne_s = (float **)NULL;
    free_matrix(mod_me_fno_s,1,xn,1,2*yn); mod_me_fno_s = (float **)NULL;
  }
  if (mod_me_rpe != NULL){
    free_f3tensor(mod_me_rpe,1,xn,1,yn,1,tn);
  }
  if (mod_me_rpo != NULL)
    free_f3tensor(mod_me_rpo,1,xn,1,yn,1,tn);
  if (mod_me_rne != NULL){
    free_f3tensor(mod_me_rne,1,xn,1,yn,1,tn);
    free_f3tensor(mod_me_rno,1,xn,1,yn,1,tn);
  }
  if (mod_me_normflag > 0){
    free_f3tensor(mod_me_fg0,1,xn,1,yn,1,tn); mod_me_fg0 = (float ***)NULL;
    free_f3tensor(mod_me_fg1,1,xn,1,yn,1,tn); mod_me_fg1 = (float ***)NULL;
    if (mod_me_fg0_s != NULL){
      free_matrix(mod_me_fg0_s,1,xn,1,2*yn); mod_me_fg0_s = (float **)NULL;
      free_matrix(mod_me_fg1_s,1,xn,1,2*yn); mod_me_fg1_s = (float **)NULL;
    }
    if (mod_me_rg0 != NULL){
      free_f3tensor(mod_me_rg0,1,xn,1,yn,1,tn);
      free_f3tensor(mod_me_rg1,1,xn,1,yn,1,tn);
    }
  }
  myfree(mod_me_modtype);
}
void mod_me_compute_response_from_ft(data,fs,fn,xn,yn,tn)
     float ***data;               
     struct mod_me_fstruct **fs;  
     int fn;                      
     int xn,yn,tn;                
{
  int i;
  float fc,**speq,***r,**rs;
  mylog(mylogf,"  MOD_ME_COMPUTE_RESPONSE_FROM_FT\n");
  fc = 2.0/((float)(xn*yn*tn));
  mylog(mylogf,"    Stimulus FFT\n");
  speq = matrix(1,xn,1,2*yn);
  contort_real_3d_farray(data,1,1,1,xn,yn,tn);
  rlft3(data,speq,xn,yn,tn,1);
  if (myid == -1){
    printf("    Stim FT times ME FT.\n");
    printf("      filter:  ");
    fflush(stdout);
  }else{
    mylog(mylogf,"    Stim FT times ME FT\n");
    mylog(mylogf,"    Filter:  ");
  }
  for(i=0;i<fn;i++){  
    if (fs[i]->flag == 1){  
      three_d_fft_prod(data,speq,fs[i]->f,fs[i]->s,xn,yn,tn,&r,&rs);
      rlft3(r,rs,xn,yn,tn,-1); free_matrix(rs,1,xn,1,2*yn);
      multiply_3d_farray(r,1,xn,1,yn,1,tn,fc);
      contort_real_3d_farray(r,1,1,1,xn,yn,tn);
      fs[i]->r = r;
      if (myid == -1){
	printf("%d ",i);
	fflush(stdout);
      }else{
	sprintf(ggstr,"%d ",i);
	mylog(mylogf,ggstr);
      }
    }
  }
  if (myid == -1){
    printf("\n");
  }else{
    mylog(mylogf,"\n");
  }
  free_matrix(speq,1,xn,1,2*yn);
}
void mod_me_compute_response_quad_opp_from_ft(data,fpe,fpo,fne,fno,
					      fpe_s,fpo_s,fne_s,fno_s,
					      xn,yn,tn,rrpe,rrpo,rrne,rrno,
					      rrg0,rrg1)
     float ***data,***fpe,***fpo,***fne,***fno;
     float **fpe_s,**fpo_s,**fne_s,**fno_s;
     int xn,yn,tn;
     float ****rrpe,****rrpo,****rrne,****rrno;
     float ****rrg0,****rrg1;
{
  int i;
  int fn;
  struct mod_me_fstruct **fs;
  mylog(mylogf,"  MOD_ME_COMPUTE_RESPONSE_QUAD_OPP_FROM_FT\n");
  fn = 4;
  if (mod_me_normflag > 0)
    fn += 2;
  fs = (struct mod_me_fstruct **)myalloc(fn*sizeof(struct mod_me_fstruct *));
  for(i=0;i<fn;i++)
    fs[i] = (struct mod_me_fstruct *)myalloc(sizeof(struct mod_me_fstruct));
  fs[0]->f = fpe;  fs[0]->s = fpe_s;
  fs[1]->f = fpo;  fs[1]->s = fpo_s;
  fs[2]->f = fne;  fs[2]->s = fne_s;
  fs[3]->f = fno;  fs[3]->s = fno_s;
  if (mod_me_normflag > 0){
    fs[4]->f = mod_me_fg0;  fs[4]->s = mod_me_fg0_s;
    fs[5]->f = mod_me_fg1;  fs[5]->s = mod_me_fg1_s;
  }
  mod_me_compute_response_from_ft(data,fs,fn,xn,yn,tn);
  *rrpe = fs[0]->r;
  *rrpo = fs[1]->r;
  *rrne = fs[2]->r;
  *rrno = fs[3]->r;
  if (mod_me_normflag > 0){
    *rrg0 = fs[4]->r;
    *rrg1 = fs[5]->r;
  }else{
    *rrg0 = *rrg1 = NULL;
  }
  for(i=0;i<fn;i++)
    myfree(fs[i]);
  myfree(fs);
}
void mod_me_compute_response_quad_opp_from_ft_x(data,fpe,fpo,fpx,fne,fno,fnx,
						fpe_s,fpo_s,fpx_s,
						fne_s,fno_s,fnx_s,
						xn,yn,tn,rrpe,rrpo,rrpx,
						rrne,rrno,rrnx,
						rrg0,rrg1)
     float ***data,***fpe,***fpo,***fpx,***fne,***fno,***fnx;
     float **fpe_s,**fpo_s,**fpx_s,**fne_s,**fno_s,**fnx_s;
     int xn,yn,tn;
     float ****rrpe,****rrpo,****rrpx,****rrne,****rrno,****rrnx;
     float ****rrg0,****rrg1;
{
  float **speq,***rpe,***rpo,***rpx,***rne,***rno,***rnx;
  float **pe_s,**po_s,**px_s,**ne_s,**no_s,**nx_s,fc;
  float ***rg0,***rg1;
  float **g0_s,**g1_s;
  mylog(mylogf,"  MOD_ME_COMPUTE_RESPONSE_QUAD_OPP_FROM_FT_X\n");
  fc = 2.0/((float)(xn*yn*tn));
  if (myid == -1){
    printf("      Stimulus FFT.");
    fflush(stdout);
  }else
    mylog(mylogf,"    Stimulus FFT\n");
  speq = matrix(1,xn,1,2*yn);
  contort_real_3d_farray(data,1,1,1,xn,yn,tn);
  rlft3(data,speq,xn,yn,tn,1);
  if (myid == -1){
    printf("  Stim FT times ME FT.");
    fflush(stdout);
  }else
    mylog(mylogf,"    Stim FT times ME FT\n");
  three_d_fft_prod(data,speq,fpe,fpe_s,xn,yn,tn,&rpe,&pe_s);
  three_d_fft_prod(data,speq,fpo,fpo_s,xn,yn,tn,&rpo,&po_s);
  three_d_fft_prod(data,speq,fpx,fpx_s,xn,yn,tn,&rpx,&px_s);
  three_d_fft_prod(data,speq,fne,fne_s,xn,yn,tn,&rne,&ne_s);
  three_d_fft_prod(data,speq,fno,fno_s,xn,yn,tn,&rno,&no_s);
  three_d_fft_prod(data,speq,fnx,fnx_s,xn,yn,tn,&rnx,&nx_s);
  if (mod_me_normflag > 0){
    three_d_fft_prod(data,speq,mod_me_fg0,mod_me_fg0_s,xn,yn,tn,&rg0,&g0_s);
    three_d_fft_prod(data,speq,mod_me_fg1,mod_me_fg1_s,xn,yn,tn,&rg1,&g1_s);
  }
  free_matrix(speq,1,xn,1,2*yn);
  if (myid == -1){
    printf("  Inverse FFT.");
    fflush(stdout);
  }else
    mylog(mylogf,"    Inverse FFT\n");
  sprintf(ggstr,"   xn,yn,tn  %d %d %d",xn,yn,tn);
  mylog(mylogf,ggstr);
  rlft3(rpe,pe_s,xn,yn,tn,-1); free_matrix(pe_s,1,xn,1,2*yn);
  rlft3(rpo,po_s,xn,yn,tn,-1); free_matrix(po_s,1,xn,1,2*yn);
  rlft3(rpx,px_s,xn,yn,tn,-1); free_matrix(px_s,1,xn,1,2*yn);
  rlft3(rne,ne_s,xn,yn,tn,-1); free_matrix(ne_s,1,xn,1,2*yn);
  rlft3(rno,no_s,xn,yn,tn,-1); free_matrix(no_s,1,xn,1,2*yn);
  rlft3(rnx,nx_s,xn,yn,tn,-1); free_matrix(nx_s,1,xn,1,2*yn);
  multiply_3d_farray(rpe,1,xn,1,yn,1,tn,fc);
  multiply_3d_farray(rpo,1,xn,1,yn,1,tn,fc);
  multiply_3d_farray(rpx,1,xn,1,yn,1,tn,fc);
  multiply_3d_farray(rne,1,xn,1,yn,1,tn,fc);
  multiply_3d_farray(rno,1,xn,1,yn,1,tn,fc);
  multiply_3d_farray(rnx,1,xn,1,yn,1,tn,fc);
  contort_real_3d_farray(rpe,1,1,1,xn,yn,tn);
  contort_real_3d_farray(rpo,1,1,1,xn,yn,tn);
  contort_real_3d_farray(rpx,1,1,1,xn,yn,tn);
  contort_real_3d_farray(rne,1,1,1,xn,yn,tn);
  contort_real_3d_farray(rno,1,1,1,xn,yn,tn);
  contort_real_3d_farray(rnx,1,1,1,xn,yn,tn);
  if (mod_me_normflag > 0){
    mylog(mylogf,"    'normflag' Computation\n");
    rlft3(rg0,g0_s,xn,yn,tn,-1); free_matrix(g0_s,1,xn,1,2*yn);
    rlft3(rg1,g1_s,xn,yn,tn,-1); free_matrix(g1_s,1,xn,1,2*yn);
    multiply_3d_farray(rg0,1,xn,1,yn,1,tn,fc);
    multiply_3d_farray(rg1,1,xn,1,yn,1,tn,fc);
    contort_real_3d_farray(rg0,1,1,1,xn,yn,tn);
    contort_real_3d_farray(rg1,1,1,1,xn,yn,tn);
  }else{
    rg0 = rg1 = NULL;
  }
  if (myid == -1)
    printf("  Done.\n");
  else
    mylog(mylogf,"    Done.\n");
  *rrpe = rpe;
  *rrpo = rpo;
  *rrpx = rpx;
  *rrne = rne;
  *rrno = rno;
  *rrnx = rnx;
  *rrg0 = rg0;
  *rrg1 = rg1;
}
void mod_me_compute_response_gabor_comp_from_ft(data,fpe,fpo,fpe_s,fpo_s,
						xn,yn,tn,rrpe,rrpo)
     float ***data,***fpe,***fpo;
     float **fpe_s,**fpo_s;
     int xn,yn,tn;
     float ****rrpe,****rrpo;
{
  float **speq,***rpe,***rpo;
  float **pe_s,**po_s,fc;
  mylog(mylogf,"  MOD_ME_COMPUTE_RESPONSE_GABOR_COMP_FROM_FT\n");
  fc = 2.0/((float)(xn*yn*tn));
  if (myid == -1){
    printf("      Stimulus FFT.");
    fflush(stdout);
  }
  speq = matrix(1,xn,1,2*yn);
  contort_real_3d_farray(data,1,1,1,xn,yn,tn);
  rlft3(data,speq,xn,yn,tn,1);
  if (myid == -1){
    printf("  Stim FT times ME FT.");
    fflush(stdout);
  }
  three_d_fft_prod(data,speq,fpe,fpe_s,xn,yn,tn,&rpe,&pe_s);
  three_d_fft_prod(data,speq,fpo,fpo_s,xn,yn,tn,&rpo,&po_s);
  free_matrix(speq,1,xn,1,2*yn);
  if (myid == -1){
    printf("  Inverse FFT.");
    fflush(stdout);
  }
  rlft3(rpe,pe_s,xn,yn,tn,-1); free_matrix(pe_s,1,xn,1,2*yn);
  rlft3(rpo,po_s,xn,yn,tn,-1); free_matrix(po_s,1,xn,1,2*yn);
  multiply_3d_farray(rpe,1,xn,1,yn,1,tn,fc);
  multiply_3d_farray(rpo,1,xn,1,yn,1,tn,fc);
  contort_real_3d_farray(rpe,1,1,1,xn,yn,tn);
  contort_real_3d_farray(rpo,1,1,1,xn,yn,tn);
  if (myid == -1)
    printf("  Done.\n");
  *rrpe = rpe;
  *rrpo = rpo;
}
void mod_reich_compute_response_from_ft(data,flp,fhp,flp_s,fhp_s,
					xn,yn,tn,rrhp,rrlp)
     float ***data,***flp,***fhp;
     float **flp_s,**fhp_s;
     int xn,yn,tn;
     float ****rrhp,****rrlp;
{
  float **speq,***rlp,***rhp;
  float **lp_s,**hp_s,fc;
  mylog(mylogf,"  MOD_REICH_COMPUTE_RESPONSE_FROM_FT\n");
  fc = 2.0/((float)(xn*yn*tn));
  if (myid == -1){
    printf("      Stimulus FFT.");
    fflush(stdout);
  }
  speq = matrix(1,xn,1,2*yn);
  contort_real_3d_farray(data,1,1,1,xn,yn,tn);
  rlft3(data,speq,xn,yn,tn,1);
  if (myid == -1){
    printf("  Stim FT times ME FT.");
    fflush(stdout);
  }
  three_d_fft_prod(data,speq,flp,flp_s,xn,yn,tn,&rlp,&lp_s);
  three_d_fft_prod(data,speq,fhp,fhp_s,xn,yn,tn,&rhp,&hp_s);
  free_matrix(speq,1,xn,1,2*yn);
  if (myid == -1){
    printf("  Inverse FFT.");
    fflush(stdout);
  }
  rlft3(rlp,lp_s,xn,yn,tn,-1); free_matrix(lp_s,1,xn,1,2*yn);
  rlft3(rhp,hp_s,xn,yn,tn,-1); free_matrix(hp_s,1,xn,1,2*yn);
  multiply_3d_farray(rlp,1,xn,1,yn,1,tn,fc);
  multiply_3d_farray(rhp,1,xn,1,yn,1,tn,fc);
  contort_real_3d_farray(rlp,1,1,1,xn,yn,tn);
  contort_real_3d_farray(rhp,1,1,1,xn,yn,tn);
  if (myid == -1)
    printf("  Done.\n");
  *rrlp = rlp;
  *rrhp = rhp;
}
void mod_me_compute_response_mem(data,mem,xn,yn,tn)
     float ***data;
     struct mod_mem *mem;
     int xn,yn,tn;
{
  int i;
  int n;
  float **speq,**pe_s,**po_s,**ne_s,**no_s,fc;
  mylog(mylogf,"  MOD_ME_COMPUTE_RESPONSE_MEM\n");
  fc = 2.0/((float)(xn*yn*tn));
  if (myid == -1){
    printf("      Stimulus FFT.");
    fflush(stdout);
  }
  speq = matrix(1,xn,1,2*yn);
  contort_real_3d_farray(data,1,1,1,xn,yn,tn);
  rlft3(data,speq,xn,yn,tn,1);
  if (myid == -1){
    printf("  Stim FT times ME FT.");
    fflush(stdout);
  }
  n = mem->nf;
  for(i=0;i<n;i++){
    three_d_fft_prod(data,speq,mem->f[i][0],mem->fs[i][0],xn,yn,tn,
		     &(mem->r[i][0]),&pe_s);
    three_d_fft_prod(data,speq,mem->f[i][1],mem->fs[i][1],xn,yn,tn,
		     &(mem->r[i][1]),&po_s);
    three_d_fft_prod(data,speq,mem->f[i][2],mem->fs[i][2],xn,yn,tn,
		     &(mem->r[i][2]),&ne_s);
    three_d_fft_prod(data,speq,mem->f[i][3],mem->fs[i][3],xn,yn,tn,
		     &(mem->r[i][3]),&no_s);
    rlft3(mem->r[i][0],pe_s,xn,yn,tn,-1); free_matrix(pe_s,1,xn,1,2*yn);
    rlft3(mem->r[i][1],po_s,xn,yn,tn,-1); free_matrix(po_s,1,xn,1,2*yn);
    rlft3(mem->r[i][2],ne_s,xn,yn,tn,-1); free_matrix(ne_s,1,xn,1,2*yn);
    rlft3(mem->r[i][3],no_s,xn,yn,tn,-1); free_matrix(no_s,1,xn,1,2*yn);
    multiply_3d_farray(mem->r[i][0],1,xn,1,yn,1,tn,fc);
    multiply_3d_farray(mem->r[i][1],1,xn,1,yn,1,tn,fc);
    multiply_3d_farray(mem->r[i][2],1,xn,1,yn,1,tn,fc);
    multiply_3d_farray(mem->r[i][3],1,xn,1,yn,1,tn,fc);
    contort_real_3d_farray(mem->r[i][0],1,1,1,xn,yn,tn);
    contort_real_3d_farray(mem->r[i][1],1,1,1,xn,yn,tn);
    contort_real_3d_farray(mem->r[i][2],1,1,1,xn,yn,tn);
    contort_real_3d_farray(mem->r[i][3],1,1,1,xn,yn,tn);
    if (myid == -1)
      printf("    Done filter %d.\n",i);
  }
  free_matrix(speq,1,xn,1,2*yn);
}
void mod_me_compute_response_simp_from_ft(data,fpe,fpe_s,xn,yn,tn,rrpe)
     float ***data,***fpe;
     float **fpe_s;
     int xn,yn,tn;
     float ****rrpe;
{
  float **speq,***rpe;
  float **pe_s,fc;
  mylog(mylogf,"  MOD_ME_COMPUTE_RESPONSE_SIMP_FROM_FT\n");
  fc = 2.0/((float)(xn*yn*tn));
  if (myid == -1){
    printf("      Stimulus FFT.");
    fflush(stdout);
  }
  speq = matrix(1,xn,1,2*yn);
  contort_real_3d_farray(data,1,1,1,xn,yn,tn);
  rlft3(data,speq,xn,yn,tn,1);
  if (myid == -1){
    printf("  Stim FT times ME FT.");
    fflush(stdout);
  }
  three_d_fft_prod(data,speq,fpe,fpe_s,xn,yn,tn,&rpe,&pe_s);
  free_matrix(speq,1,xn,1,2*yn);
  if (myid == -1){
    printf("  Inverse FFT.");
    fflush(stdout);
  }
  rlft3(rpe,pe_s,xn,yn,tn,-1); free_matrix(pe_s,1,xn,1,2*yn);
  multiply_3d_farray(rpe,1,xn,1,yn,1,tn,fc);
  contort_real_3d_farray(rpe,1,1,1,xn,yn,tn);
  if (myid == -1)
    printf("  Done.\n");
  *rrpe = rpe;
}
void mod_me_handover_basic(m,r,mep_raw,men_raw,mep,men,rpe,rpo,rne,rno,
			   xn,yn,tn)
     struct model_struct *m;      
     struct response_struct *r;   
     float *mep_raw,*men_raw;     
     float *mep,*men;             
     float ***rpe,***rpo,***rne,***rno; 
     int xn,yn,tn;                
{
  int i;
  float *t;
  for(i=0;i<r->n;i++){ 
    if (strcmp(r->datid[i],"me_pref")==0){
      mod_util_resp_store_f_samp(r,i,mep,tn,1.0/mod_me_tscale,mylogf);
    }else if (strcmp(r->datid[i],"me_anti")==0){
      mod_util_resp_store_f_samp(r,i,men,tn,1.0/mod_me_tscale,mylogf);
    }else if (strcmp(r->datid[i],"me_opp")==0){
      if ((mep != NULL) && (men != NULL)){
	t = diff_farrays(mep,men,tn); 
	mod_util_resp_store_f_samp(r,i,t,tn,1.0/mod_me_tscale,mylogf);
	myfree(t);
      }
    }else if (strcmp(r->datid[i],"me_pref_raw")==0){
      mod_util_resp_store_f_samp(r,i,mep_raw,tn,1.0/mod_me_tscale,mylogf);
    }else if (strcmp(r->datid[i],"me_anti_raw")==0){
      mod_util_resp_store_f_samp(r,i,men_raw,tn,1.0/mod_me_tscale,mylogf);
    }else if (strcmp(r->datid[i],"filter_pref_even")==0){
      if (rpe != NULL){
	t = &(rpe[xn/2][yn/2][1]);
	mod_util_resp_store_f_samp(r,i,t,tn,1.0/mod_me_tscale,mylogf);
      }
    }else if (strcmp(r->datid[i],"filter_pref_odd")==0){
      if (rpo != NULL){
	t = &(rpo[xn/2][yn/2][1]);
	mod_util_resp_store_f_samp(r,i,t,tn,1.0/mod_me_tscale,mylogf);
      }
    }else if (strcmp(r->datid[i],"filter_anti_even")==0){
      if (rne != NULL){
	t = &(rne[xn/2][yn/2][1]);
	mod_util_resp_store_f_samp(r,i,t,tn,1.0/mod_me_tscale,mylogf);
      }
    }else if (strcmp(r->datid[i],"filter_anti_odd")==0){
      if (rno != NULL){
	t = &(rno[xn/2][yn/2][1]);
	mod_util_resp_store_f_samp(r,i,t,tn,1.0/mod_me_tscale,mylogf);
      }
    }else if (strcmp(r->datid[i],"filter_out")==0){
      if (strcmp(mod_me_modtype,"ds_simp_01")==0){
	mod_util_resp_store_f_samp(r,i,mep,tn,1.0/mod_me_tscale,mylogf);
      }else if (strcmp(mod_me_modtype,"ds_liv3")==0){
	mod_util_resp_store_f_samp(r,i,mep_raw,tn,1.0/mod_me_tscale,mylogf);
      }
    }
  }
}
float *mod_me_resp_binoc_thresh(float *d,       
				int n,          
				float thresh,   
				int signflag){  
  int i;
  float t,*y,fsgn;
  fsgn = 1.0;
  if (signflag == -1)
    fsgn = -1.0;
  y = (float *)myalloc(n*sizeof(float));
  if (mod_me_binoc_srect == 1){
    for(i=0;i<n;i++){
      t = fsgn*d[i] - thresh;
      if (t >= 0.0)
	y[i] = t;
      else
	y[i] = 0.0;
    }
  }else{
    for(i=0;i<n;i++)
      y[i] = fsgn*d[i] - thresh;
  }
  return y;
}
float *mod_me_resp_binoc_sig(int xi, int yi,  
			     char *sid,       
			     float thresh,    
			     int sqflag){     
  int i;
  int tn,signflag,si;
  float ty,sr,*tl,*tr,*ttl,*ttr,*y;
  tn = mod_me_tn;
  if ((strcmp(sid,"b1p")==0) || (strcmp(sid,"b1n")==0)){
    tl = &(mod_me_ff[0]->r[xi][yi][1]);   
    tr = &(mod_me_ff[2]->r[xi][yi][1]);   
    if (strcmp(sid,"b1p")==0)  
      si = 0;
    else
      si = 1;
  }else if ((strcmp(sid,"b2p")==0) || (strcmp(sid,"b2n")==0)){
    tl = &(mod_me_ff[1]->r[xi][yi][1]);   
    tr = &(mod_me_ff[3]->r[xi][yi][1]);   
    if (strcmp(sid,"b2p")==0)  
      si = 2;
    else
      si = 3;
  }else{
    exit_error("MOD_ME_RESP_BINOC_SIG","Unknown sid");
  }
  if (sid[2] == 'p')
    signflag = 1;
  else if (sid[2] == 'n')
    signflag = -1;
  if (mod_me_binoc_rsign[si] == '+')
    sr = 1.0;
  else
    sr = -1.0;
  ttl = mod_me_resp_binoc_thresh(tl,tn,thresh,signflag);
  ttr = mod_me_resp_binoc_thresh(tr,tn,thresh,signflag);
  y = (float *)myalloc(tn*sizeof(float));
  for(i=0;i<tn;i++){
    if (sqflag == 1){  
      ty = ttl[i] + sr*ttr[i];
      if (ty > 0.0)
	y[i] = ty*ty;
      else
	y[i] = 0.0;
    }else if (sqflag == 2)  
      y[i] = (ttl[i] + sr*ttr[i]) * (ttl[i] + sr*ttr[i]);
    else
      y[i] = ttl[i] + sr*ttr[i];  
  }
  return y;
}
void mod_me_gen_poisson(m,r,sgo,d,n,seed,rfs,rns,rv,rvn)
     struct model_struct *m;      
     struct response_struct *r;   
     struct onode *sgo;           
     float *d;                    
     int n;                       
     int seed;
     float **rfs;                 
     int    *rns;                 
     float **rv;                  
     int    *rvn;                 
{
  int ns,vn;
  float *fs,*v,samp,*t;
  samp = 1.0/mod_me_tscale;
  t = copy_farray(d,n);
  ifc_util_poisson(mylogf,m,sgo,t,n,samp,seed,0,1,&fs,&ns,&v,&vn);
  sprintf(ggstr,"    Made %d Poisson spikes.\n",ns);
  mylog(mylogf,ggstr);
  add_const_farray(fs,ns,mod_me_tdelay*1000.0); 
  *rfs = fs;
  *rns = ns;
  *rv  = v;
  *rvn = vn;
  myfree(d);
}
void mod_me_handover_binoc(m,r,xi,yi,binen,xn,yn,tn)
     struct model_struct *m;      
     struct response_struct *r;   
     int xi,yi;                   
     float *binen;                
     int xn,yn,tn;                
{
  int i;
  int sqflag;
  float thresh,*t,*t1,*t2,*tpos,*tneg;
  thresh = mod_me_binoc_athresh;  
  if (strcmp(mod_me_binoc_nonlin,"halfsq")==0)
    sqflag = 1;
  else if (strcmp(mod_me_binoc_nonlin,"square")==0)
    sqflag = 2;
  else if (strcmp(mod_me_binoc_nonlin,"none")==0)
    sqflag = 0;
  for(i=0;i<r->n;i++){ 
    if (strcmp(r->datid[i],"binoc_energy")==0){
      mod_util_resp_store_f_samp(r,i,binen,tn,1.0/mod_me_tscale,mylogf);
    }else if (strcmp(r->datid[i],"filter_left_1")==0){  
      t = &(mod_me_ff[0]->r[xi][yi][1]);
      mod_util_resp_store_f_samp(r,i,t,tn,1.0/mod_me_tscale,mylogf);
    }else if (strcmp(r->datid[i],"filter_left_2")==0){  
      t = &(mod_me_ff[1]->r[xi][yi][1]);
      mod_util_resp_store_f_samp(r,i,t,tn,1.0/mod_me_tscale,mylogf);
    }else if (strcmp(r->datid[i],"filter_right_1")==0){
      t = &(mod_me_ff[2]->r[xi][yi][1]);
      mod_util_resp_store_f_samp(r,i,t,tn,1.0/mod_me_tscale,mylogf);
    }else if (strcmp(r->datid[i],"filter_right_2")==0){
      t = &(mod_me_ff[3]->r[xi][yi][1]);
      mod_util_resp_store_f_samp(r,i,t,tn,1.0/mod_me_tscale,mylogf);
    }else if (strcmp(r->datid[i],"binoc_1_pos")==0){
      t = mod_me_resp_binoc_sig(xi,yi,"b1p",thresh,0);  
      mod_util_resp_store_f_samp(r,i,t,tn,1.0/mod_me_tscale,mylogf);
      myfree(t);
    }else if (strcmp(r->datid[i],"binoc_1_neg")==0){
      t = mod_me_resp_binoc_sig(xi,yi,"b1n",thresh,0);  
      mod_util_resp_store_f_samp(r,i,t,tn,1.0/mod_me_tscale,mylogf);
      myfree(t);
    }else if (strcmp(r->datid[i],"binoc_2_pos")==0){
      t = mod_me_resp_binoc_sig(xi,yi,"b2p",thresh,0);  
      mod_util_resp_store_f_samp(r,i,t,tn,1.0/mod_me_tscale,mylogf);
      myfree(t);
    }else if (strcmp(r->datid[i],"binoc_2_neg")==0){
      t = mod_me_resp_binoc_sig(xi,yi,"b2n",thresh,0);  
      mod_util_resp_store_f_samp(r,i,t,tn,1.0/mod_me_tscale,mylogf);
      myfree(t);
    }else if (strcmp(r->datid[i],"binoc_1_pos_sq")==0){
      t = mod_me_resp_binoc_sig(xi,yi,"b1p",thresh,sqflag);
      mod_util_resp_store_f_samp(r,i,t,tn,1.0/mod_me_tscale,mylogf);
      myfree(t);
    }else if (strcmp(r->datid[i],"binoc_1_neg_sq")==0){
      t = mod_me_resp_binoc_sig(xi,yi,"b1n",thresh,sqflag);
      mod_util_resp_store_f_samp(r,i,t,tn,1.0/mod_me_tscale,mylogf);
      myfree(t);
    }else if (strcmp(r->datid[i],"binoc_2_pos_sq")==0){
      t = mod_me_resp_binoc_sig(xi,yi,"b2p",thresh,sqflag);
      mod_util_resp_store_f_samp(r,i,t,tn,1.0/mod_me_tscale,mylogf);
      myfree(t);
    }else if (strcmp(r->datid[i],"binoc_2_neg_sq")==0){
      t = mod_me_resp_binoc_sig(xi,yi,"b2n",thresh,sqflag);
      mod_util_resp_store_f_samp(r,i,t,tn,1.0/mod_me_tscale,mylogf);
      myfree(t);
    }else if (strcmp(r->datid[i],"binoc_1")==0){
      tpos = mod_me_resp_binoc_sig(xi,yi,"b1p",thresh,sqflag);
      tneg = mod_me_resp_binoc_sig(xi,yi,"b1n",thresh,sqflag);
      t = add_farrays(tpos,tneg,tn);
      mod_util_resp_store_f_samp(r,i,t,tn,1.0/mod_me_tscale,mylogf);
      myfree(tpos); myfree(tneg); myfree(t);
    }else if (strcmp(r->datid[i],"binoc_2")==0){
      tpos = mod_me_resp_binoc_sig(xi,yi,"b2p",thresh,sqflag);
      tneg = mod_me_resp_binoc_sig(xi,yi,"b2n",thresh,sqflag);
      t = add_farrays(tpos,tneg,tn);
      mod_util_resp_store_f_samp(r,i,t,tn,1.0/mod_me_tscale,mylogf);
      myfree(tpos); myfree(tneg); myfree(t);
    }
  }
}
void mod_me_handover_v5(m,r)
     struct model_struct *m;      
     struct response_struct *r;   
{
  int i;
  int xi,yi,ci,li,tn,id,xn,yn,seed,ns,vn;
  float *t,*tt,*fs,*v;
  struct mod_me_v5_struct *mv5;
  struct mod_me_v1_input ***v1resp;
  struct mod_me_v1resp *tv1;
  struct pop_layer *pl;
  struct mod_me_v5_pop *mtresp;
  struct onode *sgo,*popo;
  mv5 = mod_me_v5;
  v1resp = mv5->v1resp;
  xn = mod_me_xn;
  yn = mod_me_yn;
  tt = NULL;  
  tn = mod_me_tn;
  for(i=0;i<r->n;i++){ 
    if (r->rformat[i] == 0){
    if (compare_prefix_string_order("v1r_raw_", r->datid[i]) ||
	compare_prefix_string_order("v1r_norm_",r->datid[i]) ||
	compare_prefix_string_order("v1r_opp_", r->datid[i]) ||
	compare_prefix_string_order("v1r_bde_", r->datid[i]) ||
	compare_prefix_string_order("v1r_me_", r->datid[i]) ||
	compare_prefix_string_order("v1_binoc_",r->datid[i]) ||
	(strcmp(r->datid[i],"v1r_sum")==0)){
      if (mv5->binoc == 0){
	printf("  *** Data ID requires Right Eye:  %s\n",r->datid[i]);
	exit_error("MOD_ME_HANDOVER_V5","Stimulus is left eye only");
      }
    }
    if (compare_prefix_string_order("v1_binoc_",r->datid[i])){
      exit_error("MOD_ME_HANDOVER_V5","No 'v1_binoc_...' response");
    }
    if (compare_prefix_string_order("v1_raw_",  r->datid[i]) ||
	compare_prefix_string_order("v1_rawodd_", r->datid[i]) ||
	compare_prefix_string_order("v1r_raw_", r->datid[i]) ||
	compare_prefix_string_order("v1r_rawodd_", r->datid[i]) ||
	compare_prefix_string_order("v1_norm_", r->datid[i]) ||
	compare_prefix_string_order("v1r_norm_",r->datid[i]) ||
	compare_prefix_string_order("v1_normodd_", r->datid[i]) ||
	compare_prefix_string_order("v1r_normodd_",r->datid[i]) ||
	compare_prefix_string_order("v1_opp_even_pos_",  r->datid[i]) ||
	compare_prefix_string_order("v1_opp_even_neg_",  r->datid[i]) ||
	compare_prefix_string_order("v1_opp_odd_pos_",  r->datid[i]) ||
	compare_prefix_string_order("v1_opp_odd_neg_",  r->datid[i]) ||
	compare_prefix_string_order("v1r_opp_even_pos_",  r->datid[i]) ||
	compare_prefix_string_order("v1r_opp_even_neg_",  r->datid[i]) ||
	compare_prefix_string_order("v1r_opp_odd_pos_",  r->datid[i]) ||
	compare_prefix_string_order("v1r_opp_odd_neg_",  r->datid[i]) ||
	compare_prefix_string_order("v1_bde_neg_",  r->datid[i]) ||
	compare_prefix_string_order("v1_bde_pos_",  r->datid[i]) ||
	compare_prefix_string_order("v1r_bde_neg_",  r->datid[i]) ||
	compare_prefix_string_order("v1r_bde_pos_",  r->datid[i]) ||
	compare_prefix_string_order("v1_opp_",  r->datid[i]) ||
	compare_prefix_string_order("v1r_opp_", r->datid[i]) ||
	compare_prefix_string_order("v1_oppodd_",  r->datid[i]) ||
	compare_prefix_string_order("v1r_oppodd_", r->datid[i]) ||
	compare_prefix_string_order("v1_bde_",  r->datid[i]) ||
	compare_prefix_string_order("v1r_bde_", r->datid[i]) ||
	compare_prefix_string_order("v1_bd_",  r->datid[i]) ||
	compare_prefix_string_order("v1r_bd_", r->datid[i]) ||
	compare_prefix_string_order("v1_binoc_", r->datid[i])){
      id = carray_util_underscore_int_final(r->datid[i]);
      if ((id < 1) || (id > mv5->n)){
	printf("  Data ID:  %s\n",r->datid[i]);
	printf("    Index:  %d\n",id);
	exit_error("MOD_ME_HANDOVER_V5","Response index out of range");
      }
      if (compare_prefix_string_order("v1_raw_",  r->datid[i])){
	t = v1resp[0][0]->dl->raw[id-1][0];   
      }else if (compare_prefix_string_order("v1_rawodd_", r->datid[i])){
	t = v1resp[0][0]->dl->raw[id-1][1];
      }else if (compare_prefix_string_order("v1r_raw_", r->datid[i])){
	t = v1resp[0][0]->dr->raw[id-1][0];
      }else if (compare_prefix_string_order("v1r_rawodd_", r->datid[i])){
	t = v1resp[0][0]->dr->raw[id-1][1];
      }else if (compare_prefix_string_order("v1_norm_", r->datid[i])){
	t = v1resp[0][0]->dl->norm[id-1][0];
      }else if (compare_prefix_string_order("v1_normodd_", r->datid[i])){
	t = v1resp[0][0]->dl->norm[id-1][1];
      }else if (compare_prefix_string_order("v1r_norm_", r->datid[i])){
	t = v1resp[0][0]->dr->norm[id-1][0];
      }else if (compare_prefix_string_order("v1r_normodd_", r->datid[i])){
	t = v1resp[0][0]->dr->norm[id-1][1];
      }else if (compare_prefix_string_order("v1_opp_even_pos_", r->datid[i])){
	t = v1resp[0][0]->dl->opp[id-1][0];
      }else if (compare_prefix_string_order("v1_opp_odd_pos_", r->datid[i])){
	t = v1resp[0][0]->dl->opp[id-1][1];
      }else if (compare_prefix_string_order("v1_opp_even_neg_", r->datid[i])){
	t = v1resp[0][0]->dl->opp[id-1][2];
      }else if (compare_prefix_string_order("v1_opp_odd_neg_", r->datid[i])){
	t = v1resp[0][0]->dl->opp[id-1][3];
      }else if (compare_prefix_string_order("v1r_opp_even_pos_", r->datid[i])){
	t = v1resp[0][0]->dr->opp[id-1][0];
      }else if (compare_prefix_string_order("v1r_opp_odd_pos_", r->datid[i])){
	t = v1resp[0][0]->dr->opp[id-1][1];
      }else if (compare_prefix_string_order("v1r_opp_even_neg_", r->datid[i])){
	t = v1resp[0][0]->dr->opp[id-1][2];
      }else if (compare_prefix_string_order("v1r_opp_odd_neg_", r->datid[i])){
	t = v1resp[0][0]->dr->opp[id-1][3];
      }else if (compare_prefix_string_order("v1_opp_", r->datid[i])){
	exit_error("MOD_ME_HANDOVER_V5",
	   "Use 'v1_opp_even_pos_...' instead of 'v1_opp_...' (.rsp)\n");
      }else if (compare_prefix_string_order("v1_oppodd_", r->datid[i])){
	exit_error("MOD_ME_HANDOVER_V5",
	   "Use 'v1_opp_odd_pos_...' instead of 'v1_oppodd_...' (.rsp)\n");
      }else if (compare_prefix_string_order("v1r_opp_", r->datid[i])){
	exit_error("MOD_ME_HANDOVER_V5",
	   "Use 'v1r_opp_even_pos_...' instead of 'v1r_opp_...' (.rsp)\n");
      }else if (compare_prefix_string_order("v1r_oppodd_", r->datid[i])){
	exit_error("MOD_ME_HANDOVER_V5",
	   "Use 'v1r_opp_odd_pos_...' instead of 'v1r_oppodd_...' (.rsp)\n");
      }else if (compare_prefix_string_order("v1_bde_", r->datid[i])){
	t = v1resp[0][0]->dl->bde[id-1][6];
      }else if (compare_prefix_string_order("v1r_bde_", r->datid[i])){
	t = v1resp[0][0]->dr->bde[id-1][6];
      }else if (compare_prefix_string_order("v1_bde_pos_", r->datid[i])){
	t = v1resp[0][0]->dl->bde[id-1][2];
      }else if (compare_prefix_string_order("v1r_bde_pos_", r->datid[i])){
	t = v1resp[0][0]->dr->bde[id-1][2];
      }else if (compare_prefix_string_order("v1_bde_neg_", r->datid[i])){
	t = v1resp[0][0]->dl->bde[id-1][5];
      }else if (compare_prefix_string_order("v1r_bde_neg_", r->datid[i])){
	t = v1resp[0][0]->dr->bde[id-1][5];
      }else if (compare_prefix_string_order("v1_bde_", r->datid[i])){
	exit_error("MOD_ME_HANDOVER_V5",
		   "Use 'v1_bde_pos_...' instead of 'v1_bde_...' (.rsp)\n");
      }else if (compare_prefix_string_order("v1r_bde_", r->datid[i])){
	exit_error("MOD_ME_HANDOVER_V5",
		   "Use 'v1r_bde_pos_...' instead of 'v1r_bde_...' (.rsp)\n");
      }else if (compare_prefix_string_order("v1_bd_even_", r->datid[i])){
	t = mv5->v1resp[0][0]->dl->bde[id-1][0];
      }else if (compare_prefix_string_order("v1r_bd_even_", r->datid[i])){
	t = mv5->v1resp[0][0]->dr->bde[id-1][0];
      }else if (compare_prefix_string_order("v1_bd_odd_", r->datid[i])){
	t = mv5->v1resp[0][0]->dl->bde[id-1][1];
      }else if (compare_prefix_string_order("v1r_bd_odd_", r->datid[i])){
	t = mv5->v1resp[0][0]->dr->bde[id-1][1];
      }else if (compare_prefix_string_order("v1_bd_even2_", r->datid[i])){
	t = v1resp[0][0]->dl->bde[id-1][0];
	tt = copy_farray(t,tn);	square_farray(tt,tn); t = tt;
      }else if (compare_prefix_string_order("v1r_bd_even2_", r->datid[i])){
	t = v1resp[0][0]->dr->bde[id-1][0];
	tt = copy_farray(t,tn);	square_farray(tt,tn); t = tt;
      }else if (compare_prefix_string_order("v1_bd_odd2_", r->datid[i])){
	t = v1resp[0][0]->dl->bde[id-1][1];
	tt = copy_farray(t,tn);	square_farray(tt,tn); t = tt;
      }else if (compare_prefix_string_order("v1r_bd_odd2_", r->datid[i])){
	t = v1resp[0][0]->dr->bde[id-1][1];
	tt = copy_farray(t,tn);	square_farray(tt,tn); t = tt;
      }else if (compare_prefix_string_order("v1_binoc_", r->datid[i])){
	exit_error("MOD_ME_HANDOVER_V5",
		   "Do not use 'v1_binoc_...' in .rsp file (Aug 2016).");
      }
    }else if (strcmp(r->datid[i],"v1_sum")==0){
      t = v1resp[0][0]->dl->sum;
    }else if (strcmp(r->datid[i],"v1r_sum")==0){
      t = v1resp[0][0]->dr->sum;
    }else if (strcmp(r->datid[i],"mt")==0){
      t = mv5->v1resp[0][0]->mtb;
    }else if (strcmp(r->datid[i],"mt_r")==0){
      t = mv5->mt_raw_r;
    }else if (strcmp(r->datid[i],"mt_l")==0){
      t = mv5->mt_raw_l;
    }else if (strcmp(r->datid[i],"mt_nl")==0){
      t = mv5->mt_norm;
    }else if ((strcmp(r->datid[i],"spikes")==0) ||
	      (strcmp(r->datid[i],"poisson_prob")==0)){
      t = mv5->mt_norm;
      seed = m->mseed[r->tsi];
      sgo = onode_child_get_unique(m->o,"spike_gen");
      mod_me_gen_poisson(m,r,sgo,t,tn,seed,&fs,&ns,&v,&vn);
      if (strcmp(r->datid[i],"spikes")==0){
	mod_util_resp_store_s(r,i,fs,ns,1,mylogf);  
      }else if (strcmp(r->datid[i],"poisson_prob")==0){
	mod_util_resp_store_f(r,i,v,vn,1,mylogf);   
      }
      myfree(fs);
      myfree(v);
      t = NULL;  
    }else
      t = NULL;
    }else if (r->rformat[i] == 1){
      xi = r->xi[i];
      yi = r->yi[i];
      ci = r->zi[i];
      if (mod_me_mpt == NULL){
	if ((xi != 0) || (yi != 0))
	  exit_error("MOD_ME_HANDOVER_V5",
		     "xi and yi must be 0, model has no MT summation");
      }
      if ((strcmp(r->plname[i],"v1")==0)||(strcmp(r->plname[i],"v1r")==0)){
	if ((xi < 0) || (xi >= xn) || (yi < 0) || (yi >= yn))
	  exit_error("MOD_ME_HANDOVER_V5",
	      "xi and yi must be in [0,xn-1] and [0,yn-1], respectively");
	if (mv5->v1resp[xi][yi]->flag == 0){
	  printf("  ***  xi,yi = %d, %d\n",xi,yi);
	  exit_error("MOD_ME_HANDOVER_V5",
		     "No V1 response was saved for the requested location.");
	}
	if (strcmp(r->plname[i],"v1")==0){
	  tv1 = v1resp[xi][yi]->dl;
	}else if (strcmp(r->plname[i],"v1r")==0){
	  tv1 = v1resp[xi][yi]->dr;
	}
	if ((strcmp(r->datid[i],"raw"     )==0)||
	    (strcmp(r->datid[i],"raw_even")==0)){
	  t = tv1->raw[ci][0];
	}else if (strcmp(r->datid[i],"raw_odd")==0){
	  t = tv1->raw[ci][1];
	}else if ((strcmp(r->datid[i],"norm"     )==0)||
		  (strcmp(r->datid[i],"norm_even")==0)){
	  t = tv1->norm[ci][0];
	}else if (strcmp(r->datid[i],"norm_odd")==0){
	  t = tv1->norm[ci][1];
	}else if (strcmp(r->datid[i],"opp_even")==0){
	  t = tv1->opp[ci][0];
	}else if (strcmp(r->datid[i],"opp_odd")==0){
	  t = tv1->opp[ci][1];
	}else if (strcmp(r->datid[i],"sum")==0){
	  t = tv1->sum;
	}else if (strcmp(r->datid[i],"bd_pos_even")==0){
	  t = tv1->bde[ci][0];
	}else if (strcmp(r->datid[i],"bd_pos_odd")==0){
	  t = tv1->bde[ci][1];
	}else if (strcmp(r->datid[i],"bde_pos")==0){
	  t = tv1->bde[ci][2];
	}else if (strcmp(r->datid[i],"bd_neg_even")==0){
	  t = tv1->bde[ci][3];
	}else if (strcmp(r->datid[i],"bd_neg_odd")==0){
	  t = tv1->bde[ci][4];
	}else if (strcmp(r->datid[i],"bde_neg")==0){
	  t = tv1->bde[ci][5];
	}else if (strcmp(r->datid[i],"bde")==0){
	  t = tv1->bde[ci][6];
	}else if (strcmp(r->datid[i],"mtsub_monoc")==0){
	  t = tv1->mt;
	}else if (strcmp(r->datid[i],"mtsub_binoc")==0){
	  t = v1resp[xi][yi]->mtb;
	}else{
	  printf("  *** datid:  %s\n",r->datid[i]);
	  exit_error("MOD_ME_HANDOVER_V5","Unknown 'datid'");
	}
      }else{
	li = popu_get_layer_index_by_name(mod_me_mpt,r->plname[i]);
	if (li < 0){
	  printf("  %s\n",r->plname[i]);
	  mylog_exit(mylogf,"MOD_ME_HANDOVER_V5  Unknown population name.\n");
	}
	pl = mod_me_mpt->lay[li];  
	mtresp = mv5->mtp[li - mv5->mtli0];
	if ((xi < 0) || (xi >= pl->xn) || (yi < 0) || (yi >= pl->yn))
	  exit_error("MOD_ME_HANDOVER_V5",
		     "xi or yi exceed size of 'mt' population");
	if (strcmp(r->datid[i],"raw")==0){
	  t = mtresp->ssum[xi][yi];
	}else if (strcmp(r->datid[i],"norm")==0){
	  t = mtresp->nl[xi][yi];
	}else if ((strcmp(r->datid[i],"spikes")==0) ||
		  (strcmp(r->datid[i],"poisson_prob")==0)){
	  t = mtresp->nl[xi][yi];
	  seed = mtresp->seed[xi][yi];
	  popo = onode_get_node_type_item_val(m->o,"pop","name",r->plname[i]);
	  sgo = onode_child_get_unique(popo,"spike_gen");
	  mod_me_gen_poisson(m,r,sgo,t,tn,seed,&fs,&ns,&v,&vn);
	  if (strcmp(r->datid[i],"spikes")==0){
	    mod_util_resp_store_s(r,i,fs,ns,1,mylogf);  
	  }else if (strcmp(r->datid[i],"poisson_prob")==0){
	    mod_util_resp_store_f(r,i,v,vn,1,mylogf);   
	  }
	  myfree(fs);
	  myfree(v);
	  t = NULL;  
	}else{
	  printf("  *** datid:  %s\n",r->datid[i]);
	  exit_error("MOD_ME_HANDOVER_V5","Unknown 'datid'");
	}
      }
    }
    if (t != NULL){
      mod_util_resp_store_f_samp(r,i,t,tn,1.0/mod_me_tscale,mylogf);
    }
    if (tt != NULL){  
      myfree(tt);
      tt = NULL;
    }
  }
}
    void mod_me_gen_hand_poisson(m,r,dp,da,n,diff_flag)
     struct model_struct *m;      
     struct response_struct *r;   
     float *dp;                   
     float *da;                   
     int n;                       
     int diff_flag;               
{
  int i;
  int ns,vn,ri,seed;
  float *fs,*v,samp,*d;
  struct onode *sgo;
  samp = 1.0/mod_me_tscale;
  seed = m->mseed[r->tsi];
  if (diff_flag == 1){
    if ((dp == NULL) || (da == NULL))
      mylogx(mylogf,"MOD_ME_GEN_HAND_POISSON","Null data received");
    d = subtract_farrays(dp,da,n);   
  }else{
    d = copy_farray(dp,n);           
  }
  if (m->ppl == NULL){
    sgo = onode_child_get_unique(m->o,"spike_gen");
    ifc_util_poisson(mylogf,m,sgo,d,n,samp,seed,0,1,&fs,&ns,&v,&vn);
  }else{
    ifc_util_poisson(mylogf,m,NULL,d,n,samp,seed,0,1,&fs,&ns,&v,&vn);
  }
  sprintf(ggstr,"    Made %d Poisson spikes\n",ns);
  mylog(mylogf,ggstr);
  add_const_farray(fs,ns,mod_me_tdelay*1000.0); 
  for(i=0;i<r->n;i++){ 
    if (strcmp(r->datid[i],"spikes")==0){
      mod_util_resp_store_s(r,i,fs,ns,1,mylogf);  
    }else if (strcmp(r->datid[i],"poisson_prob")==0){
      mod_util_resp_store_f(r,i,v,vn,1,mylogf);  
    }
  }
  myfree(d);
  myfree(fs);
  myfree(v);
}
void mod_me_gen_hand_ifc(m,r,dp,da,tn)
     struct model_struct *m;      
     struct response_struct *r;   
     float *dp;                   
     float *da;                   
     int tn;                      
{
  int i;
  int ns,fvn,seed;
  float *gti,*gtx,*fs,*fv,samp,samp_out;
  samp = 1.0/mod_me_tscale;
  seed = m->mseed[r->tsi];
  if (mod_me_oppflag == 0){
    gtx = diff_farrays(dp,da,tn);  
    gti = get_zero_farray(tn);
  }else if (mod_me_oppflag == 2){
    gtx = diff_farrays(dp,da,tn);  
    gti = diff_farrays(da,dp,tn);  
  }else if (mod_me_oppflag == 3){
    gtx = copy_farray(dp,tn);      
    gti = get_zero_farray(tn);
  }else{
    gtx = copy_farray(dp,tn);
    gti = copy_farray(da,tn);
  }
  ifc_test(myid,m,"ifc",gtx,gti,samp,tn,seed,1,NULL,&fs,&ns,1,&fv,&fvn);
  for(i=0;i<r->n;i++){ 
    if (strcmp(r->datid[i],"spikes")==0){
      add_const_farray(fs,ns,mod_me_tdelay*1000.0);  
      samp_out = r->samp[i];  
      multiply_farray(fs,ns,samp_out/1000.0);
      mod_util_resp_store_s(r,i,fs,ns,1,mylogf);  
    }else if (strcmp(r->datid[i],"ifc_gi")==0){
      mod_util_resp_store_f_samp(r,i,gti,tn,samp,mylogf);
    }else if (strcmp(r->datid[i],"ifc_gx")==0){
      mod_util_resp_store_f_samp(r,i,gtx,tn,samp,mylogf);
    }else if (strcmp(r->datid[i],"ifc_vm")==0){
      mod_util_resp_store_f_samp(r,i,fv,fvn,samp,mylogf);
    }
  }
  myfree(fs);
  myfree(fv);
  myfree(gtx);
  myfree(gti);
}
void mod_me_resp_binoc_gain_test(s)
     struct stim_struct *s;      
{
  int ti,xi,yi;
  int tn,xn,yn,t0;
  float ***fr0,***fr1,***fr2,***fr3;
  float *sum0,*sum1,*sum2,*sum3,*tot;
  char tname[SLEN];
  float sl,sr;
  tn = mod_me_tn;
  xn = mod_me_xn;
  yn = mod_me_yn;
  tot  = get_zero_farray(tn);
  for(ti=1;ti<=tn;ti++){
    t0 = ti-1;
    for(xi=1;xi<=xn;xi++){
      for(yi=1;yi<=yn;yi++){
	sl =  s->d[xi][yi][ti] - 0.5;
	sr =  s->d_r[xi][yi][ti] - 0.5;
	tot[t0] += (sl*sl);
	tot[t0] += (sr*sr);
      }
    }
  }
  sprintf(tname,"Tot_%d",s->stimno);
  append_farray_plot("zz.gain_binoc.pl",tname,tot,tn,1);
}
void mod_me_resp_binoc_filt(xi,yi,rr)
     int xi,yi;   
     float **rr;  
{
  int i;
  int tn,sqflag;
  float thresh,*pos1,*neg1,*pos2,*neg2,*r;
  tn = mod_me_tn;
  thresh = mod_me_binoc_athresh;
  if (strcmp(mod_me_binoc_nonlin,"halfsq")==0)
    sqflag = 1;
  else if (strcmp(mod_me_binoc_nonlin,"square")==0)
    sqflag = 2;
  else if (strcmp(mod_me_binoc_nonlin,"none")==0)
    sqflag = 0;
  pos1 = mod_me_resp_binoc_sig(xi,yi,"b1p",thresh,sqflag);  
  neg1 = mod_me_resp_binoc_sig(xi,yi,"b1n",thresh,sqflag);
  pos2 = mod_me_resp_binoc_sig(xi,yi,"b2p",thresh,sqflag);
  neg2 = mod_me_resp_binoc_sig(xi,yi,"b2n",thresh,sqflag);
  r = (float *)myalloc(tn*sizeof(float));
  for(i=0;i<tn;i++)
    r[i] = pos1[i] + neg1[i] + pos2[i] + neg2[i];
  *rr = r;
  myfree(pos1); myfree(neg1); myfree(pos2); myfree(neg2);
}
void model_me_01_get_response(m,s,r,k)
     struct model_struct *m;     
     struct stim_struct *s;      
     struct response_struct *r;  
     int k;                      
{
  int i,jx,jy;
  int xn,yn,tn,fn,x,y,tnr,diff_flag;
  float ***rpe,***rpo,***rne,***rno,*mep,*men,*mep_raw,*men_raw;
  float ***rg0,***rg1,*r1pe,*r1po,*r1ne,*r1no,*gg;
  char *spikegen;
  struct onode *sgen;
  struct mod_me_fstruct **fs;  
  xn = mod_me_xn;
  yn = mod_me_yn;
  tn = mod_me_tn;
  fs = mod_me_ff;
  fn = mod_me_fn;
  if ((k==0) || (fs[0]->r == NULL) || (s->stimno != mod_me_stimno_prev)){
    for(i=0;i<fn;i++)  
      if (fs[i]->r != NULL)
	free_f3tensor(fs[i]->r,1,xn,1,yn,1,tn);  
    if ((strcmp(mod_me_modtype,"binoc_filter")==0)){
      fs[0]->flag = fs[1]->flag = 1;  
      fs[2]->flag = fs[3]->flag = 0;
      mod_me_compute_response_from_ft(s->d,fs,fn,xn,yn,tn);   
      fs[0]->flag = fs[1]->flag = 0;
      fs[2]->flag = fs[3]->flag = 1;  
      mod_me_compute_response_from_ft(s->d_r,fs,fn,xn,yn,tn); 
    }else{
      mod_me_compute_response_from_ft(s->d,fs,fn,xn,yn,tn);   
    }
  }
  rpe = fs[0]->r;
  rpo = fs[1]->r;
  rne = fs[2]->r;
  rno = fs[3]->r;
  if (fn == 6){
    rg0 = fs[4]->r;
    rg1 = fs[5]->r;
  }
  x = xn/2;
  y = yn/2;
  if ((strcmp(mod_me_modtype,"binoc_filter")==0)){
    mod_me_resp_binoc_filt(x,y,&mep_raw);
    men_raw = get_zero_farray(tn);
  }else{
    mep_raw = (float *)myalloc(tn*sizeof(float));
    men_raw = (float *)myalloc(tn*sizeof(float));
    for(i=0;i<tn;i++){
      mep_raw[i] = rpe[x][y][1+i]*rpe[x][y][1+i]+rpo[x][y][1+i]*rpo[x][y][1+i];
      men_raw[i] = rne[x][y][1+i]*rne[x][y][1+i]+rno[x][y][1+i]*rno[x][y][1+i];
    }
  }
  tnr = tn;
  if (mod_me_pow != 1.0){
    mep = (float *)myalloc(tn*sizeof(float));
    men = (float *)myalloc(tn*sizeof(float));
    mylog(mylogf,"  WYETH NEW Applying power %f after squaring.\n",mod_me_pow);
    for(i=0;i<tnr;i++){
      mep[i] = pow(mep_raw[i],mod_me_pow);
      men[i] = pow(men_raw[i],mod_me_pow);
    }
  }else{
    mep = copy_farray(mep_raw,tn);
    men = copy_farray(men_raw,tn);
  }
  if (mod_me_normflag > 0){
    float *smooth,tnorm,tt;
    float mean,sdev,tsig;
    int sp1,sp2;
    sp1 = x - mod_me_norm_xn/2;
    sp2 = sp1 + mod_me_norm_xn;
    gg  = (float *)myalloc(tn*sizeof(float));
    for(i=0;i<tn;i++){
      tnorm = 0.0;
      for(jx=sp1;jx<sp2;jx++){ 
	for(jy=sp1;jy<sp2;jy++){
	  tt = (rg0[jx][jy][1+i]*rg0[jx][jy][1+i] +
		rg1[jx][jy][1+i]*rg1[jx][jy][1+i]);
	  tnorm += pow(tt,mod_me_norm_pow);
	}
      }
      gg[i] = mod_me_norm_c + 
	mod_me_norm_f * tnorm / (float)(mod_me_norm_xn*mod_me_norm_xn);
      if (gg[i] < 1.0)
	gg[i] = 1.0;
    }
    if (myid == -1)
      append_farray_plot("zz.norm.pl","gg",gg,tn,1);
    if (mod_me_norm_tsd > 0.0){
      tsig = mod_me_norm_tsd / mod_me_tscale;
      smooth = smooth_with_gaussian(gg,tn,tsig,0.01);
      myfree(gg);
      gg = smooth;
    }
    if (myid == -1)
      append_farray_plot("zz.norm.pl","gg_Smooth",gg,tn,1);
    if (mod_me_norm_app == 1){
      for(i=0;i<tn;i++){
	mep[i] /= gg[i];
	men[i] /= gg[i];
      }
    }else{
      exit_error("MODEL_ME_01_GET_RESPONSE","Bad me_norm_app type");
    }
    mean_sdev_farray(gg+50,tn-100,&mean,&sdev);
    sprintf(ggstr,"  GAIN SIGNAL STATS:  %f %f\n",mean,sdev);
    mylog(mylogf,ggstr);
    mean_sdev_farray(mep+50,tn-100,&mean,&sdev);
    sprintf(ggstr,"  ME-P SIGNAL STATS:  %f %f\n",mean,sdev);
    mylog(mylogf,ggstr);
    myfree(gg);
  }
  mod_me_stimno_prev = s->stimno;
  if ((strcmp(mod_me_modtype,"binoc_filter")==0)){
    mod_me_handover_binoc(m,r,x,y,mep,xn,yn,tn);
  }else{
    mod_me_handover_basic(m,r,mep_raw,men_raw,mep,men,rpe,rpo,rne,rno,xn,yn,tn);
  }
  if (m->ppl == NULL){
    sgen = onode_child_get_unique(m->o,"spike_gen");
    spikegen = onode_getpar_chr_exit(sgen,"type");
  }else
    spikegen = paramfile_get_char_param_or_exit(m->ppl,"spike_gen");
  if (strcmp(spikegen,"poisson")==0){
    if (mod_me_oppflag == 0)
      diff_flag = 1;
    else
      diff_flag = 0;
    mod_me_gen_hand_poisson(m,r,mep,men,tn,diff_flag);
  }else if (strcmp(spikegen,"ifc")==0){
    mod_me_gen_hand_ifc(m,r,mep,men,tn);
  }else{
    sprintf(ggstr,"spike_gen = %s\n",spikegen);
    mylog(mylogf,ggstr);
    mylog_exit(mylogf,"MODEL_ME_01_GET_RESPONSE  Unknown spike_gen.\n");
  }
  myfree(spikegen);
  myfree(mep);     
  myfree(men);     
  myfree(mep_raw); 
  myfree(men_raw); 
  mod_util_resp_unfilled_exit(r,mylogf);
}
void model_me_01_get_response_x(m,s,r,k)
     struct model_struct *m;     
     struct stim_struct *s;      
     struct response_struct *r;  
     int k;                      
{
  int i,jx,jy;
  int xn,yn,tn,x,y,tnr,diff_flag;
  float ***fpe,***fpo,***fpx,***fne,***fno,***fnx;
  float **fpe_s,**fpo_s,**fpx_s,**fne_s,**fno_s,**fnx_s;
  float ***rpe,***rpo,***rpx,***rne,***rno,***rnx,*mep,*men,*mep_raw,*men_raw;
  float ***rg0,***rg1,*gg;
  char *spikegen;
  struct onode *sgen;
  xn = mod_me_xn;
  yn = mod_me_yn;
  tn = mod_me_tn;
  fpe   = mod_me_fpe;    fpo   = mod_me_fpo;    fpx   = mod_me_fpx;
  fne   = mod_me_fne;    fno   = mod_me_fno;    fnx   = mod_me_fnx;
  fpe_s = mod_me_fpe_s;  fpo_s = mod_me_fpo_s;  fpx_s = mod_me_fpx_s;
  fne_s = mod_me_fne_s;  fno_s = mod_me_fno_s;  fnx_s = mod_me_fnx_s;
  if ((k==0) || (mod_me_rpe == NULL) || (s->stimno != mod_me_stimno_prev)){
    if (mod_me_rpe != NULL){
      free_f3tensor(mod_me_rpe,1,xn,1,yn,1,tn);
      free_f3tensor(mod_me_rpo,1,xn,1,yn,1,tn);
      free_f3tensor(mod_me_rpx,1,xn,1,yn,1,tn);
      free_f3tensor(mod_me_rne,1,xn,1,yn,1,tn);
      free_f3tensor(mod_me_rno,1,xn,1,yn,1,tn);
      free_f3tensor(mod_me_rnx,1,xn,1,yn,1,tn);
    }
    if (mod_me_rg0 != NULL){
      free_f3tensor(mod_me_rg0,1,xn,1,yn,1,tn);
      free_f3tensor(mod_me_rg1,1,xn,1,yn,1,tn);
    }
    mod_me_compute_response_quad_opp_from_ft_x(s->d,fpe,fpo,fpx,fne,fno,fnx,
					       fpe_s,fpo_s,fpx_s,
					       fne_s,fno_s,fnx_s,
					       xn,yn,tn,&rpe,&rpo,&rpx,
					       &rne,&rno,&rnx,
					       &rg0,&rg1);
    mylog(mylogf,"  done:  mod_me_compute_response_quad_opp_from_ft\n");
    mod_me_rpe = rpe; mod_me_rpo = rpo; mod_me_rpx = rpx;
    mod_me_rne = rne; mod_me_rno = rno; mod_me_rnx = rnx;
    mod_me_rg0 = rg0; mod_me_rg1 = rg1;
  }else{
    rpe = mod_me_rpe; rpo = mod_me_rpo; rpx = mod_me_rpx;
    rne = mod_me_rne; rno = mod_me_rno; rnx = mod_me_rnx;
    rg0 = mod_me_rg0; rg1 = mod_me_rg1;
  }
  x = xn/2;
  y = yn/2;
  mep_raw = (float *)myalloc(tn*sizeof(float));
  men_raw = (float *)myalloc(tn*sizeof(float));
  mylog(mylogf,"****  WYETH HERE multiplying three\n");
  for(i=0;i<tn;i++){
    mep_raw[i] = rpe[x][y][1+i]*rpo[x][y][1+i]*rpx[x][y][1+i];
    men_raw[i] = rne[x][y][1+i]*rno[x][y][1+i]*rnx[x][y][1+i];
  }
  tnr = tn;
  if (mod_me_pow != 1.0){
    mep = (float *)myalloc(tn*sizeof(float));
    men = (float *)myalloc(tn*sizeof(float));
    sprintf(ggstr,"  WYETH - NEW Applying power %f after squaring.\n",
	    mod_me_pow);
    mylog(mylogf,ggstr);
    for(i=0;i<tnr;i++){
      mep[i] = pow(mep_raw[i],mod_me_pow);
      men[i] = pow(men_raw[i],mod_me_pow);
    }
  }else{
    mep = copy_farray(mep_raw,tn);
    men = copy_farray(men_raw,tn);
  }
  if (mod_me_normflag > 0){
    float *smooth,tnorm,tt;
    float mean,sdev,tsig;
    int sp1,sp2;
    sp1 = x - mod_me_norm_xn/2;
    sp2 = sp1 + mod_me_norm_xn;
    gg  = (float *)myalloc(tn*sizeof(float));
    for(i=0;i<tn;i++){
      tnorm = 0.0;
      for(jx=sp1;jx<sp2;jx++){ 
	for(jy=sp1;jy<sp2;jy++){
	  tt = (rg0[jx][jy][1+i]*rg0[jx][jy][1+i] +
		rg1[jx][jy][1+i]*rg1[jx][jy][1+i]);
	  tnorm += pow(tt,mod_me_norm_pow);
	}
      }
      gg[i] = mod_me_norm_c + 
	mod_me_norm_f * tnorm / (float)(mod_me_norm_xn*mod_me_norm_xn);
      if (gg[i] < 1.0)
	gg[i] = 1.0;
    }
    if (myid == -1)
      append_farray_plot("zz.norm.pl","gg",gg,tn,1);
    if (mod_me_norm_tsd > 0.0){
      tsig = mod_me_norm_tsd / mod_me_tscale;
      smooth = smooth_with_gaussian(gg,tn,tsig,0.01);
      myfree(gg);
      gg = smooth;
    }
    if (myid == -1)
      append_farray_plot("zz.norm.pl","gg_Smooth",gg,tn,1);
    if (mod_me_norm_app == 1){
      for(i=0;i<tn;i++){
	mep[i] /= gg[i];
	men[i] /= gg[i];
      }
    }else{
      exit_error("MODEL_ME_01_GET_RESPONSE","Bad me_norm_app type");
    }
    mean_sdev_farray(gg+50,tn-100,&mean,&sdev);
    sprintf(ggstr,"  GAIN SIGNAL STATS:  %f %f\n",mean,sdev);
    mylog(mylogf,ggstr);
    mean_sdev_farray(mep+50,tn-100,&mean,&sdev);
    sprintf(ggstr,"  ME-P SIGNAL STATS:  %f %f\n",mean,sdev);
    mylog(mylogf,ggstr);
    myfree(gg);
  }
  mod_me_stimno_prev = s->stimno;
  mod_me_handover_basic(m,r,mep_raw,men_raw,mep,men,rpe,rpo,rne,rno,xn,yn,tn);
  if (m->ppl == NULL){
    sgen = onode_child_get_unique(m->o,"spike_gen");
    spikegen = onode_getpar_chr_exit(sgen,"type");
  }else
    spikegen = paramfile_get_char_param_or_exit(m->ppl,"spike_gen");
  if (strcmp(spikegen,"poisson")==0){
    if (mod_me_oppflag == 0)
      diff_flag = 1;
    else
      diff_flag = 0;
    mod_me_gen_hand_poisson(m,r,mep,men,tn,diff_flag);
  }else if (strcmp(spikegen,"ifc")==0){
    mod_me_gen_hand_ifc(m,r,mep,men,tn);
  }else{
    printf("spike_gen = %s\n",spikegen);
    mylog_exit(mylogf,"MODEL_ME_01_GET_RESPONSE  Unknown spike_gen.\n");
  }
  myfree(spikegen);
  myfree(mep);  
  myfree(men);  
  myfree(mep_raw); 
  myfree(men_raw); 
  mod_util_resp_unfilled_exit(r,mylogf);
}
void mod_me_v5_raw_resp(eyeflag,v1s,x,y)
     int eyeflag;                  
     struct mod_me_v1resp *v1s;    
     int x,y;                      
{
  int i,fi,fj;
  int xn,yn,tn,fn,foff;
  float t_mep,t_men,*tpe,*tpo,*tne,*tno;
  float *tr,*tr_opp,*lsum,***traw,**tme;
  struct mod_me_fstruct **fs;    
  struct mod_me_v5_struct *mv5;  
  xn  = mod_me_xn;
  yn  = mod_me_yn;
  tn  = mod_me_tn;
  fs  = mod_me_ff;
  fn  = mod_me_fn;
  mv5 = mod_me_v5;
  foff = 0;  
  if (eyeflag == 1){
    if (mod_me_fre == 1){
      foff = mod_me_fn/2;  
    }
  }
  traw = v1s->raw;
  tme  = v1s->me;
  lsum = v1s->sum;
  for(i=0;i<tn;i++)  
    lsum[i] = 0.0;
  if (mv5->v1_dflag == 0){
    for(fi=0;fi<mv5->n/2;fi++){
      tpe = fs[fi*4 + 0 + foff]->r[x][y];
      tpo = fs[fi*4 + 1 + foff]->r[x][y];
      tne = fs[fi*4 + 2 + foff]->r[x][y];
      tno = fs[fi*4 + 3 + foff]->r[x][y];
      fj = fi + mv5->n/2;  
      tr     = traw[fi][0];  
      tr_opp = traw[fj][0];  
      for(i=0;i<tn;i++){
	t_mep = tpe[1+i]*tpe[1+i] + tpo[1+i]*tpo[1+i];
	t_men = tne[1+i]*tne[1+i] + tno[1+i]*tno[1+i];
	if (mod_me_oppflag == 3){
	  tr[i]     = t_mep;
	  tr_opp[i] = t_men;
	}else if (mod_me_oppflag == 0){
	  if (t_mep > t_men){
	    tr[i]     = t_mep - t_men;
	    tr_opp[i] = 0.0;
	  }else{
	    tr[i] = 0.0;
	    tr_opp[i] = t_men - t_mep;  
	  }
	}else{
	  exit_error("MOD_ME_V5_RAW_RESP","Bad value for opp_flag");
	}
	lsum[i] += tr[i] + tr_opp[i];  
      }
    }
  }else{
    for(fi=0;fi<mv5->n/2;fi++){
      tpe = fs[fi*4 + 0 + foff]->r[x][y];
      tpo = fs[fi*4 + 1 + foff]->r[x][y];
      tne = fs[fi*4 + 2 + foff]->r[x][y];
      tno = fs[fi*4 + 3 + foff]->r[x][y];
      fj = fi+mv5->n/2;  
      for(i=0;i<tn;i++){
	traw[fi][0][i] = tpe[1+i];
	traw[fi][1][i] = tpo[1+i];
	traw[fj][0][i] = tne[1+i];
	traw[fj][1][i] = tno[1+i];
	t_mep = tpe[1+i]*tpe[1+i] + tpo[1+i]*tpo[1+i];
	t_men = tne[1+i]*tne[1+i] + tno[1+i]*tno[1+i];
	tme[fi][i] = sqrt(t_mep);  
	tme[fj][i] = sqrt(t_men);
	if (mv5->v1_dnorm == 0){
	  lsum[i] += fabs(tpe[1+i]) + fabs(tpo[1+i]) +
	    fabs(tne[1+i]) + fabs(tno[1+i]);
	}else if (mv5->v1_dnorm == 1){
	  lsum[i] += tpe[1+i]*tpe[1+i] + tpo[1+i]*tpo[1+i] +
	    tne[1+i]*tne[1+i] + tno[1+i]*tno[1+i];
	}else{
	  exit_error("MOD_ME_V5_RAW_RESP",
		     "Unknown disparity norm flag value\n");
	}
      }
    }
  }
}
void mod_me_v5_raw_top(eyeflag)
     int eyeflag;                  
{
  int i,j;
  int xn,yn;
  struct mod_me_v5_struct *mv5;  
  struct mod_me_v1resp *v1s;     
  xn  = mod_me_xn;
  yn  = mod_me_yn;
  mv5 = mod_me_v5;
  if (mod_me_mpt == NULL){
    if (eyeflag == 0)
      v1s = mv5->v1resp[0][0]->dl;
    else
      v1s = mv5->v1resp[0][0]->dr;
    mod_me_v5_raw_resp(eyeflag,v1s,xn/2,yn/2);
  }else{
    for(i=0;i<xn;i++){
      for(j=0;j<yn;j++){
	if (mv5->v1resp[i][j]->flag == 2){
	  if (eyeflag == 0)
	    v1s = mv5->v1resp[i][j]->dl;
	  else
	    v1s = mv5->v1resp[i][j]->dr;
	  mod_me_v5_raw_resp(eyeflag,v1s,i+1,j+1);
	}
      }
    }
  }
}
void mod_me_v5_norm_v1_work(v1s,a1,a2,a4,c3,c3r)
     struct mod_me_v1_input *v1s;
     float a1,a2,a4;       
     float c3,c3r;         
{
  int i,j;
  int ndir,tn;
  float *tr1,*tr2,*lsum;
  ndir = mod_me_v5->n;         
  tn   = mod_me_tn;
  lsum = v1s->dl->sum;
  for(i=0;i<ndir;i++){
    tr1 = v1s->dl->raw[i][0];  
    tr2 = v1s->dl->norm[i][0]; 
    for(j=0;j<tn;j++){
      tr2[j] = tr1[j] / (a1 * tr1[j] + a2 * lsum[j] + c3 + a4);
    }
  }
  if (mod_me_v5->binoc == 1){  
    lsum = v1s->dr->sum;
    for(i=0;i<ndir;i++){
      tr1 = v1s->dr->raw[i][0];   
      tr2 = v1s->dr->norm[i][0];  
      for(j=0;j<tn;j++){
	tr2[j] = tr1[j] / (a1 * tr1[j] + a2 * lsum[j] + c3r + a4);
      }
    }
  }
}
void mod_me_v5_norm_v1_disp(v1s,a1,a2,a4,c3,c3r)
     struct mod_me_v1_input *v1s;
     float a1,a2,a4;       
     float c3,c3r;         
{
  int i,j;
  int fi,fio,ndir,tn;
  float *tr1,*tr2,*tr3,*tr3off,*tr1r,*tr2r,*tr3r,*tr3roff,*tte,*tto;
  float *lsum,*lsumr,*mel,*mer,oppw,f,f1;
  struct mod_me_v5_struct *mv5;  
  mv5 = mod_me_v5;
  ndir = mv5->n;         
  tn   = mod_me_tn;
  lsum  = v1s->dl->sum;
  lsumr = v1s->dr->sum;
  for(fi=0;fi<ndir;fi++){
    mel = v1s->dl->me[fi];
    mer = v1s->dr->me[fi];
    for(j=0;j<mv5->v1_nc;j++){
      tr1  = v1s->dl->raw[fi][j];   
      tr2  = v1s->dl->norm[fi][j];  
      tr1r = v1s->dr->raw[fi][j];   
      tr2r = v1s->dr->norm[fi][j];  
      if (mv5->v1_dnorm == 0){
	for(i=0;i<tn;i++){
	  tr2[i]  = tr1[i]  / (a1*fabs(tr1[i])  + a2 * lsum[i]  + c3  + a4);
	  tr2r[i] = tr1r[i] / (a1*fabs(tr1r[i]) + a2 * lsumr[i] + c3r + a4);
	}
      }else if (mv5->v1_dnorm == 1){
	for(i=0;i<tn;i++){
	  tr2[i]  = tr1[i]  / (a1 * mel[i] + a2 * lsum[i]  + c3  + a4);
	  tr2r[i] = tr1r[i] / (a1 * mer[i] + a2 * lsumr[i] + c3r + a4);
	}
      }
    }
  }
  oppw = mv5->v1_opp_w;
  for(fi=0;fi<ndir;fi++){
    fio = fi + ndir/2;         
    if (fio >= ndir)
      fio -= ndir;
    mel = v1s->dl->me[fio];  
    mer = v1s->dr->me[fio];
    for(j=0;j<mv5->v1_nc;j++){
      tr1     = v1s->dl->norm[fi][j];   
      tr2     = v1s->dl->norm[fio][j];  
      tr3     = v1s->dl->opp[fi][j];    
      tr3off  = v1s->dl->opp[fi][j+2];  
      tr1r    = v1s->dr->norm[fi][j];  
      tr2r    = v1s->dr->norm[fio][j]; 
      tr3r    = v1s->dr->opp[fi][j];   
      tr3roff = v1s->dr->opp[fi][j+2]; 
      for(i=0;i<tn;i++){
	tr3[i]     =  tr1[i]  - oppw * mel[i];  
	tr3r[i]    =  tr1r[i] - oppw * mer[i];
	tr3off[i]  = -tr1[i]  - oppw * mel[i];  
	tr3roff[i] = -tr1r[i] - oppw * mer[i];
      }
      if (mv5->v1_recto == 1){
	half_wave_rectify_farray(tr3,tn);
	half_wave_rectify_farray(tr3r,tn);
	half_wave_rectify_farray(tr3off,tn);
	half_wave_rectify_farray(tr3roff,tn);
      }
    }
  }
  for(fi=0;fi<ndir;fi++){
    f = mv5->v1_mix_f;
    f1 = 1.0 - f;
    tte = add_scale_farrays(v1s->dl->opp[fi][0],
			    v1s->dr->opp[fi][0],f,f1,tn);
    tto = add_scale_farrays(v1s->dl->opp[fi][1],
			    v1s->dr->opp[fi][1],f,f1,tn);
    if (v1s->dl->bde[fi][0] != NULL){
      myfree(v1s->dl->bde[fi][0]);  
      myfree(v1s->dl->bde[fi][1]);
      myfree(v1s->dl->bde[fi][2]);
    }
    v1s->dl->bde[fi][0] = tte;
    v1s->dl->bde[fi][1] = tto;
    v1s->dl->bde[fi][2] = add_squared_farrays(tto,tte,tn);
    tte = add_scale_farrays(v1s->dl->opp[fi][0+2],
			    v1s->dr->opp[fi][0+2],f,f1,tn);
    tto = add_scale_farrays(v1s->dl->opp[fi][1+2],
			    v1s->dr->opp[fi][1+2],f,f1,tn);
    if (v1s->dl->bde[fi][0] != NULL){
      myfree(v1s->dl->bde[fi][3]);  
      myfree(v1s->dl->bde[fi][4]);
      myfree(v1s->dl->bde[fi][5]);
      myfree(v1s->dl->bde[fi][6]);
    }
    v1s->dl->bde[fi][3] = tte;
    v1s->dl->bde[fi][4] = tto;
    v1s->dl->bde[fi][5] = add_squared_farrays(tto,tte,tn);
    v1s->dl->bde[fi][6] =
      add_scale_farrays(v1s->dl->bde[fi][2],
			v1s->dl->bde[fi][5],0.5,0.5,tn);
    tte = add_scale_farrays(v1s->dl->opp[fi][0],
			    v1s->dr->opp[fi][0],f1,f,tn);
    tto = add_scale_farrays(v1s->dl->opp[fi][1],
			    v1s->dr->opp[fi][1],f1,f,tn);
    if (v1s->dr->bde[fi][0] != NULL){
      myfree(v1s->dr->bde[fi][0]);  
      myfree(v1s->dr->bde[fi][1]);
      myfree(v1s->dr->bde[fi][2]);
    }
    v1s->dr->bde[fi][0] = tte;
    v1s->dr->bde[fi][1] = tto;
    v1s->dr->bde[fi][2] = add_squared_farrays(tto,tte,tn);
    tte = add_scale_farrays(v1s->dl->opp[fi][0+2],
			    v1s->dr->opp[fi][0+2],f1,f,tn);
    tto = add_scale_farrays(v1s->dl->opp[fi][1+2],
			    v1s->dr->opp[fi][1+2],f1,f,tn);
    if (v1s->dr->bde[fi][0] != NULL){
      myfree(v1s->dr->bde[fi][3]);  
      myfree(v1s->dr->bde[fi][4]);
      myfree(v1s->dr->bde[fi][5]);
      myfree(v1s->dr->bde[fi][6]);
    }
    v1s->dr->bde[fi][3] = tte;
    v1s->dr->bde[fi][4] = tto;
    v1s->dr->bde[fi][5] = add_squared_farrays(tto,tte,tn);
    v1s->dr->bde[fi][6] =
      add_scale_farrays(v1s->dr->bde[fi][2],
			v1s->dr->bde[fi][5],0.5,0.5,tn);
  }
}
void mod_me_v5_norm_v1(a1,a2,a4,c3,c3r)
     float a1,a2,a4;       
     float c3,c3r;         
{
  int i,j;
  struct mod_me_v5_struct *mv5;  
  mv5 = mod_me_v5;
  if (mod_me_mpt == NULL){  
    if (mv5->v1_dflag == 0)
      mod_me_v5_norm_v1_work(mv5->v1resp[0][0],a1,a2,a4,c3,c3r);
    else
      mod_me_v5_norm_v1_disp(mv5->v1resp[0][0],a1,a2,a4,c3,c3r);
  }else{  
    for(i=0;i<mod_me_xn;i++){
      for(j=0;j<mod_me_yn;j++){
	if (mv5->v1resp[i][j]->flag == 2){
	  if (mv5->v1_dflag == 0)
	    mod_me_v5_norm_v1_work(mv5->v1resp[i][j],a1,a2,a4,c3,c3r);
	  else
	    mod_me_v5_norm_v1_disp(mv5->v1resp[i][j],a1,a2,a4,c3,c3r);
	}
      }
    }
  }
}
void mod_me_v5_opp_v1_work(v1s)
     struct mod_me_v1_input *v1s;
{
  int i;
  int fi,fio,ndir,tn;
  float *tr1,*tr2,*tr3,oppw;
  struct mod_me_v5_struct *mv5;  
  mv5  = mod_me_v5;
  ndir = mv5->n;         
  tn   = mod_me_tn;
  oppw = mv5->v1_opp_w;
  for(fi=0;fi<ndir;fi++){
    fio = fi + ndir/2;         
    if (fio >= ndir)
      fio -= ndir;
    tr1 = v1s->dl->norm[fi][0];   
    tr2 = v1s->dl->norm[fio][0];  
    tr3 = v1s->dl->opp[fi][0];    
    for(i=0;i<tn;i++)
      tr3[i] = tr1[i] - oppw * tr2[i];
    if (mv5->v1_recto == 1)
      half_wave_rectify_farray(tr3,tn);
    if (mv5->binoc == 1){
      tr1 = v1s->dr->norm[fi][0];   
      tr2 = v1s->dr->norm[fio][0];  
      tr3 = v1s->dr->opp[fi][0];    
      for(i=0;i<tn;i++)
	tr3[i] = tr1[i] - oppw * tr2[i];
      if (mv5->v1_recto == 1)
	half_wave_rectify_farray(tr3,tn);
    }
  }
}
void mod_me_v5_opp_v1()
{
  int i,j;
  struct mod_me_v5_struct *mv5;  
  mv5 = mod_me_v5;
  if (mod_me_mpt == NULL){  
    mod_me_v5_opp_v1_work(mv5->v1resp[0][0]);
  }else{  
    for(i=0;i<mod_me_xn;i++){
      for(j=0;j<mod_me_yn;j++){
	if (mv5->v1resp[i][j]->flag == 2){
	  mod_me_v5_opp_v1_work(mv5->v1resp[i][j]);
	}
      }
    }
  }
}
float *mod_me_v5_mt_nl(d,tn,mta,mtb)
     float *d;
     int tn;
     float mta,mtb;
{
  int i;
  float *t;
  t = (float *)myalloc(tn*sizeof(float));
  if (mta > 0.0){
    for(i=0;i<tn;i++)
      t[i] = mta * exp(mtb * d[i]);  
  }else{
    for(i=0;i<tn;i++)
      t[i] = d[i];  
  }
  return t;
}
void mod_me_v5_mt_work(v1s,whack_flag,whack,w,wr,binw)
     struct mod_me_v1_input *v1s;
     int whack_flag;   
     float whack;      
     float *w;         
     float *wr;        
     float binw;       
{
  int i;
  int fi,ndir,tn;
  float *tr1,*tr2,*tr3,wt;
  struct mod_me_v5_struct *mv5;  
  mv5 = mod_me_v5;
  ndir = mv5->n;         
  tn   = mod_me_tn;
  tr2 = v1s->dl->mt;  
  for(i=0;i<tn;i++)   
    tr2[i] = 0.0;
  for(fi=0;fi<ndir;fi++){
    wt = w[fi];
    if ((whack_flag == 1) && (wt < 0.0)) 
      wt *= whack;   
    if (mv5->v1_dflag == 1){
      tr1 = v1s->dl->bde[fi][6];  
    }else{
      tr1 = v1s->dl->opp[fi][0];  
    }
    if (mv5->noise_v1_out != NULL)
      mod_me_noise_add(tr1,tn,mv5->noise_v1_out);
    for(i=0;i<tn;i++)
      tr2[i] += wt * tr1[i];   
  }
  tr2 = v1s->dr->mt;  
  for(i=0;i<tn;i++)   
    tr2[i] = 0.0;
  for(fi=0;fi<ndir;fi++){
    wt = wr[fi];
    if ((whack_flag == 1) && (wt < 0.0)) 
	wt *= whack;   
    if (mv5->v1_dflag == 1)
      tr1 = v1s->dr->bde[fi][6];  
    else
      tr1 = v1s->dr->opp[fi][0];  
    if (mv5->noise_v1_out != NULL) 
      mod_me_noise_add(tr1,tn,mv5->noise_v1_out);
    for(i=0;i<tn;i++)
      tr2[i] += wt * tr1[i];   
  }
  tr1 = v1s->mtb;     
  tr2 = v1s->dr->mt;  
  tr3 = v1s->dl->mt;  
  for(i=0;i<tn;i++){
    tr1[i] = tr3[i] + binw * tr2[i];  
  }
}
void mod_me_v5_mt(whack_flag,whack,w,wr,r_bias)
     int whack_flag;   
     float whack;      
     float *w;         
     float *wr;        
     float r_bias;     
{
  int i,j;
  struct mod_me_v5_struct *mv5;  
  mv5 = mod_me_v5;
  if (mod_me_mpt == NULL){  
    mod_me_v5_mt_work(mv5->v1resp[0][0],whack_flag,whack,w,wr,r_bias);
  }else{  
    for(i=0;i<mod_me_xn;i++){
      for(j=0;j<mod_me_yn;j++){
	if (mv5->v1resp[i][j]->flag == 2){  
	  mod_me_v5_mt_work(mv5->v1resp[i][j],whack_flag,whack,w,wr,r_bias);
	}
      }
    }
  }
}
void mod_me_v5_pop_stack(pl,mtpop)
     struct pop_layer *pl;         
     struct mod_me_v5_pop *mtpop;  
{
  int i,j,k;
  int n,xi,yi,tn;
  float *tr,mta,mtb;
  struct mod_me_v5_struct *mv5;  
  struct pop_cell *c;
  struct pop_syn *s,*t;
  struct pop_top *mpt;
  printf("  MOD_ME_V5_POP_STACK\n");
  mv5 = mod_me_v5;
  mpt = mod_me_mpt;
  tn  = mod_me_tn;
  mta = mtpop->nl_a;
  mtb = mtpop->nl_b;
  tr = (float *)myalloc(tn*sizeof(float *));
  for(i=0;i<pl->xn;i++){   
    for(j=0;j<pl->yn;j++){
      c = &(pl->c[i][j][0]);  
      for(k=0;k<tn;k++)
	tr[k] = 0.0;     
      s = pop_cell_get_next_syn_layer_name(c->in,1,"v1");  
      n = 0;
      while(s != NULL){
	n += 1;
	xi = s->pre->layx;  
	yi = s->pre->layy;
	if (mv5->v1resp[xi][yi]->flag == 0){
	  mylog_exit(mylogf,"MOD_ME_V5_POP_STACK  input not saved.");
	}
	for(k=0;k<tn;k++)
	  tr[k] += mv5->v1resp[xi][yi]->mtb[k];
	t = s->post_next; 
	s = pop_cell_get_next_syn_layer_name(t,1,"v1");
      }
      mtpop->ssum[i][j] = get_scale_farray(tr,tn,1.0/(float)n);
      mtpop->nl[i][j] = mod_me_v5_mt_nl(mtpop->ssum[i][j],tn,mta,mtb);
    }
  }
  myfree(tr);
}
void mod_me_v5_pop(pl,mtpop)
     struct pop_layer *pl;           
     struct mod_me_v5_pop *mtpop;   
{
  int i,j,k;
  int xi,yi,zi,ti,tn;
  float *trr,*trl,w,*tr1,mta,mtb;
  struct mod_me_v5_struct *mv5;  
  struct pop_cell *c;
  struct pop_syn *s,*t;
  struct mod_me_v1_input *v1s;
  printf("  MOD_ME_V5_POP\n");
  mv5 = mod_me_v5;
  tn  = mod_me_tn;
  mta = mtpop->nl_a;
  mtb = mtpop->nl_b;
  trr = (float *)myalloc(tn*sizeof(float *));
  trl = (float *)myalloc(tn*sizeof(float *));
  for(i=0;i<pl->xn;i++){     
    for(j=0;j<pl->yn;j++){
      c = &(pl->c[i][j][0]);  
      for(k=0;k<tn;k++){
	trr[k] = 0.0;     
	trl[k] = 0.0;     
      }
      s = pop_cell_get_next_syn_layer_name(c->in,1,"v1");  
      while(s != NULL){
	xi = s->pre->layx;  
	yi = s->pre->layy;
	zi = s->pre->layz;
	if ((zi < 0) || (zi >= mv5->n)) 
	  mylog_exit(mylogf,"MOD_ME_V5_POP  'zi' out of range.");
	if (mv5->v1resp[xi][yi]->flag == 0)
	  mylog_exit(mylogf,"MOD_ME_V5_POP  input not saved.");
	v1s = mv5->v1resp[xi][yi];  
	if (mv5->v1_dflag == 1){
	  tr1 = v1s->dl->bde[zi][6];  
	}else{
	  tr1 = v1s->dl->opp[zi][0];  
	}
	w = mtpop->w[zi];  
	for(ti=0;ti<tn;ti++)
	  trl[ti] += w * tr1[ti];   
	if (mv5->v1_dflag == 1)
	  tr1 = v1s->dr->bde[zi][6];
	else
	  tr1 = v1s->dr->opp[zi][0];
	w = mtpop->w_r[zi];  
	for(ti=0;ti<tn;ti++)
	  trr[ti] += w * tr1[ti];   
	t = s->post_next; 
	s = pop_cell_get_next_syn_layer_name(t,1,"v1");
      }
      multiply_farray(trr,tn,mtpop->r_bias);  
      mtpop->ssum[i][j] = add_farrays(trl,trr,tn);  
      multiply_farray(mtpop->ssum[i][j],tn,1.0/(float)(mtpop->nsamp));
      mtpop->nl[i][j] = mod_me_v5_mt_nl(mtpop->ssum[i][j],tn,mta,mtb);
    }
  }
  myfree(trr);
  myfree(trl);
}
void mod_me_v5_mix_worker(s1,s2,n,tn,f)
     float ***s1,***s2;  
     int n;              
     int tn;             
     float f;            
{
  int i,j;
  float *t1,*t2,f1;
  f1 = 1.0 - f;
  for(i=0;i<n;i++){
    t1 = copy_farray(s1[i][0],tn);
    t2 = copy_farray(s2[i][0],tn);
    for(j=0;j<tn;j++){
      s1[i][0][j]  = f*t1[j] + f1*t2[j];
      s2[i][0][j]  = f*t2[j] + f1*t1[j];
    }
    myfree(t1);
    myfree(t2);
  }
}
void mod_me_v5_mix_v1(mylogf,stage_str)
     char *mylogf;
     char *stage_str;  
{
  int i,j;
  int tn,ndir,xn,yn;
  struct mod_me_v5_struct *mv5;  
  mv5 = mod_me_v5;
  xn  = mod_me_xn;
  yn  = mod_me_yn;
  if ((strcmp(stage_str,mv5->v1_mix_s)!=0) ||  
      (mv5->binoc != 1) ||                     
      (mv5->v1_mix_f >= 1.0)){                 
    return;
  }
  ndir = mv5->n;   
  tn = mod_me_tn;
  if (mod_me_mpt == NULL){
    if (strcmp(stage_str,"linear")==0){  
      mylog(mylogf,"    *** Mixing linear V1 signals\n");
      mod_me_v5_mix_worker(mv5->v1resp[0][0]->dl->raw,
			   mv5->v1resp[0][0]->dr->raw,ndir,tn,mv5->v1_mix_f);
      printf("*** WARNING:  the normalization sum has not been mixed\n");
    }else if (strcmp(stage_str,"normalized")==0){
      mylog(mylogf,"    *** Mixing normalized V1 signals\n");
      mod_me_v5_mix_worker(mv5->v1resp[0][0]->dl->norm,
			   mv5->v1resp[0][0]->dr->norm,ndir,tn,mv5->v1_mix_f);
    }else if (strcmp(stage_str,"opponent")==0){
      mylog(mylogf,"    *** Mixing opponent V1 signals\n");
      mod_me_v5_mix_worker(mv5->v1resp[0][0]->dl->opp,
			   mv5->v1resp[0][0]->dr->opp,ndir,tn,mv5->v1_mix_f);
    }else{
      mylog_exit(mylogf,"MOD_ME_V5_MIX_V1  Unknown mixing stage\n");
    }
  }else{
    for(i=0;i<xn;i++){
      for(j=0;j<yn;j++){
	if (mv5->v1resp[i][j]->flag == 2){
	  if (strcmp(stage_str,"linear")==0){  
	    if (i+j == 0)
	      mylog(mylogf,"    *** Mixing linear V1 signals\n");
	    mod_me_v5_mix_worker(mv5->v1resp[i][j]->dl->raw,
				 mv5->v1resp[i][j]->dr->raw,
				 ndir,tn,mv5->v1_mix_f);
	    if (i+j == 0)
	      printf("*** WARNING:  normalization sum has not been mixed\n");
	  }else if (strcmp(stage_str,"normalized")==0){
	    if (i+j == 0)
	      mylog(mylogf,"    *** Mixing normalized V1 signals\n");
	    mod_me_v5_mix_worker(mv5->v1resp[i][j]->dl->norm,
				 mv5->v1resp[i][j]->dr->norm,
				 ndir,tn,mv5->v1_mix_f);
	  }else if (strcmp(stage_str,"opponent")==0){
	    if (i+j == 0)
	      mylog(mylogf,"    *** Mixing opponent V1 signals\n");
	    mod_me_v5_mix_worker(mv5->v1resp[i][j]->dl->opp,
				 mv5->v1resp[i][j]->dr->opp,
				 ndir,tn,mv5->v1_mix_f);
	  }else{
	    mylog_exit(mylogf,"MOD_ME_V5_MIX_V1  Unknown mixing stage\n");
	  }
	}
      }
    }
  }
}
void model_me_v5_get_response(m,s,r,k)
     struct model_struct *m;     
     struct stim_struct *s;      
     struct response_struct *r;  
     int k;                      
{
  int i,j;
  int xn,yn,tn,ndir,fn,n,fi,fio,whack_flag,monoc_gate,mxn,myn,*lseedlist;
  float *mep,*men,*mel,*mer,stimpar_l,stimpar_lr,oppw,binw,whack,f,f1;
  float *tr1,*tr2,*tr1r,*tr2r,*tr3,*tr3r,*lsum,*lsumr,*tv1,*tv1r;
  float *tr3off,*tr3roff;
  float a1,a2,c3,c3r,a4,w,mta,mtb,*tte,*tto;
  char *spikegen,tstr[SLEN];
  struct onode *sgen;
  struct mod_me_fstruct **fs;    
  struct mod_me_v5_struct *mv5;  
  struct pop_layer *pl;
  struct mod_me_v5_pop *mtpop;
  mod_me_tsi = r->tsi;
  xn  = mod_me_xn;
  yn  = mod_me_yn;
  tn  = mod_me_tn;
  fs  = mod_me_ff;
  fn  = mod_me_fn;
  mv5 = mod_me_v5;
  ndir = mv5->n;           
  if (mv5->noise_v1_out != NULL)
    mv5->noise_v1_out->sflag = 1;  
  if ((k==0) || (fs[0]->r == NULL) || (s->stimno != mod_me_stimno_prev)){
    for(i=0;i<fn;i++)  
      if (fs[i]->r != NULL)
	free_f3tensor(fs[i]->r,1,xn,1,yn,1,tn);  
    if (mod_me_fre == 1){  
      for(i=0;i<fn;i++){     
	if (i < fn/2)
	  fs[i]->flag = 1;    
	else
	  fs[i]->flag = 0;    
      }
    }
    mod_me_compute_response_from_ft(s->d,fs,fn,xn,yn,tn);   
    mod_me_v5_raw_top(0);  
    if (s->d_r != NULL){
      mv5->binoc = 1;
      printf("    right eye\n");
      if (mod_me_fre == 0){
	for(i=0;i<fn;i++)  
	  if (fs[i]->r != NULL)
	    free_f3tensor(fs[i]->r,1,xn,1,yn,1,tn);  
      }else{
	for(i=0;i<fn;i++){     
	  if (i < fn/2)
	    fs[i]->flag = 0;    
	  else
	    fs[i]->flag = 1;    
	}
      }
      mod_me_compute_response_from_ft(s->d_r,fs,fn,xn,yn,tn); 
      mod_me_v5_raw_top(1);  
    }else{
      mv5->binoc = 0;
      if (mod_me_fre == 1)
	exit_error("MODEL_ME_V5_GET_RESPONSE",
		   "Stimulus is monocular, but there are RE filters.");
    }
  }
  mod_me_v5_mix_v1(mylogf,"linear");
  stimpar_l  = param_getf_dflt(s->ppl,"stimmod_msc",mv5->L);
  if (stimpar_l < 0.0)
    stimpar_l = mv5->L;
  sprintf(ggstr,"   STIMPAR: rmsm_L = %f\n",stimpar_l);
  mylog(mylogf,ggstr);
  if (stimpar_l < 0.0)
    mylog_exit(mylogf,
	       "MODEL_ME_01_GET_RESPONSE  Either rmsm_L or stimpar_msc < 0\n");
  c3 = mv5->alph3 * stimpar_l;  
  a1 = mv5->alph1;
  a2 = mv5->alph2 / (float)ndir;
  a4 = mv5->alph4;
  if (mv5->binoc == 1){  
    stimpar_lr = param_getf_dflt(s->ppl,"stimmod_msc_r",stimpar_l);
    if (stimpar_lr < 0.0)
      stimpar_lr = stimpar_l;
    c3r = mv5->alph3 * stimpar_lr;  
  }
  mod_me_v5_norm_v1(a1,a2,a4,c3,c3r);
  mod_me_v5_mix_v1(mylogf,"normalized");
  if (mv5->v1_dflag == 0){
    mod_me_v5_opp_v1();
  }
  mod_me_v5_mix_v1(mylogf,"opponent");
  whack_flag = 0;
  monoc_gate = 0;
  if (mod_me_mpt == NULL){
    whack = mv5->bin_hack;  
    if (whack >= 0.0){
      whack_flag = 1;
      sprintf(tstr,"  *** Tailby Hack: scale negative weights by %f\n",whack);
      mylog(mylogf,tstr);
    }
  }
  if (mod_me_mpt == NULL){
    if (mv5->w != NULL){ 
      mta = mv5->mt_a;  
      mtb = mv5->mt_b;
    }else{
      exit_error("WYETH","New way not implemented yet");
    }
    mod_me_v5_mt(whack_flag,whack,mv5->w,mv5->w_r,mv5->v1_bin_w);
    mv5->mt_norm = mod_me_v5_mt_nl(mv5->v1resp[0][0]->mtb,tn,mta,mtb);
    mep = copy_farray(mv5->mt_norm,tn);
    men = NULL;
  }else{
    for(i=0;i<mv5->mt_npop;i++){  
      pl = mod_me_mpt->lay[mv5->mtli0 + i];  
      mtpop = mv5->mtp[i];           
      if (mv5->mtp[i]->stackflag == 0){ 
	mod_me_v5_pop(pl,mtpop);  
      }else{ 
	mod_me_v5_mt(whack_flag,whack,mtpop->w,mtpop->w_r,mtpop->r_bias);
	mod_me_v5_pop_stack(pl,mtpop);
      }
    }
  }
  if (mod_me_mpt != NULL){
    lseedlist = get_seeds(m->mseed[r->tsi],1000000,mv5->mt_npop);
    for(i=0;i<mv5->mt_npop;i++){  
      pl = mod_me_mpt->lay[mv5->mtli0 + i];  
      mtpop = mv5->mtp[i];                   
      if (mtpop->seed != NULL)
	free_2d_iarray(mtpop->seed,pl->xn);
      mtpop->seed = get_seeds_2d(lseedlist[i],100000,pl->xn,pl->yn);
    }
    myfree(lseedlist);
  }
  mod_me_handover_v5(m,r);
  mod_me_stimno_prev = s->stimno;
  mod_util_resp_unfilled_exit(r,mylogf);
}
void model_filter_xyt_get_response(m,s,r,k)
     struct model_struct *m;     
     struct stim_struct *s;      
     struct response_struct *r;  
     int k;                      
{
  int i;
  int xn,yn,tn,x,y;
  float ***fpe,**fpe_s,***rpe,*mep,*resp_e;
  char *spikegen;
  struct onode *sgo;
  xn    = mod_me_xn;
  yn    = mod_me_yn;
  tn    = mod_me_tn;
  fpe   = mod_me_fpe;
  fpe_s = mod_me_fpe_s;
  if ((k==0) || (mod_me_rpe == NULL) || (s->stimno != mod_me_stimno_prev)){
    if (mod_me_rpe != NULL){
      free_f3tensor(mod_me_rpe,1,xn,1,yn,1,tn);
    }
    mod_me_compute_response_simp_from_ft(s->d,fpe,fpe_s,xn,yn,tn,&rpe);
    mod_me_rpe = rpe;  
  }else{
    rpe = mod_me_rpe;  
  }
  x = xn/2; 
  y = yn/2;
  resp_e = &(rpe[x][y][1]);
  if (mod_me_pow != 1.0){
    mep = (float *)myalloc(tn*sizeof(float));
    for(i=0;i<tn;i++){
      mep[i] = pow(resp_e[i],mod_me_pow);
    }
  }else
    mep = copy_farray(resp_e,tn);
  mod_me_stimno_prev = s->stimno;
  for(i=0;i<r->n;i++){ 
    if (strcmp(r->datid[i],"spikes")==0){
      if (m->ppl == NULL){
	sgo = onode_child_get_unique(m->o,"spike_gen");
	spikegen = onode_getpar_chr_exit(sgo,"type");
      }else
	spikegen = paramfile_get_char_param_or_exit(m->ppl,"spike_gen");
      if (strcmp(spikegen,"poisson")==0){
	mod_me_gen_hand_poisson(m,r,mep,NULL,tn,0);
      }else{
	printf("spikegen = %s\n",spikegen);
	mylog_exit(mylogf,
		   "MODEL_FILTER_XYT_GET_RESPONSE  unknown spike_gen\n");
      }
      myfree(spikegen);
    }else if (strcmp(r->datid[i],"response")==0){
      mod_util_resp_store_f_samp(r,i,resp_e,tn,1.0/mod_me_tscale,mylogf);
    }else if (strcmp(r->datid[i],"response_power")==0){
      mod_util_resp_store_f_samp(r,i,mep,tn,1.0/mod_me_tscale,mylogf);
    }else{
      mylog_exit(mylogf,"MOD_FILTER_XYT_GET_RESPONSE unknown response item\n");
    }
  }
  myfree(mep);
}
void model_gabor_comp_get_response(m,s,r,k)
     struct model_struct *m;     
     struct stim_struct *s;      
     struct response_struct *r;  
     int k;                      
{
  int i;
  int xn,yn,tn,x,y,ri,dti;
  float ***fpe,***fpo,**fpe_s,**fpo_s,***rpe,***rpo,*mep;
  float *resp_e,*resp_o,*resp_e2,*resp_o2,sampling;
  char *spikegen;
  xn = mod_me_xn;
  yn = mod_me_yn;
  tn = mod_me_tn;
  fpe = mod_me_fpe;
  fpo = mod_me_fpo;
  fpe_s = mod_me_fpe_s;  fpo_s = mod_me_fpo_s;
  if ((k==0) || (mod_me_rpe == NULL) || (s->stimno != mod_me_stimno_prev)){
    if (mod_me_rpe != NULL){
      free_f3tensor(mod_me_rpe,1,xn,1,yn,1,tn);
      free_f3tensor(mod_me_rpo,1,xn,1,yn,1,tn);
    }
    mod_me_compute_response_gabor_comp_from_ft(s->d,fpe,fpo,fpe_s,fpo_s,
					       xn,yn,tn,&rpe,&rpo);
    mod_me_rpe = rpe; mod_me_rpo = rpo;  
  }else{
    rpe = mod_me_rpe; rpo = mod_me_rpo;  
  }
  x = xn/2; 
  y = yn/2;
  mep = (float *)myalloc(tn*sizeof(float));
  resp_e = &(rpe[x][y][1]);
  resp_o = &(rpo[x][y][1]);
  resp_e2 = (float *)myalloc(tn*sizeof(float));
  resp_o2 = (float *)myalloc(tn*sizeof(float));
  if (strcmp(mod_me_modtype,"rd_2gabor")==0){
    if (mod_rd_2gabor_rect == 1){
      half_wave_rectify_farray(resp_e,tn);
      half_wave_rectify_farray(resp_o,tn);
    }
    dti = mod_rd_2gabor_dti;
    for(i=0;i<tn;i++){
      if (i >= dti)
	mep[i] = resp_e[i-dti] * resp_o[i];  
      else
	mep[i] = resp_o[i];  
    }
  }else{
    for(i=0;i<tn;i++){
      resp_e2[i] = resp_e[i]*resp_e[i];  
      resp_o2[i] = resp_o[i]*resp_o[i];
      mep[i] = resp_e2[i] + resp_o2[i];
    }
  }
  if (mod_me_pow != 1.0){
    for(i=0;i<tn;i++){
      mep[i] = pow(mep[i],mod_me_pow);
    }
  }
  mod_me_stimno_prev = s->stimno;
  for(i=0;i<r->n;i++){ 
    if (strcmp(r->datid[i],"spikes")==0){
      {
	char *spikegen;
	struct onode *sgo;
	if (m->ppl == NULL){
	  sgo = onode_child_get_unique(m->o,"spike_gen");
	  spikegen = onode_getpar_chr_exit(sgo,"type");
	}else
	  spikegen = paramfile_get_char_param_or_exit(m->ppl,"spike_gen");
	if (strcmp(spikegen,"poisson")==0){
	  mod_me_gen_hand_poisson(m,r,mep,NULL,tn,0);
	}else{
	  printf("spikegen = %s\n",spikegen);
	  mylog_exit(mylogf,
		     "MODEL_GABOR_COMP_GET_RESPONSE  unknown spike_gen\n");
	}
	myfree(spikegen);
      }
    }else if (strcmp(r->datid[i],"response")==0){
      mod_util_resp_store_f_samp(r,i,mep,tn,1.0/mod_me_tscale,mylogf);
    }else if (strcmp(r->datid[i],"even")==0){
      mod_util_resp_store_f_samp(r,i,resp_e,tn,1.0/mod_me_tscale,mylogf);
    }else if (strcmp(r->datid[i],"even_squared")==0){
      mod_util_resp_store_f_samp(r,i,resp_e2,tn,1.0/mod_me_tscale,mylogf);
    }else if (strcmp(r->datid[i],"odd")==0){
      mod_util_resp_store_f_samp(r,i,resp_o,tn,1.0/mod_me_tscale,mylogf);
    }else if (strcmp(r->datid[i],"odd_squared")==0){
      mod_util_resp_store_f_samp(r,i,resp_o2,tn,1.0/mod_me_tscale,mylogf);
    }else{
      mylog_exit(mylogf,"MOD_GABOR_COMP_GET_RESPONSE unknown response item\n");
    }
  }
  myfree(mep);
  myfree(resp_e2);
  myfree(resp_o2);
}
void model_ds_simp_01_get_response(m,s,r,k)
     struct model_struct *m;     
     struct stim_struct *s;      
     struct response_struct *r;  
     int k;                      
{
  int i;
  int xn,yn,tn,x,y,qflag;
  float ***fpe,**fpe_s,***rpe,*mep,tr,***tfil;
  float ***fpo,**fpo_s,***rpo;
  char *spikegen;
  struct onode *sgen;
  struct mod_me_fstruct **fs;
  xn    = mod_me_xn;
  yn    = mod_me_yn;
  tn    = mod_me_tn;
  fs = mod_me_ff;
  if (strcmp(mod_me_filt,"two")==0)
    qflag = 1;
  else
    qflag = 0;
  if ((strcmp(mod_me_filt,"even")==0)|| qflag){
    fpe   = mod_me_fpe;
    fpe_s = fs[0]->s; 
  }else if (strcmp(mod_me_filt,"odd")==0){
    fpe   = mod_me_fpo;
    fpe_s = fs[1]->s; 
  }else{
    exit_error("MODEL_DS_SIMP_01_GET_RESPONSE","Unknown 'me_filt'");
  }
  if (qflag){
    fpo   = mod_me_fpo;
    fpo_s = fs[1]->s; 
  }
  if ((k==0) || (mod_me_rpe == NULL) || (s->stimno != mod_me_stimno_prev)){
    if (mod_me_rpe != NULL){
      free_f3tensor(mod_me_rpe,1,xn,1,yn,1,tn);
      if (qflag)
	free_f3tensor(mod_me_rpo,1,xn,1,yn,1,tn);
    }
    mod_me_compute_response_simp_from_ft(s->d,fpe,fpe_s,xn,yn,tn,&rpe);
    if (qflag)
      mod_me_compute_response_simp_from_ft(s->d,fpo,fpo_s,xn,yn,tn,&rpo);
    mod_me_rpe = rpe; 
    if (qflag)
      mod_me_rpo = rpo; 
  }else{
    rpe = mod_me_rpe; 
    if (qflag)
      rpo = mod_me_rpo;
  }
  x = xn/2;
  y = yn/2;
  mep = (float *)myalloc(tn*sizeof(float));
  if (qflag == 1){
    for(i=0;i<tn;i++){
      tr  = rpe[x][y][1+i];           
      if (tr <= 0.0)                  
	tr = 0.0;
      if (mod_me_pow != 1.0){
	mep[i] = pow(tr,mod_me_pow);  
      }else
	mep[i] = tr;
      tr  = rpo[x][y][1+i];           
      if (tr <= 0.0)
	tr = 0.0;
      if (mod_me_pow != 1.0){
	mep[i] += pow(tr,mod_me_pow);
      }else
	mep[i] += tr;
    }
  }else{
    for(i=0;i<tn;i++){
      tr = rpe[x][y][1+i];
      if (mod_me_pow != 1.0){
	mep[i] = pow(tr,mod_me_pow);
      }else
	mep[i] = tr;
    }
  }
  mod_me_stimno_prev = s->stimno;
  mod_me_handover_basic(m,r,NULL,NULL,mep,NULL,rpe,NULL,NULL,NULL,xn,yn,tn);
  if (qflag)
    mod_me_handover_basic(m,r,NULL,NULL,mep,NULL,rpe,rpo,NULL,NULL,xn,yn,tn);
  if (m->ppl == NULL){
    sgen = onode_child_get_unique(m->o,"spike_gen");
    spikegen = onode_getpar_chr_exit(sgen,"type");
  }else
    spikegen = paramfile_get_char_param_or_exit(m->ppl,"spike_gen");
  if (strcmp(spikegen,"poisson")==0){
    mod_me_gen_hand_poisson(m,r,mep,NULL,tn,0);
  }else  if (strcmp(spikegen,"ifcn")==0){
    mod_me_gen_hand_ifc(m,r,mep,NULL,tn);  
  }else{
    printf("spike_gen = %s\n",spikegen);
    mylog_exit(mylogf,"MODEL_DS_SIMP_01_GET_RESPONSE  Unknown spike_gen.\n");
  }
  myfree(spikegen);
  myfree(mep);
  mod_util_resp_unfilled_exit(r,mylogf);
}
void model_ds_liv3_get_response(m,s,r,k)
     struct model_struct *m;     
     struct stim_struct *s;      
     struct response_struct *r;  
     int k;                      
{
  int i;
  int xn,yn,tn,x,y,dy,locflag;
  float ***fpe,**fpe_s,***rpe,*mep,tr,***tfil,yoff,ssd;
  float *s1,*s2,*s3;  
  char *spikegen;
  xn    = mod_me_xn;
  yn    = mod_me_yn;
  tn    = mod_me_tn;
  if (strcmp(mod_me_filt,"even")==0){
    fpe   = mod_me_fpe;
    fpe_s = mod_me_fpe_s;
  }else if (strcmp(mod_me_filt,"odd")==0){
    fpe   = mod_me_fpo;
    fpe_s = mod_me_fpo_s;
  }else{
    exit_error("MODEL_DS_SIMP_01_GET_RESPONSE","Unknown 'me_filt'");
  }
  if ((k==0) || (mod_me_rpe == NULL) || (s->stimno != mod_me_stimno_prev)){
    if (mod_me_rpe != NULL){
      free_f3tensor(mod_me_rpe,1,xn,1,yn,1,tn);
    }
    mod_me_compute_response_simp_from_ft(s->d,fpe,fpe_s,xn,yn,tn,&rpe);
    mod_me_rpe = rpe; 
  }else{
    rpe = mod_me_rpe; 
  }
  yoff = paramfile_get_float_param_or_exit(m->ppl,"liv3_offset_sd");
  ssd  = paramfile_get_float_param_or_exit(m->ppl,"me_ssd");
  locflag = paramfile_get_float_param_or_exit(m->ppl,"liv3_loc_flag");
  x = xn/2;
  y = yn/2;
  dy = my_rint(yoff * ssd / mod_me_sscale);
  if ((y+dy) >= yn)
    mylogx(mylogf,"MODEL_DS_LIV3_GET_RESPONSE","liv3_offset_sd too large");
  s1 = (float *)myalloc(tn*sizeof(float));
  s2 = (float *)myalloc(tn*sizeof(float));
  s3 = (float *)myalloc(tn*sizeof(float));
  mep = (float *)myalloc(tn*sizeof(float));
  for(i=0;i<tn;i++){
    s1[i] = rpe[x][y-dy][1+i];
    s2[i] = rpe[x][y   ][1+i];
    s3[i] = rpe[x][y+dy][1+i];
  }
  if (locflag == 0){  
    for(i=0;i<tn;i++){
      mep[i] = s1[i] + s2[i] + s3[i];
    }
    half_wave_rectify_farray(mep,tn);
  }else if (locflag == 1){
    half_wave_rectify_farray(s1,tn); 
    half_wave_rectify_farray(s2,tn);
    half_wave_rectify_farray(s3,tn);
    for(i=0;i<tn;i++){
      mep[i] = s1[i] + s2[i] + s3[i];
    }
  }else if (locflag == 2){            
    half_wave_rectify_farray(s2,tn);
    for(i=0;i<tn;i++){
      mep[i] = s2[i];
    }
  }else{
    mylogx(mylogf,"MODEL_DS_LIV3_GET_RESPONSE","Bad 'liv3_loc_flag' value");
  }
  square_farray(mep,tn);
  myfree(s1); myfree(s2); myfree(s3);
  mod_me_stimno_prev = s->stimno;
  mod_me_handover_basic(m,r,NULL,NULL,mep,NULL,rpe,NULL,NULL,NULL,xn,yn,tn);
  spikegen = paramfile_get_char_param_or_exit(m->ppl,"spike_gen");
  if (strcmp(spikegen,"poisson")==0){
    mod_me_gen_hand_poisson(m,r,mep,NULL,tn,0);
  }else  if (strcmp(spikegen,"ifcn")==0){
    mod_me_gen_hand_ifc(m,r,mep,NULL,tn);  
  }else{
    printf("spike_gen = %s\n",spikegen);
    mylog_exit(mylogf,"MODEL_DS_SIMP_01_GET_RESPONSE  Unknown spike_gen.\n");
  }
  myfree(spikegen);
  myfree(mep);
  mod_util_resp_unfilled_exit(r,mylogf);
}
float *model_mem_regulate_response(m,topp)
     struct model_struct *m;     
     float **topp;               
{
  int i,j;
  int nf,tn,imax;
  float **wf,*maxa,f,f1,*r;
  char tstr[SLEN];
  struct mod_mem *mem;
  mem = mod_me_mem; 
  tn = mod_me_tn;
  nf = mem->nf;
  f = mem->wf;
  f1 = 1.0 - f;
  wf = get_2d_farray(nf,tn);
  for(j=0;j<nf;j++)
    wf[j][0] = 1.0/(float)nf;  
  maxa = get_farray(nf);
  for(i=1;i<tn;i++){
    for(j=0;j<nf;j++)
      maxa[j] = fabs(topp[j][i]);
    imax = max_index_farray(maxa,nf);
    for(j=0;j<nf;j++){ 
      if (j == imax)
	wf[j][i] = f * wf[j][i-1] + f1 * 1.0;  
      else
	wf[j][i] = f * wf[j][i-1] + f1 * 0.0;  
    }
  }
  myfree(maxa);
  if ((myid == -1) && (mem->dumpflag == 1)){
    for(j=0;j<nf;j++){
      sprintf(tstr,"W_%d",j);
      append_farray_plot("zzz.resp.pl",tstr,wf[j],tn,1);
    }
  }
  r = get_zero_farray(tn);
  for(i=0;i<tn;i++){
    for(j=0;j<nf;j++){
      r[i] += wf[j][i] * topp[j][i];
    }
  }
  free_2d_farray(wf,nf);
  return r;
}
void model_mem_get_response(m,s,r,k)
     struct model_struct *m;     
     struct stim_struct *s;      
     struct response_struct *r;  
     int k;                      
{
  int i,j;
  int xn,yn,tn,x,y,ns;
  float *mp,*ma,*mr0,*mr1,*mr2,*mr3,*wr;
  float *totp,*tota,**topp,*fs;
  char tstr[SLEN],*spikegen;
  struct mod_mem *mem;
  struct onode *sgo;
  mem = mod_me_mem; 
  xn = mod_me_xn;
  yn = mod_me_yn;
  tn = mod_me_tn;
  if ((k==0) || (mem->r[0][0] == NULL) || (s->stimno != mod_me_stimno_prev)){
    if (mem->r[0][0] != NULL){  
      for(i=0;i<mem->nf;i++){
	free_f3tensor(mem->r[i][0],1,xn,1,yn,1,tn);
	free_f3tensor(mem->r[i][1],1,xn,1,yn,1,tn);
	free_f3tensor(mem->r[i][2],1,xn,1,yn,1,tn);
	free_f3tensor(mem->r[i][3],1,xn,1,yn,1,tn);
      }
    }
    mod_me_compute_response_mem(s->d,mem,xn,yn,tn);
  }
  for(i=0;i<mem->nf;i++){  
    for(j=0;j<mem->nr;j++){  
      x = mem->xi[j];
      y = mem->yi[j];
      mr0 = mem->r[i][0][x][y];
      mr1 = mem->r[i][1][x][y];
      mr2 = mem->r[i][2][x][y];
      mr3 = mem->r[i][3][x][y];
      mp = mem->mp[i][j];
      ma = mem->ma[i][j];
      for(k=0;k<tn;k++){
	mp[k] = mr0[1+k]*mr0[1+k] + mr1[1+k]*mr1[1+k];
	ma[k] = mr2[1+k]*mr2[1+k] + mr3[1+k]*mr3[1+k];
      }
      if ((myid == -1) && (mem->dumpflag == 1)){
	if (mem->nr == 1){
	  sprintf(tstr,"rf_%d__%d_%d_pref",i,x,y);
	  append_farray_plot("zzz.resp.pl",tstr,mp,tn,1);
	  sprintf(tstr,"rf_%d__%d_%d_anti",i,x,y);
	  append_farray_plot("zzz.resp.pl",tstr,ma,tn,1);
	}
      }
    }
  }
  topp = (float **)myalloc(mem->nf*sizeof(float *));
  if (mem->nr > 1){
    totp = get_zero_farray(tn);
    tota = get_zero_farray(tn);
    for(i=0;i<mem->nf;i++){  
      for(j=0;j<mem->nr;j++){  
	for(k=0;k<tn;k++){
	  totp[k] += mem->mp[i][j][k];
	  tota[k] += mem->ma[i][j][k];
	}
      }
      multiply_farray(totp,tn,1.0/(float)mem->nr);
      multiply_farray(tota,tn,1.0/(float)mem->nr);
      topp[i] = diff_farrays(totp,tota,tn);
      if (mem->scale[i] != 1.0)
	multiply_farray(topp[i],tn,mem->scale[i]);
      if ((myid == -1) && (mem->dumpflag == 1)){
	sprintf(tstr,"T_opp_%d",i);
	append_farray_plot("zzz.resp.pl",tstr,topp[i],tn,1);
      }
      zero_farray(totp,tn);
      zero_farray(tota,tn);
    }
  }
  wr = model_mem_regulate_response(m,topp);
  if ((myid == -1) && (mem->dumpflag == 1)){
    append_farray_plot("zzz.resp.pl","WR",wr,tn,1);
  }
  mod_me_stimno_prev = s->stimno;
  sgo = onode_child_get_unique(m->o,"spike_gen");
  spikegen = onode_getpar_chr_exit(sgo,"type");
  if (strcmp(spikegen,"poisson")==0){
    mod_me_gen_hand_poisson(m,r,wr,NULL,tn,0);
  }else{
    printf("spikegen = %s\n",spikegen);
    mylog_exit(mylogf,"MODEL_MEM_GET_RESPONSE  unknown spike_gen\n");
  }
  myfree(spikegen);
}
void model_reich_get_response(m,s,r,k)
     struct model_struct *m;     
     struct stim_struct *s;      
     struct response_struct *r;  
     int k;                      
{
  int i,j;
  int xn,yn,tn,ri,x0,x1,y0,y1,ti,dx,n_unit;
  float ***rlp,***rhp,*tlp_a,*tlp_b,*thp_a,*thp_b,*tt;
  char pname[SLEN];
  xn = mod_me_xn;
  yn = mod_me_yn;
  tn = mod_me_tn;
  if ((k==0) || (mod_reich_rlp == NULL) ||(s->stimno != mod_me_stimno_prev)){
    if (mod_reich_rlp != NULL){
      free_f3tensor(mod_reich_rlp,1,xn,1,yn,1,tn);
      free_f3tensor(mod_reich_rhp,1,xn,1,yn,1,tn);
    }
    mod_reich_compute_response_from_ft(s->d,mod_reich_lp,mod_reich_hp,
				       mod_reich_lp_s,mod_reich_hp_s,
				       xn,yn,tn,&rhp,&rlp);
    mod_reich_rlp = rlp; 
    mod_reich_rhp = rhp;
    mod_me_stimno_prev = s->stimno;
  }else{
    rlp = mod_reich_rlp;  
    rhp = mod_reich_rhp;
  }
  tt = get_zero_farray(tn);    
  x0 = mod_reich_ux0;          
  x1 = x0 + mod_reich_uxn - 1;
  y0 = mod_reich_uy0;
  y1 = y0 + mod_reich_uyn - 1;
  dx = mod_reich_dx;
  for(i=x0;i<=x1;i++){
    for(j=y0;j<=y1;j++){
      tlp_a = rlp[i   ][j];  
      thp_a = rhp[i   ][j];  
      tlp_b = rlp[i+dx][j];  
      thp_b = rhp[i+dx][j];  
      if (mod_me_oppflag == 1){
	for(ti=0;ti<tn;ti++){
	  tt[ti] += tlp_a[ti]*thp_b[ti] - thp_a[ti]*tlp_b[ti];
	}
      }else{
	for(ti=0;ti<tn;ti++){
	  tt[ti] += tlp_a[ti]*thp_b[ti];
	}
      }
    }
  }
  n_unit = mod_reich_uxn * mod_reich_uyn;
  multiply_farray(tt,tn,1.0/(float)n_unit);
  if (mod_reich_dump == 1){ 
    int x,y;
    float *tla,*tra,*tdiff,*tdump;
    x = xn/2;
    y = yn/2;
    tla = (float *)myalloc(tn*sizeof(float));
    tra = (float *)myalloc(tn*sizeof(float));
    tdiff = (float *)myalloc(tn*sizeof(float));
    for(ti=0;ti<tn;ti++){
      tla[ti] = rlp[x][y][ti] * rhp[x+dx][y][ti];
      tra[ti] = rhp[x][y][ti] * rlp[x+dx][y][ti];
      tdiff[ti] = tla[ti] - tra[ti];
    }
    sprintf(pname,"%s_HP_ctr",r->tname);
    append_farray_plot("zzz.rd.pl",pname,rhp[x][y],tn,1);
    sprintf(pname,"%s_LP_ctr+%d",r->tname,dx);
    append_farray_plot("zzz.rd.pl",pname,rlp[x+dx][y],tn,1);
    sprintf(pname,"%s_right_arm",r->tname);
    append_farray_plot("zzz.rd.pl",pname,tra,tn,1);
    sprintf(pname,"%s_HP_ctr+%d",r->tname,dx);
    append_farray_plot("zzz.rd.pl",pname,rhp[x+dx][y],tn,1);
    sprintf(pname,"%s_LP_ctr",r->tname);
    append_farray_plot("zzz.rd.pl",pname,rlp[x][y],tn,1);
    sprintf(pname,"%s_left_arm",r->tname);
    append_farray_plot("zzz.rd.pl",pname,tla,tn,1);
    sprintf(pname,"%s_la-ra",r->tname);
    append_farray_plot("zzz.rd.pl",pname,tdiff,tn,1);
    sprintf(pname,"%s_Tot_Response",r->tname);
    append_farray_plot("zzz.rd.pl",pname,tt,tn,1);
    myfree(tla);
    myfree(tra);
    myfree(tdiff);
  }
  for(i=0;i<r->n;i++){ 
    if (strcmp(r->datid[i],"spikes")==0){
      {
	char *spikegen;
	struct onode *sgo;
	sgo = onode_child_get_unique(m->o,"spike_gen");
	spikegen = onode_getpar_chr_exit(sgo,"type");
	if (strcmp(spikegen,"poisson")==0){
	  mod_me_gen_hand_poisson(m,r,tt,NULL,tn,0);
	}else{
	  printf("spikegen = %s\n",spikegen);
	  mylog_exit(mylogf,"MODEL_REICH_GET_RESPONSE  unknown spike_gen\n");
	}
	myfree(spikegen);
      }
    }else if (strcmp(r->datid[i],"response")==0){
      mod_util_resp_store_f_samp(r,i,tt,tn,1.0/mod_me_tscale,mylogf);
    }else{
      mylog_exit(mylogf,"MOD_REICH_GET_RESPONSE  unknown response item\n");
    }
  }
  myfree(tt);
}
void mod_me_run_me_gabor_01(m,s,r,k,action)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
     int k;                     
     int action;                
{
  myid = mylog_set_id_log(m->process_id,&mylogf);  
  if (action == 0){
    if (m->ppl == NULL)
      model_me_01_prep_o(m);
    else
      model_me_01_prep(m);
    model_me_01_prep_ft();
  }else if (action == 1){
    if (me_xflag == 0)
      model_me_01_get_response(m,s,r,k);
    else
      model_me_01_get_response_x(m,s,r,k);
  }else if (action == -1){
    model_me_01_done(m->ppl);
  }
}
void mod_me_run_me_v5(m,s,r,k,action)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
     int k;                     
     int action;                
{
  myid = mylog_set_id_log(m->process_id,&mylogf);  
  if ((action == 0)||(action == 10)){  
    model_me_v5_prep(m,s);
    if (action == 0)
      model_me_01_prep_ft();
  }else if (action == 1){
    model_me_v5_get_response(m,s,r,k);
  }else if (action == -1){
    ; 
  }
}
void mod_me_run_filter_xyt(m,s,r,k,action)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
     int k;                     
     int action;                
{
  myid = mylog_set_id_log(m->process_id,&mylogf);  
  if (action == 0){
    model_filter_xyt_prep(m);
  }else if (action == 1){
    model_filter_xyt_get_response(m,s,r,k);
  }else if (action == -1){
    ; 
  }
}
void mod_me_run_gabor_comp(m,s,r,k,action)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
     int k;                     
     int action;                
{
  myid = mylog_set_id_log(m->process_id,&mylogf);  
  if (action == 0){
    model_gabor_comp_prep(m);
  }else if (action == 1){
    model_gabor_comp_get_response(m,s,r,k);
  }else if (action == -1){
    ; 
  }
}
void mod_me_run_ds_simp_01(m,s,r,k,action)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
     int k;                     
     int action;                
{
  myid = mylog_set_id_log(m->process_id,&mylogf);  
  if (action == 0){
    if (m->ppl == NULL)
      model_me_01_prep_o(m);
    else
      model_me_01_prep(m);
    model_me_01_prep_ft();
  }else if (action == 1){
    model_ds_simp_01_get_response(m,s,r,k);
  }else if (action == -1){
    model_me_01_done(m->ppl);
  }
}
void mod_me_run_ds_liv3(m,s,r,k,action)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
     int k;                     
     int action;                
{
  myid = mylog_set_id_log(m->process_id,&mylogf);  
  if (action == 0){
    if (m->ppl == NULL)
      model_me_01_prep_o(m);
    else
      model_me_01_prep(m);
    model_me_01_prep_ft();
  }else if (action == 1){
    model_ds_liv3_get_response(m,s,r,k);
  }else if (action == -1){
    model_me_01_done(m->ppl);
  }
}
void mod_me_run_mem(m,s,r,k,action)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
     int k;                     
     int action;                
{
  myid = mylog_set_id_log(m->process_id,&mylogf);  
  if (action == 0){
    model_mem_prep(m);
    model_me_01_prep_ft();  
    { 
      int i;
      int fn;
      struct mod_me_fstruct **fs;
      fn = mod_me_fn;
      fs = mod_me_ff;
      for(i=0;i<mod_me_mem->nf;i++){
	mod_me_mem->fs[i][0] = fs[i*4  ]->s;
	mod_me_mem->fs[i][1] = fs[i*4+1]->s;
	mod_me_mem->fs[i][2] = fs[i*4+2]->s;
	mod_me_mem->fs[i][3] = fs[i*4+3]->s;
      }
    }
  }else if (action == 1){
    model_mem_get_response(m,s,r,k);
  }else if (action == -1){
    mylog(mylogf," *** WYETH HERE NEED TO CLEAN UP\n");
  }
}
void mod_me_run_reich(m,s,r,k,action)
     struct model_struct *m;    
     struct stim_struct *s;     
     struct response_struct *r; 
     int k;                     
     int action;                
{
  myid = mylog_set_id_log(m->process_id,&mylogf);  
  if (action == 0){
    model_reich_prep(m);
  }else if (action == 1){
    model_reich_get_response(m,s,r,k);
  }else if (action == -1){
    ; 
  }
}
